// This program was compiled from OCaml by js_of_ocaml 1.0
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1)
      for (var i = 0; i < l; i++) a2 [i2 + i] = a1 [i1 + i];
    else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (!this.len) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_classify_float (x) {
  if (isFinite (x)) {
    if (Math.abs(x) >= 2.2250738585072014e-308) return 0;
    if (x != 0) return 1;
    return 2;
  }
  return isNaN(x)?4:3;
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_equal (x, y) { return +(caml_compare_val(x,y,false) == 0); }
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_float (fmt, x) {
  var s, f = caml_parse_format(fmt);
  var prec = (f.prec < 0)?6:f.prec;
  if (x < 0) { f.sign = -1; x = -x; }
  if (isNaN(x)) { s = "nan"; f.filler = ' '; }
  else if (!isFinite(x)) { s = "inf"; f.filler = ' '; }
  else
    switch (f.conv) {
    case 'e':
      var s = x.toExponential(prec);
      var i = s.length;
      if (s.charAt(i - 3) == 'e')
        s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
      break;
    case 'f':
      s = x.toFixed(prec); break;
    case 'g':
      prec = prec?prec:1;
      s = x.toExponential(prec - 1);
      var j = s.indexOf('e');
      var exp = +s.slice(j + 1);
      if (exp < -4 || x.toFixed(0).length > prec) {
        var i = j - 1; while (s.charAt(i) == '0') i--;
        if (s.charAt(i) == '.') i--;
        s = s.slice(0, i + 1) + s.slice(j);
        i = s.length;
        if (s.charAt(i - 3) == 'e')
          s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
        break;
      } else {
        var p = prec;
        if (exp < 0) { p -= exp + 1; s = x.toFixed(p); }
        else while (s = x.toFixed(p), s.length > prec + 1) p--;
        if (p) {
          var i = s.length - 1; while (s.charAt(i) == '0') i--;
          if (s.charAt(i) == '.') i--;
          s = s.slice(0, i + 1);
        }
      }
      break;
    }
  return caml_finish_formatting(f, s);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_greaterequal (x, y) { return +(caml_compare(x,y,false) >= 0); }
function caml_int64_is_negative(x) {
  return (x[3] << 16) < 0;
}
function caml_int64_neg (x) {
  var y1 = - x[1];
  var y2 = - x[2] + (y1 >> 24);
  var y3 = - x[3] + (y2 >> 24);
  return [255, y1 & 0xffffff, y2 & 0xffffff, y3 & 0xffff];
}
function caml_int64_of_int32 (x) {
  return [255, x & 0xffffff, (x >> 24) & 0xffffff, (x >> 31) & 0xffff]
}
function caml_int64_ucompare(x,y) {
  if (x[3] > y[3]) return 1;
  if (x[3] < y[3]) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int64_lsl1 (x) {
  x[3] = (x[3] << 1) | (x[2] >> 23);
  x[2] = ((x[2] << 1) | (x[1] >> 23)) & 0xffffff;
  x[1] = (x[1] << 1) & 0xffffff;
}
function caml_int64_lsr1 (x) {
  x[1] = ((x[1] >>> 1) | (x[2] << 23)) & 0xffffff;
  x[2] = ((x[2] >>> 1) | (x[3] << 23)) & 0xffffff;
  x[3] = x[3] >>> 1;
}
function caml_int64_sub (x, y) {
  var z1 = x[1] - y[1];
  var z2 = x[2] - y[2] + (z1 >> 24);
  var z3 = x[3] - y[3] + (z2 >> 24);
  return [255, z1 & 0xffffff, z2 & 0xffffff, z3 & 0xffff];
}
function caml_int64_udivmod (x, y) {
  var offset = 0;
  var modulus = x.slice ();
  var divisor = y.slice ();
  var quotient = [255, 0, 0, 0];
  while (caml_int64_ucompare (modulus, divisor) > 0) {
    offset++;
    caml_int64_lsl1 (divisor);
  }
  while (offset >= 0) {
    offset --;
    caml_int64_lsl1 (quotient);
    if (caml_int64_ucompare (modulus, divisor) >= 0) {
      quotient[1] ++;
      modulus = caml_int64_sub (modulus, divisor);
    }
    caml_int64_lsr1 (divisor);
  }
  return [0,quotient, modulus];
}
function caml_int64_to_int32 (x) {
  return x[1] | (x[2] << 24);
}
function caml_int64_is_zero(x) {
  return (x[3]|x[2]|x[1]) == 0;
}
function caml_int64_format (fmt, x) {
  var f = caml_parse_format(fmt);
  if (f.signedconv && caml_int64_is_negative(x)) {
    f.sign = -1; x = caml_int64_neg(x);
  }
  var buffer = "";
  var wbase = caml_int64_of_int32(f.base);
  var cvtbl = "0123456789abcdef";
  do {
    var p = caml_int64_udivmod(x, wbase);
    x = p[1];
    buffer = cvtbl.charAt(caml_int64_to_int32(p[2])) + buffer;
  } while (! caml_int64_is_zero(x));
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - buffer.length;
    if (n > 0) buffer = caml_str_repeat (n, '0') + buffer;
  }
  return caml_finish_formatting(f, buffer);
}
function caml_parse_sign_and_base (s) {
  var i = 0, base = 10, sign = s.get(0) == 45?(i++,-1):1;
  if (s.get(i) == 48)
    switch (s.get(i + 1)) {
    case 120: case 88: base = 16; i += 2; break;
    case 111: case 79: base =  8; i += 2; break;
    case  98: case 66: base =  2; i += 2; break;
    }
  return [i, sign, base];
}
function caml_parse_digit(c) {
  if (c >= 48 && c <= 57)  return c - 48;
  if (c >= 65 && c <= 90)  return c - 55;
  if (c >= 97 && c <= 122) return c - 87;
  return -1;
}
var caml_global_data = [0];
function caml_failwith (msg) {
  caml_raise_with_string(caml_global_data[3], msg);
}
function caml_int_of_string (s) {
  var r = caml_parse_sign_and_base (s);
  var i = r[0], sign = r[1], base = r[2];
  var threshold = -1 >>> 0;
  var c = s.get(i);
  var d = caml_parse_digit(c);
  if (d < 0 || d >= base) caml_failwith("int_of_string");
  var res = d;
  for (;;) {
    i++;
    c = s.get(i);
    if (c == 95) continue;
    d = caml_parse_digit(c);
    if (d < 0 || d >= base) break;
    res = base * res + d;
    if (res > threshold) caml_failwith("int_of_string");
  }
  if (i != s.getLen()) caml_failwith("int_of_string");
  res = sign * res;
  if ((res | 0) != res) caml_failwith("int_of_string");
  return res;
}
function caml_is_printable(c) { return +(c > 31 && c < 127); }
function caml_js_from_byte_string (s) {return s.getFullBytes();}
var caml_js_regexps = { amp:/&/g, lt:/</g, quot:/\"/g, all:/[&<\"]/ };
function caml_js_html_escape (s) {
  if (!caml_js_regexps.all.test(s)) return s;
  return s.replace(caml_js_regexps.amp, "&amp;")
          .replace(caml_js_regexps.lt, "&lt;")
          .replace(caml_js_regexps.quot, "&quot;");
}
function caml_js_on_ie () {
  var ua = window.navigator?window.navigator.userAgent:"";
  return ua.indexOf("MSIE") != -1 && ua.indexOf("Opera") != 0;
}
function caml_js_to_byte_string (s) {return new MlString (s);}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function MlStringFromArray (a) {
  var len = a.length; this.array = a; this.len = this.last = len;
}
MlStringFromArray.prototype = new MlString ();
var caml_md5_string =
function () {
  function add (x, y) { return (x + y) | 0; }
  function xx(q,a,b,x,s,t) {
    a = add(add(a, q), add(x, t));
    return add((a << s) | (a >>> (32 - s)), b);
  }
  function ff(a,b,c,d,x,s,t) {
    return xx((b & c) | ((~b) & d), a, b, x, s, t);
  }
  function gg(a,b,c,d,x,s,t) {
    return xx((b & d) | (c & (~d)), a, b, x, s, t);
  }
  function hh(a,b,c,d,x,s,t) { return xx(b ^ c ^ d, a, b, x, s, t); }
  function ii(a,b,c,d,x,s,t) { return xx(c ^ (b | (~d)), a, b, x, s, t); }
  function md5(buffer, length) {
    var i = length;
    buffer[i >> 2] |= 0x80 << (8 * (i & 3));
    for (i = (i & ~0x3) + 4;(i & 0x3F) < 56 ;i += 4)
      buffer[i >> 2] = 0;
    buffer[i >> 2] = length << 3;
    i += 4;
    buffer[i >> 2] = (length >> 29) & 0x1FFFFFFF;
    var w = [0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476];
    for(i = 0; i < buffer.length; i += 16) {
      var a = w[0], b = w[1], c = w[2], d = w[3];
      a = ff(a, b, c, d, buffer[i+ 0], 7, 0xD76AA478);
      d = ff(d, a, b, c, buffer[i+ 1], 12, 0xE8C7B756);
      c = ff(c, d, a, b, buffer[i+ 2], 17, 0x242070DB);
      b = ff(b, c, d, a, buffer[i+ 3], 22, 0xC1BDCEEE);
      a = ff(a, b, c, d, buffer[i+ 4], 7, 0xF57C0FAF);
      d = ff(d, a, b, c, buffer[i+ 5], 12, 0x4787C62A);
      c = ff(c, d, a, b, buffer[i+ 6], 17, 0xA8304613);
      b = ff(b, c, d, a, buffer[i+ 7], 22, 0xFD469501);
      a = ff(a, b, c, d, buffer[i+ 8], 7, 0x698098D8);
      d = ff(d, a, b, c, buffer[i+ 9], 12, 0x8B44F7AF);
      c = ff(c, d, a, b, buffer[i+10], 17, 0xFFFF5BB1);
      b = ff(b, c, d, a, buffer[i+11], 22, 0x895CD7BE);
      a = ff(a, b, c, d, buffer[i+12], 7, 0x6B901122);
      d = ff(d, a, b, c, buffer[i+13], 12, 0xFD987193);
      c = ff(c, d, a, b, buffer[i+14], 17, 0xA679438E);
      b = ff(b, c, d, a, buffer[i+15], 22, 0x49B40821);
      a = gg(a, b, c, d, buffer[i+ 1], 5, 0xF61E2562);
      d = gg(d, a, b, c, buffer[i+ 6], 9, 0xC040B340);
      c = gg(c, d, a, b, buffer[i+11], 14, 0x265E5A51);
      b = gg(b, c, d, a, buffer[i+ 0], 20, 0xE9B6C7AA);
      a = gg(a, b, c, d, buffer[i+ 5], 5, 0xD62F105D);
      d = gg(d, a, b, c, buffer[i+10], 9, 0x02441453);
      c = gg(c, d, a, b, buffer[i+15], 14, 0xD8A1E681);
      b = gg(b, c, d, a, buffer[i+ 4], 20, 0xE7D3FBC8);
      a = gg(a, b, c, d, buffer[i+ 9], 5, 0x21E1CDE6);
      d = gg(d, a, b, c, buffer[i+14], 9, 0xC33707D6);
      c = gg(c, d, a, b, buffer[i+ 3], 14, 0xF4D50D87);
      b = gg(b, c, d, a, buffer[i+ 8], 20, 0x455A14ED);
      a = gg(a, b, c, d, buffer[i+13], 5, 0xA9E3E905);
      d = gg(d, a, b, c, buffer[i+ 2], 9, 0xFCEFA3F8);
      c = gg(c, d, a, b, buffer[i+ 7], 14, 0x676F02D9);
      b = gg(b, c, d, a, buffer[i+12], 20, 0x8D2A4C8A);
      a = hh(a, b, c, d, buffer[i+ 5], 4, 0xFFFA3942);
      d = hh(d, a, b, c, buffer[i+ 8], 11, 0x8771F681);
      c = hh(c, d, a, b, buffer[i+11], 16, 0x6D9D6122);
      b = hh(b, c, d, a, buffer[i+14], 23, 0xFDE5380C);
      a = hh(a, b, c, d, buffer[i+ 1], 4, 0xA4BEEA44);
      d = hh(d, a, b, c, buffer[i+ 4], 11, 0x4BDECFA9);
      c = hh(c, d, a, b, buffer[i+ 7], 16, 0xF6BB4B60);
      b = hh(b, c, d, a, buffer[i+10], 23, 0xBEBFBC70);
      a = hh(a, b, c, d, buffer[i+13], 4, 0x289B7EC6);
      d = hh(d, a, b, c, buffer[i+ 0], 11, 0xEAA127FA);
      c = hh(c, d, a, b, buffer[i+ 3], 16, 0xD4EF3085);
      b = hh(b, c, d, a, buffer[i+ 6], 23, 0x04881D05);
      a = hh(a, b, c, d, buffer[i+ 9], 4, 0xD9D4D039);
      d = hh(d, a, b, c, buffer[i+12], 11, 0xE6DB99E5);
      c = hh(c, d, a, b, buffer[i+15], 16, 0x1FA27CF8);
      b = hh(b, c, d, a, buffer[i+ 2], 23, 0xC4AC5665);
      a = ii(a, b, c, d, buffer[i+ 0], 6, 0xF4292244);
      d = ii(d, a, b, c, buffer[i+ 7], 10, 0x432AFF97);
      c = ii(c, d, a, b, buffer[i+14], 15, 0xAB9423A7);
      b = ii(b, c, d, a, buffer[i+ 5], 21, 0xFC93A039);
      a = ii(a, b, c, d, buffer[i+12], 6, 0x655B59C3);
      d = ii(d, a, b, c, buffer[i+ 3], 10, 0x8F0CCC92);
      c = ii(c, d, a, b, buffer[i+10], 15, 0xFFEFF47D);
      b = ii(b, c, d, a, buffer[i+ 1], 21, 0x85845DD1);
      a = ii(a, b, c, d, buffer[i+ 8], 6, 0x6FA87E4F);
      d = ii(d, a, b, c, buffer[i+15], 10, 0xFE2CE6E0);
      c = ii(c, d, a, b, buffer[i+ 6], 15, 0xA3014314);
      b = ii(b, c, d, a, buffer[i+13], 21, 0x4E0811A1);
      a = ii(a, b, c, d, buffer[i+ 4], 6, 0xF7537E82);
      d = ii(d, a, b, c, buffer[i+11], 10, 0xBD3AF235);
      c = ii(c, d, a, b, buffer[i+ 2], 15, 0x2AD7D2BB);
      b = ii(b, c, d, a, buffer[i+ 9], 21, 0xEB86D391);
      w[0] = add(a, w[0]);
      w[1] = add(b, w[1]);
      w[2] = add(c, w[2]);
      w[3] = add(d, w[3]);
    }
    var t = [];
    for (var i = 0; i < 4; i++)
      for (var j = 0; j < 4; j++)
        t[i * 4 + j] = (w[i] >> (8 * j)) & 0xFF;
    return t;
  }
  return function (s, ofs, len) {
    var buf = [];
    if (s.array) {
      var a = s.array;
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] = a[j] | (a[j+1] << 8) | (a[j+2] << 16) | (a[j+3] << 24);
      }
      for (; i < len; i++) buf[i>>2] |= a[i + ofs] << (8 * (i & 3));
    } else {
      var b = s.getFullBytes();
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] =
          b.charCodeAt(j) | (b.charCodeAt(j+1) << 8) |
          (b.charCodeAt(j+2) << 16) | (b.charCodeAt(j+3) << 24);
      }
      for (; i < len; i++) buf[i>>2] |= b.charCodeAt(i + ofs) << (8 * (i & 3));
    }
    return new MlStringFromArray(md5(buf, len));
  }
} ();
function caml_ml_out_channels_list () { return 0; }
function caml_raise_constant (tag) { throw [0, tag]; }
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_string_equal(s1, s2) {
  var b1 = s1.fullBytes;
  var b2 = s2.fullBytes;
  if (b1 != null && b2 != null) return (b1 == b2)?1:0;
  return (s1.getFullBytes () == s2.getFullBytes ())?1:0;
}
function caml_string_notequal(s1, s2) { return 1-caml_string_equal(s1, s2); }
function caml_sys_get_config () {
  return [0, new MlWrappedString("Unix"), 32];
}
var caml_initial_time = new Date() * 0.001;
function caml_sys_time () { return new Date() * 0.001 - caml_initial_time; }
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function(){function jD(xM,xN,xO,xP,xQ,xR,xS){return xM.length==6?xM(xN,xO,xP,xQ,xR,xS):caml_call_gen(xM,[xN,xO,xP,xQ,xR,xS]);}function sK(xH,xI,xJ,xK,xL){return xH.length==4?xH(xI,xJ,xK,xL):caml_call_gen(xH,[xI,xJ,xK,xL]);}function fi(xD,xE,xF,xG){return xD.length==3?xD(xE,xF,xG):caml_call_gen(xD,[xE,xF,xG]);}function fN(xA,xB,xC){return xA.length==2?xA(xB,xC):caml_call_gen(xA,[xB,xC]);}function cW(xy,xz){return xy.length==1?xy(xz):caml_call_gen(xy,[xz]);}var a=[0,new MlString("Failure")],b=[0,new MlString("Invalid_argument")],c=[0,new MlString("Not_found")],d=[0,new MlString("Assert_failure")],e=new MlString("select");caml_register_global(5,[0,new MlString("Division_by_zero")]);caml_register_global(3,b);caml_register_global(2,a);var cA=new MlString("%.12g"),cz=new MlString("."),cy=new MlString("%d"),cx=new MlString("true"),cw=new MlString("false"),cv=new MlString("Pervasives.do_at_exit"),cu=new MlString("nth"),ct=new MlString("List.nth"),cs=new MlString("\\b"),cr=new MlString("\\t"),cq=new MlString("\\n"),cp=new MlString("\\r"),co=new MlString("\\\\"),cn=new MlString("\\'"),cm=new MlString(""),cl=new MlString("String.blit"),ck=new MlString("String.sub"),cj=new MlString("Queue.Empty"),ci=new MlString("Buffer.add: cannot grow buffer"),ch=new MlString("%"),cg=new MlString(""),cf=new MlString(""),ce=new MlString("\""),cd=new MlString("\""),cc=new MlString("'"),cb=new MlString("'"),ca=new MlString("."),b$=new MlString("printf: bad positional specification (0)."),b_=new MlString("%_"),b9=[0,new MlString("printf.ml"),144,8],b8=new MlString("''"),b7=new MlString("Printf: premature end of format string ``"),b6=new MlString("''"),b5=new MlString(" in format string ``"),b4=new MlString(", at char number "),b3=new MlString("Printf: bad conversion %"),b2=new MlString("Sformat.index_of_int: negative argument "),b1=new MlString("x"),b0=new MlString("Lwt_sequence.Empty"),bZ=[0,new MlString("src/core/lwt.ml"),499,20],bY=[0,new MlString("src/core/lwt.ml"),502,8],bX=[0,new MlString("src/core/lwt.ml"),477,20],bW=[0,new MlString("src/core/lwt.ml"),480,8],bV=[0,new MlString("src/core/lwt.ml"),440,20],bU=[0,new MlString("src/core/lwt.ml"),443,8],bT=new MlString("Lwt.fast_connect"),bS=new MlString("Lwt.connect"),bR=new MlString("Lwt.wakeup_exn"),bQ=new MlString("Lwt.wakeup"),bP=new MlString("Lwt.Canceled"),bO=new MlString("table"),bN=new MlString("img"),bM=new MlString("br"),bL=new MlString("h1"),bK=new MlString("div"),bJ=new MlString("option"),bI=new MlString("\""),bH=new MlString(" name=\""),bG=new MlString("\""),bF=new MlString(" type=\""),bE=new MlString("<"),bD=new MlString(">"),bC=new MlString(""),bB=new MlString("\\$&"),bA=new MlString("$$$$"),bz=new MlString("g"),by=new MlString("g"),bx=new MlString("[$]"),bw=new MlString("[\\][()\\\\|+*.?{}^$]"),bv=[0,new MlString(""),0],bu=new MlString(""),bt=new MlString(""),bs=new MlString("#"),br=new MlString(""),bq=new MlString("?"),bp=new MlString(""),bo=new MlString("/"),bn=new MlString("/"),bm=new MlString(":"),bl=new MlString(""),bk=new MlString("http://"),bj=new MlString(""),bi=new MlString("#"),bh=new MlString(""),bg=new MlString("?"),bf=new MlString(""),be=new MlString("/"),bd=new MlString("/"),bc=new MlString(":"),bb=new MlString(""),ba=new MlString("https://"),a$=new MlString(""),a_=new MlString("#"),a9=new MlString(""),a8=new MlString("?"),a7=new MlString(""),a6=new MlString("/"),a5=new MlString("file://"),a4=new MlString(""),a3=new MlString(""),a2=new MlString(""),a1=new MlString(""),a0=new MlString(""),aZ=new MlString(""),aY=new MlString("="),aX=new MlString("&"),aW=new MlString("file"),aV=new MlString("file:"),aU=new MlString("http"),aT=new MlString("http:"),aS=new MlString("https"),aR=new MlString("https:"),aQ=new MlString("%2B"),aP=new MlString("Url.Local_exn"),aO=new MlString("+"),aN=new MlString("Url.Not_an_http_protocol"),aM=new MlString("^([Hh][Tt][Tt][Pp][Ss]?)://([0-9a-zA-Z.-]+|\\[[0-9a-zA-Z.-]+\\]|\\[[0-9A-Fa-f:.]+\\])?(:([0-9]+))?/([^\\?#]*)(\\?([^#]*))?(#(.*))?$"),aL=new MlString("^([Ff][Ii][Ll][Ee])://([^\\?#]*)(\\?([^#])*)?(#(.*))?$"),aK=new MlString("browser can't read file: unimplemented"),aJ=new MlString("utf8"),aI=[0,new MlString("file.ml"),132,15],aH=new MlString("string"),aG=new MlString("can't retrieve file name: not implemented"),aF=new MlString(""),aE=new MlString("POST"),aD=new MlString("multipart/form-data; boundary="),aC=new MlString("POST"),aB=[0,new MlString("POST"),[0,new MlString("application/x-www-form-urlencoded")],126925477],aA=[0,new MlString("POST"),0,126925477],az=new MlString("GET"),ay=new MlString("?"),ax=new MlString("Content-type"),aw=new MlString("="),av=new MlString("="),au=new MlString("&"),at=new MlString("Content-Type: application/octet-stream\r\n"),as=new MlString("\"\r\n"),ar=new MlString("\"; filename=\""),aq=new MlString("Content-Disposition: form-data; name=\""),ap=new MlString("\r\n"),ao=new MlString("\r\n"),an=new MlString("\r\n"),am=new MlString("--"),al=new MlString("\r\n"),ak=new MlString("\"\r\n\r\n"),aj=new MlString("Content-Disposition: form-data; name=\""),ai=new MlString("--\r\n"),ah=new MlString("--"),ag=new MlString("js_of_ocaml-------------------"),af=new MlString("Msxml2.XMLHTTP"),ae=new MlString("Msxml3.XMLHTTP"),ad=new MlString("Microsoft.XMLHTTP"),ac=[0,new MlString("xmlHttpRequest.ml"),79,2],ab=new MlString("XmlHttpRequest.Wrong_headers"),aa=new MlString("sprites/guy.png"),$=new MlString("sprites/boulder.png"),_=new MlString("index out of bounds"),Z=new MlString("YOU WIN !"),Y=new MlString("YOU LOSE !"),X=new MlString("sprites/end.png"),W=new MlString("sprites/R.png"),V=new MlString("sprites/L.png"),U=new MlString("sprites/U.png"),T=new MlString("sprites/D.png"),S=new MlString("sprites/push_r.png"),R=new MlString("sprites/bR.png"),Q=new MlString("sprites/push_l.png"),P=new MlString("sprites/bL.png"),O=new MlString("eos"),N=new MlString("eos"),M=new MlString("eos"),L=new MlString("%g"),K=new MlString("1"),J=new MlString("malformed level"),I=new MlString("border-collapse:collapse;line-height: 0; opacity: 0; margin-left:auto; margin-right:auto"),H=new MlString("padding: 0; width: 20px; height: 20px;"),G=new MlString("font-family: sans-serif; text-align: center; background-color: #e8e8e8;"),F=new MlString("Boulder Dash in Ocaml"),E=new MlString("Elapsed time: "),D=new MlString(" Remaining diamonds: "),C=new MlString(" "),B=new MlString("Choose a level"),A=[0,new MlString("boulderdash.ml"),294,17],z=new MlString("boulderdash"),y=new MlString("--"),x=new MlString("maps.txt"),w=new MlString("sprites/empty.png"),v=new MlString("sprites/grass.png"),u=new MlString("sprites/diamond.png"),t=new MlString("sprites/boulder.png"),s=new MlString("sprites/door.png"),r=new MlString("sprites/end.png"),q=new MlString("sprites/guy.png"),p=new MlString("sprites/wall.png"),o=new MlString("sprites/bam.png"),n=new MlString("%02d:%02d:%02d"),m=new MlString("--:--:--"),l=new MlString("LOADING..."),k=new MlString("border: 1px black solid; background-color: white ; display: inline ; padding-right: .5em; padding-left: .5em;"),j=new MlString("background-color: red; color: white; display:inline; position: absolute; top:0; right:0;"),i=new MlString("Boulderdash.Death");function h(f){throw [0,a,f];}function cB(g){throw [0,b,g];}function cQ(cC,cE){var cD=cC.getLen(),cF=cE.getLen(),cG=caml_create_string(cD+cF|0);caml_blit_string(cC,0,cG,0,cD);caml_blit_string(cE,0,cG,cD,cF);return cG;}function cR(cH){return caml_format_int(cy,cH);}function cJ(cI,cK){if(cI){var cL=cI[1];return [0,cL,cJ(cI[2],cK)];}return cK;}function cS(cP){var cM=caml_ml_out_channels_list(0);for(;;){if(cM){var cN=cM[2];try {}catch(cO){}var cM=cN;continue;}return 0;}}caml_register_named_value(cv,cS);function dc(cV,cT){var cU=cT.length-1;if(0===cU)return [0];var cX=caml_make_vect(cU,cW(cV,cT[0+1])),cY=1,cZ=cU-1|0;if(!(cZ<cY)){var c0=cY;for(;;){cX[c0+1]=cW(cV,cT[c0+1]);var c1=c0+1|0;if(cZ!==c0){var c0=c1;continue;}break;}}return cX;}function dd(c2){if(c2){var c3=0,c4=c2,c_=c2[2],c7=c2[1];for(;;){if(c4){var c6=c4[2],c5=c3+1|0,c3=c5,c4=c6;continue;}var c8=caml_make_vect(c3,c7),c9=1,c$=c_;for(;;){if(c$){var da=c$[2];c8[c9+1]=c$[1];var db=c9+1|0,c9=db,c$=da;continue;}return c8;}}}return [0];}function dt(de){var df=de,dg=0;for(;;){if(df){var dh=df[2],di=[0,df[1],dg],df=dh,dg=di;continue;}return dg;}}function dm(dk,dj){if(dj){var dl=dj[2],dn=cW(dk,dj[1]);return [0,dn,dm(dk,dl)];}return 0;}function du(dr,dp){var dq=dp;for(;;){if(dq){var ds=dq[2];cW(dr,dq[1]);var dq=ds;continue;}return 0;}}function dR(dv,dx){var dw=caml_create_string(dv);caml_fill_string(dw,0,dv,dx);return dw;}function dS(dA,dy,dz){if(0<=dy&&0<=dz&&!((dA.getLen()-dz|0)<dy)){var dB=caml_create_string(dz);caml_blit_string(dA,dy,dB,0,dz);return dB;}return cB(ck);}function dT(dE,dD,dG,dF,dC){if(0<=dC&&0<=dD&&!((dE.getLen()-dC|0)<dD)&&0<=dF&&!((dG.getLen()-dC|0)<dF))return caml_blit_string(dE,dD,dG,dF,dC);return cB(cl);}function dU(dN,dH){if(dH){var dI=dH[1],dJ=[0,0],dK=[0,0],dM=dH[2];du(function(dL){dJ[1]+=1;dK[1]=dK[1]+dL.getLen()|0;return 0;},dH);var dO=caml_create_string(dK[1]+caml_mul(dN.getLen(),dJ[1]-1|0)|0);caml_blit_string(dI,0,dO,0,dI.getLen());var dP=[0,dI.getLen()];du(function(dQ){caml_blit_string(dN,0,dO,dP[1],dN.getLen());dP[1]=dP[1]+dN.getLen()|0;caml_blit_string(dQ,0,dO,dP[1],dQ.getLen());dP[1]=dP[1]+dQ.getLen()|0;return 0;},dM);return dO;}return cm;}var dV=caml_sys_get_config(0)[2],dW=caml_mul(dV/8|0,(1<<(dV-10|0))-1|0)-1|0,dY=[0,cj];function eh(dX){if(0===dX[1])throw [0,dY];dX[1]=dX[1]-1|0;var dZ=dX[2],d0=dZ[2];if(d0===dZ)dX[2]=0;else dZ[2]=d0[2];return d0[1];}function eg(d1){var d2=1<=d1?d1:1,d3=dW<d2?dW:d2,d4=caml_create_string(d3);return [0,d4,0,d3,d4];}function ei(d5){return dS(d5[1],0,d5[2]);}function ea(d6,d8){var d7=[0,d6[3]];for(;;){if(d7[1]<(d6[2]+d8|0)){d7[1]=2*d7[1]|0;continue;}if(dW<d7[1])if((d6[2]+d8|0)<=dW)d7[1]=dW;else h(ci);var d9=caml_create_string(d7[1]);dT(d6[1],0,d9,0,d6[2]);d6[1]=d9;d6[3]=d7[1];return 0;}}function ej(d_,eb){var d$=d_[2];if(d_[3]<=d$)ea(d_,1);d_[1].safeSet(d$,eb);d_[2]=d$+1|0;return 0;}function ek(ee,ec){var ed=ec.getLen(),ef=ee[2]+ed|0;if(ee[3]<ef)ea(ee,ed);dT(ec,0,ee[1],ee[2],ed);ee[2]=ef;return 0;}function eo(el){return 0<=el?el:h(cQ(b2,cR(el)));}function ep(em,en){return eo(em+en|0);}var eq=cW(ep,1);function ex(er){return dS(er,0,er.getLen());}function ez(es,et,ev){var eu=cQ(b5,cQ(es,b6)),ew=cQ(b4,cQ(cR(et),eu));return cB(cQ(b3,cQ(dR(1,ev),ew)));}function fo(ey,eB,eA){return ez(ex(ey),eB,eA);}function fp(eC){return cB(cQ(b7,cQ(ex(eC),b8)));}function eW(eD,eL,eN,eP){function eK(eE){if((eD.safeGet(eE)-48|0)<0||9<(eD.safeGet(eE)-48|0))return eE;var eF=eE+1|0;for(;;){var eG=eD.safeGet(eF);if(48<=eG){if(!(58<=eG)){var eI=eF+1|0,eF=eI;continue;}var eH=0;}else if(36===eG){var eJ=eF+1|0,eH=1;}else var eH=0;if(!eH)var eJ=eE;return eJ;}}var eM=eK(eL+1|0),eO=eg((eN-eM|0)+10|0);ej(eO,37);var eQ=eM,eR=dt(eP);for(;;){if(eQ<=eN){var eS=eD.safeGet(eQ);if(42===eS){if(eR){var eT=eR[2];ek(eO,cR(eR[1]));var eU=eK(eQ+1|0),eQ=eU,eR=eT;continue;}throw [0,d,b9];}ej(eO,eS);var eV=eQ+1|0,eQ=eV;continue;}return ei(eO);}}function gP(e2,e0,eZ,eY,eX){var e1=eW(e0,eZ,eY,eX);if(78!==e2&&110!==e2)return e1;e1.safeSet(e1.getLen()-1|0,117);return e1;}function fq(e9,fh,fm,e3,fl){var e4=e3.getLen();function fj(e5,fg){var e6=40===e5?41:125;function ff(e7){var e8=e7;for(;;){if(e4<=e8)return cW(e9,e3);if(37===e3.safeGet(e8)){var e_=e8+1|0;if(e4<=e_)var e$=cW(e9,e3);else{var fa=e3.safeGet(e_),fb=fa-40|0;if(fb<0||1<fb){var fc=fb-83|0;if(fc<0||2<fc)var fd=1;else switch(fc){case 1:var fd=1;break;case 2:var fe=1,fd=0;break;default:var fe=0,fd=0;}if(fd){var e$=ff(e_+1|0),fe=2;}}else var fe=0===fb?0:1;switch(fe){case 1:var e$=fa===e6?e_+1|0:fi(fh,e3,fg,fa);break;case 2:break;default:var e$=ff(fj(fa,e_+1|0)+1|0);}}return e$;}var fk=e8+1|0,e8=fk;continue;}}return ff(fg);}return fj(fm,fl);}function fQ(fn){return fi(fq,fp,fo,fn);}function f6(fr,fC,fM){var fs=fr.getLen()-1|0;function fO(ft){var fu=ft;a:for(;;){if(fu<fs){if(37===fr.safeGet(fu)){var fv=0,fw=fu+1|0;for(;;){if(fs<fw)var fx=fp(fr);else{var fy=fr.safeGet(fw);if(58<=fy){if(95===fy){var fA=fw+1|0,fz=1,fv=fz,fw=fA;continue;}}else if(32<=fy)switch(fy-32|0){case 1:case 2:case 4:case 5:case 6:case 7:case 8:case 9:case 12:case 15:break;case 0:case 3:case 11:case 13:var fB=fw+1|0,fw=fB;continue;case 10:var fD=fi(fC,fv,fw,105),fw=fD;continue;default:var fE=fw+1|0,fw=fE;continue;}var fF=fw;c:for(;;){if(fs<fF)var fG=fp(fr);else{var fH=fr.safeGet(fF);if(126<=fH)var fI=0;else switch(fH){case 78:case 88:case 100:case 105:case 111:case 117:case 120:var fG=fi(fC,fv,fF,105),fI=1;break;case 69:case 70:case 71:case 101:case 102:case 103:var fG=fi(fC,fv,fF,102),fI=1;break;case 33:case 37:case 44:var fG=fF+1|0,fI=1;break;case 83:case 91:case 115:var fG=fi(fC,fv,fF,115),fI=1;break;case 97:case 114:case 116:var fG=fi(fC,fv,fF,fH),fI=1;break;case 76:case 108:case 110:var fJ=fF+1|0;if(fs<fJ){var fG=fi(fC,fv,fF,105),fI=1;}else{var fK=fr.safeGet(fJ)-88|0;if(fK<0||32<fK)var fL=1;else switch(fK){case 0:case 12:case 17:case 23:case 29:case 32:var fG=fN(fM,fi(fC,fv,fF,fH),105),fI=1,fL=0;break;default:var fL=1;}if(fL){var fG=fi(fC,fv,fF,105),fI=1;}}break;case 67:case 99:var fG=fi(fC,fv,fF,99),fI=1;break;case 66:case 98:var fG=fi(fC,fv,fF,66),fI=1;break;case 41:case 125:var fG=fi(fC,fv,fF,fH),fI=1;break;case 40:var fG=fO(fi(fC,fv,fF,fH)),fI=1;break;case 123:var fP=fi(fC,fv,fF,fH),fR=fi(fQ,fH,fr,fP),fS=fP;for(;;){if(fS<(fR-2|0)){var fT=fN(fM,fS,fr.safeGet(fS)),fS=fT;continue;}var fU=fR-1|0,fF=fU;continue c;}default:var fI=0;}if(!fI)var fG=fo(fr,fF,fH);}var fx=fG;break;}}var fu=fx;continue a;}}var fV=fu+1|0,fu=fV;continue;}return fu;}}fO(0);return 0;}function h4(f7){var fW=[0,0,0,0];function f5(f1,f2,fX){var fY=41!==fX?1:0,fZ=fY?125!==fX?1:0:fY;if(fZ){var f0=97===fX?2:1;if(114===fX)fW[3]=fW[3]+1|0;if(f1)fW[2]=fW[2]+f0|0;else fW[1]=fW[1]+f0|0;}return f2+1|0;}f6(f7,f5,function(f3,f4){return f3+1|0;});return fW[1];}function gL(f8,f$,gh,f9){var f_=f8.safeGet(f9);if((f_-48|0)<0||9<(f_-48|0))return fN(f$,0,f9);var ga=f_-48|0,gb=f9+1|0;for(;;){var gc=f8.safeGet(gb);if(48<=gc){if(!(58<=gc)){var gf=gb+1|0,ge=(10*ga|0)+(gc-48|0)|0,ga=ge,gb=gf;continue;}var gd=0;}else if(36===gc)if(0===ga){var gg=h(b$),gd=1;}else{var gg=fN(f$,[0,eo(ga-1|0)],gb+1|0),gd=1;}else var gd=0;if(!gd)var gg=fN(f$,0,f9);return gg;}}function gG(gi,gj){return gi?gj:cW(eq,gj);}function gv(gk,gl){return gk?gk[1]:gl;}function jC(iv,gn,iH,iw,h9,iN,gm){var go=cW(gn,gm);function h8(gt,iM,gp,gy){var gs=gp.getLen();function h5(iE,gq){var gr=gq;for(;;){if(gs<=gr)return cW(gt,go);var gu=gp.safeGet(gr);if(37===gu){var gC=function(gx,gw){return caml_array_get(gy,gv(gx,gw));},gI=function(gK,gD,gF,gz){var gA=gz;for(;;){var gB=gp.safeGet(gA)-32|0;if(!(gB<0||25<gB))switch(gB){case 1:case 2:case 4:case 5:case 6:case 7:case 8:case 9:case 12:case 15:break;case 10:return gL(gp,function(gE,gJ){var gH=[0,gC(gE,gD),gF];return gI(gK,gG(gE,gD),gH,gJ);},gD,gA+1|0);default:var gM=gA+1|0,gA=gM;continue;}var gN=gp.safeGet(gA);if(124<=gN)var gO=0;else switch(gN){case 78:case 88:case 100:case 105:case 111:case 117:case 120:var gQ=gC(gK,gD),gR=caml_format_int(gP(gN,gp,gr,gA,gF),gQ),gT=gS(gG(gK,gD),gR,gA+1|0),gO=1;break;case 69:case 71:case 101:case 102:case 103:var gU=gC(gK,gD),gV=caml_format_float(eW(gp,gr,gA,gF),gU),gT=gS(gG(gK,gD),gV,gA+1|0),gO=1;break;case 76:case 108:case 110:var gW=gp.safeGet(gA+1|0)-88|0;if(gW<0||32<gW)var gX=1;else switch(gW){case 0:case 12:case 17:case 23:case 29:case 32:var gY=gA+1|0,gZ=gN-108|0;if(gZ<0||2<gZ)var g0=0;else{switch(gZ){case 1:var g0=0,g1=0;break;case 2:var g2=gC(gK,gD),g3=caml_format_int(eW(gp,gr,gY,gF),g2),g1=1;break;default:var g4=gC(gK,gD),g3=caml_format_int(eW(gp,gr,gY,gF),g4),g1=1;}if(g1){var g5=g3,g0=1;}}if(!g0){var g6=gC(gK,gD),g5=caml_int64_format(eW(gp,gr,gY,gF),g6);}var gT=gS(gG(gK,gD),g5,gY+1|0),gO=1,gX=0;break;default:var gX=1;}if(gX){var g7=gC(gK,gD),g8=caml_format_int(gP(110,gp,gr,gA,gF),g7),gT=gS(gG(gK,gD),g8,gA+1|0),gO=1;}break;case 83:case 115:var g9=gC(gK,gD);if(115===gN)var g_=g9;else{var g$=[0,0],ha=0,hb=g9.getLen()-1|0;if(!(hb<ha)){var hc=ha;for(;;){var hd=g9.safeGet(hc),he=14<=hd?34===hd?1:92===hd?1:0:11<=hd?13<=hd?1:0:8<=hd?1:0,hf=he?2:caml_is_printable(hd)?1:4;g$[1]=g$[1]+hf|0;var hg=hc+1|0;if(hb!==hc){var hc=hg;continue;}break;}}if(g$[1]===g9.getLen())var hh=g9;else{var hi=caml_create_string(g$[1]);g$[1]=0;var hj=0,hk=g9.getLen()-1|0;if(!(hk<hj)){var hl=hj;for(;;){var hm=g9.safeGet(hl),hn=hm-34|0;if(hn<0||58<hn)if(-20<=hn)var ho=1;else{switch(hn+34|0){case 8:hi.safeSet(g$[1],92);g$[1]+=1;hi.safeSet(g$[1],98);var hp=1;break;case 9:hi.safeSet(g$[1],92);g$[1]+=1;hi.safeSet(g$[1],116);var hp=1;break;case 10:hi.safeSet(g$[1],92);g$[1]+=1;hi.safeSet(g$[1],110);var hp=1;break;case 13:hi.safeSet(g$[1],92);g$[1]+=1;hi.safeSet(g$[1],114);var hp=1;break;default:var ho=1,hp=0;}if(hp)var ho=0;}else var ho=(hn-1|0)<0||56<(hn-1|0)?(hi.safeSet(g$[1],92),g$[1]+=1,hi.safeSet(g$[1],hm),0):1;if(ho)if(caml_is_printable(hm))hi.safeSet(g$[1],hm);else{hi.safeSet(g$[1],92);g$[1]+=1;hi.safeSet(g$[1],48+(hm/100|0)|0);g$[1]+=1;hi.safeSet(g$[1],48+((hm/10|0)%10|0)|0);g$[1]+=1;hi.safeSet(g$[1],48+(hm%10|0)|0);}g$[1]+=1;var hq=hl+1|0;if(hk!==hl){var hl=hq;continue;}break;}}var hh=hi;}var g_=cQ(cd,cQ(hh,ce));}if(gA===(gr+1|0))var hr=g_;else{var hs=eW(gp,gr,gA,gF);try {var ht=0,hu=1;for(;;){if(hs.getLen()<=hu)var hv=[0,0,ht];else{var hw=hs.safeGet(hu);if(49<=hw)if(58<=hw)var hx=0;else{var hv=[0,caml_int_of_string(dS(hs,hu,(hs.getLen()-hu|0)-1|0)),ht],hx=1;}else{if(45===hw){var hz=hu+1|0,hy=1,ht=hy,hu=hz;continue;}var hx=0;}if(!hx){var hA=hu+1|0,hu=hA;continue;}}var hB=hv;break;}}catch(hC){if(hC[1]!==a)throw hC;var hB=ez(hs,0,115);}var hD=hB[1],hE=g_.getLen(),hF=0,hJ=hB[2],hI=32;if(hD===hE&&0===hF){var hG=g_,hH=1;}else var hH=0;if(!hH)if(hD<=hE)var hG=dS(g_,hF,hE);else{var hK=dR(hD,hI);if(hJ)dT(g_,hF,hK,0,hE);else dT(g_,hF,hK,hD-hE|0,hE);var hG=hK;}var hr=hG;}var gT=gS(gG(gK,gD),hr,gA+1|0),gO=1;break;case 67:case 99:var hL=gC(gK,gD);if(99===gN)var hM=dR(1,hL);else{if(39===hL)var hN=cn;else if(92===hL)var hN=co;else{if(14<=hL)var hO=0;else switch(hL){case 8:var hN=cs,hO=1;break;case 9:var hN=cr,hO=1;break;case 10:var hN=cq,hO=1;break;case 13:var hN=cp,hO=1;break;default:var hO=0;}if(!hO)if(caml_is_printable(hL)){var hP=caml_create_string(1);hP.safeSet(0,hL);var hN=hP;}else{var hQ=caml_create_string(4);hQ.safeSet(0,92);hQ.safeSet(1,48+(hL/100|0)|0);hQ.safeSet(2,48+((hL/10|0)%10|0)|0);hQ.safeSet(3,48+(hL%10|0)|0);var hN=hQ;}}var hM=cQ(cb,cQ(hN,cc));}var gT=gS(gG(gK,gD),hM,gA+1|0),gO=1;break;case 66:case 98:var hS=gA+1|0,hR=gC(gK,gD)?cx:cw,gT=gS(gG(gK,gD),hR,hS),gO=1;break;case 40:case 123:var hT=gC(gK,gD),hU=fi(fQ,gN,gp,gA+1|0);if(123===gN){var hV=eg(hT.getLen()),hZ=function(hX,hW){ej(hV,hW);return hX+1|0;};f6(hT,function(hY,h1,h0){if(hY)ek(hV,b_);else ej(hV,37);return hZ(h1,h0);},hZ);var h2=ei(hV),gT=gS(gG(gK,gD),h2,hU),gO=1;}else{var h3=gG(gK,gD),h6=ep(h4(hT),h3),gT=h8(function(h7){return h5(h6,hU);},h3,hT,gy),gO=1;}break;case 33:cW(h9,go);var gT=h5(gD,gA+1|0),gO=1;break;case 37:var gT=gS(gD,ch,gA+1|0),gO=1;break;case 41:var gT=gS(gD,cg,gA+1|0),gO=1;break;case 44:var gT=gS(gD,cf,gA+1|0),gO=1;break;case 70:var h_=gC(gK,gD);if(0===gF){var h$=caml_format_float(cA,h_),ia=0,ib=h$.getLen();for(;;){if(ib<=ia)var ic=cQ(h$,cz);else{var id=h$.safeGet(ia),ie=48<=id?58<=id?0:1:45===id?1:0;if(ie){var ig=ia+1|0,ia=ig;continue;}var ic=h$;}var ih=ic;break;}}else{var ii=eW(gp,gr,gA,gF);if(70===gN)ii.safeSet(ii.getLen()-1|0,103);var ij=caml_format_float(ii,h_);if(3<=caml_classify_float(h_))var ik=ij;else{var il=0,im=ij.getLen();for(;;){if(im<=il)var io=cQ(ij,ca);else{var ip=ij.safeGet(il)-46|0,iq=ip<0||23<ip?55===ip?1:0:(ip-1|0)<0||21<(ip-1|0)?1:0;if(!iq){var ir=il+1|0,il=ir;continue;}var io=ij;}var ik=io;break;}}var ih=ik;}var gT=gS(gG(gK,gD),ih,gA+1|0),gO=1;break;case 97:var is=gC(gK,gD),it=cW(eq,gv(gK,gD)),iu=gC(0,it),iy=gA+1|0,ix=gG(gK,it);if(iv)fN(iw,go,fN(is,0,iu));else fN(is,go,iu);var gT=h5(ix,iy),gO=1;break;case 116:var iz=gC(gK,gD),iB=gA+1|0,iA=gG(gK,gD);if(iv)fN(iw,go,cW(iz,0));else cW(iz,go);var gT=h5(iA,iB),gO=1;break;default:var gO=0;}if(!gO)var gT=fo(gp,gA,gN);return gT;}},iG=gr+1|0,iD=0;return gL(gp,function(iF,iC){return gI(iF,iE,iD,iC);},iE,iG);}fN(iH,go,gu);var iI=gr+1|0,gr=iI;continue;}}function gS(iL,iJ,iK){fN(iw,go,iJ);return h5(iL,iK);}return h5(iM,0);}var iO=fN(h8,iN,eo(0)),iP=h4(gm);if(iP<0||6<iP){var i2=function(iQ,iW){if(iP<=iQ){var iR=caml_make_vect(iP,0),iU=function(iS,iT){return caml_array_set(iR,(iP-iS|0)-1|0,iT);},iV=0,iX=iW;for(;;){if(iX){var iY=iX[2],iZ=iX[1];if(iY){iU(iV,iZ);var i0=iV+1|0,iV=i0,iX=iY;continue;}iU(iV,iZ);}return fN(iO,gm,iR);}}return function(i1){return i2(iQ+1|0,[0,i1,iW]);};},i3=i2(0,0);}else switch(iP){case 1:var i3=function(i5){var i4=caml_make_vect(1,0);caml_array_set(i4,0,i5);return fN(iO,gm,i4);};break;case 2:var i3=function(i7,i8){var i6=caml_make_vect(2,0);caml_array_set(i6,0,i7);caml_array_set(i6,1,i8);return fN(iO,gm,i6);};break;case 3:var i3=function(i_,i$,ja){var i9=caml_make_vect(3,0);caml_array_set(i9,0,i_);caml_array_set(i9,1,i$);caml_array_set(i9,2,ja);return fN(iO,gm,i9);};break;case 4:var i3=function(jc,jd,je,jf){var jb=caml_make_vect(4,0);caml_array_set(jb,0,jc);caml_array_set(jb,1,jd);caml_array_set(jb,2,je);caml_array_set(jb,3,jf);return fN(iO,gm,jb);};break;case 5:var i3=function(jh,ji,jj,jk,jl){var jg=caml_make_vect(5,0);caml_array_set(jg,0,jh);caml_array_set(jg,1,ji);caml_array_set(jg,2,jj);caml_array_set(jg,3,jk);caml_array_set(jg,4,jl);return fN(iO,gm,jg);};break;case 6:var i3=function(jn,jo,jp,jq,jr,js){var jm=caml_make_vect(6,0);caml_array_set(jm,0,jn);caml_array_set(jm,1,jo);caml_array_set(jm,2,jp);caml_array_set(jm,3,jq);caml_array_set(jm,4,jr);caml_array_set(jm,5,js);return fN(iO,gm,jm);};break;default:var i3=fN(iO,gm,[0]);}return i3;}function jB(jt){return eg(2*jt.getLen()|0);}function jy(jw,ju){var jv=ei(ju);ju[2]=0;return cW(jw,jv);}function jG(jx){var jA=cW(jy,jx);return jD(jC,1,jB,ej,ek,function(jz){return 0;},jA);}function jH(jF){return fN(jG,function(jE){return jE;},jF);}var jI=[0,0];32===dV;var jO=[0,b0];function jN(jJ){return jJ[4]?(jJ[4]=0,jJ[1][2]=jJ[2],jJ[2][1]=jJ[1],0):0;}function jP(jL){var jK=[];caml_update_dummy(jK,[0,jK,jK]);return jK;}function jQ(jM){return jM[2]===jM?1:0;}var jR=[0,bP],jS=[0,0],ks=42;function jW(jT){var jU=jT[1];{if(3===jU[0]){var jV=jU[1],jX=jW(jV);if(jX!==jV)jT[1]=[3,jX];return jX;}return jT;}}function kt(jY){return jW(jY);}function kl(jZ,j3){var j0=jZ,j1=0,ke=jS[1];for(;;){if(typeof j0==="number"){if(j1){var kd=j1[2],kc=j1[1],j0=kc,j1=kd;continue;}}else switch(j0[0]){case 1:var j2=j0[1];if(j1){var j5=j1[2],j4=j1[1];cW(j2,j3);var j0=j4,j1=j5;continue;}cW(j2,j3);break;case 2:var j6=j0[1],j7=[0,j0[2],j1],j0=j6,j1=j7;continue;default:var j8=j0[1][1];if(j8){var j9=j8[1];if(j1){var j$=j1[2],j_=j1[1];cW(j9,j3);var j0=j_,j1=j$;continue;}cW(j9,j3);}else if(j1){var kb=j1[2],ka=j1[1],j0=ka,j1=kb;continue;}}jS[1]=ke;return 0;}}function ku(kf,ki){var kg=jW(kf),kh=kg[1];switch(kh[0]){case 1:if(kh[1][1]===jR)return 0;break;case 2:var kj=[0,ki],kk=kh[1][2];kg[1]=kj;return kl(kk,kj);default:}return cB(bQ);}function kv(km,kp){var kn=jW(km),ko=kn[1];{if(2===ko[0]){var kq=[0,kp],kr=ko[1][2];kn[1]=kq;return kl(kr,kq);}return 0;}}var kw=[0,0],kx=[0,0,0],lY=[0,function(ky){return 0;}];function kF(kz,kA){return typeof kz==="number"?kA:typeof kA==="number"?kz:[2,kz,kA];}function kC(kB){if(typeof kB!=="number")switch(kB[0]){case 2:var kD=kB[1],kE=kC(kB[2]);return kF(kC(kD),kE);case 1:break;default:if(!kB[1][1])return 0;}return kB;}function lv(kG,kI){var kH=kt(kG),kJ=kt(kI),kK=kH[1];{if(2===kK[0]){var kL=kK[1];if(kH===kJ)return 0;var kM=kJ[1];{if(2===kM[0]){var kN=kM[1];kJ[1]=[3,kH];kL[1][1]=[1,kN[1]];var kO=kF(kL[2],kN[2]),kP=kL[3]+kN[3]|0;return ks<kP?(kL[3]=0,kL[2]=kC(kO),0):(kL[3]=kP,kL[2]=kO,0);}kH[1]=kM;return kl(kL[2],kM);}}return cB(bS);}}function lw(kQ,kT){var kR=kt(kQ),kS=kR[1];{if(2===kS[0]){var kU=kS[1][2];kR[1]=kT;return kl(kU,kT);}return cB(bT);}}function lJ(kV){return [0,[0,kV]];}function lk(kW){return [0,[1,kW]];}function lm(kX){return [0,[2,[0,kX,0,0]]];}function lZ(k7){var kY=[],k6=0,k5=0;caml_update_dummy(kY,[0,[2,[0,[0,[0,function(k4){var kZ=jW(kY),k0=kZ[1];if(2===k0[0]){var k1=[1,[0,jR]],k2=k0[1][2];kZ[1]=k1;var k3=kl(k2,k1);}else var k3=0;return k3;}]],k5,k6]]]);return [0,kY,kY];}function lh(k8,k9){var k_=typeof k8[2]==="number"?[1,k9]:[2,[1,k9],k8[2]];k8[2]=k_;return 0;}function l0(k$,lb){var la=kt(k$)[1];switch(la[0]){case 1:if(la[1][1]===jR)return cW(lb,0);break;case 2:var lg=la[1],ld=jS[1];return lh(lg,function(lc){if(1===lc[0]&&lc[1][1]===jR){jS[1]=ld;try {var le=cW(lb,0);}catch(lf){return 0;}return le;}return 0;});default:}return 0;}function l1(li,lr){var lj=kt(li)[1];switch(lj[0]){case 1:return lk(lj[1]);case 2:var ll=lj[1],ln=lm(ll[1]),lp=jS[1];lh(ll,function(lo){switch(lo[0]){case 0:var lq=lo[1];jS[1]=lp;try {var ls=cW(lr,lq),lt=ls;}catch(lu){var lt=lk(lu);}return lv(ln,lt);case 1:return lw(ln,[1,lo[1]]);default:throw [0,d,bV];}});return ln;case 3:throw [0,d,bU];default:return cW(lr,lj[1]);}}function l2(lx,lF){var ly=kt(lx)[1];switch(ly[0]){case 1:var lz=[0,[1,ly[1]]];break;case 2:var lA=ly[1],lB=lm(lA[1]),lD=jS[1];lh(lA,function(lC){switch(lC[0]){case 0:var lE=lC[1];jS[1]=lD;try {var lG=[0,cW(lF,lE)],lH=lG;}catch(lI){var lH=[1,lI];}return lw(lB,lH);case 1:return lw(lB,[1,lC[1]]);default:throw [0,d,bX];}});var lz=lB;break;case 3:throw [0,d,bW];default:var lz=lJ(cW(lF,ly[1]));}return lz;}function l3(lK,lP){try {var lL=cW(lK,0),lM=lL;}catch(lN){var lM=lk(lN);}var lO=kt(lM)[1];switch(lO[0]){case 1:return cW(lP,lO[1]);case 2:var lQ=lO[1],lR=lm(lQ[1]),lT=jS[1];lh(lQ,function(lS){switch(lS[0]){case 0:return lw(lR,lS);case 1:var lU=lS[1];jS[1]=lT;try {var lV=cW(lP,lU),lW=lV;}catch(lX){var lW=lk(lX);}return lv(lR,lW);default:throw [0,d,bZ];}});return lR;case 3:throw [0,d,bY];default:return lM;}}var l4=[0],l5=[0,caml_make_vect(55,0),0],l6=caml_equal(l4,[0])?[0,0]:l4,l7=l6.length-1,l8=0,l9=54;if(!(l9<l8)){var l_=l8;for(;;){caml_array_set(l5[1],l_,l_);var l$=l_+1|0;if(l9!==l_){var l_=l$;continue;}break;}}var ma=[0,b1],mb=0,mc=55,md=caml_greaterequal(mc,l7)?mc:l7,me=54+md|0;if(!(me<mb)){var mf=mb;for(;;){var mg=mf%55|0,mh=ma[1],mi=cQ(mh,cR(caml_array_get(l6,caml_mod(mf,l7))));ma[1]=caml_md5_string(mi,0,mi.getLen());var mj=ma[1];caml_array_set(l5[1],mg,caml_array_get(l5[1],mg)^(((mj.safeGet(0)+(mj.safeGet(1)<<8)|0)+(mj.safeGet(2)<<16)|0)+(mj.safeGet(3)<<24)|0));var mk=mf+1|0;if(me!==mf){var mf=mk;continue;}break;}}l5[2]=0;var mn=[0,function(ml){return 0;}],mm=jP(0),mp=[0,0];function mz(ms){if(jQ(mm))return 0;var mo=jP(0);mo[1][2]=mm[2];mm[2][1]=mo[1];mo[1]=mm[1];mm[1][2]=mo;mm[1]=mm;mm[2]=mm;mp[1]=0;var mq=mo[2];for(;;){if(mq!==mo){if(mq[4])ku(mq[3],0);var mr=mq[2],mq=mr;continue;}return 0;}}function mw(mu,mt){if(mt){var mv=mt[2],my=cW(mu,mt[1]);return l1(my,function(mx){return mw(mu,mv);});}return lJ(0);}var mA=null,mB=undefined;function mI(mC,mD,mE){return mC==mA?cW(mD,0):cW(mE,mC);}function mV(mJ){function mH(mF){return [0,mF];}return mI(mJ,function(mG){return 0;},mH);}function mW(mK){return mK!==mB?1:0;}function mT(mL,mM,mN){return mL===mB?cW(mM,0):cW(mN,mL);}function mX(mO,mP){return mO===mB?cW(mP,0):mO;}function mY(mU){function mS(mQ){return [0,mQ];}return mT(mU,function(mR){return 0;},mS);}var mZ=false,m0=RegExp,m1=Array,m6=true;function m5(m2,m3){return m2[m3];}function m7(m4){return m4;}var m$=Math;function m_(m8){return escape(m8);}function na(m9){return m9 instanceof m1?0:[0,new MlWrappedString(m9.toString())];}jI[1]=[0,na,jI[1]];function nd(nb){return nb;}function ne(nc){return nc;}function no(nf,ng){nf.appendChild(ng);return 0;}function np(nh,ni){nh.removeChild(ni);return 0;}function nq(nk){return ne(caml_js_wrap_callback(function(nj){if(nj){var nl=cW(nk,nj);if(!(nl|0))nj.preventDefault();return nl;}var nm=event,nn=cW(nk,nm);nm.returnValue=nn;return nn;}));}var nr=caml_js_on_ie(0)|0,ns=window;function nE(nt,nu){return nt?cW(nu,nt[1]):0;}function nx(nw,nv){return nw.createElement(nv.toString());}function nA(nz,ny){return nx(nz,ny);}function nF(nB){return nA(nB,bJ);}function nG(nC){return nA(nC,bK);}function nH(nD){return nA(nD,bM);}nd(window.HTMLElement)===mB;function nR(nK){var nI=lZ(0),nJ=nI[1],nL=nI[2],nN=nK*1000,nO=ns.setTimeout(caml_js_wrap_callback(function(nM){return ku(nL,0);}),nN);l0(nJ,function(nP){return ns.clearTimeout(nO);});return nJ;}mn[1]=function(nQ){return 1===nQ?(ns.setTimeout(caml_js_wrap_callback(mz),0),0):0;};function nU(nS){var nT=bz.toString();return new m0(caml_js_from_byte_string(nS),nT);}var nV=new m0(bx.toString(),by.toString()),nX=nU(bw),nW=ns.location;function n0(nY,nZ){return nZ.split(dR(1,nY).toString());}var n1=[0,aP];function n3(n2){throw [0,n1];}var n4=caml_js_from_byte_string(aO),n5=nU(caml_js_to_byte_string(n4.replace(nX,bB.toString())));function ob(n6){return caml_js_to_byte_string(unescape(n6));}function oc(n7,n9){var n8=n7?n7[1]:1;if(n8){var n_=caml_js_to_byte_string(m_(caml_js_from_byte_string(n9)));n5.lastIndex=0;var n$=caml_js_from_byte_string(n_),oa=caml_js_from_byte_string(aQ);return caml_js_to_byte_string(n$.replace(n5,oa.replace(nV,bA.toString())));}return caml_js_to_byte_string(m_(caml_js_from_byte_string(n9)));}var oP=[0,aN];function oj(od){try {var oe=od.getLen();if(0===oe)var of=bv;else{var og=0,oi=47,oh=od.getLen();for(;;){if(oh<=og)throw [0,c];if(od.safeGet(og)!==oi){var om=og+1|0,og=om;continue;}if(0===og)var ok=[0,bu,oj(dS(od,1,oe-1|0))];else{var ol=oj(dS(od,og+1|0,(oe-og|0)-1|0)),ok=[0,dS(od,0,og),ol];}var of=ok;break;}}}catch(on){if(on[1]===c)return [0,od,0];throw on;}return of;}function oQ(or){return dU(aX,dm(function(oo){var op=oo[1],oq=cQ(aY,oc(0,oo[2]));return cQ(oc(0,op),oq);},or));}function oR(os){var ot=n0(38,os),oO=ot.length;function oK(oJ,ou){var ov=ou;for(;;){if(0<=ov){try {var oH=ov-1|0,oI=function(oC){function oE(ow){var oA=ow[2],oz=ow[1];function oy(ox){return ob(mX(ox,n3));}var oB=oy(oA);return [0,oy(oz),oB];}var oD=n0(61,oC);if(2===oD.length){var oF=m5(oD,1),oG=nd([0,m5(oD,0),oF]);}else var oG=mB;return mT(oG,n3,oE);},oL=oK([0,mT(m5(ot,ov),n3,oI),oJ],oH);}catch(oM){if(oM[1]===n1){var oN=ov-1|0,ov=oN;continue;}throw oM;}return oL;}return oJ;}}return oK(0,oO-1|0);}var oS=new m0(caml_js_from_byte_string(aM)),pr=new m0(caml_js_from_byte_string(aL));function pq(oT){switch(oT[0]){case 1:var oU=oT[1],oV=oU[6],oW=oU[5],oX=oU[2],o0=oU[3],oZ=oU[1],oY=caml_string_notequal(oV,bj)?cQ(bi,oc(0,oV)):bh,o1=oW?cQ(bg,oQ(oW)):bf,o3=cQ(o1,oY),o5=cQ(bd,cQ(dU(be,dm(function(o2){return oc(0,o2);},o0)),o3)),o4=443===oX?bb:cQ(bc,cR(oX)),o6=cQ(o4,o5);return cQ(ba,cQ(oc(0,oZ),o6));case 2:var o7=oT[1],o8=o7[4],o9=o7[3],o$=o7[1],o_=caml_string_notequal(o8,a$)?cQ(a_,oc(0,o8)):a9,pa=o9?cQ(a8,oQ(o9)):a7,pc=cQ(pa,o_);return cQ(a5,cQ(dU(a6,dm(function(pb){return oc(0,pb);},o$)),pc));default:var pd=oT[1],pe=pd[6],pf=pd[5],pg=pd[2],pj=pd[3],pi=pd[1],ph=caml_string_notequal(pe,bt)?cQ(bs,oc(0,pe)):br,pk=pf?cQ(bq,oQ(pf)):bp,pm=cQ(pk,ph),po=cQ(bn,cQ(dU(bo,dm(function(pl){return oc(0,pl);},pj)),pm)),pn=80===pg?bl:cQ(bm,cR(pg)),pp=cQ(pn,po);return cQ(bk,cQ(oc(0,pi),pp));}}ob(nW.hostname);try {caml_int_of_string(caml_js_to_byte_string(nW.port));}catch(ps){if(ps[1]!==a)throw ps;}oj(ob(nW.pathname));oR(nW.search);ob(nW.href);var pB=window.FileReader,pA=window.FormData;function pz(pt,pv){if(891486873<=pt[1]){var pu=pt[2];pu[1]=[0,pv,pu[1]];return 0;}var pw=pt[2],px=pv[2],py=pv[1];return 781515420<=px[1]?pw.append(py.toString(),px[2]):pw.append(py.toString(),px[2]);}function pD(pC){return ActiveXObject;}var pG=[0,ab];function pF(pE){return pE.toString();}var pH=ns.document;function pN(pJ,pI){return no(pJ,pH.createTextNode(pF(pI)));}function pO(pK,pM){var pL=pK.firstChild;if(pL!=mA)np(pK,pL);return no(pK,pM);}var pP=pF(k),pQ=[0,i],sU=pF(j);function pW(pR){switch(pR){case 1:return pF(v);case 2:return pF(u);case 3:return pF(t);case 4:return pF(s);case 5:return pF(r);case 6:return pF(q);case 7:return pF(p);case 8:return pF(o);default:return pF(w);}}function p8(pS,pV,pT,pU){caml_array_set(caml_array_get(pS[1],pT),pV,pU);var pX=caml_array_get(caml_array_get(pS[2],pT),pV);return pX.src=pW(pU);}function qc(pZ){var pY=[0,0],p0=pZ[1].length-1-2|0,p1=1;if(!(p0<p1)){var p2=p0;for(;;){var p3=1,p4=caml_array_get(pZ[1],p2).length-1-2|0;if(!(p4<p3)){var p5=p3;for(;;){var p6=6===caml_array_get(caml_array_get(pZ[1],p2+1|0),p5)?1:0,p7=p6?3===caml_array_get(caml_array_get(pZ[1],p2),p5)?1:0:p6,p9=0===caml_array_get(caml_array_get(pZ[1],p2),p5)?3===caml_array_get(caml_array_get(pZ[1],p2-1|0),p5)?(p8(pZ,p5,p2-1|0,0),p8(pZ,p5,p2,3),pY[1]=1,1):0:0;p9;var p_=0===caml_array_get(caml_array_get(pZ[1],p2),p5)?0===caml_array_get(caml_array_get(pZ[1],p2-1|0),p5)?3===caml_array_get(caml_array_get(pZ[1],p2),p5-1|0)?3===caml_array_get(caml_array_get(pZ[1],p2-1|0),p5-1|0)?(p8(pZ,p5-1|0,p2-1|0,0),p8(pZ,p5,p2,3),pY[1]=1,1):0:0:0:0;p_;var p$=0===caml_array_get(caml_array_get(pZ[1],p2),p5)?0===caml_array_get(caml_array_get(pZ[1],p2-1|0),p5)?3===caml_array_get(caml_array_get(pZ[1],p2),p5+1|0)?3===caml_array_get(caml_array_get(pZ[1],p2-1|0),p5+1|0)?(p8(pZ,p5+1|0,p2-1|0,0),p8(pZ,p5,p2,3),pY[1]=1,1):0:0:0:0;p$;if(!p7&&6===caml_array_get(caml_array_get(pZ[1],p2+1|0),p5)&&3===caml_array_get(caml_array_get(pZ[1],p2),p5)){p8(pZ,p5,p2+1|0,8);throw [0,pQ];}var qa=p5+1|0;if(p4!==p5){var p5=qa;continue;}break;}}var qb=p2-1|0;if(p1!==p2){var p2=qb;continue;}break;}}if(pY[1]){var qe=function(qd){return qc(pZ);};return l1(nR(0.05),qe);}return lJ(0);}function q1(qi,q2,qf){var qg=qf[3];function su(ss){var qh=0,qj=qi[1].length-1-1|0;if(!(qj<qh)){var qk=qh;for(;;){var ql=0,qm=caml_array_get(qi[1],qk).length-1-1|0;if(!(qm<ql)){var qn=ql;for(;;){caml_array_get(caml_array_get(qi[2],qk),qn).onmouseover=mA;caml_array_get(caml_array_get(qi[2],qk),qn).onmouseout=mA;caml_array_get(caml_array_get(qi[2],qk),qn).onclick=mA;var qo=qn+1|0;if(qm!==qn){var qn=qo;continue;}break;}}var qp=qk+1|0;if(qj!==qk){var qk=qp;continue;}break;}}function rg(qr,qt){if(!qi[8]){qi[8]=1;var qs=function(qq){qi[8]=0;return lJ(0);};l1(cW(qr,0),qs);}return mZ;}function rf(qw,qu,qy){function qx(qv){qi[9][1]=[0,qu];return lJ(0);}return l1(cW(qw,0),qx);}function rd(qA,qB){var qz=qi[9][1];return qz?(cW(qz[1],0),qi[9][1]=0,cW(qA,0)):cW(qA,0);}function rU(qC,rk,qP,qE,qG,qI){var qD=qC,qF=qE,qH=qG,qJ=qI;for(;;){var qK=qD[2],qL=qD[1],qM=caml_array_get(caml_array_get(qi[1],qK),qL);if(5===qM||!(3<=qM))var qN=0;else{var qO=0,qN=1;}if(!qN)var qO=1;if(qO){var qR=caml_array_get(caml_array_get(qi[2],qK),qL).src,q$=function(qF,qK,qL){return function(qQ){caml_array_get(caml_array_get(qi[2],qK),qL).src=qP;return cW(qF,0);};}(qF,qK,qL),ra=function(qH,qK,qL,qR){return function(qS){caml_array_get(caml_array_get(qi[2],qK),qL).src=qR;return cW(qH,0);};}(qH,qK,qL,qR),rb=function(qJ,qK,qL){return function(qZ){function qY(qX){if(2===caml_array_get(caml_array_get(qi[1],qK),qL))qi[5]=qi[5]-1|0;p8(qi,qL,qK,6);function qW(qV){function qU(qT){p8(qi,qL,qK,0);return lJ(0);}return l1(qc(qi),qU);}return l1(nR(0.05),qW);}return l1(cW(qJ,0),qY);};}(qJ,qK,qL),rc=function(qJ,qK,qL){return function(q_){var q0=qi[3];p8(qi,q0[1],q0[2],0);function q8(q3){return q1(qi,q2,qf);}function q9(q4){return q4[1]===pQ?(qi[6]=1,lJ(0)):lk(q4);}return l1(l3(function(q7){function q6(q5){if(2===caml_array_get(caml_array_get(qi[1],qK),qL))qi[5]=qi[5]-1|0;p8(qi,qL,qK,6);qi[3]=[0,qL,qK];return qc(qi);}return l1(cW(qJ,0),q6);},q9),q8);};}(qJ,qK,qL),re=caml_array_get(caml_array_get(qi[2],qK),qL);re.onmouseover=nq(cW(rg,fN(rf,cW(rd,q$),ra)));var ri=caml_array_get(caml_array_get(qi[2],qK),qL);ri.onmouseout=nq(cW(rg,cW(rd,function(rh){return lJ(0);})));var rj=caml_array_get(caml_array_get(qi[2],qK),qL);rj.onclick=nq(cW(rg,cW(rd,rc)));if(5===caml_array_get(caml_array_get(qi[1],qK),qL))return 0;var rl=cW(rk,[0,qL,qK]),qD=rl,qF=q$,qH=ra,qJ=rb;continue;}return 0;}}function rV(rm,rp,rC,rB){var rn=rm[2],ro=rm[1],rq=cW(rp,rm),rr=rq[2],rs=rq[1],rt=cW(rp,rq),ru=rt[2],rv=rt[1];try {var rw=3===caml_array_get(caml_array_get(qi[1],rr),rs)?1:0,rx=rw?0===caml_array_get(caml_array_get(qi[1],ru),rv)?1:0:rw,ry=rx;}catch(rz){if(rz[1]===b&&!caml_string_notequal(rz[2],_)){var ry=0,rA=1;}else var rA=0;if(!rA)throw rz;}if(ry){var rN=function(rD){caml_array_get(caml_array_get(qi[2],rn),ro).src=rB;caml_array_get(caml_array_get(qi[2],rr),rs).src=rC;return lJ(0);},rO=function(rG){var rE=caml_array_get(caml_array_get(qi[2],rn),ro);rE.src=pF(aa);var rF=caml_array_get(caml_array_get(qi[2],rr),rs);return rF.src=pF($);},rP=function(rM){p8(qi,ro,rn,0);p8(qi,rs,rr,6);qi[3]=rq;p8(qi,rv,ru,3);function rK(rH){return q1(qi,q2,qf);}function rL(rI){return rI[1]===pQ?(qi[6]=1,lJ(0)):lk(rI);}return l1(l3(function(rJ){return qc(qi);},rL),rK);},rQ=caml_array_get(caml_array_get(qi[2],rr),rs);rQ.onmouseover=nq(cW(rg,fN(rf,cW(rd,rN),rO)));var rS=caml_array_get(caml_array_get(qi[2],rr),rs);rS.onmouseout=nq(cW(rg,cW(rd,function(rR){return lJ(0);})));var rT=caml_array_get(caml_array_get(qi[2],rr),rs);return rT.onclick=nq(cW(rg,cW(rd,rP)));}return 0;}if(caml_equal(qi[3],qi[4])){cW(qg,0);ns.alert(pF(Z));}else if(qi[6]){cW(qg,0);ns.alert(pF(Y));}else{if(0===qi[5]){var rW=qi[4],rX=rW[2],rY=rW[1],rZ=caml_array_get(caml_array_get(qi[2],rX),rY);rZ.src=pF(X);caml_array_set(caml_array_get(qi[1],rX),rY,5);}var r6=function(r0){return [0,r0[1]+1|0,r0[2]];},r7=function(r1){return [0,r1[1]-1|0,r1[2]];},r8=function(r2){return [0,r2[1],r2[2]-1|0];},r9=function(r3){return [0,r3[1],r3[2]+1|0];},r_=function(r4){return 0;},r$=function(r5){return lJ(0);},sa=pF(W);rU(r6(qi[3]),r6,sa,r$,r_,r$);var sb=pF(V);rU(r7(qi[3]),r7,sb,r$,r_,r$);var sc=pF(U);rU(r8(qi[3]),r8,sc,r$,r_,r$);var sd=pF(T);rU(r9(qi[3]),r9,sd,r$,r_,r$);var se=pF(S),sf=pF(R);rV(qi[3],r6,sf,se);var sg=pF(Q),sh=pF(P);rV(qi[3],r7,sh,sg);cW(q2,qi[5]);}var si=qi[7];if(si[1])if(jQ(si[2]))si[1]=0;else{var sj=0,sk=si[2];if(jQ(sk))throw [0,jO];var sl=sk[2];jN(sl);var sm=sl[3];if(kw[1]){var so=function(sn){return kv(sm,sj);};kx[1]=kx[1]+1|0;if(1===kx[1]){var sp=[];caml_update_dummy(sp,[0,so,sp]);kx[2]=sp;}else{var sq=kx[2],sr=[0,so,sq[2]];sq[2]=sr;kx[2]=sr;}}else{kw[1]=1;kv(sm,sj);for(;;){if(0!==kx[1]){fN(eh,kx,0);continue;}kw[1]=0;break;}}}return lJ(0);}var st=qi[7];if(st[1]){var sv=lZ(0),sw=sv[1],sx=st[2],sy=[0,sx[1],sx,sv[2],1];sx[1][2]=sy;sx[1]=sy;l0(sw,function(sz){return jN(sy);});var sA=sw;}else{st[1]=1;var sA=lJ(0);}return l1(sA,su);}function wH(sC,sB){return sB?sC.style.cssText=sB[1]:0;}ns.onload=nq(function(xx){var sD=pH.getElementById(pF(z));if(sD==mA)throw [0,d,A];var sE=nG(pH),sF=[0,caml_sys_time(0)],sG=nG(pH);sG.style.cssText=pP;pN(sG,m);var sH=[0,1],sL=function(sO){var sI=caml_sys_time(0)-sF[1];if(!sH[1]){var sJ=sI|0;pO(sG,pH.createTextNode(pF(sK(jH,n,sJ/3600|0,(sJ/60|0)%60|0,sJ%60|0))));}function sN(sM){return sL(0);}return l1(nR(1),sN);};sL(0);var sR=function(sP){sH[1]=1;return 0;},sS=[0,sG,function(sQ){sF[1]=caml_sys_time(0);sH[1]=0;return 0;},sR],vO=sS[2],vN=sS[1],vM=function(tF,sX){var sT=nG(pH);sT.style.cssText=sU;pN(sT,l);no(sD,sT);function s2(sW){function sY(sV){np(sD,sT);return lJ(sV);}return l1(cW(sX,sW),sY);}var s3=0,s4=0,s5=0,s6=0,s7=0,s8=0;function s_(sZ){var s0=sZ[2],s1=sZ[4];if(0!==s0&&200!==s0)return [0,[2,[0,[0,lY],0,0]]];return lJ(s1);}var s9=s8?s8[1]:0,s$=s5?s5[1]:0,ta=s3?s3[1]:function(tb,tc){return 1;};if(s4){var td=s4[1];if(s6){var tf=s6[1];du(function(te){return pz(td,[0,te[1],[0,-976970511,te[2].toString()]]);},tf);}var tg=[0,td];}else if(s6){var th=s6[1],ti=mY(nd(pA)),tj=ti?[0,808620462,new (ti[1])()]:[0,891486873,[0,0]];du(function(tk){return pz(tj,[0,tk[1],[0,-976970511,tk[2].toString()]]);},th);var tg=[0,tj];}else var tg=0;if(tg){var tl=tg[1];if(s7)var tm=[0,aE,s7,126925477];else{if(891486873<=tl[1]){var tn=0,to=0,tp=tl[2][1];for(;;){if(tp){var tq=tp[2],tr=tp[1],ts=781515420<=tr[2][1]?0:1;if(ts){var tt=[0,tr,tn],tn=tt,tp=tq;continue;}var tu=[0,tr,to],to=tu,tp=tq;continue;}var tv=dt(to);dt(tn);if(tv){var tx=function(tw){return cR(m$.random()*1000000000|0);},ty=tx(0),tz=cQ(ag,cQ(tx(0),ty)),tA=[0,aC,[0,cQ(aD,tz)],[0,164354597,tz]];}else var tA=aB;var tB=tA;break;}}else var tB=aA;var tm=tB;}var tC=tm;}else var tC=[0,az,s7,126925477];var tD=tC[3],tE=tC[2],tH=tC[1],tG=caml_js_from_byte_string(tF);function ue(tI){var tJ=m7(tI),tK=caml_js_to_byte_string(mX(m5(tJ,1),n3).toLowerCase());if(caml_string_notequal(tK,aW)&&caml_string_notequal(tK,aV)){if(caml_string_notequal(tK,aU)&&caml_string_notequal(tK,aT)){if(caml_string_notequal(tK,aS)&&caml_string_notequal(tK,aR)){var tM=1,tL=0;}else var tL=1;if(tL){var tN=1,tM=2;}}else var tM=0;switch(tM){case 1:var tO=0;break;case 2:var tO=1;break;default:var tN=0,tO=1;}if(tO){var tP=ob(mX(m5(tJ,5),n3)),tR=function(tQ){return caml_js_from_byte_string(a0);},tT=ob(mX(m5(tJ,9),tR)),tU=function(tS){return caml_js_from_byte_string(a1);},tV=oR(mX(m5(tJ,7),tU)),tX=oj(tP),tY=function(tW){return caml_js_from_byte_string(a2);},tZ=caml_js_to_byte_string(mX(m5(tJ,4),tY)),t0=caml_string_notequal(tZ,aZ)?caml_int_of_string(tZ):tN?443:80,t1=[0,ob(mX(m5(tJ,2),n3)),t0,tX,tP,tV,tT],t2=tN?[1,t1]:[0,t1];return [0,t2];}}throw [0,oP];}function uf(ud){function ub(t3){var t4=m7(t3),t5=ob(mX(m5(t4,2),n3));function t7(t6){return caml_js_from_byte_string(a3);}var t9=caml_js_to_byte_string(mX(m5(t4,6),t7));function t_(t8){return caml_js_from_byte_string(a4);}var t$=oR(mX(m5(t4,4),t_));return [0,[2,[0,oj(t5),t5,t$,t9]]];}function uc(ua){return 0;}return mI(pr.exec(tG),uc,ub);}var ug=mI(oS.exec(tG),uf,ue);if(ug){var uh=ug[1];switch(uh[0]){case 0:var ui=uh[1],uj=ui.slice(),uk=ui[5];uj[5]=0;var ul=[0,pq([0,uj]),uk],um=1;break;case 1:var un=uh[1],uo=un.slice(),up=un[5];uo[5]=0;var ul=[0,pq([1,uo]),up],um=1;break;default:var um=0;}}else var um=0;if(!um)var ul=[0,tF,0];var uq=ul[1],ur=cJ(ul[2],s$),us=ur?cQ(uq,cQ(ay,oQ(ur))):uq,ut=lZ(0),uu=ut[2],uv=ut[1];try {var uw=new XMLHttpRequest(),ux=uw;}catch(vL){try {var uy=pD(0),uz=new uy(af.toString()),ux=uz;}catch(uG){try {var uA=pD(0),uB=new uA(ae.toString()),ux=uB;}catch(uF){try {var uC=pD(0),uD=new uC(ad.toString());}catch(uE){throw [0,d,ac];}var ux=uD;}}}ux.open(tH.toString(),us.toString(),m6);if(tE)ux.setRequestHeader(ax.toString(),tE[1].toString());du(function(uH){return ux.setRequestHeader(uH[1].toString(),uH[2].toString());},s9);function uN(uL){function uK(uI){return [0,new MlWrappedString(uI)];}function uM(uJ){return 0;}return mI(ux.getResponseHeader(caml_js_from_byte_string(uL)),uM,uK);}var uO=[0,0];function uX(uW){if(uO[1]||fN(ta,ux.status,uN))var uP=0;else{var uR=[0,pG,[0,ux.status,uN]],uQ=jW(uu),uS=uQ[1];switch(uS[0]){case 1:var uT=uS[1][1]===jR?1:0;break;case 2:var uU=[1,uR],uV=uS[1][2];uQ[1]=uU;kl(uV,uU);var uT=1;break;default:var uT=0;}if(!uT)cB(bR);ux.abort();var uP=1;}uP;uO[1]=1;return 0;}ux.onreadystatechange=caml_js_wrap_callback(function(u2){switch(ux.readyState){case 2:if(!nr)return uX(0);break;case 3:if(nr)return uX(0);break;case 4:uX(0);var u1=function(u0){var uY=mV(ux.responseXML);if(uY){var uZ=uY[1];return ne(uZ.documentElement)===mA?0:[0,uZ];}return 0;};return ku(uu,[0,us,ux.status,uN,new MlWrappedString(ux.responseText),u1]);default:}return 0;});if(tg){var u3=tg[1];if(891486873<=u3[1]){var u4=u3[2];if(typeof tD==="number"){var u_=u4[1];ux.send(ne(dU(au,dm(function(u5){var u6=u5[2],u7=u5[1];if(781515420<=u6[1]){var u8=cQ(aw,oc(0,new MlWrappedString(u6[2].name)));return cQ(oc(0,u7),u8);}var u9=cQ(av,oc(0,new MlWrappedString(u6[2])));return cQ(oc(0,u7),u9);},u_)).toString()));}else{var u$=tD[2],vc=function(va){var vb=ne(va.join(aF.toString()));return mW(ux.sendAsBinary)?ux.sendAsBinary(vb):ux.send(vb);},ve=u4[1],vd=new m1(),vJ=function(vf){vd.push(cQ(ah,cQ(u$,ai)).toString());return vd;};l2(l2(mw(function(vg){vd.push(cQ(am,cQ(u$,an)).toString());var vh=vg[2],vi=vg[1];if(781515420<=vh[1]){var vj=vh[2],vq=-1041425454,vr=function(vp){var vm=at.toString(),vl=as.toString(),vk=mY(vj.name);if(vk)var vn=vk[1];else{var vo=mY(vj.fileName),vn=vo?vo[1]:h(aG);}vd.push(cQ(aq,cQ(vi,ar)).toString(),vn,vl,vm);vd.push(ao.toString(),vp,ap.toString());return lJ(0);},vs=mY(nd(pB));if(vs){var vt=new (vs[1])(),vu=lZ(0),vv=vu[1],vz=vu[2];vt.onloadend=nq(function(vA){if(2===vt.readyState){var vw=vt.result,vx=caml_equal(typeof vw,aH.toString())?ne(vw):mA,vy=mV(vx);if(!vy)throw [0,d,aI];ku(vz,vy[1]);}return mZ;});l0(vv,function(vB){return vt.abort();});if(typeof vq==="number")if(-550809787===vq)vt.readAsDataURL(vj);else if(936573133<=vq)vt.readAsText(vj);else vt.readAsBinaryString(vj);else vt.readAsText(vj,vq[2]);var vC=vv;}else{var vE=function(vD){return h(aK);};if(typeof vq==="number")var vF=-550809787===vq?mW(vj.getAsDataURL)?vj.getAsDataURL():vE(0):936573133<=vq?mW(vj.getAsText)?vj.getAsText(aJ.toString()):vE(0):mW(vj.getAsBinary)?vj.getAsBinary():vE(0);else{var vG=vq[2],vF=mW(vj.getAsText)?vj.getAsText(vG):vE(0);}var vC=lJ(vF);}return l1(vC,vr);}var vI=vh[2],vH=al.toString();vd.push(cQ(aj,cQ(vi,ak)).toString(),vI,vH);return lJ(0);},ve),vJ),vc);}}else ux.send(u3[2]);}else ux.send(mA);l0(uv,function(vK){return ux.abort();});return l1(l1(uv,s_),s2);},vP=nG(pH);vP.style.cssText=pP;pN(vP,y);var w7=function(vQ){return pO(vP,pH.createTextNode(cR(vQ).toString()));},xw=function(v8){var vR=sD.style;vR.cssText=pF(G);var vS=nA(pH,bL);pN(vS,F);no(sD,vS);var vT=nG(pH);pN(vT,E);no(vT,vN);pN(vT,D);no(vT,vP);pN(vT,C);var vU=0,vV=0;if(0===vV&&0===vU){var vW=nx(pH,e),vX=1;}else var vX=0;if(!vX)if(nr){var vY=new m1();vY.push(bE.toString(),e.toString());nE(vV,function(vZ){vY.push(bF.toString(),caml_js_html_escape(vZ),bG.toString());return 0;});nE(vU,function(v0){vY.push(bH.toString(),caml_js_html_escape(v0),bI.toString());return 0;});vY.push(bD.toString());var vW=pH.createElement(vY.join(bC.toString()));}else{var v1=nx(pH,e);nE(vV,function(v2){return v1.type=v2;});nE(vU,function(v3){return v1.name=v3;});var vW=v1;}var v4=nF(pH);pN(v4,B);no(vW,v4);du(function(v5){var v7=v5[2],v6=nF(pH);pN(v6,v7);return no(vW,v6);},v8);vW.onchange=nq(function(w_){var v9=vW.selectedIndex-1|0;if(0<=v9){var v_=0,v$=v8;for(;;){if(v$){var wb=v$[2],wa=v_+1|0,v_=wa,v$=wb;continue;}if(v9<v_){if(0<=v9){var wc=v8,wd=v9;for(;;){if(wc){var wg=wc[2],we=wc[1];if(0!==wd){var wh=wd-1|0,wc=wg,wd=wh;continue;}var wf=we;}else var wf=h(cu);var wi=wf;break;}}else var wi=cB(ct);var w8=wi[1];vM(w8,function(wm){var wj=[0,0],wk=[0,0],wl=0,wn=wm.getLen()-1|0;if(!(wn<wl)){var wo=wl;for(;;){var wp=wm.safeGet(wo);if(47<=wp)if(83<=wp)if(89<=wp)var wq=0;else{switch(wp-83|0){case 0:wk[1]=[0,6,wk[1]];var wr=1;break;case 4:wk[1]=[0,6,wk[1]];var wr=1;break;case 5:wk[1]=[0,3,wk[1]];var wr=1;break;default:var wq=0,wr=0;}if(wr)var wq=1;}else var wq=69===wp?(wk[1]=[0,4,wk[1]],1):0;else if(10===wp){var ws=wj[1];wj[1]=[0,dt(wk[1]),ws];wk[1]=0;var wq=1;}else if(32<=wp){switch(wp-32|0){case 0:wk[1]=[0,0,wk[1]];var wt=1;break;case 3:wk[1]=[0,7,wk[1]];var wt=1;break;case 11:wk[1]=[0,2,wk[1]];var wt=1;break;case 14:wk[1]=[0,1,wk[1]];var wt=1;break;default:var wq=0,wt=0;}if(wt)var wq=1;}else var wq=0;if(!wq)h(J);var wu=wo+1|0;if(wn!==wo){var wo=wu;continue;}break;}}var wv=dd(dm(dd,dt(wj[1]))),wy=dc(cW(dc,function(wx){var ww=nA(pH,bN);ww.src=pW(wx);return ww;}),wv),wz=[0,0],wA=[0,0],wB=[0,0],wC=[0,0],wD=[0,0],wE=pF(I),wG=[0,pF(H)],wF=nA(pH,bO);wH(wF,[0,wE]);var wI=0,wJ=wy.length-1-1|0,wM=0;if(!(wJ<wI)){var wK=wI;for(;;){var wL=wF.insertRow(-1);wH(wL,wM);var wN=0,wO=caml_array_get(wy,wK).length-1-1|0;if(!(wO<wN)){var wP=wN;for(;;){var wQ=wL.insertCell(-1);wH(wQ,wG);var wR=caml_array_get(caml_array_get(wy,wK),wP);switch(caml_array_get(caml_array_get(wv,wK),wP)){case 2:wD[1]+=1;break;case 4:wB[1]=wP;wC[1]=wK;break;case 6:wz[1]=wP;wA[1]=wK;break;default:}no(wQ,wR);no(wL,wQ);var wS=wP+1|0;if(wO!==wP){var wP=wS;continue;}break;}}no(wF,wL);var wT=wK+1|0;if(wJ!==wK){var wK=wT;continue;}break;}}pO(sE,wF);function w5(w4){var wU=caml_sys_time(0);function wY(w1){var wV=caml_sys_time(0);if(1<=wV-wU){var wW=wF.style;wW.opacity=nd(pF(K));return lJ(0);}function w0(wZ){var wX=wF.style;wX.opacity=nd(pF(fN(jH,L,wV-wU)));return wY(0);}return l1(nR(0.05),w0);}function w3(w2){cW(vO,0);return lJ(0);}return l1(wY(0),w3);}var w6=[0,0,jP(0)];return l1(q1([0,wv,wy,[0,wz[1],wA[1]],[0,wB[1],wC[1]],wD[1],0,w6,0,[0,0]],w7,sS),w5);});var w9=1;}else var w9=0;break;}}else var w9=0;w9;return mZ;});no(vT,vW);no(vT,nH(pH));no(vT,nH(pH));no(vT,sE);no(sD,vT);return lJ(0);};l1(vM(x,function(w$){function xj(xb){var xa=w$.getLen(),xc=xb;for(;;){if(xa<=xc)var xd=h(N);else{if(34!==w$.safeGet(xc)){var xi=xc+1|0,xc=xi;continue;}var xe=xc+1|0,xf=xc+2|0;for(;;){if(xa<=xe)var xg=h(M);else{if(34!==w$.safeGet(xf)){var xh=xf+1|0,xf=xh;continue;}var xg=[0,dS(w$,xe,xf-xe|0),xf+1|0];}var xd=xg;break;}}return xd;}}var xk=0,xl=0;for(;;){try {var xm=xj(xk),xo=xm[1],xn=xj(xm[2]),xp=[0,[0,[0,xo,xn[1]],xn[2]]],xq=xp;}catch(xr){if(xr[1]===a&&!caml_string_notequal(xr[2],O)){var xq=0,xs=1;}else var xs=0;if(!xs)throw xr;}if(xq){var xt=xq[1],xu=xt[2],xv=[0,xt[1],xl],xk=xu,xl=xv;continue;}return lJ(dt(xl));}}),xw);return mZ;});cS(0);return;}());
