// This program was compiled from OCaml by js_of_ocaml 1.0
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1)
      for (var i = 0; i < l; i++) a2 [i2 + i] = a1 [i1 + i];
    else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (!this.len) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_equal (x, y) { return +(caml_compare_val(x,y,false) == 0); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_greaterequal (x, y) { return +(caml_compare(x,y,false) >= 0); }
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function MlStringFromArray (a) {
  var len = a.length; this.array = a; this.len = this.last = len;
}
MlStringFromArray.prototype = new MlString ();
var caml_md5_string =
function () {
  function add (x, y) { return (x + y) | 0; }
  function xx(q,a,b,x,s,t) {
    a = add(add(a, q), add(x, t));
    return add((a << s) | (a >>> (32 - s)), b);
  }
  function ff(a,b,c,d,x,s,t) {
    return xx((b & c) | ((~b) & d), a, b, x, s, t);
  }
  function gg(a,b,c,d,x,s,t) {
    return xx((b & d) | (c & (~d)), a, b, x, s, t);
  }
  function hh(a,b,c,d,x,s,t) { return xx(b ^ c ^ d, a, b, x, s, t); }
  function ii(a,b,c,d,x,s,t) { return xx(c ^ (b | (~d)), a, b, x, s, t); }
  function md5(buffer, length) {
    var i = length;
    buffer[i >> 2] |= 0x80 << (8 * (i & 3));
    for (i = (i & ~0x3) + 4;(i & 0x3F) < 56 ;i += 4)
      buffer[i >> 2] = 0;
    buffer[i >> 2] = length << 3;
    i += 4;
    buffer[i >> 2] = (length >> 29) & 0x1FFFFFFF;
    var w = [0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476];
    for(i = 0; i < buffer.length; i += 16) {
      var a = w[0], b = w[1], c = w[2], d = w[3];
      a = ff(a, b, c, d, buffer[i+ 0], 7, 0xD76AA478);
      d = ff(d, a, b, c, buffer[i+ 1], 12, 0xE8C7B756);
      c = ff(c, d, a, b, buffer[i+ 2], 17, 0x242070DB);
      b = ff(b, c, d, a, buffer[i+ 3], 22, 0xC1BDCEEE);
      a = ff(a, b, c, d, buffer[i+ 4], 7, 0xF57C0FAF);
      d = ff(d, a, b, c, buffer[i+ 5], 12, 0x4787C62A);
      c = ff(c, d, a, b, buffer[i+ 6], 17, 0xA8304613);
      b = ff(b, c, d, a, buffer[i+ 7], 22, 0xFD469501);
      a = ff(a, b, c, d, buffer[i+ 8], 7, 0x698098D8);
      d = ff(d, a, b, c, buffer[i+ 9], 12, 0x8B44F7AF);
      c = ff(c, d, a, b, buffer[i+10], 17, 0xFFFF5BB1);
      b = ff(b, c, d, a, buffer[i+11], 22, 0x895CD7BE);
      a = ff(a, b, c, d, buffer[i+12], 7, 0x6B901122);
      d = ff(d, a, b, c, buffer[i+13], 12, 0xFD987193);
      c = ff(c, d, a, b, buffer[i+14], 17, 0xA679438E);
      b = ff(b, c, d, a, buffer[i+15], 22, 0x49B40821);
      a = gg(a, b, c, d, buffer[i+ 1], 5, 0xF61E2562);
      d = gg(d, a, b, c, buffer[i+ 6], 9, 0xC040B340);
      c = gg(c, d, a, b, buffer[i+11], 14, 0x265E5A51);
      b = gg(b, c, d, a, buffer[i+ 0], 20, 0xE9B6C7AA);
      a = gg(a, b, c, d, buffer[i+ 5], 5, 0xD62F105D);
      d = gg(d, a, b, c, buffer[i+10], 9, 0x02441453);
      c = gg(c, d, a, b, buffer[i+15], 14, 0xD8A1E681);
      b = gg(b, c, d, a, buffer[i+ 4], 20, 0xE7D3FBC8);
      a = gg(a, b, c, d, buffer[i+ 9], 5, 0x21E1CDE6);
      d = gg(d, a, b, c, buffer[i+14], 9, 0xC33707D6);
      c = gg(c, d, a, b, buffer[i+ 3], 14, 0xF4D50D87);
      b = gg(b, c, d, a, buffer[i+ 8], 20, 0x455A14ED);
      a = gg(a, b, c, d, buffer[i+13], 5, 0xA9E3E905);
      d = gg(d, a, b, c, buffer[i+ 2], 9, 0xFCEFA3F8);
      c = gg(c, d, a, b, buffer[i+ 7], 14, 0x676F02D9);
      b = gg(b, c, d, a, buffer[i+12], 20, 0x8D2A4C8A);
      a = hh(a, b, c, d, buffer[i+ 5], 4, 0xFFFA3942);
      d = hh(d, a, b, c, buffer[i+ 8], 11, 0x8771F681);
      c = hh(c, d, a, b, buffer[i+11], 16, 0x6D9D6122);
      b = hh(b, c, d, a, buffer[i+14], 23, 0xFDE5380C);
      a = hh(a, b, c, d, buffer[i+ 1], 4, 0xA4BEEA44);
      d = hh(d, a, b, c, buffer[i+ 4], 11, 0x4BDECFA9);
      c = hh(c, d, a, b, buffer[i+ 7], 16, 0xF6BB4B60);
      b = hh(b, c, d, a, buffer[i+10], 23, 0xBEBFBC70);
      a = hh(a, b, c, d, buffer[i+13], 4, 0x289B7EC6);
      d = hh(d, a, b, c, buffer[i+ 0], 11, 0xEAA127FA);
      c = hh(c, d, a, b, buffer[i+ 3], 16, 0xD4EF3085);
      b = hh(b, c, d, a, buffer[i+ 6], 23, 0x04881D05);
      a = hh(a, b, c, d, buffer[i+ 9], 4, 0xD9D4D039);
      d = hh(d, a, b, c, buffer[i+12], 11, 0xE6DB99E5);
      c = hh(c, d, a, b, buffer[i+15], 16, 0x1FA27CF8);
      b = hh(b, c, d, a, buffer[i+ 2], 23, 0xC4AC5665);
      a = ii(a, b, c, d, buffer[i+ 0], 6, 0xF4292244);
      d = ii(d, a, b, c, buffer[i+ 7], 10, 0x432AFF97);
      c = ii(c, d, a, b, buffer[i+14], 15, 0xAB9423A7);
      b = ii(b, c, d, a, buffer[i+ 5], 21, 0xFC93A039);
      a = ii(a, b, c, d, buffer[i+12], 6, 0x655B59C3);
      d = ii(d, a, b, c, buffer[i+ 3], 10, 0x8F0CCC92);
      c = ii(c, d, a, b, buffer[i+10], 15, 0xFFEFF47D);
      b = ii(b, c, d, a, buffer[i+ 1], 21, 0x85845DD1);
      a = ii(a, b, c, d, buffer[i+ 8], 6, 0x6FA87E4F);
      d = ii(d, a, b, c, buffer[i+15], 10, 0xFE2CE6E0);
      c = ii(c, d, a, b, buffer[i+ 6], 15, 0xA3014314);
      b = ii(b, c, d, a, buffer[i+13], 21, 0x4E0811A1);
      a = ii(a, b, c, d, buffer[i+ 4], 6, 0xF7537E82);
      d = ii(d, a, b, c, buffer[i+11], 10, 0xBD3AF235);
      c = ii(c, d, a, b, buffer[i+ 2], 15, 0x2AD7D2BB);
      b = ii(b, c, d, a, buffer[i+ 9], 21, 0xEB86D391);
      w[0] = add(a, w[0]);
      w[1] = add(b, w[1]);
      w[2] = add(c, w[2]);
      w[3] = add(d, w[3]);
    }
    var t = [];
    for (var i = 0; i < 4; i++)
      for (var j = 0; j < 4; j++)
        t[i * 4 + j] = (w[i] >> (8 * j)) & 0xFF;
    return t;
  }
  return function (s, ofs, len) {
    var buf = [];
    if (s.array) {
      var a = s.array;
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] = a[j] | (a[j+1] << 8) | (a[j+2] << 16) | (a[j+3] << 24);
      }
      for (; i < len; i++) buf[i>>2] |= a[i + ofs] << (8 * (i & 3));
    } else {
      var b = s.getFullBytes();
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] =
          b.charCodeAt(j) | (b.charCodeAt(j+1) << 8) |
          (b.charCodeAt(j+2) << 16) | (b.charCodeAt(j+3) << 24);
      }
      for (; i < len; i++) buf[i>>2] |= b.charCodeAt(i + ofs) << (8 * (i & 3));
    }
    return new MlStringFromArray(md5(buf, len));
  }
} ();
function caml_ml_out_channels_list () { return 0; }
function caml_raise_constant (tag) { throw [0, tag]; }
var caml_global_data = [0];
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_sys_get_config () {
  return [0, new MlWrappedString("Unix"), 32];
}
function caml_sys_random_seed () {
  return new Date()^0xffffffff*Math.random();
}
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function(){function F(d0,d1){return d0.length==1?d0(d1):caml_call_gen(d0,[d1]);}var a=[0,new MlString("Invalid_argument")],b=[0,new MlString("Assert_failure")];caml_register_global(5,[0,new MlString("Division_by_zero")]);caml_register_global(3,a);caml_register_global(2,[0,new MlString("Failure")]);var x=new MlString("%d"),w=new MlString("Pervasives.do_at_exit"),v=new MlString("Random.int"),u=new MlString("x"),t=[0,-85831125,-577944012,364182224,414272206,318284740,-83334073,383018966,-803368505,840823159,-1049181805,536292337,-561475319,189156120,-343492228,-929965496,51606627,-933575263,366354223,-70331559,-373178062,-91851154,913149062,526082594,-52316769,784300257,-405988474,-443597373,-124092012,-1025194932,-658227331,258888527,511570777,-983757954,283659902,308386020,-831053109,-591471064,-208553628,-46077654,-866544835,193777847,-454033636,671350186,149669678,-816697806,-986083620,558145612,-890291011,-1045608679,-172409642,710253903,-563095704,-421363914,409934019,801085050],s=[0,new MlString("src/core/lwt.ml"),440,20],r=[0,new MlString("src/core/lwt.ml"),443,8],q=new MlString("Lwt.fast_connect"),p=new MlString("Lwt.connect"),o=new MlString("Lwt.wakeup"),n=new MlString("Lwt.Canceled"),m=new MlString("canvas"),l=new MlString("2d"),k=new MlString("Dom_html.Canvas_not_available"),j=new MlString("copy"),i=new MlString("lighter"),h=new MlString("source-over"),g=new MlString("#a8a8f6"),f=new MlString("#d9d9d9"),e=new MlString("#767676");function d(c){throw [0,a,c];}function C(B){var y=caml_ml_out_channels_list(0);for(;;){if(y){var z=y[2];try {}catch(A){}var y=z;continue;}return 0;}}caml_register_named_value(w,C);function L(D,E){if(0===D)return [0];var G=caml_make_vect(D,F(E,0)),H=1,I=D-1|0;if(!(I<H)){var J=H;for(;;){G[J+1]=F(E,J);var K=J+1|0;if(I!==J){var J=K;continue;}break;}}return G;}var M=[0,0],ai=caml_sys_get_config(0)[2];function ah(T,N){var O=caml_equal(N,[0])?[0,0]:N,P=O.length-1,Q=0,R=54;if(!(R<Q)){var S=Q;for(;;){caml_array_set(T[1],S,S);var U=S+1|0;if(R!==S){var S=U;continue;}break;}}var V=[0,u],W=0,X=55,Y=caml_greaterequal(X,P)?X:P,Z=54+Y|0;if(!(Z<W)){var _=W;for(;;){var $=_%55|0,aa=V[1],ab=caml_format_int(x,caml_array_get(O,caml_mod(_,P))),ac=aa.getLen(),ad=ab.getLen(),ae=caml_create_string(ac+ad|0);caml_blit_string(aa,0,ae,0,ac);caml_blit_string(ab,0,ae,ac,ad);V[1]=caml_md5_string(ae,0,ae.getLen());var af=V[1];caml_array_set(T[1],$,caml_array_get(T[1],$)^(((af.safeGet(0)+(af.safeGet(1)<<8)|0)+(af.safeGet(2)<<16)|0)+(af.safeGet(3)<<24)|0));var ag=_+1|0;if(Z!==_){var _=ag;continue;}break;}}T[2]=0;return 0;}32===ai;var aj=[0,t.slice(),0];function aq(ak){if(1073741823<ak||!(0<ak))var al=0;else for(;;){aj[2]=(aj[2]+1|0)%55|0;var am=caml_array_get(aj[1],(aj[2]+24|0)%55|0)+(caml_array_get(aj[1],aj[2])^caml_array_get(aj[1],aj[2])>>>25&31)|0;caml_array_set(aj[1],aj[2],am);var an=am&1073741823,ao=caml_mod(an,ak);if(((1073741823-ak|0)+1|0)<(an-ao|0))continue;var ap=ao,al=1;break;}if(!al)var ap=d(v);return ap;}function at(as){var ar=[];caml_update_dummy(ar,[0,ar,ar]);return ar;}var au=[0,n],av=[0,0],ba=42;function az(aw){var ax=aw[1];{if(3===ax[0]){var ay=ax[1],aA=az(ay);if(aA!==ay)aw[1]=[3,aA];return aA;}return aw;}}function bb(aB){return az(aB);}function a0(aC,aG){var aD=aC,aE=0,aT=av[1];for(;;){if(typeof aD==="number"){if(aE){var aS=aE[2],aR=aE[1],aD=aR,aE=aS;continue;}}else switch(aD[0]){case 1:var aF=aD[1];if(aE){var aI=aE[2],aH=aE[1];F(aF,aG);var aD=aH,aE=aI;continue;}F(aF,aG);break;case 2:var aJ=aD[1],aK=[0,aD[2],aE],aD=aJ,aE=aK;continue;default:var aL=aD[1][1];if(aL){var aM=aL[1];if(aE){var aO=aE[2],aN=aE[1];F(aM,aG);var aD=aN,aE=aO;continue;}F(aM,aG);}else if(aE){var aQ=aE[2],aP=aE[1],aD=aP,aE=aQ;continue;}}av[1]=aT;return 0;}}function bc(aU,aX){var aV=az(aU),aW=aV[1];switch(aW[0]){case 1:if(aW[1][1]===au)return 0;break;case 2:var aY=[0,aX],aZ=aW[1][2];aV[1]=aY;return a0(aZ,aY);default:}return d(o);}function a7(a1,a2){return typeof a1==="number"?a2:typeof a2==="number"?a1:[2,a1,a2];}function a4(a3){if(typeof a3!=="number")switch(a3[0]){case 2:var a5=a3[1],a6=a4(a3[2]);return a7(a4(a5),a6);case 1:break;default:if(!a3[1][1])return 0;}return a3;}function bd(a8){return [0,[1,a8]];}function be(a9,a_){var a$=typeof a9[2]==="number"?[1,a_]:[2,[1,a_],a9[2]];a9[2]=a$;return 0;}ah([0,caml_make_vect(55,0),0],[0]);var bh=[0,function(bf){return 0;}],bg=at(0),bj=[0,0];function bs(bm){if(bg[2]===bg)return 0;var bi=at(0);bi[1][2]=bg[2];bg[2][1]=bi[1];bi[1]=bg[1];bg[1][2]=bi;bg[1]=bg;bg[2]=bg;bj[1]=0;var bk=bi[2];for(;;){if(bk!==bi){if(bk[4])bc(bk[3],0);var bl=bk[2],bk=bl;continue;}return 0;}}var br=null,bq=undefined,bp=false,bo=Array;function bt(bn){return bn instanceof bo?0:[0,new MlWrappedString(bn.toString())];}M[1]=[0,bt,M[1]];var bu=l.toString(),bv=window,bw=[0,k];window.HTMLElement===bq;bh[1]=function(bx){return 1===bx?(bv.setTimeout(caml_js_wrap_callback(bs),0),0):0;};var by=12,bz=20,bA=Math.floor(bz*Math.sqrt(3)/2+0.5);ah(aj,[0,caml_sys_random_seed(0)]);function bM(bL,bB,bE,bG){var bC=bB<0?1:0;if(bC)var bD=bC;else{var bF=bE<0?1:0;if(bF)var bD=bF;else{var bH=bG<0?1:0;if(bH)var bD=bH;else{var bI=bB<by?1:0;if(bI){var bJ=bE<by?1:0;if(bJ){var bK=bG<by?1:0,bD=bK?caml_array_get(caml_array_get(caml_array_get(bL,bB),bE),bG):bK;}else var bD=bJ;}else var bD=bI;}}}return bD;}var bT=g.toString(),bZ=f.toString(),bW=e.toString();function b_(bQ,bN,bP,bO,bR){bQ.save();bQ.translate((((bN-bO|0)+by|0)-1|0)*bA,((by-1|0)-bP|0)*bz+(bN+bO|0)*bz/2);F(bR,bQ);return bQ.restore();}function cD(bS){bS.fillStyle=bT;bS.beginPath();bS.moveTo(bA,0);bS.lineTo(2*bA,bz/2);bS.lineTo(bA,bz);bS.lineTo(0,bz/2);return bS.fill();}function cI(bU){bU.beginPath();bU.moveTo(0,bz/2);bU.lineTo(bA,0);bU.lineTo(2*bA,bz/2);return bU.stroke();}function cC(bV){bV.fillStyle=bW;bV.beginPath();bV.moveTo(bA,bz);bV.lineTo(bA,2*bz);bV.lineTo(2*bA,1.5*bz);bV.lineTo(2*bA,bz/2);return bV.fill();}function cH(bX){bX.beginPath();bX.moveTo(bA,2*bz);bX.lineTo(bA,bz);bX.lineTo(2*bA,bz/2);return bX.stroke();}function cB(bY){bY.fillStyle=bZ;bY.beginPath();bY.moveTo(bA,bz);bY.lineTo(bA,2*bz);bY.lineTo(0,1.5*bz);bY.lineTo(0,bz/2);return bY.fill();}function cG(b0){b0.beginPath();b0.moveTo(bA,bz);b0.lineTo(0,bz/2);b0.lineTo(0,1.5*bz);return b0.stroke();}function cE(ca,b9,b1){var b2=0,b3=by-1|0,ce=b1[3],cd=b1[2],b$=b1[1];if(!(b3<b2)){var b4=b2;for(;;){var b5=[0,by-1|0],b6=0,b7=by-1|0;if(!(b7<b6)){var b8=b6;b:for(;;){for(;;){if(0<=b5[1]&&!caml_array_get(caml_array_get(caml_array_get(b9,b4),b5[1]),b8)){b5[1]+=-1;continue;}b_(ca,b4,b5[1],b8,b$);var cb=b8+1|0;if(b7!==b8){var b8=cb;continue b;}break;}break;}}var cc=b4+1|0;if(b3!==b4){var b4=cc;continue;}break;}}var cf=0,cg=by-1|0;if(!(cg<cf)){var ch=cf;for(;;){var ci=[0,by-1|0],cj=0,ck=by-1|0;if(!(ck<cj)){var cl=cj;b:for(;;){for(;;){if(0<=ci[1]&&!caml_array_get(caml_array_get(caml_array_get(b9,ci[1]),ch),cl)){ci[1]+=-1;continue;}b_(ca,ci[1],ch,cl,cd);var cm=cl+1|0;if(ck!==cl){var cl=cm;continue b;}break;}break;}}var cn=ch+1|0;if(cg!==ch){var ch=cn;continue;}break;}}var co=0,cp=by-1|0;if(!(cp<co)){var cq=co;for(;;){var cr=[0,by-1|0],cs=0,ct=by-1|0;if(!(ct<cs)){var cu=cs;b:for(;;){for(;;){if(0<=cr[1]&&!caml_array_get(caml_array_get(caml_array_get(b9,cq),cu),cr[1])){cr[1]+=-1;continue;}b_(ca,cq,cu,cr[1],ce);var cv=cu+1|0;if(ct!==cu){var cu=cv;continue b;}break;}break;}}var cw=cq+1|0;if(cp!==cq){var cq=cw;continue;}break;}}return 0;}function dM(cy){var cx=bv.document.createElement(m.toString());if(1-(cx.getContext==br?1:0)){cx.width=caml_mul(by*2|0,bA|0)+1|0;cx.height=caml_mul(by*2|0,bz|0)+1|0;return cx;}throw [0,bw];}function cX(cJ,cz,cF){var cA=cz.getContext(bu);cA.setTransform(1,0,0,1,0,0);cA.clearRect(0,0,cz.width,cz.height);cA.setTransform(1,0,0,1,0.5,0.5);cA.globalCompositeOperation=i.toString();cE(cA,cF,[0,cD,cC,cB]);cA.globalCompositeOperation=h.toString();cE(cA,cF,[0,cI,cH,cG]);cA.beginPath();cA.moveTo(0,by*1.5*bz);cA.lineTo(by*bA,by*2*bz);cA.lineTo(by*2*bA,by*1.5*bz);cA.lineTo(by*2*bA,by*0.5*bz);cA.stroke();return cJ.drawImage(cz,0,0);}function c0(cZ,cY,cR){function c2(c1){var cK=[0,0],cL=0,cM=99;if(!(cM<cL)){var cN=cL;for(;;){var cO=aq(by),cP=aq(by),cQ=aq(by);if(caml_array_get(caml_array_get(caml_array_get(cR,cO),cP),cQ)){if(bM(cR,cO+1|0,cP,cQ)||bM(cR,cO,cP+1|0,cQ)||bM(cR,cO,cP,cQ+1|0))var cS=0;else{caml_array_set(caml_array_get(caml_array_get(cR,cO),cP),cQ,0);var cT=1,cS=1;}if(!cS)var cT=0;}else{if(bM(cR,cO-1|0,cP,cQ)&&bM(cR,cO,cP-1|0,cQ)&&bM(cR,cO,cP,cQ-1|0)){caml_array_set(caml_array_get(caml_array_get(cR,cO),cP),cQ,1);var cT=1,cU=1;}else var cU=0;if(!cU)var cT=0;}var cV=cT?cT:cK[1];cK[1]=cV;var cW=cN+1|0;if(cM!==cN){var cN=cW;continue;}break;}}if(cK[1])cX(cZ,cY,cR);return c0(cZ,cY,cR);}var c3=[],da=0.2,c$=0,c_=0;caml_update_dummy(c3,[0,[2,[0,[0,[0,function(c9){var c4=az(c3),c5=c4[1];if(2===c5[0]){var c6=[1,[0,au]],c7=c5[1][2];c4[1]=c6;var c8=a0(c7,c6);}else var c8=0;return c8;}]],c_,c$]]]);var dc=da*1000,dd=bv.setTimeout(caml_js_wrap_callback(function(db){return bc(c3,0);}),dc);function df(de){return bv.clearTimeout(dd);}var dg=bb(c3)[1];switch(dg[0]){case 1:var dh=dg[1][1]===au?(df(0),1):0;break;case 2:var dm=dg[1],dj=av[1];be(dm,function(di){if(1===di[0]&&di[1][1]===au){av[1]=dj;try {var dk=df(0);}catch(dl){return 0;}return dk;}return 0;});var dh=1;break;default:var dh=0;}dh;var dn=bb(c3)[1];switch(dn[0]){case 1:var dp=bd(dn[1]);break;case 2:var dq=dn[1],dr=[0,[2,[0,dq[1],0,0]]],dt=av[1];be(dq,function(ds){switch(ds[0]){case 0:var du=ds[1];av[1]=dt;try {var dv=c2(du),dw=dv;}catch(dx){var dw=bd(dx);}var dy=bb(dr),dz=bb(dw),dA=dy[1];if(2===dA[0]){var dB=dA[1];if(dy===dz)var dC=0;else{var dD=dz[1];if(2===dD[0]){var dE=dD[1];dz[1]=[3,dy];dB[1][1]=[1,dE[1]];var dF=a7(dB[2],dE[2]),dG=dB[3]+dE[3]|0,dC=ba<dG?(dB[3]=0,dB[2]=a4(dF),0):(dB[3]=dG,dB[2]=dF,0);}else{dy[1]=dD;var dC=a0(dB[2],dD);}}}else var dC=d(p);return dC;case 1:var dH=[1,ds[1]],dI=bb(dr),dJ=dI[1];if(2===dJ[0]){var dK=dJ[1][2];dI[1]=dH;var dL=a0(dK,dH);}else var dL=d(q);return dL;default:throw [0,b,s];}});var dp=dr;break;case 3:throw [0,b,r];default:var dp=c2(dn[1]);}return dp;}function dV(dU){var dN=dM(0),dO=dM(0);bv.document.body.appendChild(dN);var dP=dN.getContext(bu);dP.globalCompositeOperation=j.toString();var dQ=1,dT=L(by,function(dS){return L(by,function(dR){return caml_make_vect(by,dQ);});});cX(dP,dO,dT);c0(dP,dO,dT);return bp;}bv.onload=caml_js_wrap_callback(function(dW){if(dW){var dX=dV(dW);if(!(dX|0))dW.preventDefault();return dX;}var dY=event,dZ=dV(dY);dY.returnValue=dZ;return dZ;});C(0);return;}());
