// This program was compiled from OCaml by js_of_ocaml 1.0
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1)
      for (var i = 0; i < l; i++) a2 [i2 + i] = a1 [i1 + i];
    else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (!this.len) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_classify_float (x) {
  if (isFinite (x)) {
    if (Math.abs(x) >= 2.2250738585072014e-308) return 0;
    if (x != 0) return 1;
    return 2;
  }
  return isNaN(x)?4:3;
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_equal (x, y) { return +(caml_compare_val(x,y,false) == 0); }
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_float (fmt, x) {
  var s, f = caml_parse_format(fmt);
  var prec = (f.prec < 0)?6:f.prec;
  if (x < 0) { f.sign = -1; x = -x; }
  if (isNaN(x)) { s = "nan"; f.filler = ' '; }
  else if (!isFinite(x)) { s = "inf"; f.filler = ' '; }
  else
    switch (f.conv) {
    case 'e':
      var s = x.toExponential(prec);
      var i = s.length;
      if (s.charAt(i - 3) == 'e')
        s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
      break;
    case 'f':
      s = x.toFixed(prec); break;
    case 'g':
      prec = prec?prec:1;
      s = x.toExponential(prec - 1);
      var j = s.indexOf('e');
      var exp = +s.slice(j + 1);
      if (exp < -4 || x.toFixed(0).length > prec) {
        var i = j - 1; while (s.charAt(i) == '0') i--;
        if (s.charAt(i) == '.') i--;
        s = s.slice(0, i + 1) + s.slice(j);
        i = s.length;
        if (s.charAt(i - 3) == 'e')
          s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
        break;
      } else {
        var p = prec;
        if (exp < 0) { p -= exp + 1; s = x.toFixed(p); }
        else while (s = x.toFixed(p), s.length > prec + 1) p--;
        if (p) {
          var i = s.length - 1; while (s.charAt(i) == '0') i--;
          if (s.charAt(i) == '.') i--;
          s = s.slice(0, i + 1);
        }
      }
      break;
    }
  return caml_finish_formatting(f, s);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_greaterequal (x, y) { return +(caml_compare(x,y,false) >= 0); }
function caml_int64_is_negative(x) {
  return (x[3] << 16) < 0;
}
function caml_int64_neg (x) {
  var y1 = - x[1];
  var y2 = - x[2] + (y1 >> 24);
  var y3 = - x[3] + (y2 >> 24);
  return [255, y1 & 0xffffff, y2 & 0xffffff, y3 & 0xffff];
}
function caml_int64_of_int32 (x) {
  return [255, x & 0xffffff, (x >> 24) & 0xffffff, (x >> 31) & 0xffff]
}
function caml_int64_ucompare(x,y) {
  if (x[3] > y[3]) return 1;
  if (x[3] < y[3]) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int64_lsl1 (x) {
  x[3] = (x[3] << 1) | (x[2] >> 23);
  x[2] = ((x[2] << 1) | (x[1] >> 23)) & 0xffffff;
  x[1] = (x[1] << 1) & 0xffffff;
}
function caml_int64_lsr1 (x) {
  x[1] = ((x[1] >>> 1) | (x[2] << 23)) & 0xffffff;
  x[2] = ((x[2] >>> 1) | (x[3] << 23)) & 0xffffff;
  x[3] = x[3] >>> 1;
}
function caml_int64_sub (x, y) {
  var z1 = x[1] - y[1];
  var z2 = x[2] - y[2] + (z1 >> 24);
  var z3 = x[3] - y[3] + (z2 >> 24);
  return [255, z1 & 0xffffff, z2 & 0xffffff, z3 & 0xffff];
}
function caml_int64_udivmod (x, y) {
  var offset = 0;
  var modulus = x.slice ();
  var divisor = y.slice ();
  var quotient = [255, 0, 0, 0];
  while (caml_int64_ucompare (modulus, divisor) > 0) {
    offset++;
    caml_int64_lsl1 (divisor);
  }
  while (offset >= 0) {
    offset --;
    caml_int64_lsl1 (quotient);
    if (caml_int64_ucompare (modulus, divisor) >= 0) {
      quotient[1] ++;
      modulus = caml_int64_sub (modulus, divisor);
    }
    caml_int64_lsr1 (divisor);
  }
  return [0,quotient, modulus];
}
function caml_int64_to_int32 (x) {
  return x[1] | (x[2] << 24);
}
function caml_int64_is_zero(x) {
  return (x[3]|x[2]|x[1]) == 0;
}
function caml_int64_format (fmt, x) {
  var f = caml_parse_format(fmt);
  if (f.signedconv && caml_int64_is_negative(x)) {
    f.sign = -1; x = caml_int64_neg(x);
  }
  var buffer = "";
  var wbase = caml_int64_of_int32(f.base);
  var cvtbl = "0123456789abcdef";
  do {
    var p = caml_int64_udivmod(x, wbase);
    x = p[1];
    buffer = cvtbl.charAt(caml_int64_to_int32(p[2])) + buffer;
  } while (! caml_int64_is_zero(x));
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - buffer.length;
    if (n > 0) buffer = caml_str_repeat (n, '0') + buffer;
  }
  return caml_finish_formatting(f, buffer);
}
function caml_parse_sign_and_base (s) {
  var i = 0, base = 10, sign = s.get(0) == 45?(i++,-1):1;
  if (s.get(i) == 48)
    switch (s.get(i + 1)) {
    case 120: case 88: base = 16; i += 2; break;
    case 111: case 79: base =  8; i += 2; break;
    case  98: case 66: base =  2; i += 2; break;
    }
  return [i, sign, base];
}
function caml_parse_digit(c) {
  if (c >= 48 && c <= 57)  return c - 48;
  if (c >= 65 && c <= 90)  return c - 55;
  if (c >= 97 && c <= 122) return c - 87;
  return -1;
}
var caml_global_data = [0];
function caml_failwith (msg) {
  caml_raise_with_string(caml_global_data[3], msg);
}
function caml_int_of_string (s) {
  var r = caml_parse_sign_and_base (s);
  var i = r[0], sign = r[1], base = r[2];
  var threshold = -1 >>> 0;
  var c = s.get(i);
  var d = caml_parse_digit(c);
  if (d < 0 || d >= base) caml_failwith("int_of_string");
  var res = d;
  for (;;) {
    i++;
    c = s.get(i);
    if (c == 95) continue;
    d = caml_parse_digit(c);
    if (d < 0 || d >= base) break;
    res = base * res + d;
    if (res > threshold) caml_failwith("int_of_string");
  }
  if (i != s.getLen()) caml_failwith("int_of_string");
  res = sign * res;
  if ((res | 0) != res) caml_failwith("int_of_string");
  return res;
}
function caml_is_printable(c) { return +(c > 31 && c < 127); }
function caml_js_call(f, o, args) { return f.apply(o, args.slice(1)); }
var caml_js_regexps = { amp:/&/g, lt:/</g, quot:/\"/g, all:/[&<\"]/ };
function caml_js_html_escape (s) {
  if (!caml_js_regexps.all.test(s)) return s;
  return s.replace(caml_js_regexps.amp, "&amp;")
          .replace(caml_js_regexps.lt, "&lt;")
          .replace(caml_js_regexps.quot, "&quot;");
}
function caml_js_on_ie () {
  var ua = window.navigator?window.navigator.userAgent:"";
  return ua.indexOf("MSIE") != -1 && ua.indexOf("Opera") != 0;
}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function MlStringFromArray (a) {
  var len = a.length; this.array = a; this.len = this.last = len;
}
MlStringFromArray.prototype = new MlString ();
var caml_md5_string =
function () {
  function add (x, y) { return (x + y) | 0; }
  function xx(q,a,b,x,s,t) {
    a = add(add(a, q), add(x, t));
    return add((a << s) | (a >>> (32 - s)), b);
  }
  function ff(a,b,c,d,x,s,t) {
    return xx((b & c) | ((~b) & d), a, b, x, s, t);
  }
  function gg(a,b,c,d,x,s,t) {
    return xx((b & d) | (c & (~d)), a, b, x, s, t);
  }
  function hh(a,b,c,d,x,s,t) { return xx(b ^ c ^ d, a, b, x, s, t); }
  function ii(a,b,c,d,x,s,t) { return xx(c ^ (b | (~d)), a, b, x, s, t); }
  function md5(buffer, length) {
    var i = length;
    buffer[i >> 2] |= 0x80 << (8 * (i & 3));
    for (i = (i & ~0x3) + 4;(i & 0x3F) < 56 ;i += 4)
      buffer[i >> 2] = 0;
    buffer[i >> 2] = length << 3;
    i += 4;
    buffer[i >> 2] = (length >> 29) & 0x1FFFFFFF;
    var w = [0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476];
    for(i = 0; i < buffer.length; i += 16) {
      var a = w[0], b = w[1], c = w[2], d = w[3];
      a = ff(a, b, c, d, buffer[i+ 0], 7, 0xD76AA478);
      d = ff(d, a, b, c, buffer[i+ 1], 12, 0xE8C7B756);
      c = ff(c, d, a, b, buffer[i+ 2], 17, 0x242070DB);
      b = ff(b, c, d, a, buffer[i+ 3], 22, 0xC1BDCEEE);
      a = ff(a, b, c, d, buffer[i+ 4], 7, 0xF57C0FAF);
      d = ff(d, a, b, c, buffer[i+ 5], 12, 0x4787C62A);
      c = ff(c, d, a, b, buffer[i+ 6], 17, 0xA8304613);
      b = ff(b, c, d, a, buffer[i+ 7], 22, 0xFD469501);
      a = ff(a, b, c, d, buffer[i+ 8], 7, 0x698098D8);
      d = ff(d, a, b, c, buffer[i+ 9], 12, 0x8B44F7AF);
      c = ff(c, d, a, b, buffer[i+10], 17, 0xFFFF5BB1);
      b = ff(b, c, d, a, buffer[i+11], 22, 0x895CD7BE);
      a = ff(a, b, c, d, buffer[i+12], 7, 0x6B901122);
      d = ff(d, a, b, c, buffer[i+13], 12, 0xFD987193);
      c = ff(c, d, a, b, buffer[i+14], 17, 0xA679438E);
      b = ff(b, c, d, a, buffer[i+15], 22, 0x49B40821);
      a = gg(a, b, c, d, buffer[i+ 1], 5, 0xF61E2562);
      d = gg(d, a, b, c, buffer[i+ 6], 9, 0xC040B340);
      c = gg(c, d, a, b, buffer[i+11], 14, 0x265E5A51);
      b = gg(b, c, d, a, buffer[i+ 0], 20, 0xE9B6C7AA);
      a = gg(a, b, c, d, buffer[i+ 5], 5, 0xD62F105D);
      d = gg(d, a, b, c, buffer[i+10], 9, 0x02441453);
      c = gg(c, d, a, b, buffer[i+15], 14, 0xD8A1E681);
      b = gg(b, c, d, a, buffer[i+ 4], 20, 0xE7D3FBC8);
      a = gg(a, b, c, d, buffer[i+ 9], 5, 0x21E1CDE6);
      d = gg(d, a, b, c, buffer[i+14], 9, 0xC33707D6);
      c = gg(c, d, a, b, buffer[i+ 3], 14, 0xF4D50D87);
      b = gg(b, c, d, a, buffer[i+ 8], 20, 0x455A14ED);
      a = gg(a, b, c, d, buffer[i+13], 5, 0xA9E3E905);
      d = gg(d, a, b, c, buffer[i+ 2], 9, 0xFCEFA3F8);
      c = gg(c, d, a, b, buffer[i+ 7], 14, 0x676F02D9);
      b = gg(b, c, d, a, buffer[i+12], 20, 0x8D2A4C8A);
      a = hh(a, b, c, d, buffer[i+ 5], 4, 0xFFFA3942);
      d = hh(d, a, b, c, buffer[i+ 8], 11, 0x8771F681);
      c = hh(c, d, a, b, buffer[i+11], 16, 0x6D9D6122);
      b = hh(b, c, d, a, buffer[i+14], 23, 0xFDE5380C);
      a = hh(a, b, c, d, buffer[i+ 1], 4, 0xA4BEEA44);
      d = hh(d, a, b, c, buffer[i+ 4], 11, 0x4BDECFA9);
      c = hh(c, d, a, b, buffer[i+ 7], 16, 0xF6BB4B60);
      b = hh(b, c, d, a, buffer[i+10], 23, 0xBEBFBC70);
      a = hh(a, b, c, d, buffer[i+13], 4, 0x289B7EC6);
      d = hh(d, a, b, c, buffer[i+ 0], 11, 0xEAA127FA);
      c = hh(c, d, a, b, buffer[i+ 3], 16, 0xD4EF3085);
      b = hh(b, c, d, a, buffer[i+ 6], 23, 0x04881D05);
      a = hh(a, b, c, d, buffer[i+ 9], 4, 0xD9D4D039);
      d = hh(d, a, b, c, buffer[i+12], 11, 0xE6DB99E5);
      c = hh(c, d, a, b, buffer[i+15], 16, 0x1FA27CF8);
      b = hh(b, c, d, a, buffer[i+ 2], 23, 0xC4AC5665);
      a = ii(a, b, c, d, buffer[i+ 0], 6, 0xF4292244);
      d = ii(d, a, b, c, buffer[i+ 7], 10, 0x432AFF97);
      c = ii(c, d, a, b, buffer[i+14], 15, 0xAB9423A7);
      b = ii(b, c, d, a, buffer[i+ 5], 21, 0xFC93A039);
      a = ii(a, b, c, d, buffer[i+12], 6, 0x655B59C3);
      d = ii(d, a, b, c, buffer[i+ 3], 10, 0x8F0CCC92);
      c = ii(c, d, a, b, buffer[i+10], 15, 0xFFEFF47D);
      b = ii(b, c, d, a, buffer[i+ 1], 21, 0x85845DD1);
      a = ii(a, b, c, d, buffer[i+ 8], 6, 0x6FA87E4F);
      d = ii(d, a, b, c, buffer[i+15], 10, 0xFE2CE6E0);
      c = ii(c, d, a, b, buffer[i+ 6], 15, 0xA3014314);
      b = ii(b, c, d, a, buffer[i+13], 21, 0x4E0811A1);
      a = ii(a, b, c, d, buffer[i+ 4], 6, 0xF7537E82);
      d = ii(d, a, b, c, buffer[i+11], 10, 0xBD3AF235);
      c = ii(c, d, a, b, buffer[i+ 2], 15, 0x2AD7D2BB);
      b = ii(b, c, d, a, buffer[i+ 9], 21, 0xEB86D391);
      w[0] = add(a, w[0]);
      w[1] = add(b, w[1]);
      w[2] = add(c, w[2]);
      w[3] = add(d, w[3]);
    }
    var t = [];
    for (var i = 0; i < 4; i++)
      for (var j = 0; j < 4; j++)
        t[i * 4 + j] = (w[i] >> (8 * j)) & 0xFF;
    return t;
  }
  return function (s, ofs, len) {
    var buf = [];
    if (s.array) {
      var a = s.array;
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] = a[j] | (a[j+1] << 8) | (a[j+2] << 16) | (a[j+3] << 24);
      }
      for (; i < len; i++) buf[i>>2] |= a[i + ofs] << (8 * (i & 3));
    } else {
      var b = s.getFullBytes();
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] =
          b.charCodeAt(j) | (b.charCodeAt(j+1) << 8) |
          (b.charCodeAt(j+2) << 16) | (b.charCodeAt(j+3) << 24);
      }
      for (; i < len; i++) buf[i>>2] |= b.charCodeAt(i + ofs) << (8 * (i & 3));
    }
    return new MlStringFromArray(md5(buf, len));
  }
} ();
function caml_ml_out_channels_list () { return 0; }
function caml_raise_constant (tag) { throw [0, tag]; }
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_sys_get_config () {
  return [0, new MlWrappedString("Unix"), 32];
}
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function()
   {function _g7_(_pw_,_px_,_py_,_pz_,_pA_,_pB_,_pC_)
     {return _pw_.length==6
              ?_pw_(_px_,_py_,_pz_,_pA_,_pB_,_pC_)
              :caml_call_gen(_pw_,[_px_,_py_,_pz_,_pA_,_pB_,_pC_]);}
    function _cO_(_ps_,_pt_,_pu_,_pv_)
     {return _ps_.length==3
              ?_ps_(_pt_,_pu_,_pv_)
              :caml_call_gen(_ps_,[_pt_,_pu_,_pv_]);}
    function _dh_(_pp_,_pq_,_pr_)
     {return _pp_.length==2?_pp_(_pq_,_pr_):caml_call_gen(_pp_,[_pq_,_pr_]);}
    function _a6_(_pn_,_po_)
     {return _pn_.length==1?_pn_(_po_):caml_call_gen(_pn_,[_po_]);}
    var
     _a_=[0,new MlString("Failure")],
     _b_=[0,new MlString("Invalid_argument")],
     _c_=[0,new MlString("Assert_failure")];
    caml_register_global(5,[0,new MlString("Division_by_zero")]);
    caml_register_global(3,_b_);
    caml_register_global(2,_a_);
    var
     _aO_=new MlString("%.12g"),
     _aN_=new MlString("."),
     _aM_=new MlString("%d"),
     _aL_=new MlString("true"),
     _aK_=new MlString("false"),
     _aJ_=new MlString("Pervasives.do_at_exit"),
     _aI_=new MlString("\\b"),
     _aH_=new MlString("\\t"),
     _aG_=new MlString("\\n"),
     _aF_=new MlString("\\r"),
     _aE_=new MlString("\\\\"),
     _aD_=new MlString("\\'"),
     _aC_=new MlString("String.blit"),
     _aB_=new MlString("String.sub"),
     _aA_=new MlString("Buffer.add: cannot grow buffer"),
     _az_=new MlString("%"),
     _ay_=new MlString(""),
     _ax_=new MlString(""),
     _aw_=new MlString("\""),
     _av_=new MlString("\""),
     _au_=new MlString("'"),
     _at_=new MlString("'"),
     _as_=new MlString("."),
     _ar_=new MlString("printf: bad positional specification (0)."),
     _aq_=new MlString("%_"),
     _ap_=[0,new MlString("printf.ml"),144,8],
     _ao_=new MlString("''"),
     _an_=new MlString("Printf: premature end of format string ``"),
     _am_=new MlString("''"),
     _al_=new MlString(" in format string ``"),
     _ak_=new MlString(", at char number "),
     _aj_=new MlString("Printf: bad conversion %"),
     _ai_=new MlString("Sformat.index_of_int: negative argument "),
     _ah_=new MlString("x"),
     _ag_=[0,new MlString("src/core/lwt.ml"),573,20],
     _af_=[0,new MlString("src/core/lwt.ml"),575,8],
     _ae_=[0,new MlString("src/core/lwt.ml"),440,20],
     _ad_=[0,new MlString("src/core/lwt.ml"),443,8],
     _ac_=new MlString("Lwt.fast_connect"),
     _ab_=new MlString("Lwt.connect"),
     _aa_=new MlString("Lwt.wakeup"),
     _$_=new MlString("Lwt.Canceled"),
     ___=new MlString("on"),
     _Z_=new MlString("canvas"),
     _Y_=new MlString("img"),
     _X_=new MlString("br"),
     _W_=new MlString("p"),
     _V_=new MlString("div"),
     _U_=new MlString("label"),
     _T_=new MlString("input"),
     _S_=new MlString("select"),
     _R_=new MlString("option"),
     _Q_=new MlString("\""),
     _P_=new MlString(" name=\""),
     _O_=new MlString("\""),
     _N_=new MlString(" type=\""),
     _M_=new MlString("<"),
     _L_=new MlString(">"),
     _K_=new MlString(""),
     _J_=new MlString("mouseup"),
     _I_=new MlString("mousemove"),
     _H_=new MlString("2d"),
     _G_=new MlString("Dom_html.Canvas_not_available"),
     _F_=new MlString("lighter"),
     _E_=new MlString("copy"),
     _D_=new MlString("% 2.f"),
     _C_=new MlString(""),
     _B_=new MlString("controls"),
     _A_=new MlString("Click and drag mouse to rotate."),
     _z_=new MlString("Resume"),
     _y_=new MlString("Pause"),
     _x_=new MlString("Fixed position"),
     _w_=new MlString("Follow rotation"),
     _v_=new MlString("Reset orientation"),
     _u_=new MlString("Date:"),
     _t_=
      [0,
       new MlString("December solstice"),
       [0,new MlString("Equinox"),[0,new MlString("June solstice"),0]]],
     _s_=new MlString("Lighting"),
     _r_=new MlString("Clip"),
     _q_=new MlString("Frames per second: "),
     _p_=
      new
       MlString
       ("Credit: <a href='http://visibleearth.nasa.gov/'>Visual Earth</a>, Nasa"),
     _o_=[0,new MlString("planet.ml"),415,0],
     _n_=[0,new MlString("planet.ml"),416,0],
     _m_=[0,new MlString("planet.ml"),417,0],
     _l_=[0,new MlString("planet.ml"),418,0],
     _k_=new MlString("copy"),
     _j_=new MlString("checkbox"),
     _i_=new MlString("button"),
     v_h_=[254,0,0,1],
     _g_=new MlString("../planet/texture.jpg");
    function _f_(s_d_){throw [0,_a_,s_d_];}
    function _aP_(s_e_){throw [0,_b_,s_e_];}
    function _a0_(s1_aQ_,s2_aS_)
     {var
       l1_aR_=s1_aQ_.getLen(),
       l2_aT_=s2_aS_.getLen(),
       s_aU_=caml_create_string(l1_aR_+l2_aT_|0);
      caml_blit_string(s1_aQ_,0,s_aU_,0,l1_aR_);
      caml_blit_string(s2_aS_,0,s_aU_,l1_aR_,l2_aT_);
      return s_aU_;}
    function string_of_int_a1_(n_aV_){return caml_format_int(_aM_,n_aV_);}
    function do_at_exit_a2_(param_aZ_)
     {var param_aW_=caml_ml_out_channels_list(0);
      for(;;)
       {if(param_aW_)
         {var l_aX_=param_aW_[2];
          try {}catch(_aY_){}
          var param_aW_=l_aX_;
          continue;}
        return 0;}}
    caml_register_named_value(_aJ_,do_at_exit_a2_);
    function _ba_(f_a5_,a_a3_)
     {var l_a4_=a_a3_.length-1;
      if(0===l_a4_)return [0];
      var
       r_a7_=caml_make_vect(l_a4_,_a6_(f_a5_,a_a3_[0+1])),
       _a8_=1,
       _a9_=l_a4_-1|0;
      if(!(_a9_<_a8_))
       {var i_a__=_a8_;
        for(;;)
         {r_a7_[i_a__+1]=_a6_(f_a5_,a_a3_[i_a__+1]);
          var _a$_=i_a__+1|0;
          if(_a9_!==i_a__){var i_a__=_a$_;continue;}
          break;}}
      return r_a7_;}
    function _bn_(n_bb_,c_bd_)
     {var s_bc_=caml_create_string(n_bb_);
      caml_fill_string(s_bc_,0,n_bb_,c_bd_);
      return s_bc_;}
    function _bo_(s_bg_,ofs_be_,len_bf_)
     {if(0<=ofs_be_&&0<=len_bf_&&!((s_bg_.getLen()-len_bf_|0)<ofs_be_))
       {var r_bh_=caml_create_string(len_bf_);
        caml_blit_string(s_bg_,ofs_be_,r_bh_,0,len_bf_);
        return r_bh_;}
      return _aP_(_aB_);}
    function _bp_(s1_bk_,ofs1_bj_,s2_bm_,ofs2_bl_,len_bi_)
     {if
       (0<=
        len_bi_&&
        0<=
        ofs1_bj_&&
        !((s1_bk_.getLen()-len_bi_|0)<ofs1_bj_)&&
        0<=
        ofs2_bl_&&
        !((s2_bm_.getLen()-len_bi_|0)<ofs2_bl_))
       return caml_blit_string(s1_bk_,ofs1_bj_,s2_bm_,ofs2_bl_,len_bi_);
      return _aP_(_aC_);}
    var
     _bq_=caml_sys_get_config(0)[2],
     _br_=caml_mul(_bq_/8|0,(1<<(_bq_-10|0))-1|0)-1|0;
    function _bJ_(n_bs_)
     {var
       n_bt_=1<=n_bs_?n_bs_:1,
       n_bu_=_br_<n_bt_?_br_:n_bt_,
       s_bv_=caml_create_string(n_bu_);
      return [0,s_bv_,0,n_bu_,s_bv_];}
    function _bK_(b_bw_){return _bo_(b_bw_[1],0,b_bw_[2]);}
    function _bD_(b_bx_,more_bz_)
     {var new_len_by_=[0,b_bx_[3]];
      for(;;)
       {if(new_len_by_[1]<(b_bx_[2]+more_bz_|0))
         {new_len_by_[1]=2*new_len_by_[1]|0;continue;}
        if(_br_<new_len_by_[1])
         if((b_bx_[2]+more_bz_|0)<=_br_)new_len_by_[1]=_br_;else _f_(_aA_);
        var new_buffer_bA_=caml_create_string(new_len_by_[1]);
        _bp_(b_bx_[1],0,new_buffer_bA_,0,b_bx_[2]);
        b_bx_[1]=new_buffer_bA_;
        b_bx_[3]=new_len_by_[1];
        return 0;}}
    function _bL_(b_bB_,c_bE_)
     {var pos_bC_=b_bB_[2];
      if(b_bB_[3]<=pos_bC_)_bD_(b_bB_,1);
      b_bB_[1].safeSet(pos_bC_,c_bE_);
      b_bB_[2]=pos_bC_+1|0;
      return 0;}
    function _bM_(b_bH_,s_bF_)
     {var len_bG_=s_bF_.getLen(),new_position_bI_=b_bH_[2]+len_bG_|0;
      if(b_bH_[3]<new_position_bI_)_bD_(b_bH_,len_bG_);
      _bp_(s_bF_,0,b_bH_[1],b_bH_[2],len_bG_);
      b_bH_[2]=new_position_bI_;
      return 0;}
    function index_of_int_bQ_(i_bN_)
     {return 0<=i_bN_?i_bN_:_f_(_a0_(_ai_,string_of_int_a1_(i_bN_)));}
    function add_int_index_bR_(i_bO_,idx_bP_)
     {return index_of_int_bQ_(i_bO_+idx_bP_|0);}
    var _bS_=_a6_(add_int_index_bR_,1);
    function _bZ_(fmt_bT_){return _bo_(fmt_bT_,0,fmt_bT_.getLen());}
    function bad_conversion_b1_(sfmt_bU_,i_bV_,c_bX_)
     {var
       _bW_=_a0_(_al_,_a0_(sfmt_bU_,_am_)),
       _bY_=_a0_(_ak_,_a0_(string_of_int_a1_(i_bV_),_bW_));
      return _aP_(_a0_(_aj_,_a0_(_bn_(1,c_bX_),_bY_)));}
    function bad_conversion_format_cU_(fmt_b0_,i_b3_,c_b2_)
     {return bad_conversion_b1_(_bZ_(fmt_b0_),i_b3_,c_b2_);}
    function incomplete_format_cV_(fmt_b4_)
     {return _aP_(_a0_(_an_,_a0_(_bZ_(fmt_b4_),_ao_)));}
    function extract_format_cq_(fmt_b5_,start_cb_,stop_cd_,widths_cf_)
     {function skip_positional_spec_ca_(start_b6_)
       {if
         ((fmt_b5_.safeGet(start_b6_)-48|0)<
          0||
          9<
          (fmt_b5_.safeGet(start_b6_)-48|0))
         return start_b6_;
        var i_b7_=start_b6_+1|0;
        for(;;)
         {var _b8_=fmt_b5_.safeGet(i_b7_);
          if(48<=_b8_)
           {if(!(58<=_b8_)){var _b__=i_b7_+1|0,i_b7_=_b__;continue;}
            var _b9_=0;}
          else
           if(36===_b8_){var _b$_=i_b7_+1|0,_b9_=1;}else var _b9_=0;
          if(!_b9_)var _b$_=start_b6_;
          return _b$_;}}
      var
       start_cc_=skip_positional_spec_ca_(start_cb_+1|0),
       b_ce_=_bJ_((stop_cd_-start_cc_|0)+10|0);
      _bL_(b_ce_,37);
      var l1_cg_=widths_cf_,l2_ch_=0;
      for(;;)
       {if(l1_cg_)
         {var
           l_ci_=l1_cg_[2],
           _cj_=[0,l1_cg_[1],l2_ch_],
           l1_cg_=l_ci_,
           l2_ch_=_cj_;
          continue;}
        var i_ck_=start_cc_,widths_cl_=l2_ch_;
        for(;;)
         {if(i_ck_<=stop_cd_)
           {var _cm_=fmt_b5_.safeGet(i_ck_);
            if(42===_cm_)
             {if(widths_cl_)
               {var t_cn_=widths_cl_[2];
                _bM_(b_ce_,string_of_int_a1_(widths_cl_[1]));
                var
                 i_co_=skip_positional_spec_ca_(i_ck_+1|0),
                 i_ck_=i_co_,
                 widths_cl_=t_cn_;
                continue;}
              throw [0,_c_,_ap_];}
            _bL_(b_ce_,_cm_);
            var _cp_=i_ck_+1|0,i_ck_=_cp_;
            continue;}
          return _bK_(b_ce_);}}}
    function extract_format_int_ej_
     (conv_cw_,fmt_cu_,start_ct_,stop_cs_,widths_cr_)
     {var sfmt_cv_=extract_format_cq_(fmt_cu_,start_ct_,stop_cs_,widths_cr_);
      if(78!==conv_cw_&&110!==conv_cw_)return sfmt_cv_;
      sfmt_cv_.safeSet(sfmt_cv_.getLen()-1|0,117);
      return sfmt_cv_;}
    function sub_format_cW_
     (incomplete_format_cD_,bad_conversion_format_cN_,conv_cS_,fmt_cx_,i_cR_)
     {var len_cy_=fmt_cx_.getLen();
      function sub_fmt_cP_(c_cz_,i_cM_)
       {var close_cA_=40===c_cz_?41:125;
        function sub_cL_(j_cB_)
         {var j_cC_=j_cB_;
          for(;;)
           {if(len_cy_<=j_cC_)return _a6_(incomplete_format_cD_,fmt_cx_);
            if(37===fmt_cx_.safeGet(j_cC_))
             {var _cE_=j_cC_+1|0;
              if(len_cy_<=_cE_)
               var _cF_=_a6_(incomplete_format_cD_,fmt_cx_);
              else
               {var _cG_=fmt_cx_.safeGet(_cE_),_cH_=_cG_-40|0;
                if(_cH_<0||1<_cH_)
                 {var _cI_=_cH_-83|0;
                  if(_cI_<0||2<_cI_)
                   var _cJ_=1;
                  else
                   switch(_cI_)
                    {case 1:var _cJ_=1;break;
                     case 2:var _cK_=1,_cJ_=0;break;
                     default:var _cK_=0,_cJ_=0;}
                  if(_cJ_){var _cF_=sub_cL_(_cE_+1|0),_cK_=2;}}
                else
                 var _cK_=0===_cH_?0:1;
                switch(_cK_)
                 {case 1:
                   var
                    _cF_=
                     _cG_===close_cA_
                      ?_cE_+1|0
                      :_cO_(bad_conversion_format_cN_,fmt_cx_,i_cM_,_cG_);
                   break;
                  case 2:break;
                  default:var _cF_=sub_cL_(sub_fmt_cP_(_cG_,_cE_+1|0)+1|0);}}
              return _cF_;}
            var _cQ_=j_cC_+1|0,j_cC_=_cQ_;
            continue;}}
        return sub_cL_(i_cM_);}
      return sub_fmt_cP_(conv_cS_,i_cR_);}
    function sub_format_for_printf_dk_(conv_cT_)
     {return _cO_
              (sub_format_cW_,
               incomplete_format_cV_,
               bad_conversion_format_cU_,
               conv_cT_);}
    function iter_on_format_args_dA_(fmt_cX_,add_conv_c8_,add_char_dg_)
     {var lim_cY_=fmt_cX_.getLen()-1|0;
      function scan_fmt_di_(i_cZ_)
       {var i_c0_=i_cZ_;
        a:
        for(;;)
         {if(i_c0_<lim_cY_)
           {if(37===fmt_cX_.safeGet(i_c0_))
             {var skip_c1_=0,i_c2_=i_c0_+1|0;
              for(;;)
               {if(lim_cY_<i_c2_)
                 var _c3_=incomplete_format_cV_(fmt_cX_);
                else
                 {var _c4_=fmt_cX_.safeGet(i_c2_);
                  if(58<=_c4_)
                   {if(95===_c4_)
                     {var _c6_=i_c2_+1|0,_c5_=1,skip_c1_=_c5_,i_c2_=_c6_;
                      continue;}}
                  else
                   if(32<=_c4_)
                    switch(_c4_-32|0)
                     {case 1:
                      case 2:
                      case 4:
                      case 5:
                      case 6:
                      case 7:
                      case 8:
                      case 9:
                      case 12:
                      case 15:break;
                      case 0:
                      case 3:
                      case 11:
                      case 13:var _c7_=i_c2_+1|0,i_c2_=_c7_;continue;
                      case 10:
                       var _c9_=_cO_(add_conv_c8_,skip_c1_,i_c2_,105),i_c2_=_c9_;
                       continue;
                      default:var _c__=i_c2_+1|0,i_c2_=_c__;continue;}
                  var i_c$_=i_c2_;
                  c:
                  for(;;)
                   {if(lim_cY_<i_c$_)
                     var _da_=incomplete_format_cV_(fmt_cX_);
                    else
                     {var _db_=fmt_cX_.safeGet(i_c$_);
                      if(126<=_db_)
                       var _dc_=0;
                      else
                       switch(_db_)
                        {case 78:
                         case 88:
                         case 100:
                         case 105:
                         case 111:
                         case 117:
                         case 120:
                          var _da_=_cO_(add_conv_c8_,skip_c1_,i_c$_,105),_dc_=1;break;
                         case 69:
                         case 70:
                         case 71:
                         case 101:
                         case 102:
                         case 103:
                          var _da_=_cO_(add_conv_c8_,skip_c1_,i_c$_,102),_dc_=1;break;
                         case 33:
                         case 37:
                         case 44:var _da_=i_c$_+1|0,_dc_=1;break;
                         case 83:
                         case 91:
                         case 115:
                          var _da_=_cO_(add_conv_c8_,skip_c1_,i_c$_,115),_dc_=1;break;
                         case 97:
                         case 114:
                         case 116:
                          var _da_=_cO_(add_conv_c8_,skip_c1_,i_c$_,_db_),_dc_=1;
                          break;
                         case 76:
                         case 108:
                         case 110:
                          var j_dd_=i_c$_+1|0;
                          if(lim_cY_<j_dd_)
                           {var _da_=_cO_(add_conv_c8_,skip_c1_,i_c$_,105),_dc_=1;}
                          else
                           {var _de_=fmt_cX_.safeGet(j_dd_)-88|0;
                            if(_de_<0||32<_de_)
                             var _df_=1;
                            else
                             switch(_de_)
                              {case 0:
                               case 12:
                               case 17:
                               case 23:
                               case 29:
                               case 32:
                                var
                                 _da_=
                                  _dh_
                                   (add_char_dg_,_cO_(add_conv_c8_,skip_c1_,i_c$_,_db_),105),
                                 _dc_=1,
                                 _df_=0;
                                break;
                               default:var _df_=1;}
                            if(_df_)
                             {var _da_=_cO_(add_conv_c8_,skip_c1_,i_c$_,105),_dc_=1;}}
                          break;
                         case 67:
                         case 99:
                          var _da_=_cO_(add_conv_c8_,skip_c1_,i_c$_,99),_dc_=1;break;
                         case 66:
                         case 98:
                          var _da_=_cO_(add_conv_c8_,skip_c1_,i_c$_,66),_dc_=1;break;
                         case 41:
                         case 125:
                          var _da_=_cO_(add_conv_c8_,skip_c1_,i_c$_,_db_),_dc_=1;
                          break;
                         case 40:
                          var
                           _da_=scan_fmt_di_(_cO_(add_conv_c8_,skip_c1_,i_c$_,_db_)),
                           _dc_=1;
                          break;
                         case 123:
                          var
                           i_dj_=_cO_(add_conv_c8_,skip_c1_,i_c$_,_db_),
                           j_dl_=_cO_(sub_format_for_printf_dk_,_db_,fmt_cX_,i_dj_),
                           i_dm_=i_dj_;
                          for(;;)
                           {if(i_dm_<(j_dl_-2|0))
                             {var
                               _dn_=_dh_(add_char_dg_,i_dm_,fmt_cX_.safeGet(i_dm_)),
                               i_dm_=_dn_;
                              continue;}
                            var _do_=j_dl_-1|0,i_c$_=_do_;
                            continue c;}
                         default:var _dc_=0;}
                      if(!_dc_)
                       var _da_=bad_conversion_format_cU_(fmt_cX_,i_c$_,_db_);}
                    var _c3_=_da_;
                    break;}}
                var i_c0_=_c3_;
                continue a;}}
            var _dp_=i_c0_+1|0,i_c0_=_dp_;
            continue;}
          return i_c0_;}}
      scan_fmt_di_(0);
      return 0;}
    function count_arguments_of_format_fy_(fmt_dB_)
     {var ac_dq_=[0,0,0,0];
      function add_conv_dz_(skip_dv_,i_dw_,c_dr_)
       {var _ds_=41!==c_dr_?1:0,_dt_=_ds_?125!==c_dr_?1:0:_ds_;
        if(_dt_)
         {var inc_du_=97===c_dr_?2:1;
          if(114===c_dr_)ac_dq_[3]=ac_dq_[3]+1|0;
          if(skip_dv_)
           ac_dq_[2]=ac_dq_[2]+inc_du_|0;
          else
           ac_dq_[1]=ac_dq_[1]+inc_du_|0;}
        return i_dw_+1|0;}
      iter_on_format_args_dA_
       (fmt_dB_,add_conv_dz_,function(i_dx_,c_dy_){return i_dx_+1|0;});
      return ac_dq_[1];}
    function scan_positional_spec_ef_(fmt_dC_,got_spec_dF_,n_dN_,i_dD_)
     {var _dE_=fmt_dC_.safeGet(i_dD_);
      if((_dE_-48|0)<0||9<(_dE_-48|0))return _dh_(got_spec_dF_,0,i_dD_);
      var accu_dG_=_dE_-48|0,j_dH_=i_dD_+1|0;
      for(;;)
       {var _dI_=fmt_dC_.safeGet(j_dH_);
        if(48<=_dI_)
         {if(!(58<=_dI_))
           {var
             _dL_=j_dH_+1|0,
             _dK_=(10*accu_dG_|0)+(_dI_-48|0)|0,
             accu_dG_=_dK_,
             j_dH_=_dL_;
            continue;}
          var _dJ_=0;}
        else
         if(36===_dI_)
          if(0===accu_dG_)
           {var _dM_=_f_(_ar_),_dJ_=1;}
          else
           {var
             _dM_=
              _dh_(got_spec_dF_,[0,index_of_int_bQ_(accu_dG_-1|0)],j_dH_+1|0),
             _dJ_=1;}
         else
          var _dJ_=0;
        if(!_dJ_)var _dM_=_dh_(got_spec_dF_,0,i_dD_);
        return _dM_;}}
    function next_index_ea_(spec_dO_,n_dP_)
     {return spec_dO_?n_dP_:_a6_(_bS_,n_dP_);}
    function get_index_d1_(spec_dQ_,n_dR_){return spec_dQ_?spec_dQ_[1]:n_dR_;}
    function _g6_
     (to_s_fZ_,get_out_dT_,outc_f$_,outs_f0_,flush_fD_,k_gf_,fmt_dS_)
     {var out_dU_=_a6_(get_out_dT_,fmt_dS_);
      function pr_fC_(k_dZ_,n_ge_,fmt_dV_,v_d4_)
       {var len_dY_=fmt_dV_.getLen();
        function doprn_fz_(n_f8_,i_dW_)
         {var i_dX_=i_dW_;
          for(;;)
           {if(len_dY_<=i_dX_)return _a6_(k_dZ_,out_dU_);
            var _d0_=fmt_dV_.safeGet(i_dX_);
            if(37===_d0_)
             {var
               get_arg_d8_=
                function(spec_d3_,n_d2_)
                 {return caml_array_get(v_d4_,get_index_d1_(spec_d3_,n_d2_));},
               scan_flags_ec_=
                function(spec_ee_,n_d9_,widths_d$_,i_d5_)
                 {var i_d6_=i_d5_;
                  for(;;)
                   {var _d7_=fmt_dV_.safeGet(i_d6_)-32|0;
                    if(!(_d7_<0||25<_d7_))
                     switch(_d7_)
                      {case 1:
                       case 2:
                       case 4:
                       case 5:
                       case 6:
                       case 7:
                       case 8:
                       case 9:
                       case 12:
                       case 15:break;
                       case 10:
                        return scan_positional_spec_ef_
                                (fmt_dV_,
                                 function(wspec_d__,i_ed_)
                                  {var _eb_=[0,get_arg_d8_(wspec_d__,n_d9_),widths_d$_];
                                   return scan_flags_ec_
                                           (spec_ee_,next_index_ea_(wspec_d__,n_d9_),_eb_,i_ed_);},
                                 n_d9_,
                                 i_d6_+1|0);
                       default:var _eg_=i_d6_+1|0,i_d6_=_eg_;continue;}
                    var _eh_=fmt_dV_.safeGet(i_d6_);
                    if(124<=_eh_)
                     var _ei_=0;
                    else
                     switch(_eh_)
                      {case 78:
                       case 88:
                       case 100:
                       case 105:
                       case 111:
                       case 117:
                       case 120:
                        var
                         x_ek_=get_arg_d8_(spec_ee_,n_d9_),
                         s_el_=
                          caml_format_int
                           (extract_format_int_ej_(_eh_,fmt_dV_,i_dX_,i_d6_,widths_d$_),
                            x_ek_),
                         _en_=
                          cont_s_em_(next_index_ea_(spec_ee_,n_d9_),s_el_,i_d6_+1|0),
                         _ei_=1;
                        break;
                       case 69:
                       case 71:
                       case 101:
                       case 102:
                       case 103:
                        var
                         x_eo_=get_arg_d8_(spec_ee_,n_d9_),
                         s_ep_=
                          caml_format_float
                           (extract_format_cq_(fmt_dV_,i_dX_,i_d6_,widths_d$_),x_eo_),
                         _en_=
                          cont_s_em_(next_index_ea_(spec_ee_,n_d9_),s_ep_,i_d6_+1|0),
                         _ei_=1;
                        break;
                       case 76:
                       case 108:
                       case 110:
                        var _eq_=fmt_dV_.safeGet(i_d6_+1|0)-88|0;
                        if(_eq_<0||32<_eq_)
                         var _er_=1;
                        else
                         switch(_eq_)
                          {case 0:
                           case 12:
                           case 17:
                           case 23:
                           case 29:
                           case 32:
                            var i_es_=i_d6_+1|0,_et_=_eh_-108|0;
                            if(_et_<0||2<_et_)
                             var _eu_=0;
                            else
                             {switch(_et_)
                               {case 1:var _eu_=0,_ev_=0;break;
                                case 2:
                                 var
                                  x_ew_=get_arg_d8_(spec_ee_,n_d9_),
                                  _ex_=
                                   caml_format_int
                                    (extract_format_cq_(fmt_dV_,i_dX_,i_es_,widths_d$_),x_ew_),
                                  _ev_=1;
                                 break;
                                default:
                                 var
                                  x_ey_=get_arg_d8_(spec_ee_,n_d9_),
                                  _ex_=
                                   caml_format_int
                                    (extract_format_cq_(fmt_dV_,i_dX_,i_es_,widths_d$_),x_ey_),
                                  _ev_=1;}
                              if(_ev_){var s_ez_=_ex_,_eu_=1;}}
                            if(!_eu_)
                             {var
                               x_eA_=get_arg_d8_(spec_ee_,n_d9_),
                               s_ez_=
                                caml_int64_format
                                 (extract_format_cq_(fmt_dV_,i_dX_,i_es_,widths_d$_),x_eA_);}
                            var
                             _en_=
                              cont_s_em_(next_index_ea_(spec_ee_,n_d9_),s_ez_,i_es_+1|0),
                             _ei_=1,
                             _er_=0;
                            break;
                           default:var _er_=1;}
                        if(_er_)
                         {var
                           x_eB_=get_arg_d8_(spec_ee_,n_d9_),
                           s_eC_=
                            caml_format_int
                             (extract_format_int_ej_(110,fmt_dV_,i_dX_,i_d6_,widths_d$_),
                              x_eB_),
                           _en_=
                            cont_s_em_(next_index_ea_(spec_ee_,n_d9_),s_eC_,i_d6_+1|0),
                           _ei_=1;}
                        break;
                       case 83:
                       case 115:
                        var x_eD_=get_arg_d8_(spec_ee_,n_d9_);
                        if(115===_eh_)
                         var x_eE_=x_eD_;
                        else
                         {var n_eF_=[0,0],_eG_=0,_eH_=x_eD_.getLen()-1|0;
                          if(!(_eH_<_eG_))
                           {var i_eI_=_eG_;
                            for(;;)
                             {var
                               _eJ_=x_eD_.safeGet(i_eI_),
                               _eK_=
                                14<=_eJ_
                                 ?34===_eJ_?1:92===_eJ_?1:0
                                 :11<=_eJ_?13<=_eJ_?1:0:8<=_eJ_?1:0,
                               _eL_=_eK_?2:caml_is_printable(_eJ_)?1:4;
                              n_eF_[1]=n_eF_[1]+_eL_|0;
                              var _eM_=i_eI_+1|0;
                              if(_eH_!==i_eI_){var i_eI_=_eM_;continue;}
                              break;}}
                          if(n_eF_[1]===x_eD_.getLen())
                           var _eN_=x_eD_;
                          else
                           {var s__eO_=caml_create_string(n_eF_[1]);
                            n_eF_[1]=0;
                            var _eP_=0,_eQ_=x_eD_.getLen()-1|0;
                            if(!(_eQ_<_eP_))
                             {var i_eR_=_eP_;
                              for(;;)
                               {var _eS_=x_eD_.safeGet(i_eR_),_eT_=_eS_-34|0;
                                if(_eT_<0||58<_eT_)
                                 if(-20<=_eT_)
                                  var _eU_=1;
                                 else
                                  {switch(_eT_+34|0)
                                    {case 8:
                                      s__eO_.safeSet(n_eF_[1],92);
                                      n_eF_[1]+=1;
                                      s__eO_.safeSet(n_eF_[1],98);
                                      var _eV_=1;
                                      break;
                                     case 9:
                                      s__eO_.safeSet(n_eF_[1],92);
                                      n_eF_[1]+=1;
                                      s__eO_.safeSet(n_eF_[1],116);
                                      var _eV_=1;
                                      break;
                                     case 10:
                                      s__eO_.safeSet(n_eF_[1],92);
                                      n_eF_[1]+=1;
                                      s__eO_.safeSet(n_eF_[1],110);
                                      var _eV_=1;
                                      break;
                                     case 13:
                                      s__eO_.safeSet(n_eF_[1],92);
                                      n_eF_[1]+=1;
                                      s__eO_.safeSet(n_eF_[1],114);
                                      var _eV_=1;
                                      break;
                                     default:var _eU_=1,_eV_=0;}
                                   if(_eV_)var _eU_=0;}
                                else
                                 var
                                  _eU_=
                                   (_eT_-1|0)<0||56<(_eT_-1|0)
                                    ?(s__eO_.safeSet(n_eF_[1],92),
                                      n_eF_[1]+=
                                      1,
                                      s__eO_.safeSet(n_eF_[1],_eS_),
                                      0)
                                    :1;
                                if(_eU_)
                                 if(caml_is_printable(_eS_))
                                  s__eO_.safeSet(n_eF_[1],_eS_);
                                 else
                                  {s__eO_.safeSet(n_eF_[1],92);
                                   n_eF_[1]+=1;
                                   s__eO_.safeSet(n_eF_[1],48+(_eS_/100|0)|0);
                                   n_eF_[1]+=1;
                                   s__eO_.safeSet(n_eF_[1],48+((_eS_/10|0)%10|0)|0);
                                   n_eF_[1]+=1;
                                   s__eO_.safeSet(n_eF_[1],48+(_eS_%10|0)|0);}
                                n_eF_[1]+=1;
                                var _eW_=i_eR_+1|0;
                                if(_eQ_!==i_eR_){var i_eR_=_eW_;continue;}
                                break;}}
                            var _eN_=s__eO_;}
                          var x_eE_=_a0_(_av_,_a0_(_eN_,_aw_));}
                        if(i_d6_===(i_dX_+1|0))
                         var s_eX_=x_eE_;
                        else
                         {var
                           _eY_=
                            extract_format_cq_(fmt_dV_,i_dX_,i_d6_,widths_d$_);
                          try
                           {var neg_eZ_=0,i_e0_=1;
                            for(;;)
                             {if(_eY_.getLen()<=i_e0_)
                               var _e1_=[0,0,neg_eZ_];
                              else
                               {var _e2_=_eY_.safeGet(i_e0_);
                                if(49<=_e2_)
                                 if(58<=_e2_)
                                  var _e3_=0;
                                 else
                                  {var
                                    _e1_=
                                     [0,
                                      caml_int_of_string
                                       (_bo_(_eY_,i_e0_,(_eY_.getLen()-i_e0_|0)-1|0)),
                                      neg_eZ_],
                                    _e3_=1;}
                                else
                                 {if(45===_e2_)
                                   {var _e5_=i_e0_+1|0,_e4_=1,neg_eZ_=_e4_,i_e0_=_e5_;
                                    continue;}
                                  var _e3_=0;}
                                if(!_e3_){var _e6_=i_e0_+1|0,i_e0_=_e6_;continue;}}
                              var match_e7_=_e1_;
                              break;}}
                          catch(_e8_)
                           {if(_e8_[1]!==_a_)throw _e8_;
                            var match_e7_=bad_conversion_b1_(_eY_,0,115);}
                          var
                           p_e9_=match_e7_[1],
                           _e__=x_eE_.getLen(),
                           _e$_=0,
                           neg_fd_=match_e7_[2],
                           _fc_=32;
                          if(p_e9_===_e__&&0===_e$_)
                           {var _fa_=x_eE_,_fb_=1;}
                          else
                           var _fb_=0;
                          if(!_fb_)
                           if(p_e9_<=_e__)
                            var _fa_=_bo_(x_eE_,_e$_,_e__);
                           else
                            {var res_fe_=_bn_(p_e9_,_fc_);
                             if(neg_fd_)
                              _bp_(x_eE_,_e$_,res_fe_,0,_e__);
                             else
                              _bp_(x_eE_,_e$_,res_fe_,p_e9_-_e__|0,_e__);
                             var _fa_=res_fe_;}
                          var s_eX_=_fa_;}
                        var
                         _en_=
                          cont_s_em_(next_index_ea_(spec_ee_,n_d9_),s_eX_,i_d6_+1|0),
                         _ei_=1;
                        break;
                       case 67:
                       case 99:
                        var x_ff_=get_arg_d8_(spec_ee_,n_d9_);
                        if(99===_eh_)
                         var s_fg_=_bn_(1,x_ff_);
                        else
                         {if(39===x_ff_)
                           var _fh_=_aD_;
                          else
                           if(92===x_ff_)
                            var _fh_=_aE_;
                           else
                            {if(14<=x_ff_)
                              var _fi_=0;
                             else
                              switch(x_ff_)
                               {case 8:var _fh_=_aI_,_fi_=1;break;
                                case 9:var _fh_=_aH_,_fi_=1;break;
                                case 10:var _fh_=_aG_,_fi_=1;break;
                                case 13:var _fh_=_aF_,_fi_=1;break;
                                default:var _fi_=0;}
                             if(!_fi_)
                              if(caml_is_printable(x_ff_))
                               {var s_fj_=caml_create_string(1);
                                s_fj_.safeSet(0,x_ff_);
                                var _fh_=s_fj_;}
                              else
                               {var s_fk_=caml_create_string(4);
                                s_fk_.safeSet(0,92);
                                s_fk_.safeSet(1,48+(x_ff_/100|0)|0);
                                s_fk_.safeSet(2,48+((x_ff_/10|0)%10|0)|0);
                                s_fk_.safeSet(3,48+(x_ff_%10|0)|0);
                                var _fh_=s_fk_;}}
                          var s_fg_=_a0_(_at_,_a0_(_fh_,_au_));}
                        var
                         _en_=
                          cont_s_em_(next_index_ea_(spec_ee_,n_d9_),s_fg_,i_d6_+1|0),
                         _ei_=1;
                        break;
                       case 66:
                       case 98:
                        var
                         _fm_=i_d6_+1|0,
                         _fl_=get_arg_d8_(spec_ee_,n_d9_)?_aL_:_aK_,
                         _en_=cont_s_em_(next_index_ea_(spec_ee_,n_d9_),_fl_,_fm_),
                         _ei_=1;
                        break;
                       case 40:
                       case 123:
                        var
                         xf_fn_=get_arg_d8_(spec_ee_,n_d9_),
                         j_fo_=_cO_(sub_format_for_printf_dk_,_eh_,fmt_dV_,i_d6_+1|0);
                        if(123===_eh_)
                         {var
                           b_fp_=_bJ_(xf_fn_.getLen()),
                           add_char_ft_=
                            function(i_fr_,c_fq_){_bL_(b_fp_,c_fq_);return i_fr_+1|0;};
                          iter_on_format_args_dA_
                           (xf_fn_,
                            function(skip_fs_,i_fv_,c_fu_)
                             {if(skip_fs_)_bM_(b_fp_,_aq_);else _bL_(b_fp_,37);
                              return add_char_ft_(i_fv_,c_fu_);},
                            add_char_ft_);
                          var
                           _fw_=_bK_(b_fp_),
                           _en_=cont_s_em_(next_index_ea_(spec_ee_,n_d9_),_fw_,j_fo_),
                           _ei_=1;}
                        else
                         {var
                           _fx_=next_index_ea_(spec_ee_,n_d9_),
                           m_fA_=
                            add_int_index_bR_
                             (count_arguments_of_format_fy_(xf_fn_),_fx_),
                           _en_=
                            pr_fC_
                             (function(param_fB_){return doprn_fz_(m_fA_,j_fo_);},
                              _fx_,
                              xf_fn_,
                              v_d4_),
                           _ei_=1;}
                        break;
                       case 33:
                        _a6_(flush_fD_,out_dU_);
                        var _en_=doprn_fz_(n_d9_,i_d6_+1|0),_ei_=1;
                        break;
                       case 37:
                        var _en_=cont_s_em_(n_d9_,_az_,i_d6_+1|0),_ei_=1;break;
                       case 41:
                        var _en_=cont_s_em_(n_d9_,_ay_,i_d6_+1|0),_ei_=1;break;
                       case 44:
                        var _en_=cont_s_em_(n_d9_,_ax_,i_d6_+1|0),_ei_=1;break;
                       case 70:
                        var x_fE_=get_arg_d8_(spec_ee_,n_d9_);
                        if(0===widths_d$_)
                         {var
                           _fF_=caml_format_float(_aO_,x_fE_),
                           i_fG_=0,
                           l_fH_=_fF_.getLen();
                          for(;;)
                           {if(l_fH_<=i_fG_)
                             var _fI_=_a0_(_fF_,_aN_);
                            else
                             {var
                               _fJ_=_fF_.safeGet(i_fG_),
                               _fK_=48<=_fJ_?58<=_fJ_?0:1:45===_fJ_?1:0;
                              if(_fK_){var _fL_=i_fG_+1|0,i_fG_=_fL_;continue;}
                              var _fI_=_fF_;}
                            var s_fM_=_fI_;
                            break;}}
                        else
                         {var
                           sfmt_fN_=
                            extract_format_cq_(fmt_dV_,i_dX_,i_d6_,widths_d$_);
                          if(70===_eh_)sfmt_fN_.safeSet(sfmt_fN_.getLen()-1|0,103);
                          var s_fO_=caml_format_float(sfmt_fN_,x_fE_);
                          if(3<=caml_classify_float(x_fE_))
                           var _fP_=s_fO_;
                          else
                           {var i_fQ_=0,l_fR_=s_fO_.getLen();
                            for(;;)
                             {if(l_fR_<=i_fQ_)
                               var _fS_=_a0_(s_fO_,_as_);
                              else
                               {var
                                 _fT_=s_fO_.safeGet(i_fQ_)-46|0,
                                 _fU_=
                                  _fT_<0||23<_fT_
                                   ?55===_fT_?1:0
                                   :(_fT_-1|0)<0||21<(_fT_-1|0)?1:0;
                                if(!_fU_){var _fV_=i_fQ_+1|0,i_fQ_=_fV_;continue;}
                                var _fS_=s_fO_;}
                              var _fP_=_fS_;
                              break;}}
                          var s_fM_=_fP_;}
                        var
                         _en_=
                          cont_s_em_(next_index_ea_(spec_ee_,n_d9_),s_fM_,i_d6_+1|0),
                         _ei_=1;
                        break;
                       case 97:
                        var
                         printer_fW_=get_arg_d8_(spec_ee_,n_d9_),
                         n_fX_=_a6_(_bS_,get_index_d1_(spec_ee_,n_d9_)),
                         arg_fY_=get_arg_d8_(0,n_fX_),
                         _f2_=i_d6_+1|0,
                         _f1_=next_index_ea_(spec_ee_,n_fX_);
                        if(to_s_fZ_)
                         _dh_(outs_f0_,out_dU_,_dh_(printer_fW_,0,arg_fY_));
                        else
                         _dh_(printer_fW_,out_dU_,arg_fY_);
                        var _en_=doprn_fz_(_f1_,_f2_),_ei_=1;
                        break;
                       case 116:
                        var
                         printer_f3_=get_arg_d8_(spec_ee_,n_d9_),
                         _f5_=i_d6_+1|0,
                         _f4_=next_index_ea_(spec_ee_,n_d9_);
                        if(to_s_fZ_)
                         _dh_(outs_f0_,out_dU_,_a6_(printer_f3_,0));
                        else
                         _a6_(printer_f3_,out_dU_);
                        var _en_=doprn_fz_(_f4_,_f5_),_ei_=1;
                        break;
                       default:var _ei_=0;}
                    if(!_ei_)
                     var _en_=bad_conversion_format_cU_(fmt_dV_,i_d6_,_eh_);
                    return _en_;}},
               _f__=i_dX_+1|0,
               _f7_=0;
              return scan_positional_spec_ef_
                      (fmt_dV_,
                       function(spec_f9_,i_f6_)
                        {return scan_flags_ec_(spec_f9_,n_f8_,_f7_,i_f6_);},
                       n_f8_,
                       _f__);}
            _dh_(outc_f$_,out_dU_,_d0_);
            var _ga_=i_dX_+1|0,i_dX_=_ga_;
            continue;}}
        function cont_s_em_(n_gd_,s_gb_,i_gc_)
         {_dh_(outs_f0_,out_dU_,s_gb_);return doprn_fz_(n_gd_,i_gc_);}
        return doprn_fz_(n_ge_,0);}
      var
       kpr_gg_=_dh_(pr_fC_,k_gf_,index_of_int_bQ_(0)),
       _gh_=count_arguments_of_format_fy_(fmt_dS_);
      if(_gh_<0||6<_gh_)
       {var
         loop_gu_=
          function(i_gi_,args_go_)
           {if(_gh_<=i_gi_)
             {var
               a_gj_=caml_make_vect(_gh_,0),
               _gm_=
                function(i_gk_,arg_gl_)
                 {return caml_array_set(a_gj_,(_gh_-i_gk_|0)-1|0,arg_gl_);},
               i_gn_=0,
               param_gp_=args_go_;
              for(;;)
               {if(param_gp_)
                 {var _gq_=param_gp_[2],_gr_=param_gp_[1];
                  if(_gq_)
                   {_gm_(i_gn_,_gr_);
                    var _gs_=i_gn_+1|0,i_gn_=_gs_,param_gp_=_gq_;
                    continue;}
                  _gm_(i_gn_,_gr_);}
                return _dh_(kpr_gg_,fmt_dS_,a_gj_);}}
            return function(x_gt_)
             {return loop_gu_(i_gi_+1|0,[0,x_gt_,args_go_]);};},
         _gv_=loop_gu_(0,0);}
      else
       switch(_gh_)
        {case 1:
          var
           _gv_=
            function(x_gx_)
             {var a_gw_=caml_make_vect(1,0);
              caml_array_set(a_gw_,0,x_gx_);
              return _dh_(kpr_gg_,fmt_dS_,a_gw_);};
          break;
         case 2:
          var
           _gv_=
            function(x_gz_,y_gA_)
             {var a_gy_=caml_make_vect(2,0);
              caml_array_set(a_gy_,0,x_gz_);
              caml_array_set(a_gy_,1,y_gA_);
              return _dh_(kpr_gg_,fmt_dS_,a_gy_);};
          break;
         case 3:
          var
           _gv_=
            function(x_gC_,y_gD_,z_gE_)
             {var a_gB_=caml_make_vect(3,0);
              caml_array_set(a_gB_,0,x_gC_);
              caml_array_set(a_gB_,1,y_gD_);
              caml_array_set(a_gB_,2,z_gE_);
              return _dh_(kpr_gg_,fmt_dS_,a_gB_);};
          break;
         case 4:
          var
           _gv_=
            function(x_gG_,y_gH_,z_gI_,t_gJ_)
             {var a_gF_=caml_make_vect(4,0);
              caml_array_set(a_gF_,0,x_gG_);
              caml_array_set(a_gF_,1,y_gH_);
              caml_array_set(a_gF_,2,z_gI_);
              caml_array_set(a_gF_,3,t_gJ_);
              return _dh_(kpr_gg_,fmt_dS_,a_gF_);};
          break;
         case 5:
          var
           _gv_=
            function(x_gL_,y_gM_,z_gN_,t_gO_,u_gP_)
             {var a_gK_=caml_make_vect(5,0);
              caml_array_set(a_gK_,0,x_gL_);
              caml_array_set(a_gK_,1,y_gM_);
              caml_array_set(a_gK_,2,z_gN_);
              caml_array_set(a_gK_,3,t_gO_);
              caml_array_set(a_gK_,4,u_gP_);
              return _dh_(kpr_gg_,fmt_dS_,a_gK_);};
          break;
         case 6:
          var
           _gv_=
            function(x_gR_,y_gS_,z_gT_,t_gU_,u_gV_,v_gW_)
             {var a_gQ_=caml_make_vect(6,0);
              caml_array_set(a_gQ_,0,x_gR_);
              caml_array_set(a_gQ_,1,y_gS_);
              caml_array_set(a_gQ_,2,z_gT_);
              caml_array_set(a_gQ_,3,t_gU_);
              caml_array_set(a_gQ_,4,u_gV_);
              caml_array_set(a_gQ_,5,v_gW_);
              return _dh_(kpr_gg_,fmt_dS_,a_gQ_);};
          break;
         default:var _gv_=_dh_(kpr_gg_,fmt_dS_,[0]);}
      return _gv_;}
    function _g5_(fmt_gX_){return _bJ_(2*fmt_gX_.getLen()|0);}
    function _g2_(k_g0_,b_gY_)
     {var s_gZ_=_bK_(b_gY_);b_gY_[2]=0;return _a6_(k_g0_,s_gZ_);}
    function _g__(k_g1_)
     {var _g4_=_a6_(_g2_,k_g1_);
      return _g7_(_g6_,1,_g5_,_bL_,_bM_,function(_g3_){return 0;},_g4_);}
    var _g$_=[0,0];
    function _ha_(fmt_g9_)
     {return _dh_(_g__,function(s_g8_){return s_g8_;},fmt_g9_);}
    32===_bq_;
    function _hd_(param_hc_)
     {var seq_hb_=[];
      caml_update_dummy(seq_hb_,[0,seq_hb_,seq_hb_]);
      return seq_hb_;}
    var Canceled_he_=[0,_$_],current_data_hf_=[0,0],max_removed_iq_=42;
    function repr_rec_hj_(t_hg_)
     {var _hh_=t_hg_[1];
      {if(3===_hh_[0])
        {var t__hi_=_hh_[1],t___hk_=repr_rec_hj_(t__hi_);
         if(t___hk_!==t__hi_)t_hg_[1]=[3,t___hk_];
         return t___hk_;}
       return t_hg_;}}
    function repr_h6_(t_hl_){return repr_rec_hj_(t_hl_);}
    function run_waiters_hK_(waiters_hm_,state_hq_)
     {var ws_hn_=waiters_hm_,rem_ho_=0,save_hD_=current_data_hf_[1];
      for(;;)
       {if(typeof ws_hn_==="number")
         {if(rem_ho_)
           {var
             rem_hC_=rem_ho_[2],
             ws_hB_=rem_ho_[1],
             ws_hn_=ws_hB_,
             rem_ho_=rem_hC_;
            continue;}}
        else
         switch(ws_hn_[0])
          {case 1:
            var _hp_=ws_hn_[1];
            if(rem_ho_)
             {var rem_hs_=rem_ho_[2],ws_hr_=rem_ho_[1];
              _a6_(_hp_,state_hq_);
              var ws_hn_=ws_hr_,rem_ho_=rem_hs_;
              continue;}
            _a6_(_hp_,state_hq_);
            break;
           case 2:
            var
             ws1_ht_=ws_hn_[1],
             _hu_=[0,ws_hn_[2],rem_ho_],
             ws_hn_=ws1_ht_,
             rem_ho_=_hu_;
            continue;
           default:
            var _hv_=ws_hn_[1][1];
            if(_hv_)
             {var _hw_=_hv_[1];
              if(rem_ho_)
               {var rem_hy_=rem_ho_[2],ws_hx_=rem_ho_[1];
                _a6_(_hw_,state_hq_);
                var ws_hn_=ws_hx_,rem_ho_=rem_hy_;
                continue;}
              _a6_(_hw_,state_hq_);}
            else
             if(rem_ho_)
              {var
                rem_hA_=rem_ho_[2],
                ws_hz_=rem_ho_[1],
                ws_hn_=ws_hz_,
                rem_ho_=rem_hA_;
               continue;}}
        current_data_hf_[1]=save_hD_;
        return 0;}}
    function wakeup_ix_(t_hE_,v_hH_)
     {var t_hF_=repr_rec_hj_(t_hE_),_hG_=t_hF_[1];
      switch(_hG_[0])
       {case 1:if(_hG_[1][1]===Canceled_he_)return 0;break;
        case 2:
         var state_hI_=[0,v_hH_],waiters_hJ_=_hG_[1][2];
         t_hF_[1]=state_hI_;
         return run_waiters_hK_(waiters_hJ_,state_hI_);
        default:}
      return _aP_(_aa_);}
    function append_hR_(l1_hL_,l2_hM_)
     {return typeof l1_hL_==="number"
              ?l2_hM_
              :typeof l2_hM_==="number"?l1_hL_:[2,l1_hL_,l2_hM_];}
    function cleanup_hO_(ws_hN_)
     {if(typeof ws_hN_!=="number")
       switch(ws_hN_[0])
        {case 2:
          var l1_hP_=ws_hN_[1],_hQ_=cleanup_hO_(ws_hN_[2]);
          return append_hR_(cleanup_hO_(l1_hP_),_hQ_);
         case 1:break;
         default:if(!ws_hN_[1][1])return 0;}
      return ws_hN_;}
    function fail_h9_(e_hS_){return [0,[1,e_hS_]];}
    function task_iy_(param_h2_)
     {var t_hT_=[],_h1_=0,_h0_=0;
      caml_update_dummy
       (t_hT_,
        [0,
         [2,
          [0,
           [0,
            [0,
             function(param_hZ_)
              {var t_hU_=repr_rec_hj_(t_hT_),_hV_=t_hU_[1];
               if(2===_hV_[0])
                {var state_hW_=[1,[0,Canceled_he_]],waiters_hX_=_hV_[1][2];
                 t_hU_[1]=state_hW_;
                 var _hY_=run_waiters_hK_(waiters_hX_,state_hW_);}
               else
                var _hY_=0;
               return _hY_;}]],
           _h0_,
           _h1_]]]);
      return [0,t_hT_,t_hT_];}
    function add_immutable_waiter_iw_(sleeper_h3_,waiter_h4_)
     {var
       _h5_=
        typeof sleeper_h3_[2]==="number"
         ?[1,waiter_h4_]
         :[2,[1,waiter_h4_],sleeper_h3_[2]];
      sleeper_h3_[2]=_h5_;
      return 0;}
    function bind_iz_(t_h7_,f_id_)
     {var _h8_=repr_h6_(t_h7_)[1];
      switch(_h8_[0])
       {case 1:return fail_h9_(_h8_[1]);
        case 2:
         var
          sleeper_h__=_h8_[1],
          _h$_=[0,[2,[0,sleeper_h__[1],0,0]]],
          data_ib_=current_data_hf_[1];
         add_immutable_waiter_iw_
          (sleeper_h__,
           function(param_ia_)
            {switch(param_ia_[0])
              {case 0:
                var v_ic_=param_ia_[1];
                current_data_hf_[1]=data_ib_;
                try
                 {var _ie_=_a6_(f_id_,v_ic_),_if_=_ie_;}
                catch(_ig_){var _if_=fail_h9_(_ig_);}
                var
                 t1_ih_=repr_h6_(_h$_),
                 t2_ii_=repr_h6_(_if_),
                 _ij_=t1_ih_[1];
                if(2===_ij_[0])
                 {var sleeper1_ik_=_ij_[1];
                  if(t1_ih_===t2_ii_)
                   var _il_=0;
                  else
                   {var _im_=t2_ii_[1];
                    if(2===_im_[0])
                     {var sleeper2_in_=_im_[1];
                      t2_ii_[1]=[3,t1_ih_];
                      sleeper1_ik_[1][1]=[1,sleeper2_in_[1]];
                      var
                       waiters_io_=append_hR_(sleeper1_ik_[2],sleeper2_in_[2]),
                       removed_ip_=sleeper1_ik_[3]+sleeper2_in_[3]|0,
                       _il_=
                        max_removed_iq_<removed_ip_
                         ?(sleeper1_ik_[3]=
                           0,
                           sleeper1_ik_[2]=
                           cleanup_hO_(waiters_io_),
                           0)
                         :(sleeper1_ik_[3]=removed_ip_,sleeper1_ik_[2]=waiters_io_,0);}
                    else
                     {t1_ih_[1]=_im_;
                      var _il_=run_waiters_hK_(sleeper1_ik_[2],_im_);}}}
                else
                 var _il_=_aP_(_ab_);
                return _il_;
               case 1:
                var _ir_=[1,param_ia_[1]],t_is_=repr_h6_(_h$_),_it_=t_is_[1];
                if(2===_it_[0])
                 {var waiters_iu_=_it_[1][2];
                  t_is_[1]=_ir_;
                  var _iv_=run_waiters_hK_(waiters_iu_,_ir_);}
                else
                 var _iv_=_aP_(_ac_);
                return _iv_;
               default:throw [0,_c_,_ae_];}});
         return _h$_;
        case 3:throw [0,_c_,_ad_];
        default:return _a6_(f_id_,_h8_[1]);}}
    var
     _iA_=[0],
     _iB_=[0,caml_make_vect(55,0),0],
     seed_iC_=caml_equal(_iA_,[0])?[0,0]:_iA_,
     l_iD_=seed_iC_.length-1,
     _iE_=0,
     _iF_=54;
    if(!(_iF_<_iE_))
     {var i_iG_=_iE_;
      for(;;)
       {caml_array_set(_iB_[1],i_iG_,i_iG_);
        var _iH_=i_iG_+1|0;
        if(_iF_!==i_iG_){var i_iG_=_iH_;continue;}
        break;}}
    var
     accu_iI_=[0,_ah_],
     _iJ_=0,
     _iK_=55,
     _iL_=caml_greaterequal(_iK_,l_iD_)?_iK_:l_iD_,
     _iM_=54+_iL_|0;
    if(!(_iM_<_iJ_))
     {var i_iN_=_iJ_;
      for(;;)
       {var
         j_iO_=i_iN_%55|0,
         _iP_=accu_iI_[1],
         _iQ_=
          _a0_
           (_iP_,
            string_of_int_a1_(caml_array_get(seed_iC_,caml_mod(i_iN_,l_iD_))));
        accu_iI_[1]=caml_md5_string(_iQ_,0,_iQ_.getLen());
        var _iR_=accu_iI_[1];
        caml_array_set
         (_iB_[1],
          j_iO_,
          caml_array_get(_iB_[1],j_iO_)^
          (((_iR_.safeGet(0)+(_iR_.safeGet(1)<<8)|0)+(_iR_.safeGet(2)<<16)|0)+
           (_iR_.safeGet(3)<<24)|
           0));
        var _iS_=i_iN_+1|0;
        if(_iM_!==i_iN_){var i_iN_=_iS_;continue;}
        break;}}
    _iB_[2]=0;
    var
     pause_hook_iV_=[0,function(_iT_){return 0;}],
     _iU_=_hd_(0),
     _iX_=[0,0],
     null_i1_=null,
     undefined_i2_=undefined,
     _true_i3_=true,
     _false_i4_=false,
     array_constructor_i5_=Array,
     date_constr_i6_=Date;
    function _i8_(param_i0_)
     {if(_iU_[2]===_iU_)return 0;
      var tmp_iW_=_hd_(0);
      tmp_iW_[1][2]=_iU_[2];
      _iU_[2][1]=tmp_iW_[1];
      tmp_iW_[1]=_iU_[1];
      _iU_[1][2]=tmp_iW_;
      _iU_[1]=_iU_;
      _iU_[2]=_iU_;
      _iX_[1]=0;
      var curr_iY_=tmp_iW_[2];
      for(;;)
       {if(curr_iY_!==tmp_iW_)
         {if(curr_iY_[4])wakeup_ix_(curr_iY_[3],0);
          var _iZ_=curr_iY_[2],curr_iY_=_iZ_;
          continue;}
        return 0;}}
    function _i9_(e_i7_)
     {return e_i7_ instanceof array_constructor_i5_
              ?0
              :[0,new MlWrappedString(e_i7_.toString())];}
    _g$_[1]=[0,_i9_,_g$_[1]];
    function _i$_(_i__){return _i__;}
    function appendChild_jw_(p_ja_,n_jb_){p_ja_.appendChild(n_jb_);return 0;}
    function handler_jx_(f_jd_)
     {return _i$_
              (caml_js_wrap_callback
                (function(e_jc_)
                  {if(e_jc_)
                    {var res_je_=_a6_(f_jd_,e_jc_);
                     if(!(res_je_|0))e_jc_.preventDefault();
                     return res_je_;}
                   var _jf_=event,res_jg_=_a6_(f_jd_,_jf_);
                   _jf_.returnValue=res_jg_;
                   return res_jg_;}));}
    function _jy_(s_jh_){return s_jh_.toString();}
    function _jz_(e_ji_,typ_jj_,h_jm_,capt_jt_)
     {if(e_ji_.addEventListener===undefined_i2_)
       {var
         ev_jk_=___.toString().concat(typ_jj_),
         callback_jr_=
          function(e_jl_)
           {var _jq_=[0,h_jm_,e_jl_,[0]];
            return _a6_
                    (function(_jp_,_jo_,_jn_)
                      {return caml_js_call(_jp_,_jo_,_jn_);},
                     _jq_);};
        e_ji_.attachEvent(ev_jk_,callback_jr_);
        return function(param_js_)
         {return e_ji_.detachEvent(ev_jk_,callback_jr_);};}
      e_ji_.addEventListener(typ_jj_,h_jm_,capt_jt_);
      return function(param_ju_)
       {return e_ji_.removeEventListener(typ_jj_,h_jm_,capt_jt_);};}
    function _jA_(id_jv_){return _a6_(id_jv_,0);}
    var
     mouseup_jB_=_jy_(_J_),
     mousemove_jD_=_jy_(_I_),
     _2d__jC_=_H_.toString(),
     window_jE_=window,
     document_jF_=window_jE_.document,
     onIE_jR_=caml_js_on_ie(0)|0;
    function opt_iter_jU_(x_jG_,f_jH_){return x_jG_?_a6_(f_jH_,x_jG_[1]):0;}
    function createElement_jK_(doc_jJ_,name_jI_)
     {return doc_jJ_.createElement(name_jI_.toString());}
    function unsafeCreateElement_j3_(doc_jM_,name_jL_)
     {return createElement_jK_(doc_jM_,name_jL_);}
    function unsafeCreateElementEx_jZ_(_type_jN_,name_jO_,doc_jQ_,elt_jP_)
     {if(0===_type_jN_&&0===name_jO_)
       return createElement_jK_(doc_jQ_,elt_jP_);
      if(onIE_jR_)
       {var a_jS_=new array_constructor_i5_();
        a_jS_.push(_M_.toString(),elt_jP_.toString());
        opt_iter_jU_
         (_type_jN_,
          function(t_jT_)
           {a_jS_.push
             (_N_.toString(),caml_js_html_escape(t_jT_),_O_.toString());
            return 0;});
        opt_iter_jU_
         (name_jO_,
          function(n_jV_)
           {a_jS_.push
             (_P_.toString(),caml_js_html_escape(n_jV_),_Q_.toString());
            return 0;});
        a_jS_.push(_L_.toString());
        return doc_jQ_.createElement(a_jS_.join(_K_.toString()));}
      var res_jW_=createElement_jK_(doc_jQ_,elt_jP_);
      opt_iter_jU_(_type_jN_,function(t_jX_){return res_jW_.type=t_jX_;});
      opt_iter_jU_(name_jO_,function(n_jY_){return res_jW_.name=n_jY_;});
      return res_jW_;}
    function createInput_j6_(_type_j2_,name_j1_,doc_j0_)
     {return unsafeCreateElementEx_jZ_(_type_j2_,name_j1_,doc_j0_,_T_);}
    function createLabel_j7_(doc_j4_)
     {return unsafeCreateElement_j3_(doc_j4_,_U_);}
    function createDiv_j8_(doc_j5_)
     {return unsafeCreateElement_j3_(doc_j5_,_V_);}
    var Canvas_not_available_j9_=[0,_G_];
    window.HTMLElement===undefined_i2_;
    pause_hook_iV_[1]=
    function(param_j__)
     {return 1===param_j__
              ?(window_jE_.setTimeout(caml_js_wrap_callback(_i8_),0),0)
              :0;};
    var
     width_j$_=600,
     pi_ka_=4*Math.atan(1),
     obliquity_kb_=23.5*pi_ka_/180,
     gamma_kc_=2,
     dark_kd_=Math.pow(0.2,gamma_kc_),
     button_type_ke_=_i_.toString();
    function toggle_button_k3_(txt1_kg_,txt2_ki_,action_km_)
     {var
       state_kf_=[0,0],
       txt1_kh_=txt1_kg_.toString(),
       txt2_kk_=txt2_ki_.toString(),
       b_kj_=createInput_j6_([0,button_type_ke_],0,document_jF_);
      b_kj_.value=txt1_kh_;
      b_kj_.onclick=
      handler_jx_
       (function(param_kn_)
         {state_kf_[1]=1-state_kf_[1];
          var _kl_=state_kf_[1]?txt2_kk_:txt1_kh_;
          b_kj_.value=_kl_;
          _a6_(action_km_,state_kf_[1]);
          return _true_i3_;});
      return b_kj_;}
    function checkbox_k4_(txt_kt_,checked_kp_,action_kq_)
     {var b_ko_=createInput_j6_([0,_j_.toString()],0,document_jF_);
      b_ko_.checked=!!checked_kp_;
      b_ko_.onclick=
      handler_jx_
       (function(param_kr_)
         {_a6_(action_kq_,b_ko_.checked|0);return _true_i3_;});
      var lab_ks_=createLabel_j7_(document_jF_);
      appendChild_jw_(lab_ks_,b_ko_);
      appendChild_jw_(lab_ks_,document_jF_.createTextNode(txt_kt_.toString()));
      return lab_ks_;}
    function vertex_kV_(x_kw_,y_kv_,z_ku_){return [-1,x_kw_,y_kv_,z_ku_];}
    function vect_k5_(param_ky_,_kx_)
     {return [-1,
              _kx_[1]-param_ky_[1],
              _kx_[2]-param_ky_[2],
              _kx_[3]-param_ky_[3]];}
    function matrix_vect_mul_kP_(m_kD_,param_kz_)
     {var
       z_kA_=param_kz_[3],
       y_kB_=param_kz_[2],
       x_kC_=param_kz_[1],
       r3_kE_=m_kD_[3],
       r2_kF_=m_kD_[2],
       r1_kG_=m_kD_[1];
      return [-1,
              x_kC_*r1_kG_[1]+y_kB_*r1_kG_[2]+z_kA_*r1_kG_[3],
              x_kC_*r2_kF_[1]+y_kB_*r2_kF_[2]+z_kA_*r2_kF_[3],
              x_kC_*r3_kE_[1]+y_kB_*r3_kE_[2]+z_kA_*r3_kE_[3]];}
    function matrix_transp_kL_(m_kH_)
     {var r3_kI_=m_kH_[3],r2_kJ_=m_kH_[2],r1_kK_=m_kH_[1];
      return [0,
              [-1,r1_kK_[1],r2_kJ_[1],r3_kI_[1]],
              [-1,r1_kK_[2],r2_kJ_[2],r3_kI_[2]],
              [-1,r1_kK_[3],r2_kJ_[3],r3_kI_[3]]];}
    function matrix_mul_k6_(m_kO_,m__kM_)
     {var
       m__kN_=matrix_transp_kL_(m__kM_),
       _kQ_=matrix_vect_mul_kP_(m__kN_,m_kO_[3]),
       _kR_=matrix_vect_mul_kP_(m__kN_,m_kO_[2]);
      return [0,matrix_vect_mul_kP_(m__kN_,m_kO_[1]),_kR_,_kQ_];}
    function xz_rotation_k7_(phi_kS_)
     {var
       cos_phi_kT_=Math.cos(phi_kS_),
       sin_phi_kU_=Math.sin(phi_kS_),
       _kW_=vertex_kV_(-sin_phi_kU_,0,cos_phi_kT_),
       _kX_=vertex_kV_(0,1,0);
      return [0,vertex_kV_(cos_phi_kT_,0,sin_phi_kU_),_kX_,_kW_];}
    function xy_rotation_k8_(phi_kY_)
     {var
       cos_phi_kZ_=Math.cos(phi_kY_),
       sin_phi_k0_=Math.sin(phi_kY_),
       _k1_=vertex_kV_(0,0,1),
       _k2_=vertex_kV_(-sin_phi_k0_,cos_phi_kZ_,0);
      return [0,vertex_kV_(cos_phi_kZ_,sin_phi_k0_,0),_k2_,_k1_];}
    var matrix_identity_k9_=xz_rotation_k7_(0);
    function face_li_(v1_la_,v2_k$_,v3_k__){return [0,v1_la_,v2_k$_,v3_k__];}
    function create_canvas_lj_(w_lc_,h_ld_)
     {var c_lb_=unsafeCreateElement_j3_(document_jF_,_Z_);
      if(1-(c_lb_.getContext==null_i1_?1:0))
       {c_lb_.width=w_lc_;c_lb_.height=h_ld_;return c_lb_;}
      throw [0,Canvas_not_available_j9_];}
    function min_lk_(u_le_,v_lf_){return u_le_<v_lf_?u_le_:v_lf_;}
    function max_ll_(u_lg_,v_lh_){return u_lg_<v_lh_?v_lh_:u_lg_;}
    var
     _lm_=8,
     _ln_=12,
     t_delta_lo_=pi_ka_/_lm_,
     n_lp_=_lm_*_ln_|0,
     vertices_lq_=caml_make_vect(n_lp_+2|0,vertex_kV_(0,0,0)),
     faces_lr_=caml_make_vect(n_lp_*2|0,face_li_(0,0,0)),
     south_ls_=n_lp_+1|0;
    caml_array_set(vertices_lq_,n_lp_,vertex_kV_(0,-1,0));
    caml_array_set(vertices_lq_,south_ls_,vertex_kV_(0,1,0));
    var
     _lt_=0,
     _lu_=_ln_-1|0,
     p_delta_lz_=2*pi_ka_/_ln_,
     t_offset_lB_=(pi_ka_-t_delta_lo_)/2;
    if(!(_lu_<_lt_))
     {var i_lv_=_lt_;
      for(;;)
       {var _lw_=0,_lx_=_lm_-1|0;
        if(!(_lx_<_lw_))
         {var j_ly_=_lw_;
          for(;;)
           {var
             phi_lA_=i_lv_*p_delta_lz_,
             theta_lC_=j_ly_*t_delta_lo_-t_offset_lB_,
             k_lD_=(i_lv_*_lm_|0)+j_ly_|0;
            caml_array_set
             (vertices_lq_,
              k_lD_,
              vertex_kV_
               (Math.cos(phi_lA_)*Math.cos(theta_lC_),
                Math.sin(theta_lC_),
                Math.sin(phi_lA_)*Math.cos(theta_lC_)));
            if(0===j_ly_)
             {caml_array_set
               (faces_lr_,
                2*k_lD_|0,
                face_li_(n_lp_,k_lD_,caml_mod(k_lD_+_lm_|0,n_lp_)));
              caml_array_set
               (faces_lr_,
                (2*k_lD_|0)+1|0,
                face_li_
                 (south_ls_,
                  caml_mod((k_lD_+(2*_lm_|0)|0)-1|0,n_lp_),
                  (k_lD_+_lm_|0)-1|0));}
            else
             {caml_array_set
               (faces_lr_,
                2*k_lD_|0,
                face_li_(k_lD_,caml_mod(k_lD_+_lm_|0,n_lp_),k_lD_-1|0));
              caml_array_set
               (faces_lr_,
                (2*k_lD_|0)+1|0,
                face_li_
                 (k_lD_-1|0,
                  caml_mod(k_lD_+_lm_|0,n_lp_),
                  caml_mod((k_lD_+_lm_|0)-1|0,n_lp_)));}
            var _lE_=j_ly_+1|0;
            if(_lx_!==j_ly_){var j_ly_=_lE_;continue;}
            break;}}
        var _lF_=i_lv_+1|0;
        if(_lu_!==i_lv_){var i_lv_=_lF_;continue;}
        break;}}
    var texture_pi_=_g_.toString();
    window_jE_.onload=
    handler_jx_
     (function(param_pm_)
       {function _o$_(texture_lG_)
         {var
           w_lH_=texture_lG_.width,
           h_lI_=texture_lG_.height,
           canvas_lJ_=create_canvas_lj_(w_lH_,h_lI_),
           ctx_lK_=canvas_lJ_.getContext(_2d__jC_),
           _lL_=h_lI_/8|0,
           _lM_=w_lH_/8|0,
           img_lN_=ctx_lK_.getImageData(0,0,_lM_,_lL_),
           data_lO_=img_lN_.data,
           inv_gamma_l4_=1/gamma_kc_;
          function update_shadow_l8_(obliquity_lP_)
           {var
             _lQ_=0,
             _lR_=_lL_-1|0,
             cos_obl_lY_=Math.cos(obliquity_lP_),
             sin_obl_lX_=-Math.sin(obliquity_lP_);
            if(!(_lR_<_lQ_))
             {var j_lS_=_lQ_;
              for(;;)
               {var _lT_=0,_lU_=(_lM_/2|0)-1|0;
                if(!(_lU_<_lT_))
                 {var i_lV_=_lT_;
                  for(;;)
                   {var
                     theta_lW_=(j_lS_/_lL_-0.5)*pi_ka_,
                     _lZ_=
                      Math.cos(i_lV_/_lM_*2*pi_ka_)*
                      Math.cos(theta_lW_)*
                      cos_obl_lY_+
                      Math.sin(theta_lW_)*
                      sin_obl_lX_,
                     k_l2_=4*(i_lV_+j_lS_*_lM_)|0,
                     k__l1_=4*(_lM_-i_lV_+j_lS_*_lM_-1)|0,
                     c_l0_=0<_lZ_?dark_kd_:dark_kd_-_lZ_*(1-dark_kd_)*1.2,
                     c_l3_=c_l0_<=1?c_l0_:1,
                     c_l5_=255-(255.99*Math.pow(c_l3_,inv_gamma_l4_)|0)|0;
                    data_lO_[k_l2_+3|0]=c_l5_;
                    data_lO_[k__l1_+3|0]=c_l5_;
                    var _l6_=i_lV_+1|0;
                    if(_lU_!==i_lV_){var i_lV_=_l6_;continue;}
                    break;}}
                var _l7_=j_lS_+1|0;
                if(_lR_!==j_lS_){var j_lS_=_l7_;continue;}
                break;}}
            ctx_lK_.putImageData(img_lN_,0,0);
            ctx_lK_.globalCompositeOperation=_k_.toString();
            ctx_lK_.save();
            ctx_lK_.scale(8*(_lM_+2|0)/_lM_,8*(_lL_+2|0)/_lL_);
            ctx_lK_.translate(-1,-1);
            ctx_lK_.drawImage(canvas_lJ_,0,0);
            return ctx_lK_.restore();}
          update_shadow_l8_(obliquity_kb_);
          var
           w_l9_=texture_lG_.width,
           canvas__l__=create_canvas_lj_(w_l9_,texture_lG_.height),
           ctx__l$_=canvas__l__.getContext(_2d__jC_),
           no_lighting_ma_=[0,0],
           canvas_mb_=create_canvas_lj_(width_j$_,width_j$_),
           canvas__mc_=create_canvas_lj_(width_j$_,width_j$_);
          appendChild_jw_(document_jF_.body,canvas_mb_);
          var
           ctx_md_=canvas_mb_.getContext(_2d__jC_),
           ctx__me_=canvas__mc_.getContext(_2d__jC_),
           r_mf_=width_j$_/2,
           tw_mg_=texture_lG_.width,
           th_mh_=texture_lG_.height,
           uv_ml_=
            _ba_
             (function(v_mi_)
               {var
                 u_mj_=
                  (tw_mg_-
                   Math.atan2(v_mi_[3],v_mi_[1])*
                   ((tw_mg_/2-0.99)/pi_ka_)|
                   0)%
                  tw_mg_,
                 v_mk_=th_mh_/2+Math.asin(v_mi_[2])*((th_mh_-0.99)/pi_ka_)|0;
                if(0<=u_mj_)
                 {if(u_mj_<tw_mg_)
                   {if(0<=v_mk_)
                     {if(v_mk_<th_mh_)return [0,u_mj_,v_mk_];throw [0,_c_,_l_];}
                    throw [0,_c_,_m_];}
                  throw [0,_c_,_n_];}
                throw [0,_c_,_o_];},
              vertices_lq_),
           normals_nb_=
            _ba_
             (function(param_mm_)
               {var
                 v1_mn_=caml_array_get(vertices_lq_,param_mm_[1]),
                 v2_mp_=caml_array_get(vertices_lq_,param_mm_[2]),
                 _mo_=
                  vect_k5_(v1_mn_,caml_array_get(vertices_lq_,param_mm_[3])),
                 _mq_=vect_k5_(v1_mn_,v2_mp_),
                 z2_mr_=_mo_[3],
                 y2_ms_=_mo_[2],
                 x2_mt_=_mo_[1],
                 z1_mu_=_mq_[3],
                 y1_mv_=_mq_[2],
                 x1_mw_=_mq_[1];
                return [-1,
                        y1_mv_*z2_mr_-y2_ms_*z1_mu_,
                        z1_mu_*x2_mt_-z2_mr_*x1_mw_,
                        x1_mw_*y2_ms_-x2_mt_*y1_mv_];},
              faces_lr_),
           paused_nc_=[0,0],
           follow_nd_=[0,0],
           lighting_ne_=[0,1],
           clipped_nf_=[0,1],
           obl_ng_=[0,obliquity_kb_],
           face_info_nh_=
            _ba_
             (function(f_mx_)
               {var
                 match_my_=caml_array_get(uv_ml_,f_mx_[1]),
                 v1_mz_=match_my_[2],
                 u1_mA_=match_my_[1],
                 match_mB_=caml_array_get(uv_ml_,f_mx_[2]),
                 v2_mC_=match_mB_[2],
                 u2_mD_=match_mB_[1],
                 match_mE_=caml_array_get(uv_ml_,f_mx_[3]),
                 v3_mF_=match_mE_[2],
                 u3_mG_=match_mE_[1],
                 mid_mH_=tw_mg_/2;
                if(u1_mA_==0)
                 {if(mid_mH_<u2_mD_||mid_mH_<u3_mG_)
                   var _mI_=1;
                  else
                   {var _mJ_=0,_mI_=0;}
                  if(_mI_){var u1_mK_=tw_mg_-2,_mJ_=1;}}
                else
                 var _mJ_=0;
                if(!_mJ_)var u1_mK_=u1_mA_;
                if(u2_mD_==0)
                 {if(mid_mH_<u1_mK_||mid_mH_<u3_mG_)
                   var _mL_=1;
                  else
                   {var _mM_=0,_mL_=0;}
                  if(_mL_){var u2_mN_=tw_mg_-2,_mM_=1;}}
                else
                 var _mM_=0;
                if(!_mM_)var u2_mN_=u2_mD_;
                if(u3_mG_==0)
                 {if(mid_mH_<u2_mN_||mid_mH_<u1_mK_)
                   var _mO_=1;
                  else
                   {var _mP_=0,_mO_=0;}
                  if(_mO_){var u3_mQ_=tw_mg_-2,_mP_=1;}}
                else
                 var _mP_=0;
                if(!_mP_)var u3_mQ_=u3_mG_;
                var mth_mR_=th_mh_-2;
                if(v1_mz_==0||mth_mR_<=v1_mz_)
                 var _mS_=0;
                else
                 {var u1_mT_=u1_mK_,_mS_=1;}
                if(!_mS_)var u1_mT_=(u2_mN_+u3_mQ_)/2;
                if(v2_mC_==0||mth_mR_<=v2_mC_)
                 var _mU_=0;
                else
                 {var u2_mV_=u2_mN_,_mU_=1;}
                if(!_mU_)var u2_mV_=(u1_mT_+u3_mQ_)/2;
                if(v3_mF_==0||mth_mR_<=v3_mF_)
                 var _mW_=0;
                else
                 {var u3_mX_=u3_mQ_,_mW_=1;}
                if(!_mW_)var u3_mX_=(u2_mV_+u1_mT_)/2;
                var
                 u1_mY_=max_ll_(1,u1_mT_),
                 u2_mZ_=max_ll_(1,u2_mV_),
                 u3_m0_=max_ll_(1,u3_mX_),
                 v1_m1_=max_ll_(1,v1_mz_),
                 v2_m2_=max_ll_(1,v2_mC_),
                 v3_m3_=max_ll_(1,v3_mF_),
                 du2_m4_=u2_mZ_-u1_mY_,
                 du3_m5_=u3_m0_-u1_mY_,
                 dv2_m6_=v2_m2_-v1_m1_,
                 dv3_m7_=v3_m3_-v1_m1_,
                 su_m8_=dv2_m6_*du3_m5_-dv3_m7_*du2_m4_,
                 sv_m9_=du2_m4_*dv3_m7_-du3_m5_*dv2_m6_,
                 u_m__=max_ll_(0,min_lk_(u1_mY_,min_lk_(u2_mZ_,u3_m0_))-4),
                 v_m$_=max_ll_(0,min_lk_(v1_m1_,min_lk_(v2_m2_,v3_m3_))-4),
                 u__na_=
                  min_lk_(tw_mg_,max_ll_(u1_mY_,max_ll_(u2_mZ_,u3_m0_))+4);
                return [0,
                        u1_mY_,
                        v1_m1_,
                        du2_m4_/su_m8_,
                        dv2_m6_/sv_m9_,
                        du3_m5_/su_m8_,
                        dv3_m7_/sv_m9_,
                        u_m__,
                        v_m$_,
                        u__na_-u_m__,
                        min_lk_(th_mh_,max_ll_(v1_m1_,max_ll_(v2_m2_,v3_m3_))+4)-
                        v_m$_];},
              faces_lr_),
           m_obliq_ni_=[0,xy_rotation_k8_(-obliquity_kb_)],
           m_nj_=[0,matrix_identity_k9_],
           phi_rot_nk_=[0,0],
           rateText_nl_=document_jF_.createTextNode(_C_.toString()),
           ctrl_nm_=createDiv_j8_(document_jF_);
          ctrl_nm_.className=_B_.toString();
          var d_nn_=createDiv_j8_(document_jF_);
          appendChild_jw_(d_nn_,document_jF_.createTextNode(_A_.toString()));
          appendChild_jw_(ctrl_nm_,d_nn_);
          var form_no_=createDiv_j8_(document_jF_);
          function br_nr_(param_np_)
           {return unsafeCreateElement_j3_(document_jF_,_X_);}
          appendChild_jw_
           (form_no_,
            toggle_button_k3_
             (_y_,_z_,function(p_nq_){paused_nc_[1]=p_nq_;return 0;}));
          appendChild_jw_(form_no_,br_nr_(0));
          appendChild_jw_
           (form_no_,
            toggle_button_k3_
             (_w_,_x_,function(f_ns_){follow_nd_[1]=f_ns_;return 0;}));
          appendChild_jw_(form_no_,br_nr_(0));
          var b_nt_=createInput_j6_([0,button_type_ke_],0,document_jF_);
          b_nt_.value=_v_.toString();
          b_nt_.onclick=
          handler_jx_
           (function(param_nu_)
             {m_nj_[1]=matrix_identity_k9_;
              phi_rot_nk_[1]=0;
              m_obliq_ni_[1]=xy_rotation_k8_(-obl_ng_[1]);
              return _true_i3_;});
          appendChild_jw_(form_no_,b_nt_);
          appendChild_jw_(form_no_,br_nr_(0));
          var lab_nv_=createLabel_j7_(document_jF_);
          appendChild_jw_(lab_nv_,document_jF_.createTextNode(_u_.toString()));
          var
           _nw_=unsafeCreateElementEx_jZ_(0,0,document_jF_,_S_),
           param_nx_=_t_;
          for(;;)
           {if(param_nx_)
             {var
               l_nA_=param_nx_[2],
               a_nz_=param_nx_[1],
               _ny_=unsafeCreateElement_j3_(document_jF_,_R_);
              appendChild_jw_
               (_ny_,document_jF_.createTextNode(a_nz_.toString()));
              _nw_.add(_ny_,null_i1_);
              var param_nx_=l_nA_;
              continue;}
            _nw_.onchange=
            handler_jx_
             (function(param_nD_)
               {var
                 _nB_=_nw_.selectedIndex,
                 o_nC_=0===_nB_?obliquity_kb_:1===_nB_?0:-obliquity_kb_;
                update_shadow_l8_(o_nC_);
                obl_ng_[1]=o_nC_;
                return _true_i3_;});
            appendChild_jw_(lab_nv_,_nw_);
            appendChild_jw_(form_no_,lab_nv_);
            appendChild_jw_(ctrl_nm_,form_no_);
            var form_nE_=createDiv_j8_(document_jF_);
            appendChild_jw_
             (form_nE_,
              checkbox_k4_
               (_s_,1,function(l_nF_){lighting_ne_[1]=l_nF_;return 0;}));
            appendChild_jw_(form_nE_,br_nr_(0));
            appendChild_jw_
             (form_nE_,
              checkbox_k4_
               (_r_,1,function(l_nG_){clipped_nf_[1]=l_nG_;return 0;}));
            appendChild_jw_(form_nE_,br_nr_(0));
            appendChild_jw_
             (form_nE_,document_jF_.createTextNode(_q_.toString()));
            appendChild_jw_(form_nE_,rateText_nl_);
            appendChild_jw_(ctrl_nm_,form_nE_);
            appendChild_jw_(document_jF_.body,ctrl_nm_);
            var _nH_=unsafeCreateElement_j3_(document_jF_,_W_);
            _nH_.innerHTML=_p_.toString();
            appendChild_jw_(document_jF_.body,_nH_);
            var mx_nI_=[0,0],my_nJ_=[0,0];
            canvas_mb_.onmousedown=
            handler_jx_
             (function(ev_nK_)
               {mx_nI_[1]=ev_nK_.clientX;
                my_nJ_[1]=ev_nK_.clientY;
                var
                 c2_nX_=[0,null_i1_],
                 c1_nY_=
                  _jz_
                   (document_jF_,
                    mousemove_jD_,
                    handler_jx_
                     (function(ev_nL_)
                       {var
                         x_nM_=ev_nL_.clientX,
                         y_nN_=ev_nL_.clientY,
                         dx_nO_=x_nM_-mx_nI_[1]|0,
                         dy_nP_=y_nN_-my_nJ_[1]|0;
                        if(0!==dy_nP_)
                         {var
                           _nQ_=2*dy_nP_/width_j$_,
                           cos_phi_nR_=Math.cos(_nQ_),
                           sin_phi_nS_=Math.sin(_nQ_),
                           _nT_=m_nj_[1],
                           _nU_=vertex_kV_(0,-sin_phi_nS_,cos_phi_nR_),
                           _nV_=vertex_kV_(0,cos_phi_nR_,sin_phi_nS_);
                          m_nj_[1]=
                          matrix_mul_k6_([0,vertex_kV_(1,0,0),_nV_,_nU_],_nT_);}
                        if(0!==dx_nO_)
                         {var _nW_=m_nj_[1];
                          m_nj_[1]=
                          matrix_mul_k6_(xz_rotation_k7_(2*dx_nO_/width_j$_),_nW_);}
                        mx_nI_[1]=x_nM_;
                        my_nJ_[1]=y_nN_;
                        return _true_i3_;}),
                    _true_i3_);
                c2_nX_[1]=
                _i$_
                 (_jz_
                   (document_jF_,
                    mouseup_jB_,
                    handler_jx_
                     (function(param_n0_)
                       {_jA_(c1_nY_);
                        var _nZ_=c2_nX_[1];
                        if(_nZ_!=null_i1_)_jA_(_nZ_);
                        return _true_i3_;}),
                    _true_i3_));
                return _false_i4_;});
            var
             ti_n1_=[0,new date_constr_i6_().getTime()],
             fps_n2_=[0,0],
             loop_oR_=
              function(t_oL_,phi_n3_)
               {var rotation_n4_=xz_rotation_k7_(phi_n3_-phi_rot_nk_[1]);
                if(lighting_ne_[1])
                 {no_lighting_ma_[1]=0;
                  ctx__l$_.drawImage(texture_lG_,0,0);
                  var
                   i_n5_=
                    (2*pi_ka_-phi_n3_%(2*pi_ka_))*w_l9_/2/pi_ka_%w_l9_|0;
                  ctx__l$_.drawImage(canvas_lJ_,i_n5_,0);
                  ctx__l$_.drawImage(canvas_lJ_,i_n5_-w_l9_,0);}
                else
                 if(!no_lighting_ma_[1])
                  {ctx__l$_.drawImage(texture_lG_,0,0);no_lighting_ma_[1]=1;}
                var
                 _n6_=matrix_mul_k6_(m_obliq_ni_[1],rotation_n4_),
                 m_n7_=matrix_mul_k6_(m_nj_[1],_n6_),
                 _n9_=
                  _ba_
                   (function(v_n8_){return matrix_vect_mul_kP_(m_n7_,v_n8_);},
                    vertices_lq_),
                 _n__=matrix_vect_mul_kP_(matrix_transp_kL_(m_n7_),v_h_);
                ctx__me_.clearRect(0,0,width_j$_,width_j$_);
                ctx__me_.save();
                if(clipped_nf_[1])
                 {ctx__me_.beginPath();
                  ctx__me_.arc(r_mf_,r_mf_,r_mf_*0.95,0,-2*pi_ka_,_true_i3_);
                  ctx__me_.clip();}
                ctx__me_.setTransform(r_mf_-2,0,0,r_mf_-2,r_mf_,r_mf_);
                ctx__me_.globalCompositeOperation=_F_.toString();
                var _n$_=0,_oa_=faces_lr_.length-1-1|0;
                if(!(_oa_<_n$_))
                 {var i_ob_=_n$_;
                  for(;;)
                   {var
                     _oc_=faces_lr_[i_ob_+1],
                     match_od_=caml_array_get(_n9_,_oc_[1]),
                     y1_oe_=match_od_[2],
                     x1_of_=match_od_[1],
                     match_og_=caml_array_get(_n9_,_oc_[2]),
                     y2_oh_=match_og_[2],
                     x2_oi_=match_og_[1],
                     match_oj_=caml_array_get(_n9_,_oc_[3]),
                     y3_ok_=match_oj_[2],
                     x3_ol_=match_oj_[1],
                     _om_=caml_array_get(normals_nb_,i_ob_);
                    if(0<=_om_[1]*_n__[1]+_om_[2]*_n__[2]+_om_[3]*_n__[3])
                     {ctx__me_.beginPath();
                      ctx__me_.moveTo(x1_of_,y1_oe_);
                      ctx__me_.lineTo(x2_oi_,y2_oh_);
                      ctx__me_.lineTo(x3_ol_,y3_ok_);
                      ctx__me_.closePath();
                      ctx__me_.save();
                      ctx__me_.clip();
                      var
                       match_on_=caml_array_get(face_info_nh_,i_ob_),
                       dv_oo_=match_on_[10],
                       du_op_=match_on_[9],
                       v_oq_=match_on_[8],
                       u_or_=match_on_[7],
                       dv3_os_=match_on_[6],
                       du3_ot_=match_on_[5],
                       dv2_ou_=match_on_[4],
                       du2_ov_=match_on_[3],
                       v1_ow_=match_on_[2],
                       u1_ox_=match_on_[1],
                       dx2_oy_=x2_oi_-x1_of_,
                       dx3_oz_=x3_ol_-x1_of_,
                       dy2_oA_=y2_oh_-y1_oe_,
                       dy3_oB_=y3_ok_-y1_oe_,
                       a_oC_=dx2_oy_*dv3_os_-dx3_oz_*dv2_ou_,
                       b_oD_=dx2_oy_*du3_ot_-dx3_oz_*du2_ov_,
                       d_oE_=dy2_oA_*dv3_os_-dy3_oB_*dv2_ou_,
                       e_oF_=dy2_oA_*du3_ot_-dy3_oB_*du2_ov_;
                      ctx__me_.transform
                       (a_oC_,
                        d_oE_,
                        b_oD_,
                        e_oF_,
                        x1_of_-a_oC_*u1_ox_-b_oD_*v1_ow_,
                        y1_oe_-d_oE_*u1_ox_-e_oF_*v1_ow_);
                      ctx__me_.drawImage
                       (canvas__l__,
                        u_or_,
                        v_oq_,
                        du_op_,
                        dv_oo_,
                        u_or_,
                        v_oq_,
                        du_op_,
                        dv_oo_);
                      ctx__me_.restore();}
                    var _oG_=i_ob_+1|0;
                    if(_oa_!==i_ob_){var i_ob_=_oG_;continue;}
                    break;}}
                ctx__me_.restore();
                ctx_md_.globalCompositeOperation=_E_.toString();
                ctx_md_.drawImage(canvas__mc_,0,0);
                try {ctx_md_.getImageData(0,0,1,1);}catch(_o9_){}
                var
                 t__oH_=new date_constr_i6_().getTime(),
                 hz_oI_=1000/(t__oH_-ti_n1_[1]),
                 _oJ_=fps_n2_[1]==0?hz_oI_:0.9*fps_n2_[1]+0.1*hz_oI_;
                fps_n2_[1]=_oJ_;
                rateText_nl_.data=_dh_(_ha_,_D_,fps_n2_[1]).toString();
                ti_n1_[1]=t__oH_;
                function _oU_(param_oS_)
                 {var
                   t__oK_=new date_constr_i6_().getTime(),
                   dt_oM_=t__oK_-t_oL_,
                   dt_oN_=dt_oM_<0?0:1000<dt_oM_?0:dt_oM_,
                   angle_oO_=2*pi_ka_*dt_oN_/1000/10,
                   _oP_=
                    paused_nc_[1]
                     ?0
                     :follow_nd_[1]?(phi_rot_nk_[1]=phi_rot_nk_[1]+angle_oO_,1):0;
                  _oP_;
                  var _oQ_=paused_nc_[1]?phi_n3_:phi_n3_+angle_oO_;
                  return loop_oR_(t__oK_,_oQ_);}
                var
                 match_oT_=task_iy_(0),
                 t_oV_=match_oT_[1],
                 w_oW_=match_oT_[2],
                 _oY_=0.01*1000,
                 id_oZ_=
                  window_jE_.setTimeout
                   (caml_js_wrap_callback
                     (function(param_oX_){return wakeup_ix_(w_oW_,0);}),
                    _oY_);
                function _o1_(param_o0_)
                 {return window_jE_.clearTimeout(id_oZ_);}
                var _o2_=repr_h6_(t_oV_)[1];
                switch(_o2_[0])
                 {case 1:
                   var _o3_=_o2_[1][1]===Canceled_he_?(_o1_(0),1):0;break;
                  case 2:
                   var sleeper_o8_=_o2_[1],data_o5_=current_data_hf_[1];
                   add_immutable_waiter_iw_
                    (sleeper_o8_,
                     function(param_o4_)
                      {if(1===param_o4_[0]&&param_o4_[1][1]===Canceled_he_)
                        {current_data_hf_[1]=data_o5_;
                         try {var _o6_=_o1_(0);}catch(_o7_){return 0;}
                         return _o6_;}
                       return 0;});
                   var _o3_=1;
                   break;
                  default:var _o3_=0;}
                _o3_;
                return bind_iz_(t_oV_,_oU_);};
            return loop_oR_(new date_constr_i6_().getTime(),0);}}
        var _o__=unsafeCreateElement_j3_(document_jF_,_Y_);
        function _pc_(param_pa_){return [0,[0,_o__]];}
        var match_pb_=task_iy_(0),w_pe_=match_pb_[2],t_pf_=match_pb_[1];
        function cont_pg_(x_pd_){return wakeup_ix_(w_pe_,x_pd_);}
        _o__.onload=
        handler_jx_(function(param_ph_){cont_pg_(0);return _false_i4_;});
        _o__.src=texture_pi_;
        var _pj_=repr_h6_(bind_iz_(bind_iz_(t_pf_,_pc_),_o$_))[1];
        switch(_pj_[0])
         {case 1:throw _pj_[1];
          case 2:
           var sleeper_pl_=_pj_[1];
           add_immutable_waiter_iw_
            (sleeper_pl_,
             function(param_pk_)
              {switch(param_pk_[0])
                {case 0:return 0;
                 case 1:throw param_pk_[1];
                 default:throw [0,_c_,_ag_];}});
           break;
          case 3:throw [0,_c_,_af_];
          default:}
        return _false_i4_;});
    do_at_exit_a2_(0);
    return;}
  ());
