// This program was compiled from OCaml by js_of_ocaml 1.0
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1)
      for (var i = 0; i < l; i++) a2 [i2 + i] = a1 [i1 + i];
    else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (!this.len) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_equal (x, y) { return +(caml_compare_val(x,y,false) == 0); }
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_greaterequal (x, y) { return +(caml_compare(x,y,false) >= 0); }
var caml_js_regexps = { amp:/&/g, lt:/</g, quot:/\"/g, all:/[&<\"]/ };
function caml_js_html_escape (s) {
  if (!caml_js_regexps.all.test(s)) return s;
  return s.replace(caml_js_regexps.amp, "&amp;")
          .replace(caml_js_regexps.lt, "&lt;")
          .replace(caml_js_regexps.quot, "&quot;");
}
function caml_js_on_ie () {
  var ua = window.navigator?window.navigator.userAgent:"";
  return ua.indexOf("MSIE") != -1 && ua.indexOf("Opera") != 0;
}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function MlStringFromArray (a) {
  var len = a.length; this.array = a; this.len = this.last = len;
}
MlStringFromArray.prototype = new MlString ();
var caml_md5_string =
function () {
  function add (x, y) { return (x + y) | 0; }
  function xx(q,a,b,x,s,t) {
    a = add(add(a, q), add(x, t));
    return add((a << s) | (a >>> (32 - s)), b);
  }
  function ff(a,b,c,d,x,s,t) {
    return xx((b & c) | ((~b) & d), a, b, x, s, t);
  }
  function gg(a,b,c,d,x,s,t) {
    return xx((b & d) | (c & (~d)), a, b, x, s, t);
  }
  function hh(a,b,c,d,x,s,t) { return xx(b ^ c ^ d, a, b, x, s, t); }
  function ii(a,b,c,d,x,s,t) { return xx(c ^ (b | (~d)), a, b, x, s, t); }
  function md5(buffer, length) {
    var i = length;
    buffer[i >> 2] |= 0x80 << (8 * (i & 3));
    for (i = (i & ~0x3) + 4;(i & 0x3F) < 56 ;i += 4)
      buffer[i >> 2] = 0;
    buffer[i >> 2] = length << 3;
    i += 4;
    buffer[i >> 2] = (length >> 29) & 0x1FFFFFFF;
    var w = [0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476];
    for(i = 0; i < buffer.length; i += 16) {
      var a = w[0], b = w[1], c = w[2], d = w[3];
      a = ff(a, b, c, d, buffer[i+ 0], 7, 0xD76AA478);
      d = ff(d, a, b, c, buffer[i+ 1], 12, 0xE8C7B756);
      c = ff(c, d, a, b, buffer[i+ 2], 17, 0x242070DB);
      b = ff(b, c, d, a, buffer[i+ 3], 22, 0xC1BDCEEE);
      a = ff(a, b, c, d, buffer[i+ 4], 7, 0xF57C0FAF);
      d = ff(d, a, b, c, buffer[i+ 5], 12, 0x4787C62A);
      c = ff(c, d, a, b, buffer[i+ 6], 17, 0xA8304613);
      b = ff(b, c, d, a, buffer[i+ 7], 22, 0xFD469501);
      a = ff(a, b, c, d, buffer[i+ 8], 7, 0x698098D8);
      d = ff(d, a, b, c, buffer[i+ 9], 12, 0x8B44F7AF);
      c = ff(c, d, a, b, buffer[i+10], 17, 0xFFFF5BB1);
      b = ff(b, c, d, a, buffer[i+11], 22, 0x895CD7BE);
      a = ff(a, b, c, d, buffer[i+12], 7, 0x6B901122);
      d = ff(d, a, b, c, buffer[i+13], 12, 0xFD987193);
      c = ff(c, d, a, b, buffer[i+14], 17, 0xA679438E);
      b = ff(b, c, d, a, buffer[i+15], 22, 0x49B40821);
      a = gg(a, b, c, d, buffer[i+ 1], 5, 0xF61E2562);
      d = gg(d, a, b, c, buffer[i+ 6], 9, 0xC040B340);
      c = gg(c, d, a, b, buffer[i+11], 14, 0x265E5A51);
      b = gg(b, c, d, a, buffer[i+ 0], 20, 0xE9B6C7AA);
      a = gg(a, b, c, d, buffer[i+ 5], 5, 0xD62F105D);
      d = gg(d, a, b, c, buffer[i+10], 9, 0x02441453);
      c = gg(c, d, a, b, buffer[i+15], 14, 0xD8A1E681);
      b = gg(b, c, d, a, buffer[i+ 4], 20, 0xE7D3FBC8);
      a = gg(a, b, c, d, buffer[i+ 9], 5, 0x21E1CDE6);
      d = gg(d, a, b, c, buffer[i+14], 9, 0xC33707D6);
      c = gg(c, d, a, b, buffer[i+ 3], 14, 0xF4D50D87);
      b = gg(b, c, d, a, buffer[i+ 8], 20, 0x455A14ED);
      a = gg(a, b, c, d, buffer[i+13], 5, 0xA9E3E905);
      d = gg(d, a, b, c, buffer[i+ 2], 9, 0xFCEFA3F8);
      c = gg(c, d, a, b, buffer[i+ 7], 14, 0x676F02D9);
      b = gg(b, c, d, a, buffer[i+12], 20, 0x8D2A4C8A);
      a = hh(a, b, c, d, buffer[i+ 5], 4, 0xFFFA3942);
      d = hh(d, a, b, c, buffer[i+ 8], 11, 0x8771F681);
      c = hh(c, d, a, b, buffer[i+11], 16, 0x6D9D6122);
      b = hh(b, c, d, a, buffer[i+14], 23, 0xFDE5380C);
      a = hh(a, b, c, d, buffer[i+ 1], 4, 0xA4BEEA44);
      d = hh(d, a, b, c, buffer[i+ 4], 11, 0x4BDECFA9);
      c = hh(c, d, a, b, buffer[i+ 7], 16, 0xF6BB4B60);
      b = hh(b, c, d, a, buffer[i+10], 23, 0xBEBFBC70);
      a = hh(a, b, c, d, buffer[i+13], 4, 0x289B7EC6);
      d = hh(d, a, b, c, buffer[i+ 0], 11, 0xEAA127FA);
      c = hh(c, d, a, b, buffer[i+ 3], 16, 0xD4EF3085);
      b = hh(b, c, d, a, buffer[i+ 6], 23, 0x04881D05);
      a = hh(a, b, c, d, buffer[i+ 9], 4, 0xD9D4D039);
      d = hh(d, a, b, c, buffer[i+12], 11, 0xE6DB99E5);
      c = hh(c, d, a, b, buffer[i+15], 16, 0x1FA27CF8);
      b = hh(b, c, d, a, buffer[i+ 2], 23, 0xC4AC5665);
      a = ii(a, b, c, d, buffer[i+ 0], 6, 0xF4292244);
      d = ii(d, a, b, c, buffer[i+ 7], 10, 0x432AFF97);
      c = ii(c, d, a, b, buffer[i+14], 15, 0xAB9423A7);
      b = ii(b, c, d, a, buffer[i+ 5], 21, 0xFC93A039);
      a = ii(a, b, c, d, buffer[i+12], 6, 0x655B59C3);
      d = ii(d, a, b, c, buffer[i+ 3], 10, 0x8F0CCC92);
      c = ii(c, d, a, b, buffer[i+10], 15, 0xFFEFF47D);
      b = ii(b, c, d, a, buffer[i+ 1], 21, 0x85845DD1);
      a = ii(a, b, c, d, buffer[i+ 8], 6, 0x6FA87E4F);
      d = ii(d, a, b, c, buffer[i+15], 10, 0xFE2CE6E0);
      c = ii(c, d, a, b, buffer[i+ 6], 15, 0xA3014314);
      b = ii(b, c, d, a, buffer[i+13], 21, 0x4E0811A1);
      a = ii(a, b, c, d, buffer[i+ 4], 6, 0xF7537E82);
      d = ii(d, a, b, c, buffer[i+11], 10, 0xBD3AF235);
      c = ii(c, d, a, b, buffer[i+ 2], 15, 0x2AD7D2BB);
      b = ii(b, c, d, a, buffer[i+ 9], 21, 0xEB86D391);
      w[0] = add(a, w[0]);
      w[1] = add(b, w[1]);
      w[2] = add(c, w[2]);
      w[3] = add(d, w[3]);
    }
    var t = [];
    for (var i = 0; i < 4; i++)
      for (var j = 0; j < 4; j++)
        t[i * 4 + j] = (w[i] >> (8 * j)) & 0xFF;
    return t;
  }
  return function (s, ofs, len) {
    var buf = [];
    if (s.array) {
      var a = s.array;
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] = a[j] | (a[j+1] << 8) | (a[j+2] << 16) | (a[j+3] << 24);
      }
      for (; i < len; i++) buf[i>>2] |= a[i + ofs] << (8 * (i & 3));
    } else {
      var b = s.getFullBytes();
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] =
          b.charCodeAt(j) | (b.charCodeAt(j+1) << 8) |
          (b.charCodeAt(j+2) << 16) | (b.charCodeAt(j+3) << 24);
      }
      for (; i < len; i++) buf[i>>2] |= b.charCodeAt(i + ofs) << (8 * (i & 3));
    }
    return new MlStringFromArray(md5(buf, len));
  }
} ();
function caml_ml_out_channels_list () { return 0; }
function caml_raise_constant (tag) { throw [0, tag]; }
var caml_global_data = [0];
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_string_equal(s1, s2) {
  var b1 = s1.fullBytes;
  var b2 = s2.fullBytes;
  if (b1 != null && b2 != null) return (b1 == b2)?1:0;
  return (s1.getFullBytes () == s2.getFullBytes ())?1:0;
}
function caml_string_notequal(s1, s2) { return 1-caml_string_equal(s1, s2); }
function caml_sys_get_config () {
  return [0, new MlWrappedString("Unix"), 32];
}
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function()
   {function _bs_(_gl_,_gm_)
     {return _gl_.length==1?_gl_(_gm_):caml_call_gen(_gl_,[_gm_]);}
    var
     _a_=[0,new MlString("Failure")],
     _b_=[0,new MlString("Invalid_argument")],
     _c_=[0,new MlString("Assert_failure")];
    caml_register_global(5,[0,new MlString("Division_by_zero")]);
    caml_register_global(3,_b_);
    caml_register_global(2,_a_);
    var
     _bc_=new MlString("%d"),
     _bb_=new MlString("Pervasives.do_at_exit"),
     _ba_=new MlString(""),
     _a$_=new MlString("String.blit"),
     _a__=new MlString("String.sub"),
     _a9_=new MlString("Buffer.add: cannot grow buffer"),
     _a8_=new MlString("x"),
     _a7_=[0,new MlString("src/core/lwt.ml"),440,20],
     _a6_=[0,new MlString("src/core/lwt.ml"),443,8],
     _a5_=new MlString("Lwt.fast_connect"),
     _a4_=new MlString("Lwt.connect"),
     _a3_=new MlString("Lwt.wakeup"),
     _a2_=new MlString("Lwt.Canceled"),
     _a1_=new MlString("iframe"),
     _a0_=new MlString("br"),
     _aZ_=new MlString("textarea"),
     _aY_=new MlString("input"),
     _aX_=new MlString("\""),
     _aW_=new MlString(" name=\""),
     _aV_=new MlString("\""),
     _aU_=new MlString(" type=\""),
     _aT_=new MlString("<"),
     _aS_=new MlString(">"),
     _aR_=new MlString(""),
     _aQ_=new MlString("^error_in_anchor^"),
     _aP_=[0,new MlString("main.ml"),72,76],
     _aO_=new MlString("href"),
     _aN_=new MlString("global"),
     _aM_=new MlString("wiki"),
     _aL_=new MlString("^error2_in_anchor^"),
     _aK_=[0,new MlString("]]"),0],
     _aJ_=new MlString("[["),
     _aI_=new MlString(""),
     _aH_=[0,new MlString("]]"),0],
     _aG_=new MlString("|"),
     _aF_=new MlString("[["),
     _aE_=new MlString(""),
     _aD_=[0,new MlString("main.ml"),67,35],
     _aC_=new MlString("#text"),
     _aB_=new MlString("A"),
     _aA_=new MlString("B"),
     _az_=new MlString("BR"),
     _ay_=new MlString("DIV"),
     _ax_=new MlString("H1"),
     _aw_=new MlString("H2"),
     _av_=new MlString("H3"),
     _au_=new MlString("HR"),
     _at_=new MlString("I"),
     _as_=new MlString("P"),
     _ar_=new MlString("^"),
     _aq_=new MlString("^"),
     _ap_=new MlString("\n\n"),
     _ao_=[0,new MlString("//")],
     _an_=new MlString("----"),
     _am_=new MlString("\\\\"),
     _al_=[0,new MlString("**")],
     _ak_=new MlString("wysitype"),
     _aj_=new MlString("\n\n"),
     _ai_=new MlString(""),
     _ah_=new MlString("lololo"),
     _ag_=new MlString("Enter a wikipage"),
     _af_=new MlString(""),
     _ae_=[0,new MlString("</a>"),0],
     _ad_=new MlString("\" wysitype=\"wiki\">"),
     _ac_=new MlString("<a href=\""),
     _ab_=new MlString("inserthtml"),
     _aa_=new MlString("http://google.ru"),
     _$_=new MlString("Enter a link"),
     ___=new MlString("desc"),
     _Z_=new MlString("Enter description"),
     _Y_=[0,new MlString("</a>"),0],
     _X_=new MlString("\" wysitype=\"global\">"),
     _W_=new MlString("<a href=\""),
     _V_=new MlString(""),
     _U_=new MlString("inserthtml"),
     _T_=new MlString("submit"),
     _S_=
      new
       MlString
       ("<html><body><p><b>Camelus</b><i>bactrianus</i></p></body></html>"),
     _R_=new MlString("On"),
     _Q_=new MlString("inserthorizontalrule"),
     _P_=new MlString("hr"),
     _O_=new MlString("removeformat"),
     _N_=new MlString("remove format"),
     _M_=new MlString("bold"),
     _L_=new MlString("B"),
     _K_=new MlString("italic"),
     _J_=new MlString("I"),
     _I_=new MlString("formatblock"),
     _H_=new MlString("p"),
     _G_=[0,[0,new MlString("p")]],
     _F_=new MlString("formatblock"),
     _E_=new MlString("h1"),
     _D_=[0,[0,new MlString("h1")]],
     _C_=new MlString("formatblock"),
     _B_=new MlString("h2"),
     _A_=[0,[0,new MlString("h2")]],
     _z_=new MlString("formatblock"),
     _y_=new MlString("h3"),
     _x_=[0,[0,new MlString("h3")]],
     _w_=new MlString("inserthtml"),
     _v_=new MlString("link"),
     _u_=new MlString("inserthtml"),
     _t_=new MlString("link2wiki"),
     _s_=new MlString("1px black solid"),
     _r_=new MlString("5px"),
     _q_=new MlString("wikiFrame"),
     _p_=new MlString("2px blue solid"),
     _o_=new MlString("5px"),
     _n_=new MlString(""),
     _m_=[0,new MlString("main.ml"),96,17],
     _l_=new MlString("wiki_demo"),
     _k_=new MlString("2px green solid"),
     _j_=new MlString("#"),
     _i_=new MlString("wysiFrame"),
     _h_=new MlString("Main.Break");
    function _g_(s_d_){throw [0,_b_,s_d_];}
    function _bd_(x_f_,y_e_){return caml_greaterequal(x_f_,y_e_)?x_f_:y_e_;}
    function _bn_(s1_be_,s2_bg_)
     {var
       l1_bf_=s1_be_.getLen(),
       l2_bh_=s2_bg_.getLen(),
       s_bi_=caml_create_string(l1_bf_+l2_bh_|0);
      caml_blit_string(s1_be_,0,s_bi_,0,l1_bf_);
      caml_blit_string(s2_bg_,0,s_bi_,l1_bf_,l2_bh_);
      return s_bi_;}
    function do_at_exit_bo_(param_bm_)
     {var param_bj_=caml_ml_out_channels_list(0);
      for(;;)
       {if(param_bj_)
         {var l_bk_=param_bj_[2];
          try {}catch(_bl_){}
          var param_bj_=l_bk_;
          continue;}
        return 0;}}
    caml_register_named_value(_bb_,do_at_exit_bo_);
    function _bu_(f_br_,param_bp_)
     {var param_bq_=param_bp_;
      for(;;)
       {if(param_bq_)
         {var l_bt_=param_bq_[2];
          _bs_(f_br_,param_bq_[1]);
          var param_bq_=l_bt_;
          continue;}
        return 0;}}
    function _bK_(s1_bx_,ofs1_bw_,s2_bz_,ofs2_by_,len_bv_)
     {if
       (0<=
        len_bv_&&
        0<=
        ofs1_bw_&&
        !((s1_bx_.getLen()-len_bv_|0)<ofs1_bw_)&&
        0<=
        ofs2_by_&&
        !((s2_bz_.getLen()-len_bv_|0)<ofs2_by_))
       return caml_blit_string(s1_bx_,ofs1_bw_,s2_bz_,ofs2_by_,len_bv_);
      return _g_(_a$_);}
    function _bL_(sep_bG_,l_bA_)
     {if(l_bA_)
       {var hd_bB_=l_bA_[1],num_bC_=[0,0],len_bD_=[0,0],tl_bF_=l_bA_[2];
        _bu_
         (function(s_bE_)
           {num_bC_[1]+=1;len_bD_[1]=len_bD_[1]+s_bE_.getLen()|0;return 0;},
          l_bA_);
        var
         r_bH_=
          caml_create_string
           (len_bD_[1]+caml_mul(sep_bG_.getLen(),num_bC_[1]-1|0)|0);
        caml_blit_string(hd_bB_,0,r_bH_,0,hd_bB_.getLen());
        var pos_bI_=[0,hd_bB_.getLen()];
        _bu_
         (function(s_bJ_)
           {caml_blit_string(sep_bG_,0,r_bH_,pos_bI_[1],sep_bG_.getLen());
            pos_bI_[1]=pos_bI_[1]+sep_bG_.getLen()|0;
            caml_blit_string(s_bJ_,0,r_bH_,pos_bI_[1],s_bJ_.getLen());
            pos_bI_[1]=pos_bI_[1]+s_bJ_.getLen()|0;
            return 0;},
          tl_bF_);
        return r_bH_;}
      return _ba_;}
    var
     _bM_=caml_sys_get_config(0)[2],
     _bN_=caml_mul(_bM_/8|0,(1<<(_bM_-10|0))-1|0)-1|0;
    function _bU_(b_bQ_,s_bO_)
     {var len_bP_=s_bO_.getLen(),new_position_bR_=b_bQ_[2]+len_bP_|0;
      if(b_bQ_[3]<new_position_bR_)
       {var new_len_bS_=[0,b_bQ_[3]];
        for(;;)
         {if(new_len_bS_[1]<(b_bQ_[2]+len_bP_|0))
           {new_len_bS_[1]=2*new_len_bS_[1]|0;continue;}
          if(_bN_<new_len_bS_[1])
           {if(!((b_bQ_[2]+len_bP_|0)<=_bN_))throw [0,_a_,_a9_];
            new_len_bS_[1]=_bN_;}
          var new_buffer_bT_=caml_create_string(new_len_bS_[1]);
          _bK_(b_bQ_[1],0,new_buffer_bT_,0,b_bQ_[2]);
          b_bQ_[1]=new_buffer_bT_;
          b_bQ_[3]=new_len_bS_[1];
          break;}}
      _bK_(s_bO_,0,b_bQ_[1],b_bQ_[2],len_bP_);
      b_bQ_[2]=new_position_bR_;
      return 0;}
    var _bV_=[0,0];
    32===_bM_;
    function _bY_(param_bX_)
     {var seq_bW_=[];
      caml_update_dummy(seq_bW_,[0,seq_bW_,seq_bW_]);
      return seq_bW_;}
    var Canceled_bZ_=[0,_a2_],current_data_b0_=[0,0],max_removed_cF_=42;
    function repr_rec_b4_(t_b1_)
     {var _b2_=t_b1_[1];
      {if(3===_b2_[0])
        {var t__b3_=_b2_[1],t___b5_=repr_rec_b4_(t__b3_);
         if(t___b5_!==t__b3_)t_b1_[1]=[3,t___b5_];
         return t___b5_;}
       return t_b1_;}}
    function repr_cG_(t_b6_){return repr_rec_b4_(t_b6_);}
    function run_waiters_ct_(waiters_b7_,state_b$_)
     {var ws_b8_=waiters_b7_,rem_b9_=0,save_cm_=current_data_b0_[1];
      for(;;)
       {if(typeof ws_b8_==="number")
         {if(rem_b9_)
           {var
             rem_cl_=rem_b9_[2],
             ws_ck_=rem_b9_[1],
             ws_b8_=ws_ck_,
             rem_b9_=rem_cl_;
            continue;}}
        else
         switch(ws_b8_[0])
          {case 1:
            var _b__=ws_b8_[1];
            if(rem_b9_)
             {var rem_cb_=rem_b9_[2],ws_ca_=rem_b9_[1];
              _bs_(_b__,state_b$_);
              var ws_b8_=ws_ca_,rem_b9_=rem_cb_;
              continue;}
            _bs_(_b__,state_b$_);
            break;
           case 2:
            var
             ws1_cc_=ws_b8_[1],
             _cd_=[0,ws_b8_[2],rem_b9_],
             ws_b8_=ws1_cc_,
             rem_b9_=_cd_;
            continue;
           default:
            var _ce_=ws_b8_[1][1];
            if(_ce_)
             {var _cf_=_ce_[1];
              if(rem_b9_)
               {var rem_ch_=rem_b9_[2],ws_cg_=rem_b9_[1];
                _bs_(_cf_,state_b$_);
                var ws_b8_=ws_cg_,rem_b9_=rem_ch_;
                continue;}
              _bs_(_cf_,state_b$_);}
            else
             if(rem_b9_)
              {var
                rem_cj_=rem_b9_[2],
                ws_ci_=rem_b9_[1],
                ws_b8_=ws_ci_,
                rem_b9_=rem_cj_;
               continue;}}
        current_data_b0_[1]=save_cm_;
        return 0;}}
    function wakeup_cH_(t_cn_,v_cq_)
     {var t_co_=repr_rec_b4_(t_cn_),_cp_=t_co_[1];
      switch(_cp_[0])
       {case 1:if(_cp_[1][1]===Canceled_bZ_)return 0;break;
        case 2:
         var state_cr_=[0,v_cq_],waiters_cs_=_cp_[1][2];
         t_co_[1]=state_cr_;
         return run_waiters_ct_(waiters_cs_,state_cr_);
        default:}
      return _g_(_a3_);}
    function append_cA_(l1_cu_,l2_cv_)
     {return typeof l1_cu_==="number"
              ?l2_cv_
              :typeof l2_cv_==="number"?l1_cu_:[2,l1_cu_,l2_cv_];}
    function cleanup_cx_(ws_cw_)
     {if(typeof ws_cw_!=="number")
       switch(ws_cw_[0])
        {case 2:
          var l1_cy_=ws_cw_[1],_cz_=cleanup_cx_(ws_cw_[2]);
          return append_cA_(cleanup_cx_(l1_cy_),_cz_);
         case 1:break;
         default:if(!ws_cw_[1][1])return 0;}
      return ws_cw_;}
    function fail_cI_(e_cB_){return [0,[1,e_cB_]];}
    function add_immutable_waiter_cJ_(sleeper_cC_,waiter_cD_)
     {var
       _cE_=
        typeof sleeper_cC_[2]==="number"
         ?[1,waiter_cD_]
         :[2,[1,waiter_cD_],sleeper_cC_[2]];
      sleeper_cC_[2]=_cE_;
      return 0;}
    var
     _cK_=[0],
     _cL_=[0,caml_make_vect(55,0),0],
     seed_cM_=caml_equal(_cK_,[0])?[0,0]:_cK_,
     l_cN_=seed_cM_.length-1,
     _cO_=0,
     _cP_=54;
    if(!(_cP_<_cO_))
     {var i_cQ_=_cO_;
      for(;;)
       {caml_array_set(_cL_[1],i_cQ_,i_cQ_);
        var _cR_=i_cQ_+1|0;
        if(_cP_!==i_cQ_){var i_cQ_=_cR_;continue;}
        break;}}
    var accu_cS_=[0,_a8_],_cT_=0,_cU_=54+_bd_(55,l_cN_)|0;
    if(!(_cU_<_cT_))
     {var i_cV_=_cT_;
      for(;;)
       {var
         j_cW_=i_cV_%55|0,
         _cX_=
          _bn_
           (accu_cS_[1],
            caml_format_int
             (_bc_,caml_array_get(seed_cM_,caml_mod(i_cV_,l_cN_))));
        accu_cS_[1]=caml_md5_string(_cX_,0,_cX_.getLen());
        var _cY_=accu_cS_[1];
        caml_array_set
         (_cL_[1],
          j_cW_,
          caml_array_get(_cL_[1],j_cW_)^
          (((_cY_.safeGet(0)+(_cY_.safeGet(1)<<8)|0)+(_cY_.safeGet(2)<<16)|0)+
           (_cY_.safeGet(3)<<24)|
           0));
        var _cZ_=i_cV_+1|0;
        if(_cU_!==i_cV_){var i_cV_=_cZ_;continue;}
        break;}}
    _cL_[2]=0;
    var
     pause_hook_c2_=[0,function(_c0_){return 0;}],
     _c1_=_bY_(0),
     _c4_=[0,0],
     null_c8_=null;
    function _dg_(param_c7_)
     {if(_c1_[2]===_c1_)return 0;
      var tmp_c3_=_bY_(0);
      tmp_c3_[1][2]=_c1_[2];
      _c1_[2][1]=tmp_c3_[1];
      tmp_c3_[1]=_c1_[1];
      _c1_[1][2]=tmp_c3_;
      _c1_[1]=_c1_;
      _c1_[2]=_c1_;
      _c4_[1]=0;
      var curr_c5_=tmp_c3_[2];
      for(;;)
       {if(curr_c5_!==tmp_c3_)
         {if(curr_c5_[4])wakeup_cH_(curr_c5_[3],0);
          var _c6_=curr_c5_[2],curr_c5_=_c6_;
          continue;}
        return 0;}}
    var undefined_df_=undefined;
    function _de_(x_c9_,f_c__){return x_c9_==null_c8_?0:_bs_(f_c__,x_c9_);}
    function _dh_(x_c$_,f_da_,g_db_)
     {return x_c$_==null_c8_?_bs_(f_da_,0):_bs_(g_db_,x_c$_);}
    function _di_(x_dc_,f_dd_){return x_dc_==null_c8_?_bs_(f_dd_,0):x_dc_;}
    var _true_dj_=true,_false_dk_=false,array_constructor_dl_=Array;
    function _dn_(e_dm_)
     {return e_dm_ instanceof array_constructor_dl_
              ?0
              :[0,new MlWrappedString(e_dm_.toString())];}
    _bV_[1]=[0,_dn_,_bV_[1]];
    function _dp_(_do_){return _do_;}
    function appendChild_dx_(p_dq_,n_dr_){p_dq_.appendChild(n_dr_);return 0;}
    function handler_dy_(f_dt_)
     {return _dp_
              (caml_js_wrap_callback
                (function(e_ds_)
                  {if(e_ds_)
                    {var res_du_=_bs_(f_dt_,e_ds_);
                     if(!(res_du_|0))e_ds_.preventDefault();
                     return res_du_;}
                   var _dv_=event,res_dw_=_bs_(f_dt_,_dv_);
                   _dv_.returnValue=res_dw_;
                   return res_dw_;}));}
    var
     window_dz_=window,
     document_dA_=window_dz_.document,
     onIE_dM_=caml_js_on_ie(0)|0;
    function opt_iter_dP_(x_dB_,f_dC_){return x_dB_?_bs_(f_dC_,x_dB_[1]):0;}
    function createElement_dF_(doc_dE_,name_dD_)
     {return doc_dE_.createElement(name_dD_.toString());}
    function unsafeCreateElement_dY_(doc_dH_,name_dG_)
     {return createElement_dF_(doc_dH_,name_dG_);}
    function unsafeCreateElementEx_dU_(_type_dI_,name_dJ_,doc_dL_,elt_dK_)
     {if(0===_type_dI_&&0===name_dJ_)
       return createElement_dF_(doc_dL_,elt_dK_);
      if(onIE_dM_)
       {var a_dN_=new array_constructor_dl_();
        a_dN_.push(_aT_.toString(),elt_dK_.toString());
        opt_iter_dP_
         (_type_dI_,
          function(t_dO_)
           {a_dN_.push
             (_aU_.toString(),caml_js_html_escape(t_dO_),_aV_.toString());
            return 0;});
        opt_iter_dP_
         (name_dJ_,
          function(n_dQ_)
           {a_dN_.push
             (_aW_.toString(),caml_js_html_escape(n_dQ_),_aX_.toString());
            return 0;});
        a_dN_.push(_aS_.toString());
        return doc_dL_.createElement(a_dN_.join(_aR_.toString()));}
      var res_dR_=createElement_dF_(doc_dL_,elt_dK_);
      opt_iter_dP_(_type_dI_,function(t_dS_){return res_dR_.type=t_dS_;});
      opt_iter_dP_(name_dJ_,function(n_dT_){return res_dR_.name=n_dT_;});
      return res_dR_;}
    function createTextarea_d0_(_type_dX_,name_dW_,doc_dV_)
     {return unsafeCreateElementEx_dU_(_type_dX_,name_dW_,doc_dV_,_aZ_);}
    function createBr_d1_(doc_dZ_)
     {return unsafeCreateElement_dY_(doc_dZ_,_a0_);}
    window.HTMLElement===undefined_df_;
    pause_hook_c2_[1]=
    function(param_d2_)
     {return 1===param_d2_
              ?(window_dz_.setTimeout(caml_js_wrap_callback(_dg_),0),0)
              :0;};
    function _d5_(x_d3_,f_d4_){return _bs_(f_d4_,x_d3_);}
    var Break_d6_=[0,_h_];
    function html2wiki_et_(_opt__d7_,body_em_)
     {_opt__d7_;
      var
       _d8_=10,
       n_d9_=1<=_d8_?_d8_:1,
       n_d__=_bN_<n_d9_?_bN_:n_d9_,
       s_d$_=caml_create_string(n_d__),
       _ea_=[0,s_d$_,0,n_d__,s_d$_];
      function add_str_el_(_opt__eb_,s_ed_)
       {var surr_ec_=_opt__eb_?_opt__eb_[1]:_ai_,len_ee_=s_ed_.getLen();
        try
         {var i_ef_=0;
          for(;;)
           {if(!(len_ee_<=i_ef_))
             {if
               (92===
                s_ed_.safeGet(i_ef_)&&
                i_ef_<
                (len_ee_-1|0)&&
                92===
                s_ed_.safeGet(i_ef_+1|0))
               {var _ei_=i_ef_+2|0,i_ef_=_ei_;continue;}
              if(10===s_ed_.safeGet(i_ef_))
               {var _ej_=i_ef_+1|0,i_ef_=_ej_;continue;}
              throw [0,Break_d6_,1];}
            var _eg_=0,_eh_=_eg_;
            break;}}
        catch(_ek_){if(_ek_[1]!==Break_d6_)throw _ek_;var _eh_=_ek_[2];}
        return _eh_?_bU_(_ea_,_bn_(surr_ec_,_bn_(s_ed_,surr_ec_))):0;}
      var
       childNodes_en_=body_em_.childNodes,
       _eo_=0,
       _ep_=childNodes_en_.length-1|0;
      if(!(_ep_<_eo_))
       {var i_eq_=_eo_;
        for(;;)
         {var
           _eP_=
            function(node_er_)
             {var _es_=new MlWrappedString(node_er_.nodeName);
              if(caml_string_notequal(_es_,_aC_))
               {if(caml_string_notequal(_es_,_aB_))
                 {if(caml_string_notequal(_es_,_aA_))
                   {if(caml_string_notequal(_es_,_az_))
                     {if(caml_string_notequal(_es_,_ay_))
                       {if
                         (caml_string_notequal(_es_,_ax_)&&
                          caml_string_notequal(_es_,_aw_)&&
                          caml_string_notequal(_es_,_av_))
                         return caml_string_notequal(_es_,_au_)
                                 ?caml_string_notequal(_es_,_at_)
                                   ?caml_string_notequal(_es_,_as_)
                                     ?_bU_(_ea_,_bn_(_aq_,_bn_(_es_,_ar_)))
                                     :add_str_el_(0,_bn_(html2wiki_et_(0,node_er_),_ap_))
                                   :add_str_el_(_ao_,html2wiki_et_(0,node_er_))
                                 :_bU_(_ea_,_an_);
                        var
                         n_eu_=(_es_.safeGet(1)-48|0)+1|0,
                         s_ev_=caml_create_string(n_eu_);
                        caml_fill_string(s_ev_,0,n_eu_,61);
                        return _bU_
                                (_ea_,_bn_(s_ev_,_bn_(html2wiki_et_(0,node_er_),_aj_)));}
                      return _bU_(_ea_,html2wiki_et_(0,node_er_));}
                    return _bU_(_ea_,_am_);}
                  return add_str_el_(_al_,html2wiki_et_(0,node_er_));}
                var
                 x_ex_=_dp_(node_er_),
                 el_ey_=_di_(x_ex_,function(param_ew_){throw [0,_c_,_aD_];}),
                 _eI_=
                  function(s_eE_)
                   {function _eB_(_ez_){return new MlWrappedString(_ez_);}
                    function _eC_(param_eA_){throw [0,_c_,_aP_];}
                    var
                     url_eD_=
                      _d5_(_di_(el_ey_.getAttribute(_aO_.toString()),_eC_),_eB_),
                     _eF_=new MlWrappedString(s_eE_);
                    if(caml_string_notequal(_eF_,_aN_))
                     {if(caml_string_notequal(_eF_,_aM_))return _bU_(_ea_,_aL_);
                      var _eG_=_bs_(_bU_,_ea_);
                      return _d5_(_bL_(_aI_,[0,_aJ_,[0,url_eD_,_aK_]]),_eG_);}
                    return _bU_
                            (_ea_,
                             _bL_
                              (_aE_,
                               [0,
                                _aF_,
                                [0,url_eD_,[0,_aG_,[0,html2wiki_et_(0,node_er_),_aH_]]]]));},
                 _eJ_=function(param_eH_){return _bU_(_ea_,_aQ_);};
                return _dh_(el_ey_.getAttribute(_ak_.toString()),_eJ_,_eI_);}
              var
               _eM_=node_er_.nodeValue,
               _eN_=function(x_eK_){return [0,x_eK_];},
               _eO_=_dh_(_eM_,function(param_eL_){return 0;},_eN_);
              return _eO_?_bU_(_ea_,new MlWrappedString(_eO_[1])):0;};
          _de_(childNodes_en_.item(i_eq_),_eP_);
          var _eQ_=i_eq_+1|0;
          if(_ep_!==i_eq_){var i_eq_=_eQ_;continue;}
          break;}}
      var _eR_=_ea_[2],_eS_=0,_eT_=_ea_[1];
      if(0<=_eS_&&0<=_eR_&&!((_eT_.getLen()-_eR_|0)<_eS_))
       {var r_eV_=caml_create_string(_eR_);
        caml_blit_string(_eT_,_eS_,r_eV_,0,_eR_);
        var _eW_=r_eV_,_eU_=1;}
      else
       var _eU_=0;
      if(!_eU_)var _eW_=_g_(_a__);
      return _eW_;}
    window_dz_.onload=
    handler_dy_
     (function(param_gk_)
       {function _eY_(param_eX_){throw [0,_c_,_m_];}
        var
         body_eZ_=_di_(document_dA_.getElementById(_l_.toString()),_eY_),
         _e0_=unsafeCreateElement_dY_(document_dA_,_a1_);
        _e0_.style.border=_k_.toString();
        _e0_.src=_j_.toString();
        _e0_.id=_i_.toString();
        appendChild_dx_(body_eZ_,_e0_);
        function _gj_(iDoc_e1_)
         {iDoc_e1_.open();
          iDoc_e1_.write(_S_.toString());
          iDoc_e1_.close();
          iDoc_e1_.designMode=_R_.toString();
          var iWin_e2_=_e0_.contentWindow;
          appendChild_dx_(body_eZ_,createBr_d1_(document_dA_));
          function createButton_fa_(_opt__e3_,_e5_,title_e8_,action_e__)
           {var
             show_e4_=_opt__e3_?_opt__e3_[1]:_false_dk_,
             value_e6_=_e5_?_e5_[1]:0,
             _e7_=
              unsafeCreateElementEx_dU_
               ([0,_T_.toString()],0,document_dA_,_aY_);
            _e7_.value=title_e8_.toString();
            _e7_.onclick=
            handler_dy_
             (function(param_e$_)
               {iWin_e2_.focus();
                var _e9_=value_e6_?_dp_(value_e6_[1].toString()):null_c8_;
                iDoc_e1_.execCommand(action_e__.toString(),show_e4_,_e9_);
                return _true_dj_;});
            appendChild_dx_(body_eZ_,_e7_);
            return _e7_;}
          createButton_fa_(0,0,_P_,_Q_);
          createButton_fa_(0,0,_N_,_O_);
          createButton_fa_(0,0,_L_,_M_);
          createButton_fa_(0,0,_J_,_K_);
          appendChild_dx_(body_eZ_,createBr_d1_(document_dA_));
          createButton_fa_(0,_G_,_H_,_I_);
          createButton_fa_(0,_D_,_E_,_F_);
          createButton_fa_(0,_A_,_B_,_C_);
          createButton_fa_(0,_x_,_y_,_z_);
          var a595e0b1f_fj_=createButton_fa_(0,0,_v_,_w_);
          a595e0b1f_fj_.onclick=
          handler_dy_
           (function(param_fi_)
             {function _fc_(_fb_){return new MlWrappedString(_fb_);}
              var
               link_fe_=
                _d5_(iWin_e2_.prompt(_$_.toString(),_aa_.toString()),_fc_);
              function _ff_(_fd_){return new MlWrappedString(_fd_);}
              var
               link_fg_=
                _bL_
                 (_V_,
                  [0,
                   _W_,
                   [0,
                    link_fe_,
                    [0,
                     _X_,
                     [0,
                      _d5_(iWin_e2_.prompt(_Z_.toString(),___.toString()),_ff_),
                      _Y_]]]]);
              iWin_e2_.alert(link_fg_.toString());
              var _fh_=_dp_(link_fg_.toString());
              iDoc_e1_.execCommand(_U_.toString(),_false_dk_,_fh_);
              return _true_dj_;});
          var ada69b02e_fq_=createButton_fa_(0,0,_t_,_u_);
          ada69b02e_fq_.onclick=
          handler_dy_
           (function(param_fp_)
             {function _fl_(_fk_){return new MlWrappedString(_fk_);}
              var
               link_fm_=
                _d5_(iWin_e2_.prompt(_ag_.toString(),_ah_.toString()),_fl_),
               link_fn_=
                _d5_
                 ([0,_ac_,[0,link_fm_,[0,_ad_,[0,link_fm_,_ae_]]]],
                  _bs_(_bL_,_af_));
              iWin_e2_.alert(link_fn_.toString());
              var _fo_=_dp_(link_fn_.toString());
              iDoc_e1_.execCommand(_ab_.toString(),_false_dk_,_fo_);
              return _true_dj_;});
          appendChild_dx_(body_eZ_,createBr_d1_(document_dA_));
          var preview_fr_=createTextarea_d0_(0,0,document_dA_);
          preview_fr_.readOnly=_true_dj_;
          preview_fr_.cols=34;
          preview_fr_.rows=10;
          preview_fr_.style.border=_s_.toString();
          preview_fr_.style.padding=_r_.toString();
          appendChild_dx_(body_eZ_,preview_fr_);
          var wikiFrame_fs_=createTextarea_d0_(0,0,document_dA_);
          wikiFrame_fs_.id=_q_.toString();
          wikiFrame_fs_.readOnly=_true_dj_;
          wikiFrame_fs_.cols=34;
          wikiFrame_fs_.rows=10;
          preview_fr_.style.border=_p_.toString();
          preview_fr_.style.padding=_o_.toString();
          appendChild_dx_(body_eZ_,wikiFrame_fs_);
          function dyn_preview_fy_(old_text_fu_,n_fx_)
           {var text_ft_=new MlWrappedString(iDoc_e1_.body.innerHTML);
            if(caml_string_notequal(text_ft_,old_text_fu_))
             {try
               {preview_fr_.value=text_ft_.toString();
                wikiFrame_fs_.value=html2wiki_et_(0,iDoc_e1_.body).toString();}
              catch(_fw_){}
              var n_fv_=20;}
            else
             var n_fv_=_bd_(0,n_fx_-1|0);
            function _fA_(param_fz_){return dyn_preview_fy_(text_ft_,n_fv_);}
            var _fB_=0===n_fv_?0.5:0.1,t_fC_=[],_fK_=0,_fJ_=0;
            caml_update_dummy
             (t_fC_,
              [0,
               [2,
                [0,
                 [0,
                  [0,
                   function(param_fI_)
                    {var t_fD_=repr_rec_b4_(t_fC_),_fE_=t_fD_[1];
                     if(2===_fE_[0])
                      {var state_fF_=[1,[0,Canceled_bZ_]],waiters_fG_=_fE_[1][2];
                       t_fD_[1]=state_fF_;
                       var _fH_=run_waiters_ct_(waiters_fG_,state_fF_);}
                     else
                      var _fH_=0;
                     return _fH_;}]],
                 _fJ_,
                 _fK_]]]);
            var
             _fM_=_fB_*1000,
             id_fN_=
              window_dz_.setTimeout
               (caml_js_wrap_callback
                 (function(param_fL_){return wakeup_cH_(t_fC_,0);}),
                _fM_);
            function _fP_(param_fO_){return window_dz_.clearTimeout(id_fN_);}
            var _fQ_=repr_cG_(t_fC_)[1];
            switch(_fQ_[0])
             {case 1:var _fR_=_fQ_[1][1]===Canceled_bZ_?(_fP_(0),1):0;break;
              case 2:
               var sleeper_fW_=_fQ_[1],data_fT_=current_data_b0_[1];
               add_immutable_waiter_cJ_
                (sleeper_fW_,
                 function(param_fS_)
                  {if(1===param_fS_[0]&&param_fS_[1][1]===Canceled_bZ_)
                    {current_data_b0_[1]=data_fT_;
                     try {var _fU_=_fP_(0);}catch(_fV_){return 0;}
                     return _fU_;}
                   return 0;});
               var _fR_=1;
               break;
              default:var _fR_=0;}
            _fR_;
            var _fX_=repr_cG_(t_fC_)[1];
            switch(_fX_[0])
             {case 1:var _fY_=fail_cI_(_fX_[1]);break;
              case 2:
               var
                sleeper_fZ_=_fX_[1],
                _f0_=[0,[2,[0,sleeper_fZ_[1],0,0]]],
                data_f2_=current_data_b0_[1];
               add_immutable_waiter_cJ_
                (sleeper_fZ_,
                 function(param_f1_)
                  {switch(param_f1_[0])
                    {case 0:
                      var v_f3_=param_f1_[1];
                      current_data_b0_[1]=data_f2_;
                      try
                       {var _f4_=_fA_(v_f3_),_f5_=_f4_;}
                      catch(_f6_){var _f5_=fail_cI_(_f6_);}
                      var
                       t1_f7_=repr_cG_(_f0_),
                       t2_f8_=repr_cG_(_f5_),
                       _f9_=t1_f7_[1];
                      if(2===_f9_[0])
                       {var sleeper1_f__=_f9_[1];
                        if(t1_f7_===t2_f8_)
                         var _f$_=0;
                        else
                         {var _ga_=t2_f8_[1];
                          if(2===_ga_[0])
                           {var sleeper2_gb_=_ga_[1];
                            t2_f8_[1]=[3,t1_f7_];
                            sleeper1_f__[1][1]=[1,sleeper2_gb_[1]];
                            var
                             waiters_gc_=append_cA_(sleeper1_f__[2],sleeper2_gb_[2]),
                             removed_gd_=sleeper1_f__[3]+sleeper2_gb_[3]|0,
                             _f$_=
                              max_removed_cF_<removed_gd_
                               ?(sleeper1_f__[3]=
                                 0,
                                 sleeper1_f__[2]=
                                 cleanup_cx_(waiters_gc_),
                                 0)
                               :(sleeper1_f__[3]=removed_gd_,sleeper1_f__[2]=waiters_gc_,0);}
                          else
                           {t1_f7_[1]=_ga_;
                            var _f$_=run_waiters_ct_(sleeper1_f__[2],_ga_);}}}
                      else
                       var _f$_=_g_(_a4_);
                      return _f$_;
                     case 1:
                      var
                       _ge_=[1,param_f1_[1]],
                       t_gf_=repr_cG_(_f0_),
                       _gg_=t_gf_[1];
                      if(2===_gg_[0])
                       {var waiters_gh_=_gg_[1][2];
                        t_gf_[1]=_ge_;
                        var _gi_=run_waiters_ct_(waiters_gh_,_ge_);}
                      else
                       var _gi_=_g_(_a5_);
                      return _gi_;
                     default:throw [0,_c_,_a7_];}});
               var _fY_=_f0_;
               break;
              case 3:throw [0,_c_,_a6_];
              default:var _fY_=_fA_(_fX_[1]);}
            return _fY_;}
          dyn_preview_fy_(_n_,0);
          return 0;}
        _de_(_e0_.contentDocument,_gj_);
        return _false_dk_;});
    do_at_exit_bo_(0);
    return;}
  ());
