// This program was compiled from OCaml by js_of_ocaml 1.0
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1)
      for (var i = 0; i < l; i++) a2 [i2 + i] = a1 [i1 + i];
    else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (!this.len) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_classify_float (x) {
  if (isFinite (x)) {
    if (Math.abs(x) >= 2.2250738585072014e-308) return 0;
    if (x != 0) return 1;
    return 2;
  }
  return isNaN(x)?4:3;
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_equal (x, y) { return +(caml_compare_val(x,y,false) == 0); }
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_float (fmt, x) {
  var s, f = caml_parse_format(fmt);
  var prec = (f.prec < 0)?6:f.prec;
  if (x < 0) { f.sign = -1; x = -x; }
  if (isNaN(x)) { s = "nan"; f.filler = ' '; }
  else if (!isFinite(x)) { s = "inf"; f.filler = ' '; }
  else
    switch (f.conv) {
    case 'e':
      var s = x.toExponential(prec);
      var i = s.length;
      if (s.charAt(i - 3) == 'e')
        s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
      break;
    case 'f':
      s = x.toFixed(prec); break;
    case 'g':
      prec = prec?prec:1;
      s = x.toExponential(prec - 1);
      var j = s.indexOf('e');
      var exp = +s.slice(j + 1);
      if (exp < -4 || x.toFixed(0).length > prec) {
        var i = j - 1; while (s.charAt(i) == '0') i--;
        if (s.charAt(i) == '.') i--;
        s = s.slice(0, i + 1) + s.slice(j);
        i = s.length;
        if (s.charAt(i - 3) == 'e')
          s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
        break;
      } else {
        var p = prec;
        if (exp < 0) { p -= exp + 1; s = x.toFixed(p); }
        else while (s = x.toFixed(p), s.length > prec + 1) p--;
        if (p) {
          var i = s.length - 1; while (s.charAt(i) == '0') i--;
          if (s.charAt(i) == '.') i--;
          s = s.slice(0, i + 1);
        }
      }
      break;
    }
  return caml_finish_formatting(f, s);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_greaterequal (x, y) { return +(caml_compare(x,y,false) >= 0); }
function caml_int64_to_bytes(x) {
  return [x[3] >> 8, x[3] & 0xff, x[2] >> 16, (x[2] >> 8) & 0xff, x[2] & 0xff,
          x[1] >> 16, (x[1] >> 8) & 0xff, x[1] & 0xff];
}
function caml_int64_bits_of_float (x) {
  if (!isFinite(x)) {
    if (isNaN(x)) return [255, 1, 0, 0xfff0];
    return (x > 0)?[255,0,0,0x7ff0]:[255,0,0,0xfff0];
  }
  var sign = (x>=0)?0:0x8000;
  if (sign) x = -x;
  var exp = Math.floor(Math.LOG2E*Math.log(x)) + 1023;
  if (exp <= 0) {
    exp = 0;
    x /= Math.pow(2,-1026);
  } else {
    x /= Math.pow(2,exp-1027);
    if (x < 16) { x *= 2; exp -=1; }
    if (exp == 0) { x /= 2; }
  }
  var k = Math.pow(2,24);
  var r3 = x|0;
  x = (x - r3) * k;
  var r2 = x|0;
  x = (x - r2) * k;
  var r1 = x|0;
  r3 = (r3 &0xf) | sign | exp << 4;
  return [255, r1, r2, r3];
}
function caml_hash_univ_param (count, limit, obj) {
  var hash_accu = 0;
  function hash_aux (obj) {
    limit --;
    if (count < 0 || limit < 0) return;
    if (obj instanceof Array && obj[0] === (obj[0]|0)) {
      switch (obj[0]) {
      case 248:
        count --;
        hash_accu = (hash_accu * 65599 + obj[2]) | 0;
        break
      case 250:
        limit++; hash_aux(obj); break;
      case 255:
        count --;
        hash_accu = (hash_accu * 65599 + obj[1] + (obj[2] << 24)) | 0;
        break;
      default:
        count --;
        hash_accu = (hash_accu * 19 + obj[0]) | 0;
        for (var i = obj.length - 1; i > 0; i--) hash_aux (obj[i]);
      }
    } else if (obj instanceof MlString) {
      count --;
      var a = obj.array, l = obj.getLen ();
      if (a) {
        for (var i = 0; i < l; i++) hash_accu = (hash_accu * 19 + a[i]) | 0;
      } else {
        var b = obj.getFullBytes ();
        for (var i = 0; i < l; i++)
          hash_accu = (hash_accu * 19 + b.charCodeAt(i)) | 0;
      }
    } else if (obj === (obj|0)) {
      count --;
      hash_accu = (hash_accu * 65599 + obj) | 0;
    } else if (obj === +obj) {
      count--;
      var p = caml_int64_to_bytes (caml_int64_bits_of_float (obj));
      for (var i = 7; i >= 0; i--) hash_accu = (hash_accu * 19 + p[i]) | 0;
    }
  }
  hash_aux (obj);
  return hash_accu & 0x3FFFFFFF;
}
function caml_int64_is_negative(x) {
  return (x[3] << 16) < 0;
}
function caml_int64_neg (x) {
  var y1 = - x[1];
  var y2 = - x[2] + (y1 >> 24);
  var y3 = - x[3] + (y2 >> 24);
  return [255, y1 & 0xffffff, y2 & 0xffffff, y3 & 0xffff];
}
function caml_int64_of_int32 (x) {
  return [255, x & 0xffffff, (x >> 24) & 0xffffff, (x >> 31) & 0xffff]
}
function caml_int64_ucompare(x,y) {
  if (x[3] > y[3]) return 1;
  if (x[3] < y[3]) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int64_lsl1 (x) {
  x[3] = (x[3] << 1) | (x[2] >> 23);
  x[2] = ((x[2] << 1) | (x[1] >> 23)) & 0xffffff;
  x[1] = (x[1] << 1) & 0xffffff;
}
function caml_int64_lsr1 (x) {
  x[1] = ((x[1] >>> 1) | (x[2] << 23)) & 0xffffff;
  x[2] = ((x[2] >>> 1) | (x[3] << 23)) & 0xffffff;
  x[3] = x[3] >>> 1;
}
function caml_int64_sub (x, y) {
  var z1 = x[1] - y[1];
  var z2 = x[2] - y[2] + (z1 >> 24);
  var z3 = x[3] - y[3] + (z2 >> 24);
  return [255, z1 & 0xffffff, z2 & 0xffffff, z3 & 0xffff];
}
function caml_int64_udivmod (x, y) {
  var offset = 0;
  var modulus = x.slice ();
  var divisor = y.slice ();
  var quotient = [255, 0, 0, 0];
  while (caml_int64_ucompare (modulus, divisor) > 0) {
    offset++;
    caml_int64_lsl1 (divisor);
  }
  while (offset >= 0) {
    offset --;
    caml_int64_lsl1 (quotient);
    if (caml_int64_ucompare (modulus, divisor) >= 0) {
      quotient[1] ++;
      modulus = caml_int64_sub (modulus, divisor);
    }
    caml_int64_lsr1 (divisor);
  }
  return [0,quotient, modulus];
}
function caml_int64_to_int32 (x) {
  return x[1] | (x[2] << 24);
}
function caml_int64_is_zero(x) {
  return (x[3]|x[2]|x[1]) == 0;
}
function caml_int64_format (fmt, x) {
  var f = caml_parse_format(fmt);
  if (f.signedconv && caml_int64_is_negative(x)) {
    f.sign = -1; x = caml_int64_neg(x);
  }
  var buffer = "";
  var wbase = caml_int64_of_int32(f.base);
  var cvtbl = "0123456789abcdef";
  do {
    var p = caml_int64_udivmod(x, wbase);
    x = p[1];
    buffer = cvtbl.charAt(caml_int64_to_int32(p[2])) + buffer;
  } while (! caml_int64_is_zero(x));
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - buffer.length;
    if (n > 0) buffer = caml_str_repeat (n, '0') + buffer;
  }
  return caml_finish_formatting(f, buffer);
}
function caml_parse_sign_and_base (s) {
  var i = 0, base = 10, sign = s.get(0) == 45?(i++,-1):1;
  if (s.get(i) == 48)
    switch (s.get(i + 1)) {
    case 120: case 88: base = 16; i += 2; break;
    case 111: case 79: base =  8; i += 2; break;
    case  98: case 66: base =  2; i += 2; break;
    }
  return [i, sign, base];
}
function caml_parse_digit(c) {
  if (c >= 48 && c <= 57)  return c - 48;
  if (c >= 65 && c <= 90)  return c - 55;
  if (c >= 97 && c <= 122) return c - 87;
  return -1;
}
var caml_global_data = [0];
function caml_failwith (msg) {
  caml_raise_with_string(caml_global_data[3], msg);
}
function caml_int_of_string (s) {
  var r = caml_parse_sign_and_base (s);
  var i = r[0], sign = r[1], base = r[2];
  var threshold = -1 >>> 0;
  var c = s.get(i);
  var d = caml_parse_digit(c);
  if (d < 0 || d >= base) caml_failwith("int_of_string");
  var res = d;
  for (;;) {
    i++;
    c = s.get(i);
    if (c == 95) continue;
    d = caml_parse_digit(c);
    if (d < 0 || d >= base) break;
    res = base * res + d;
    if (res > threshold) caml_failwith("int_of_string");
  }
  if (i != s.getLen()) caml_failwith("int_of_string");
  res = sign * res;
  if ((res | 0) != res) caml_failwith("int_of_string");
  return res;
}
function caml_is_printable(c) { return +(c > 31 && c < 127); }
function caml_js_call(f, o, args) { return f.apply(o, args.slice(1)); }
function caml_js_from_byte_string (s) {return s.getFullBytes();}
function caml_js_get_console () {
  var c = window.console?window.console:{};
  var m = ["log", "debug", "info", "warn", "error", "assert", "dir", "dirxml",
           "trace", "group", "groupCollapsed", "groupEnd", "time", "timeEnd"];
  function f () {}
  for (var i = 0; i < m.length; i++) if (!c[m[i]]) c[m[i]]=f;
  return c;
}
var caml_js_regexps = { amp:/&/g, lt:/</g, quot:/\"/g, all:/[&<\"]/ };
function caml_js_html_escape (s) {
  if (!caml_js_regexps.all.test(s)) return s;
  return s.replace(caml_js_regexps.amp, "&amp;")
          .replace(caml_js_regexps.lt, "&lt;")
          .replace(caml_js_regexps.quot, "&quot;");
}
function caml_js_on_ie () {
  var ua = window.navigator?window.navigator.userAgent:"";
  return ua.indexOf("MSIE") != -1 && ua.indexOf("Opera") != 0;
}
function caml_js_pure_expr (f) { return f(); }
function caml_js_to_byte_string (s) {return new MlString (s);}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_lessequal (x, y) { return +(caml_compare(x,y,false) <= 0); }
function caml_lessthan (x, y) { return +(caml_compare(x,y,false) < 0); }
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function MlStringFromArray (a) {
  var len = a.length; this.array = a; this.len = this.last = len;
}
MlStringFromArray.prototype = new MlString ();
var caml_md5_string =
function () {
  function add (x, y) { return (x + y) | 0; }
  function xx(q,a,b,x,s,t) {
    a = add(add(a, q), add(x, t));
    return add((a << s) | (a >>> (32 - s)), b);
  }
  function ff(a,b,c,d,x,s,t) {
    return xx((b & c) | ((~b) & d), a, b, x, s, t);
  }
  function gg(a,b,c,d,x,s,t) {
    return xx((b & d) | (c & (~d)), a, b, x, s, t);
  }
  function hh(a,b,c,d,x,s,t) { return xx(b ^ c ^ d, a, b, x, s, t); }
  function ii(a,b,c,d,x,s,t) { return xx(c ^ (b | (~d)), a, b, x, s, t); }
  function md5(buffer, length) {
    var i = length;
    buffer[i >> 2] |= 0x80 << (8 * (i & 3));
    for (i = (i & ~0x3) + 4;(i & 0x3F) < 56 ;i += 4)
      buffer[i >> 2] = 0;
    buffer[i >> 2] = length << 3;
    i += 4;
    buffer[i >> 2] = (length >> 29) & 0x1FFFFFFF;
    var w = [0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476];
    for(i = 0; i < buffer.length; i += 16) {
      var a = w[0], b = w[1], c = w[2], d = w[3];
      a = ff(a, b, c, d, buffer[i+ 0], 7, 0xD76AA478);
      d = ff(d, a, b, c, buffer[i+ 1], 12, 0xE8C7B756);
      c = ff(c, d, a, b, buffer[i+ 2], 17, 0x242070DB);
      b = ff(b, c, d, a, buffer[i+ 3], 22, 0xC1BDCEEE);
      a = ff(a, b, c, d, buffer[i+ 4], 7, 0xF57C0FAF);
      d = ff(d, a, b, c, buffer[i+ 5], 12, 0x4787C62A);
      c = ff(c, d, a, b, buffer[i+ 6], 17, 0xA8304613);
      b = ff(b, c, d, a, buffer[i+ 7], 22, 0xFD469501);
      a = ff(a, b, c, d, buffer[i+ 8], 7, 0x698098D8);
      d = ff(d, a, b, c, buffer[i+ 9], 12, 0x8B44F7AF);
      c = ff(c, d, a, b, buffer[i+10], 17, 0xFFFF5BB1);
      b = ff(b, c, d, a, buffer[i+11], 22, 0x895CD7BE);
      a = ff(a, b, c, d, buffer[i+12], 7, 0x6B901122);
      d = ff(d, a, b, c, buffer[i+13], 12, 0xFD987193);
      c = ff(c, d, a, b, buffer[i+14], 17, 0xA679438E);
      b = ff(b, c, d, a, buffer[i+15], 22, 0x49B40821);
      a = gg(a, b, c, d, buffer[i+ 1], 5, 0xF61E2562);
      d = gg(d, a, b, c, buffer[i+ 6], 9, 0xC040B340);
      c = gg(c, d, a, b, buffer[i+11], 14, 0x265E5A51);
      b = gg(b, c, d, a, buffer[i+ 0], 20, 0xE9B6C7AA);
      a = gg(a, b, c, d, buffer[i+ 5], 5, 0xD62F105D);
      d = gg(d, a, b, c, buffer[i+10], 9, 0x02441453);
      c = gg(c, d, a, b, buffer[i+15], 14, 0xD8A1E681);
      b = gg(b, c, d, a, buffer[i+ 4], 20, 0xE7D3FBC8);
      a = gg(a, b, c, d, buffer[i+ 9], 5, 0x21E1CDE6);
      d = gg(d, a, b, c, buffer[i+14], 9, 0xC33707D6);
      c = gg(c, d, a, b, buffer[i+ 3], 14, 0xF4D50D87);
      b = gg(b, c, d, a, buffer[i+ 8], 20, 0x455A14ED);
      a = gg(a, b, c, d, buffer[i+13], 5, 0xA9E3E905);
      d = gg(d, a, b, c, buffer[i+ 2], 9, 0xFCEFA3F8);
      c = gg(c, d, a, b, buffer[i+ 7], 14, 0x676F02D9);
      b = gg(b, c, d, a, buffer[i+12], 20, 0x8D2A4C8A);
      a = hh(a, b, c, d, buffer[i+ 5], 4, 0xFFFA3942);
      d = hh(d, a, b, c, buffer[i+ 8], 11, 0x8771F681);
      c = hh(c, d, a, b, buffer[i+11], 16, 0x6D9D6122);
      b = hh(b, c, d, a, buffer[i+14], 23, 0xFDE5380C);
      a = hh(a, b, c, d, buffer[i+ 1], 4, 0xA4BEEA44);
      d = hh(d, a, b, c, buffer[i+ 4], 11, 0x4BDECFA9);
      c = hh(c, d, a, b, buffer[i+ 7], 16, 0xF6BB4B60);
      b = hh(b, c, d, a, buffer[i+10], 23, 0xBEBFBC70);
      a = hh(a, b, c, d, buffer[i+13], 4, 0x289B7EC6);
      d = hh(d, a, b, c, buffer[i+ 0], 11, 0xEAA127FA);
      c = hh(c, d, a, b, buffer[i+ 3], 16, 0xD4EF3085);
      b = hh(b, c, d, a, buffer[i+ 6], 23, 0x04881D05);
      a = hh(a, b, c, d, buffer[i+ 9], 4, 0xD9D4D039);
      d = hh(d, a, b, c, buffer[i+12], 11, 0xE6DB99E5);
      c = hh(c, d, a, b, buffer[i+15], 16, 0x1FA27CF8);
      b = hh(b, c, d, a, buffer[i+ 2], 23, 0xC4AC5665);
      a = ii(a, b, c, d, buffer[i+ 0], 6, 0xF4292244);
      d = ii(d, a, b, c, buffer[i+ 7], 10, 0x432AFF97);
      c = ii(c, d, a, b, buffer[i+14], 15, 0xAB9423A7);
      b = ii(b, c, d, a, buffer[i+ 5], 21, 0xFC93A039);
      a = ii(a, b, c, d, buffer[i+12], 6, 0x655B59C3);
      d = ii(d, a, b, c, buffer[i+ 3], 10, 0x8F0CCC92);
      c = ii(c, d, a, b, buffer[i+10], 15, 0xFFEFF47D);
      b = ii(b, c, d, a, buffer[i+ 1], 21, 0x85845DD1);
      a = ii(a, b, c, d, buffer[i+ 8], 6, 0x6FA87E4F);
      d = ii(d, a, b, c, buffer[i+15], 10, 0xFE2CE6E0);
      c = ii(c, d, a, b, buffer[i+ 6], 15, 0xA3014314);
      b = ii(b, c, d, a, buffer[i+13], 21, 0x4E0811A1);
      a = ii(a, b, c, d, buffer[i+ 4], 6, 0xF7537E82);
      d = ii(d, a, b, c, buffer[i+11], 10, 0xBD3AF235);
      c = ii(c, d, a, b, buffer[i+ 2], 15, 0x2AD7D2BB);
      b = ii(b, c, d, a, buffer[i+ 9], 21, 0xEB86D391);
      w[0] = add(a, w[0]);
      w[1] = add(b, w[1]);
      w[2] = add(c, w[2]);
      w[3] = add(d, w[3]);
    }
    var t = [];
    for (var i = 0; i < 4; i++)
      for (var j = 0; j < 4; j++)
        t[i * 4 + j] = (w[i] >> (8 * j)) & 0xFF;
    return t;
  }
  return function (s, ofs, len) {
    var buf = [];
    if (s.array) {
      var a = s.array;
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] = a[j] | (a[j+1] << 8) | (a[j+2] << 16) | (a[j+3] << 24);
      }
      for (; i < len; i++) buf[i>>2] |= a[i + ofs] << (8 * (i & 3));
    } else {
      var b = s.getFullBytes();
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] =
          b.charCodeAt(j) | (b.charCodeAt(j+1) << 8) |
          (b.charCodeAt(j+2) << 16) | (b.charCodeAt(j+3) << 24);
      }
      for (; i < len; i++) buf[i>>2] |= b.charCodeAt(i + ofs) << (8 * (i & 3));
    }
    return new MlStringFromArray(md5(buf, len));
  }
} ();
function caml_ml_flush () { return 0; }
function caml_ml_open_descriptor_out () { return 0; }
function caml_ml_out_channels_list () { return 0; }
function caml_ml_output () { return 0; }
function caml_raise_constant (tag) { throw [0, tag]; }
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_obj_set_tag (x, tag) { x[0] = tag; return 0; }
function caml_obj_tag (x) { return (x instanceof Array)?x[0]:1000; }
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_string_equal(s1, s2) {
  var b1 = s1.fullBytes;
  var b2 = s2.fullBytes;
  if (b1 != null && b2 != null) return (b1 == b2)?1:0;
  return (s1.getFullBytes () == s2.getFullBytes ())?1:0;
}
function caml_string_notequal(s1, s2) { return 1-caml_string_equal(s1, s2); }
function caml_sys_get_config () {
  return [0, new MlWrappedString("Unix"), 32];
}
function caml_sys_random_seed () {
  return new Date()^0xffffffff*Math.random();
}
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function()
   {function _Nq_(_PB_,_PC_,_PD_,_PE_,_PF_,_PG_)
     {return _PB_.length==5
              ?_PB_(_PC_,_PD_,_PE_,_PF_,_PG_)
              :caml_call_gen(_PB_,[_PC_,_PD_,_PE_,_PF_,_PG_]);}
    function _mF_(_Pw_,_Px_,_Py_,_Pz_,_PA_)
     {return _Pw_.length==4
              ?_Pw_(_Px_,_Py_,_Pz_,_PA_)
              :caml_call_gen(_Pw_,[_Px_,_Py_,_Pz_,_PA_]);}
    function _jR_(_Ps_,_Pt_,_Pu_,_Pv_)
     {return _Ps_.length==3
              ?_Ps_(_Pt_,_Pu_,_Pv_)
              :caml_call_gen(_Ps_,[_Pt_,_Pu_,_Pv_]);}
    function _g1_(_Pp_,_Pq_,_Pr_)
     {return _Pp_.length==2?_Pp_(_Pq_,_Pr_):caml_call_gen(_Pp_,[_Pq_,_Pr_]);}
    function _gx_(_Pn_,_Po_)
     {return _Pn_.length==1?_Pn_(_Po_):caml_call_gen(_Pn_,[_Po_]);}
    var
     _a_=[0,new MlString("Failure")],
     _b_=[0,new MlString("Invalid_argument")],
     _c_=[0,new MlString("Not_found")],
     _d_=[0,new MlString("Assert_failure")],
     _e_=new MlString("button"),
     a_f_=[254,0.25,0],
     one_g_=[254,1,0],
     zero_h_=[254,0,0];
    caml_register_global(5,[0,new MlString("Division_by_zero")]);
    caml_register_global(3,_b_);
    caml_register_global(2,_a_);
    var
     _f5_=new MlString("output"),
     _f4_=new MlString("%.12g"),
     _f3_=new MlString("."),
     _f2_=new MlString("%d"),
     _f1_=new MlString("true"),
     _f0_=new MlString("false"),
     _fZ_=new MlString("Pervasives.do_at_exit"),
     _fY_=new MlString("\\b"),
     _fX_=new MlString("\\t"),
     _fW_=new MlString("\\n"),
     _fV_=new MlString("\\r"),
     _fU_=new MlString("\\\\"),
     _fT_=new MlString("\\'"),
     _fS_=new MlString(""),
     _fR_=new MlString("String.blit"),
     _fQ_=new MlString("String.sub"),
     _fP_=new MlString("CamlinternalLazy.Undefined"),
     _fO_=new MlString("Buffer.add_substring"),
     _fN_=new MlString("Buffer.add: cannot grow buffer"),
     _fM_=new MlString("%"),
     _fL_=new MlString(""),
     _fK_=new MlString(""),
     _fJ_=new MlString("\""),
     _fI_=new MlString("\""),
     _fH_=new MlString("'"),
     _fG_=new MlString("'"),
     _fF_=new MlString("."),
     _fE_=new MlString("printf: bad positional specification (0)."),
     _fD_=new MlString("%_"),
     _fC_=[0,new MlString("printf.ml"),144,8],
     _fB_=new MlString("''"),
     _fA_=new MlString("Printf: premature end of format string ``"),
     _fz_=new MlString("''"),
     _fy_=new MlString(" in format string ``"),
     _fx_=new MlString(", at char number "),
     _fw_=new MlString("Printf: bad conversion %"),
     _fv_=new MlString("Sformat.index_of_int: negative argument "),
     _fu_=new MlString("bad box format"),
     _ft_=new MlString("bad box name ho"),
     _fs_=new MlString("bad tag name specification"),
     _fr_=new MlString("bad tag name specification"),
     _fq_=new MlString(""),
     _fp_=new MlString(""),
     _fo_=new MlString(""),
     _fn_=new MlString("bad integer specification"),
     _fm_=new MlString("bad format"),
     _fl_=new MlString(")."),
     _fk_=new MlString(" ("),
     _fj_=new MlString("'', giving up at character number "),
     _fi_=new MlString(" ``"),
     _fh_=new MlString("fprintf: "),
     _fg_=[3,0,3],
     _ff_=new MlString("."),
     _fe_=new MlString(">"),
     _fd_=new MlString("</"),
     _fc_=new MlString(">"),
     _fb_=new MlString("<"),
     _fa_=new MlString("\n"),
     _e$_=new MlString("Format.Empty_queue"),
     _e__=[0,new MlString("")],
     _e9_=new MlString("Random.int"),
     _e8_=new MlString("x"),
     _e7_=
      [0,
       -85831125,
       -577944012,
       364182224,
       414272206,
       318284740,
       -83334073,
       383018966,
       -803368505,
       840823159,
       -1049181805,
       536292337,
       -561475319,
       189156120,
       -343492228,
       -929965496,
       51606627,
       -933575263,
       366354223,
       -70331559,
       -373178062,
       -91851154,
       913149062,
       526082594,
       -52316769,
       784300257,
       -405988474,
       -443597373,
       -124092012,
       -1025194932,
       -658227331,
       258888527,
       511570777,
       -983757954,
       283659902,
       308386020,
       -831053109,
       -591471064,
       -208553628,
       -46077654,
       -866544835,
       193777847,
       -454033636,
       671350186,
       149669678,
       -816697806,
       -986083620,
       558145612,
       -890291011,
       -1045608679,
       -172409642,
       710253903,
       -563095704,
       -421363914,
       409934019,
       801085050],
     _e6_=[0,new MlString("src/core/lwt.ml"),573,20],
     _e5_=[0,new MlString("src/core/lwt.ml"),575,8],
     _e4_=[0,new MlString("src/core/lwt.ml"),560,16],
     _e3_=[0,new MlString("src/core/lwt.ml"),477,20],
     _e2_=[0,new MlString("src/core/lwt.ml"),480,8],
     _e1_=[0,new MlString("src/core/lwt.ml"),440,20],
     _e0_=[0,new MlString("src/core/lwt.ml"),443,8],
     _eZ_=new MlString("Lwt.fast_connect"),
     _eY_=new MlString("Lwt.connect"),
     _eX_=new MlString("Lwt.wakeup_exn"),
     _eW_=new MlString("Lwt.wakeup"),
     _eV_=new MlString("Lwt.Canceled"),
     _eU_=new MlString("on"),
     _eT_=new MlString("canvas"),
     _eS_=new MlString("dt"),
     _eR_=new MlString("dd"),
     _eQ_=new MlString("img"),
     _eP_=new MlString("a"),
     _eO_=new MlString("div"),
     _eN_=new MlString("li"),
     _eM_=new MlString("dl"),
     _eL_=new MlString("ul"),
     _eK_=new MlString("\""),
     _eJ_=new MlString(" name=\""),
     _eI_=new MlString("\""),
     _eH_=new MlString(" type=\""),
     _eG_=new MlString("<"),
     _eF_=new MlString(">"),
     _eE_=new MlString(""),
     _eD_=new MlString("click"),
     _eC_=new MlString("mouseup"),
     _eB_=new MlString("mousemove"),
     _eA_=new MlString("keydown"),
     _ez_=new MlString("touchstart"),
     _ey_=new MlString("touchmove"),
     _ex_=new MlString("touchend"),
     _ew_=new MlString("2d"),
     _ev_=new MlString("Dom_html.Canvas_not_available"),
     _eu_=new MlString("\\$&"),
     _et_=new MlString("$$$$"),
     _es_=new MlString("g"),
     _er_=new MlString("g"),
     _eq_=new MlString("[$]"),
     _ep_=new MlString("[\\][()\\\\|+*.?{}^$]"),
     _eo_=[0,new MlString(""),0],
     _en_=new MlString(""),
     _em_=new MlString(""),
     _el_=new MlString("#"),
     _ek_=new MlString(""),
     _ej_=new MlString("?"),
     _ei_=new MlString(""),
     _eh_=new MlString("/"),
     _eg_=new MlString("/"),
     _ef_=new MlString(":"),
     _ee_=new MlString(""),
     _ed_=new MlString("http://"),
     _ec_=new MlString(""),
     _eb_=new MlString("#"),
     _ea_=new MlString(""),
     _d$_=new MlString("?"),
     _d__=new MlString(""),
     _d9_=new MlString("/"),
     _d8_=new MlString("/"),
     _d7_=new MlString(":"),
     _d6_=new MlString(""),
     _d5_=new MlString("https://"),
     _d4_=new MlString(""),
     _d3_=new MlString("#"),
     _d2_=new MlString(""),
     _d1_=new MlString("?"),
     _d0_=new MlString(""),
     _dZ_=new MlString("/"),
     _dY_=new MlString("file://"),
     _dX_=new MlString(""),
     _dW_=new MlString(""),
     _dV_=new MlString(""),
     _dU_=new MlString(""),
     _dT_=new MlString(""),
     _dS_=new MlString(""),
     _dR_=new MlString("="),
     _dQ_=new MlString("&"),
     _dP_=new MlString("file"),
     _dO_=new MlString("file:"),
     _dN_=new MlString("http"),
     _dM_=new MlString("http:"),
     _dL_=new MlString("https"),
     _dK_=new MlString("https:"),
     _dJ_=new MlString("%2B"),
     _dI_=new MlString("Url.Local_exn"),
     _dH_=new MlString("+"),
     _dG_=new MlString("Url.Not_an_http_protocol"),
     _dF_=
      new
       MlString
       ("^([Hh][Tt][Tt][Pp][Ss]?)://([0-9a-zA-Z.-]+|\\[[0-9a-zA-Z.-]+\\]|\\[[0-9A-Fa-f:.]+\\])?(:([0-9]+))?/([^\\?#]*)(\\?([^#]*))?(#(.*))?$"),
     _dE_=
      new MlString("^([Ff][Ii][Ll][Ee])://([^\\?#]*)(\\?([^#])*)?(#(.*))?$"),
     _dD_=new MlString("browser can't read file: unimplemented"),
     _dC_=new MlString("utf8"),
     _dB_=[0,new MlString("file.ml"),132,15],
     _dA_=new MlString("string"),
     _dz_=new MlString("can't retrieve file name: not implemented"),
     _dy_=new MlString(""),
     _dx_=new MlString("POST"),
     _dw_=new MlString("multipart/form-data; boundary="),
     _dv_=new MlString("POST"),
     _du_=
      [0,
       new MlString("POST"),
       [0,new MlString("application/x-www-form-urlencoded")],
       126925477],
     _dt_=[0,new MlString("POST"),0,126925477],
     _ds_=new MlString("GET"),
     _dr_=new MlString("?"),
     _dq_=new MlString("Content-type"),
     _dp_=new MlString("="),
     _do_=new MlString("="),
     _dn_=new MlString("&"),
     _dm_=new MlString("Content-Type: application/octet-stream\r\n"),
     _dl_=new MlString("\"\r\n"),
     _dk_=new MlString("\"; filename=\""),
     _dj_=new MlString("Content-Disposition: form-data; name=\""),
     _di_=new MlString("\r\n"),
     _dh_=new MlString("\r\n"),
     _dg_=new MlString("\r\n"),
     _df_=new MlString("--"),
     _de_=new MlString("\r\n"),
     _dd_=new MlString("\"\r\n\r\n"),
     _dc_=new MlString("Content-Disposition: form-data; name=\""),
     _db_=new MlString("--\r\n"),
     _da_=new MlString("--"),
     _c$_=new MlString("js_of_ocaml-------------------"),
     _c__=new MlString("Msxml2.XMLHTTP"),
     _c9_=new MlString("Msxml3.XMLHTTP"),
     _c8_=new MlString("Microsoft.XMLHTTP"),
     _c7_=[0,new MlString("xmlHttpRequest.ml"),79,2],
     _c6_=new MlString("XmlHttpRequest.Wrong_headers"),
     _c5_=new MlString("#"),
     _c4_=new MlString("absolute"),
     _c3_=new MlString("0"),
     _c2_=new MlString("0"),
     _c1_=new MlString("info-38.png"),
     _c0_=new MlString("absolute"),
     _cZ_=new MlString("2px"),
     _cY_=new MlString("0"),
     _cX_=new MlString("pointer"),
     _cW_=new MlString("Information"),
     _cV_=new MlString("36px"),
     _cU_=new MlString("36px"),
     _cT_=new MlString("globe-38.png"),
     _cS_=new MlString("absolute"),
     _cR_=new MlString("2px"),
     _cQ_=new MlString("48px"),
     _cP_=new MlString("pointer"),
     languages_cO_=
      [0,
       [0,new MlString("Fran\xc3\xa7ais"),new MlString("fr")],
       [0,[0,new MlString("English"),new MlString("en")],0]],
     _cN_=new MlString("Languages"),
     _cM_=new MlString("text on"),
     _cL_=new MlString("absolute"),
     _cK_=new MlString("0px"),
     _cJ_=new MlString("46px"),
     _cI_=new MlString("nowrap"),
     _cH_=new MlString("meeting-point-38.png"),
     _cG_=new MlString("absolute"),
     _cF_=new MlString("2px"),
     _cE_=new MlString("96px"),
     _cD_=new MlString("pointer"),
     _cC_=new MlString("Recenter"),
     _cB_=new MlString("36px"),
     _cA_=new MlString("36px"),
     z0_cz_=[254,0,0],
     z1_cy_=[254,0.1,0],
     z0_cx_=[254,0,0],
     z1_cw_=[254,0,0.1],
     z0_cv_=[254,0,0],
     z1_cu_=[254,-0.1,0],
     z0_ct_=[254,0,0],
     z1_cs_=[254,0,-0.1],
     _cr_=new MlString("transform"),
     _cq_=new MlString("pointer"),
     _cp_=new MlString(""),
     _co_=new MlString("Resize %d %d"),
     _cn_=new MlString("transform"),
     _cm_=new MlString("transform"),
     _cl_=new MlString("hidden"),
     _ck_=new MlString("100%"),
     _cj_=new MlString("hidden"),
     _ci_=new MlString("0px"),
     _ch_=new MlString("100%"),
     _cg_=new MlString("text"),
     _cf_=new MlString("80%"),
     _ce_=new MlString("auto"),
     _cd_=
      new
       MlString
       ("Unfortunately, this browser is not supported. Please try again with another browser, such as <a href=\"http://www.mozilla.org/firefox/\">Firefox</a>, <a href=\"http://www.google.com/chrome/\">Chrome</a> or <a href=\"http://www.opera.com/\">Opera</a>."),
     _cc_=new MlString("table-cell"),
     _cb_=new MlString("middle"),
     _ca_=new MlString("100%"),
     _b$_=new MlString("100%"),
     _b__=new MlString("table"),
     _b9_=new MlString("overlay"),
     _b8_=new MlString("en"),
     _b7_=new MlString("text"),
     _b6_=new MlString("80%"),
     _b5_=new MlString("auto"),
     _b4_=new MlString("table-cell"),
     _b3_=new MlString("middle"),
     _b2_=new MlString("100%"),
     _b1_=new MlString("100%"),
     _b0_=new MlString("table"),
     _bZ_=new MlString("overlay translucent"),
     _bY_=new MlString("OK"),
     _bX_=new MlString("center"),
     _bW_=new MlString("2em auto"),
     _bV_=new MlString("_blank"),
     _bU_=new MlString(".wikipedia.org/wiki/"),
     _bT_=new MlString("http://"),
     _bS_=new MlString("absolute"),
     _bR_=new MlString("0"),
     _bQ_=new MlString("0"),
     _bP_=new MlString("0"),
     _bO_=new MlString("0"),
     _bN_=new MlString("auto"),
     _bM_=new MlString("px"),
     _bL_=new MlString("10px"),
     _bK_=new MlString("absolute"),
     _bJ_=new MlString("0"),
     _bI_=new MlString("0"),
     _bH_=new MlString("0"),
     _bG_=new MlString("0"),
     _bF_=new MlString("absolute"),
     _bE_=new MlString("0"),
     _bD_=new MlString("4em"),
     _bC_=new MlString("38px"),
     _bB_=new MlString("38px"),
     _bA_=new MlString("block"),
     _bz_=new MlString("auto"),
     _by_=new MlString("auto"),
     _bx_=new MlString("100%"),
     _bw_=new MlString("100%"),
     _bv_=new MlString("auto"),
     _bu_=new MlString("auto"),
     _bt_=new MlString(".jpg"),
     _bs_=new MlString("images/"),
     _br_=new MlString("block"),
     _bq_=new MlString("auto"),
     _bp_=new MlString("auto"),
     _bo_=new MlString("100%"),
     _bn_=new MlString("100%"),
     _bm_=new MlString("auto"),
     _bl_=new MlString("auto"),
     _bk_=new MlString("text"),
     _bj_=new MlString("absolute"),
     _bi_=new MlString("0"),
     _bh_=new MlString("auto"),
     _bg_=new MlString("auto"),
     _bf_=new MlString("overlay"),
     _be_=new MlString("100%"),
     _bd_=new MlString("100%"),
     _bc_=new MlString("absolute"),
     _bb_=new MlString("0"),
     _ba_=new MlString("0"),
     _a$_=new MlString("1"),
     _a__=new MlString("button"),
     _a9_=new MlString("absolute"),
     _a8_=new MlString("0"),
     _a7_=new MlString("0"),
     _a6_=new MlString("pointer"),
     _a5_=new MlString("Click anywhere to return to the tree"),
     _a4_=new MlString("32px"),
     _a3_=new MlString("20px"),
     _a2_=new MlString("absolute"),
     _a1_=new MlString("0"),
     _a0_=new MlString("0"),
     _aZ_=new MlString("en"),
     _aY_=new MlString(""),
     _aX_=new MlString("?uselang="),
     _aW_=new MlString("http://commons.wikimedia.org/wiki/File:"),
     _aV_=new MlString("commons-38.png"),
     _aU_=new MlString("See image description on Wikimedia Commons"),
     _aT_=new MlString("48px"),
     _aS_=new MlString("12px"),
     _aR_=new MlString("wikipedia-38.png"),
     _aQ_=new MlString("In English"),
     _aP_=new MlString("en"),
     _aO_=new MlString("en"),
     _aN_=new MlString("In English"),
     _aM_=new MlString("No reference found."),
     _aL_=new MlString("text on"),
     _aK_=new MlString("absolute"),
     _aJ_=new MlString("48px"),
     _aI_=new MlString("62px"),
     _aH_=new MlString("nowrap"),
     _aG_=new MlString("text on"),
     _aF_=new MlString("text"),
     _aE_=new MlString("absolute"),
     _aD_=new MlString("tooltip on"),
     _aC_=new MlString("absolute"),
     _aB_=new MlString("38px"),
     _aA_=new MlString("px"),
     _az_=new MlString("2px"),
     _ay_=new MlString("2px"),
     _ax_=new MlString("%dpx 3px %dpx 3px"),
     _aw_=new MlString("on"),
     _av_=new MlString("off"),
     _au_=new MlString("filled_button "),
     _at_=new MlString("button"),
     _as_=new MlString("48px"),
     _ar_=new MlString("px"),
     _aq_=new MlString("_blank"),
     _ap_=new MlString("#888888"),
     _ao_=new MlString("on"),
     _an_=new MlString("off"),
     _am_=new MlString("absolute"),
     _al_=new MlString("0"),
     _ak_=new MlString("0"),
     _aj_=new MlString("image_info.json"),
     _ai_=[0,0,0,0],
     _ah_=[254,-1,0],
     _ag_=[0,new MlString("hypertree.ml"),916,2],
     _af_=new MlString("en"),
     _ae_=new MlString("<TITLE>"),
     _ad_=new MlString(""),
     _ac_=new MlString("20px sans-serif"),
     _ab_=new MlString("black"),
     _aa_=new MlString("center"),
     _$_=new MlString("middle"),
     ___=new MlString(".jpg"),
     _Z_=new MlString("thumbnails/"),
     _Y_=new MlString("draw"),
     _X_=new MlString("round"),
     _W_=new MlString("black"),
     _V_=new MlString("draw"),
     _U_=new MlString("messages.json"),
     _T_=new MlString("hyp_lang"),
     _S_=new MlString("hyp_lang"),
     _R_=new MlString("en"),
     _Q_=new MlString("hidden"),
     _P_=new MlString("absolute"),
     _O_=new MlString("nowrap"),
     _N_=new MlString("Touch cancel %d %d %d %d"),
     _M_=new MlString(""),
     _L_=new MlString("Touch end %d %d %d %d"),
     _K_=new MlString(""),
     _J_=new MlString("Touch move %d %d %d %d"),
     _I_=new MlString("move"),
     _H_=new MlString("Touch start %d %d"),
     _G_=new MlString("Mouse up %d %d %d %d"),
     _F_=new MlString(""),
     _E_=new MlString("Mouse move %d %d %d %d"),
     _D_=new MlString("move"),
     _C_=new MlString("Mouse down %d %d"),
     _B_=new MlString("icons/"),
     icons_A_=
      [0,
       new MlString("commons-38.png"),
       [0,
        new MlString("wikipedia-38.png"),
        [0,
         new MlString("info-38.png"),
         [0,
          new MlString("meeting-point-38.png"),
          [0,new MlString("globe-38.png"),0]]]]],
     _z_=new MlString("#794c0d"),
     _y_=new MlString("absolute"),
     _x_=new MlString("0"),
     _w_=new MlString("0"),
     _v_=new MlString("0.9em"),
     tree_url_u_=new MlString("tree.json"),
     _t_=new MlString("\n"),
     _s_=new MlString("[^ ]"),
     _r_=new MlString("[|]"),
     _q_=
      new
       MlString
       ("<h1>A tree of animals</h1> This <a target=\"_blank\" href=\"http://en.wikipedia.org/wiki/Phylogenetic_tree\"><em>phylogenetic</em> tree</a> displays the relationships among animals.<h2>Usage</h2>Browse the tree by dragging it with the mouse. Click on any image to display a larger version.<h2>Credits</h2>This software and the images it uses are under free licenses. Images are from <a target=\"_blank\" href=\"http://commons.wikimedia.org/wiki/Main_Page\">Wikimedia Commons</a>.  You can click on each image for details.  The software has been written by J\xc3\xa9r\xc3\xb4me Vouillon (CNRS).");
    function _p_(s_i_){throw [0,_a_,s_i_];}
    function _f6_(s_j_){throw [0,_b_,s_j_];}
    function _f7_(x_l_,y_k_){return caml_lessequal(x_l_,y_k_)?x_l_:y_k_;}
    function _f8_(x_n_,y_m_){return caml_greaterequal(x_n_,y_m_)?x_n_:y_m_;}
    function _f9_(x_o_){return 0<=x_o_?x_o_:-x_o_|0;}
    var max_int_gj_=(1<<31)-1|0;
    function _gi_(s1_f__,s2_ga_)
     {var
       l1_f$_=s1_f__.getLen(),
       l2_gb_=s2_ga_.getLen(),
       s_gc_=caml_create_string(l1_f$_+l2_gb_|0);
      caml_blit_string(s1_f__,0,s_gc_,0,l1_f$_);
      caml_blit_string(s2_ga_,0,s_gc_,l1_f$_,l2_gb_);
      return s_gc_;}
    function string_of_int_gk_(n_gd_){return caml_format_int(_f2_,n_gd_);}
    function _gf_(l1_ge_,l2_gg_)
     {if(l1_ge_)
       {var hd_gh_=l1_ge_[1];return [0,hd_gh_,_gf_(l1_ge_[2],l2_gg_)];}
      return l2_gg_;}
    var
     stdout_gu_=caml_ml_open_descriptor_out(1),
     stderr_gt_=caml_ml_open_descriptor_out(2);
    function flush_all_gv_(param_go_)
     {var param_gl_=caml_ml_out_channels_list(0);
      for(;;)
       {if(param_gl_)
         {var l_gm_=param_gl_[2];
          try {}catch(_gn_){}
          var param_gl_=l_gm_;
          continue;}
        return 0;}}
    var exit_function_gw_=[0,flush_all_gv_];
    function output_gA_(oc_gs_,s_gr_,ofs_gp_,len_gq_)
     {if(0<=ofs_gp_&&0<=len_gq_&&!((s_gr_.getLen()-len_gq_|0)<ofs_gp_))
       return caml_ml_output(oc_gs_,s_gr_,ofs_gp_,len_gq_);
      return _f6_(_f5_);}
    function do_at_exit_gz_(param_gy_){return _gx_(exit_function_gw_[1],0);}
    caml_register_named_value(_fZ_,do_at_exit_gz_);
    function _g3_(f_gF_,a_gC_)
     {var _gB_=0,_gD_=a_gC_.length-1-1|0;
      if(!(_gD_<_gB_))
       {var i_gE_=_gB_;
        for(;;)
         {_gx_(f_gF_,a_gC_[i_gE_+1]);
          var _gG_=i_gE_+1|0;
          if(_gD_!==i_gE_){var i_gE_=_gG_;continue;}
          break;}}
      return 0;}
    function _g4_(f_gJ_,a_gH_)
     {var l_gI_=a_gH_.length-1;
      if(0===l_gI_)return [0];
      var
       r_gK_=caml_make_vect(l_gI_,_gx_(f_gJ_,a_gH_[0+1])),
       _gL_=1,
       _gM_=l_gI_-1|0;
      if(!(_gM_<_gL_))
       {var i_gN_=_gL_;
        for(;;)
         {r_gK_[i_gN_+1]=_gx_(f_gJ_,a_gH_[i_gN_+1]);
          var _gO_=i_gN_+1|0;
          if(_gM_!==i_gN_){var i_gN_=_gO_;continue;}
          break;}}
      return r_gK_;}
    function _g6_(a_gP_)
     {var i_gQ_=a_gP_.length-1-1|0,res_gR_=0;
      for(;;)
       {if(0<=i_gQ_)
         {var
           _gT_=[0,a_gP_[i_gQ_+1],res_gR_],
           _gS_=i_gQ_-1|0,
           i_gQ_=_gS_,
           res_gR_=_gT_;
          continue;}
        return res_gR_;}}
    function _g5_(f_g0_,x_gU_,a_gX_)
     {var r_gV_=[0,x_gU_],_gW_=0,_gY_=a_gX_.length-1-1|0;
      if(!(_gY_<_gW_))
       {var i_gZ_=_gW_;
        for(;;)
         {r_gV_[1]=_g1_(f_g0_,r_gV_[1],a_gX_[i_gZ_+1]);
          var _g2_=i_gZ_+1|0;
          if(_gY_!==i_gZ_){var i_gZ_=_g2_;continue;}
          break;}}
      return r_gV_[1];}
    function _hp_(l_g7_)
     {var l1_g8_=l_g7_,l2_g9_=0;
      for(;;)
       {if(l1_g8_)
         {var
           l_g__=l1_g8_[2],
           _g$_=[0,l1_g8_[1],l2_g9_],
           l1_g8_=l_g__,
           l2_g9_=_g$_;
          continue;}
        return l2_g9_;}}
    function _hd_(f_hb_,param_ha_)
     {if(param_ha_)
       {var l_hc_=param_ha_[2],r_he_=_gx_(f_hb_,param_ha_[1]);
        return [0,r_he_,_hd_(f_hb_,l_hc_)];}
      return 0;}
    function _hq_(f_hh_,param_hf_)
     {var param_hg_=param_hf_;
      for(;;)
       {if(param_hg_)
         {var l_hi_=param_hg_[2];
          _gx_(f_hh_,param_hg_[1]);
          var param_hg_=l_hi_;
          continue;}
        return 0;}}
    function _hr_(x_hm_,param_hj_)
     {var param_hk_=param_hj_;
      for(;;)
       {if(param_hk_)
         {var match_hl_=param_hk_[1],l_ho_=param_hk_[2],b_hn_=match_hl_[2];
          if(match_hl_[1]===x_hm_)return b_hn_;
          var param_hk_=l_ho_;
          continue;}
        throw [0,_c_];}}
    function _hO_(n_hs_,c_hu_)
     {var s_ht_=caml_create_string(n_hs_);
      caml_fill_string(s_ht_,0,n_hs_,c_hu_);
      return s_ht_;}
    function _hP_(s_hx_,ofs_hv_,len_hw_)
     {if(0<=ofs_hv_&&0<=len_hw_&&!((s_hx_.getLen()-len_hw_|0)<ofs_hv_))
       {var r_hy_=caml_create_string(len_hw_);
        caml_blit_string(s_hx_,ofs_hv_,r_hy_,0,len_hw_);
        return r_hy_;}
      return _f6_(_fQ_);}
    function _hQ_(s1_hB_,ofs1_hA_,s2_hD_,ofs2_hC_,len_hz_)
     {if
       (0<=
        len_hz_&&
        0<=
        ofs1_hA_&&
        !((s1_hB_.getLen()-len_hz_|0)<ofs1_hA_)&&
        0<=
        ofs2_hC_&&
        !((s2_hD_.getLen()-len_hz_|0)<ofs2_hC_))
       return caml_blit_string(s1_hB_,ofs1_hA_,s2_hD_,ofs2_hC_,len_hz_);
      return _f6_(_fR_);}
    function _hR_(sep_hK_,l_hE_)
     {if(l_hE_)
       {var hd_hF_=l_hE_[1],num_hG_=[0,0],len_hH_=[0,0],tl_hJ_=l_hE_[2];
        _hq_
         (function(s_hI_)
           {num_hG_[1]+=1;len_hH_[1]=len_hH_[1]+s_hI_.getLen()|0;return 0;},
          l_hE_);
        var
         r_hL_=
          caml_create_string
           (len_hH_[1]+caml_mul(sep_hK_.getLen(),num_hG_[1]-1|0)|0);
        caml_blit_string(hd_hF_,0,r_hL_,0,hd_hF_.getLen());
        var pos_hM_=[0,hd_hF_.getLen()];
        _hq_
         (function(s_hN_)
           {caml_blit_string(sep_hK_,0,r_hL_,pos_hM_[1],sep_hK_.getLen());
            pos_hM_[1]=pos_hM_[1]+sep_hK_.getLen()|0;
            caml_blit_string(s_hN_,0,r_hL_,pos_hM_[1],s_hN_.getLen());
            pos_hM_[1]=pos_hM_[1]+s_hN_.getLen()|0;
            return 0;},
          tl_hJ_);
        return r_hL_;}
      return _fS_;}
    var
     _hS_=caml_sys_get_config(0)[2],
     _hT_=(1<<(_hS_-10|0))-1|0,
     _hU_=caml_mul(_hS_/8|0,_hT_)-1|0;
    function _hY_(x_hV_){return caml_hash_univ_param(10,100,x_hV_);}
    function _ia_(initial_size_hW_)
     {return [0,0,caml_make_vect(_f7_(_f8_(1,initial_size_hW_),_hT_),0)];}
    function _ib_(h_hX_,key_hZ_)
     {var
       _h0_=h_hX_[2].length-1,
       _h1_=caml_mod(_hY_(key_hZ_),_h0_),
       _h2_=caml_array_get(h_hX_[2],_h1_);
      if(_h2_)
       {var rest1_h3_=_h2_[3],d1_h4_=_h2_[2];
        if(0===caml_compare(key_hZ_,_h2_[1]))return d1_h4_;
        if(rest1_h3_)
         {var rest2_h5_=rest1_h3_[3],d2_h6_=rest1_h3_[2];
          if(0===caml_compare(key_hZ_,rest1_h3_[1]))return d2_h6_;
          if(rest2_h5_)
           {var rest3_h8_=rest2_h5_[3],d3_h7_=rest2_h5_[2];
            if(0===caml_compare(key_hZ_,rest2_h5_[1]))return d3_h7_;
            var param_h9_=rest3_h8_;
            for(;;)
             {if(param_h9_)
               {var rest_h$_=param_h9_[3],d_h__=param_h9_[2];
                if(0===caml_compare(key_hZ_,param_h9_[1]))return d_h__;
                var param_h9_=rest_h$_;
                continue;}
              throw [0,_c_];}}
          throw [0,_c_];}
        throw [0,_c_];}
      throw [0,_c_];}
    var _il_=246,_ii_=250,_ic_=[0,_fP_];
    function _if_(param_id_){throw [0,_ic_];}
    function _im_(blk_ie_)
     {var closure_ig_=blk_ie_[0+1];
      blk_ie_[0+1]=_if_;
      try
       {var result_ih_=_gx_(closure_ig_,0);
        blk_ie_[0+1]=result_ih_;
        caml_obj_set_tag(blk_ie_,_ii_);}
      catch(_ij_){blk_ie_[0+1]=function(param_ik_){throw _ij_;};throw _ij_;}
      return result_ih_;}
    function _iM_(n_in_)
     {var
       n_io_=1<=n_in_?n_in_:1,
       n_ip_=_hU_<n_io_?_hU_:n_io_,
       s_iq_=caml_create_string(n_ip_);
      return [0,s_iq_,0,n_ip_,s_iq_];}
    function _iN_(b_ir_){return _hP_(b_ir_[1],0,b_ir_[2]);}
    function _iy_(b_is_,more_iu_)
     {var new_len_it_=[0,b_is_[3]];
      for(;;)
       {if(new_len_it_[1]<(b_is_[2]+more_iu_|0))
         {new_len_it_[1]=2*new_len_it_[1]|0;continue;}
        if(_hU_<new_len_it_[1])
         if((b_is_[2]+more_iu_|0)<=_hU_)new_len_it_[1]=_hU_;else _p_(_fN_);
        var new_buffer_iv_=caml_create_string(new_len_it_[1]);
        _hQ_(b_is_[1],0,new_buffer_iv_,0,b_is_[2]);
        b_is_[1]=new_buffer_iv_;
        b_is_[3]=new_len_it_[1];
        return 0;}}
    function _iO_(b_iw_,c_iz_)
     {var pos_ix_=b_iw_[2];
      if(b_iw_[3]<=pos_ix_)_iy_(b_iw_,1);
      b_iw_[1].safeSet(pos_ix_,c_iz_);
      b_iw_[2]=pos_ix_+1|0;
      return 0;}
    function _iQ_(b_iG_,s_iF_,offset_iA_,len_iD_)
     {var _iB_=offset_iA_<0?1:0;
      if(_iB_)
       var _iC_=_iB_;
      else
       {var
         _iE_=len_iD_<0?1:0,
         _iC_=_iE_?_iE_:(s_iF_.getLen()-len_iD_|0)<offset_iA_?1:0;}
      if(_iC_)_f6_(_fO_);
      var new_position_iH_=b_iG_[2]+len_iD_|0;
      if(b_iG_[3]<new_position_iH_)_iy_(b_iG_,len_iD_);
      _hQ_(s_iF_,offset_iA_,b_iG_[1],b_iG_[2],len_iD_);
      b_iG_[2]=new_position_iH_;
      return 0;}
    function _iP_(b_iK_,s_iI_)
     {var len_iJ_=s_iI_.getLen(),new_position_iL_=b_iK_[2]+len_iJ_|0;
      if(b_iK_[3]<new_position_iL_)_iy_(b_iK_,len_iJ_);
      _hQ_(s_iI_,0,b_iK_[1],b_iK_[2],len_iJ_);
      b_iK_[2]=new_position_iL_;
      return 0;}
    function index_of_int_iU_(i_iR_)
     {return 0<=i_iR_?i_iR_:_p_(_gi_(_fv_,string_of_int_gk_(i_iR_)));}
    var
     _iV_=
      _gx_
       (function(i_iS_,idx_iT_){return index_of_int_iU_(i_iS_+idx_iT_|0);},1);
    function _i0_(fmt_iY_,idx_iX_,len_iW_)
     {return _hP_(fmt_iY_,idx_iX_,len_iW_);}
    function _i6_(fmt_iZ_){return _i0_(fmt_iZ_,0,fmt_iZ_.getLen());}
    function bad_conversion_i8_(sfmt_i1_,i_i2_,c_i4_)
     {var
       _i3_=_gi_(_fy_,_gi_(sfmt_i1_,_fz_)),
       _i5_=_gi_(_fx_,_gi_(string_of_int_gk_(i_i2_),_i3_));
      return _f6_(_gi_(_fw_,_gi_(_hO_(1,c_i4_),_i5_)));}
    function bad_conversion_format_jX_(fmt_i7_,i_i__,c_i9_)
     {return bad_conversion_i8_(_i6_(fmt_i7_),i_i__,c_i9_);}
    function incomplete_format_jY_(fmt_i$_)
     {return _f6_(_gi_(_fA_,_gi_(_i6_(fmt_i$_),_fB_)));}
    function extract_format_jt_(fmt_ja_,start_ji_,stop_jk_,widths_jm_)
     {function skip_positional_spec_jh_(start_jb_)
       {if
         ((fmt_ja_.safeGet(start_jb_)-48|0)<
          0||
          9<
          (fmt_ja_.safeGet(start_jb_)-48|0))
         return start_jb_;
        var i_jc_=start_jb_+1|0;
        for(;;)
         {var _jd_=fmt_ja_.safeGet(i_jc_);
          if(48<=_jd_)
           {if(!(58<=_jd_)){var _jf_=i_jc_+1|0,i_jc_=_jf_;continue;}
            var _je_=0;}
          else
           if(36===_jd_){var _jg_=i_jc_+1|0,_je_=1;}else var _je_=0;
          if(!_je_)var _jg_=start_jb_;
          return _jg_;}}
      var
       start_jj_=skip_positional_spec_jh_(start_ji_+1|0),
       b_jl_=_iM_((stop_jk_-start_jj_|0)+10|0);
      _iO_(b_jl_,37);
      var i_jn_=start_jj_,widths_jo_=_hp_(widths_jm_);
      for(;;)
       {if(i_jn_<=stop_jk_)
         {var _jp_=fmt_ja_.safeGet(i_jn_);
          if(42===_jp_)
           {if(widths_jo_)
             {var t_jq_=widths_jo_[2];
              _iP_(b_jl_,string_of_int_gk_(widths_jo_[1]));
              var
               i_jr_=skip_positional_spec_jh_(i_jn_+1|0),
               i_jn_=i_jr_,
               widths_jo_=t_jq_;
              continue;}
            throw [0,_d_,_fC_];}
          _iO_(b_jl_,_jp_);
          var _js_=i_jn_+1|0,i_jn_=_js_;
          continue;}
        return _iN_(b_jl_);}}
    function extract_format_int_k3_
     (conv_jz_,fmt_jx_,start_jw_,stop_jv_,widths_ju_)
     {var sfmt_jy_=extract_format_jt_(fmt_jx_,start_jw_,stop_jv_,widths_ju_);
      if(78!==conv_jz_&&110!==conv_jz_)return sfmt_jy_;
      sfmt_jy_.safeSet(sfmt_jy_.getLen()-1|0,117);
      return sfmt_jy_;}
    function sub_format_jZ_
     (incomplete_format_jG_,bad_conversion_format_jQ_,conv_jV_,fmt_jA_,i_jU_)
     {var len_jB_=fmt_jA_.getLen();
      function sub_fmt_jS_(c_jC_,i_jP_)
       {var close_jD_=40===c_jC_?41:125;
        function sub_jO_(j_jE_)
         {var j_jF_=j_jE_;
          for(;;)
           {if(len_jB_<=j_jF_)return _gx_(incomplete_format_jG_,fmt_jA_);
            if(37===fmt_jA_.safeGet(j_jF_))
             {var _jH_=j_jF_+1|0;
              if(len_jB_<=_jH_)
               var _jI_=_gx_(incomplete_format_jG_,fmt_jA_);
              else
               {var _jJ_=fmt_jA_.safeGet(_jH_),_jK_=_jJ_-40|0;
                if(_jK_<0||1<_jK_)
                 {var _jL_=_jK_-83|0;
                  if(_jL_<0||2<_jL_)
                   var _jM_=1;
                  else
                   switch(_jL_)
                    {case 1:var _jM_=1;break;
                     case 2:var _jN_=1,_jM_=0;break;
                     default:var _jN_=0,_jM_=0;}
                  if(_jM_){var _jI_=sub_jO_(_jH_+1|0),_jN_=2;}}
                else
                 var _jN_=0===_jK_?0:1;
                switch(_jN_)
                 {case 1:
                   var
                    _jI_=
                     _jJ_===close_jD_
                      ?_jH_+1|0
                      :_jR_(bad_conversion_format_jQ_,fmt_jA_,i_jP_,_jJ_);
                   break;
                  case 2:break;
                  default:var _jI_=sub_jO_(sub_fmt_jS_(_jJ_,_jH_+1|0)+1|0);}}
              return _jI_;}
            var _jT_=j_jF_+1|0,j_jF_=_jT_;
            continue;}}
        return sub_jO_(i_jP_);}
      return sub_fmt_jS_(conv_jV_,i_jU_);}
    function sub_format_for_printf_km_(conv_jW_)
     {return _jR_
              (sub_format_jZ_,
               incomplete_format_jY_,
               bad_conversion_format_jX_,
               conv_jW_);}
    function iter_on_format_args_mf_(fmt_j0_,add_conv_j$_,add_char_kj_)
     {var lim_j1_=fmt_j0_.getLen()-1|0;
      function scan_fmt_kk_(i_j2_)
       {var i_j3_=i_j2_;
        a:
        for(;;)
         {if(i_j3_<lim_j1_)
           {if(37===fmt_j0_.safeGet(i_j3_))
             {var skip_j4_=0,i_j5_=i_j3_+1|0;
              for(;;)
               {if(lim_j1_<i_j5_)
                 var _j6_=incomplete_format_jY_(fmt_j0_);
                else
                 {var _j7_=fmt_j0_.safeGet(i_j5_);
                  if(58<=_j7_)
                   {if(95===_j7_)
                     {var _j9_=i_j5_+1|0,_j8_=1,skip_j4_=_j8_,i_j5_=_j9_;
                      continue;}}
                  else
                   if(32<=_j7_)
                    switch(_j7_-32|0)
                     {case 1:
                      case 2:
                      case 4:
                      case 5:
                      case 6:
                      case 7:
                      case 8:
                      case 9:
                      case 12:
                      case 15:break;
                      case 0:
                      case 3:
                      case 11:
                      case 13:var _j__=i_j5_+1|0,i_j5_=_j__;continue;
                      case 10:
                       var _ka_=_jR_(add_conv_j$_,skip_j4_,i_j5_,105),i_j5_=_ka_;
                       continue;
                      default:var _kb_=i_j5_+1|0,i_j5_=_kb_;continue;}
                  var i_kc_=i_j5_;
                  c:
                  for(;;)
                   {if(lim_j1_<i_kc_)
                     var _kd_=incomplete_format_jY_(fmt_j0_);
                    else
                     {var _ke_=fmt_j0_.safeGet(i_kc_);
                      if(126<=_ke_)
                       var _kf_=0;
                      else
                       switch(_ke_)
                        {case 78:
                         case 88:
                         case 100:
                         case 105:
                         case 111:
                         case 117:
                         case 120:
                          var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,105),_kf_=1;break;
                         case 69:
                         case 70:
                         case 71:
                         case 101:
                         case 102:
                         case 103:
                          var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,102),_kf_=1;break;
                         case 33:
                         case 37:
                         case 44:var _kd_=i_kc_+1|0,_kf_=1;break;
                         case 83:
                         case 91:
                         case 115:
                          var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,115),_kf_=1;break;
                         case 97:
                         case 114:
                         case 116:
                          var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,_ke_),_kf_=1;
                          break;
                         case 76:
                         case 108:
                         case 110:
                          var j_kg_=i_kc_+1|0;
                          if(lim_j1_<j_kg_)
                           {var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,105),_kf_=1;}
                          else
                           {var _kh_=fmt_j0_.safeGet(j_kg_)-88|0;
                            if(_kh_<0||32<_kh_)
                             var _ki_=1;
                            else
                             switch(_kh_)
                              {case 0:
                               case 12:
                               case 17:
                               case 23:
                               case 29:
                               case 32:
                                var
                                 _kd_=
                                  _g1_
                                   (add_char_kj_,_jR_(add_conv_j$_,skip_j4_,i_kc_,_ke_),105),
                                 _kf_=1,
                                 _ki_=0;
                                break;
                               default:var _ki_=1;}
                            if(_ki_)
                             {var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,105),_kf_=1;}}
                          break;
                         case 67:
                         case 99:
                          var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,99),_kf_=1;break;
                         case 66:
                         case 98:
                          var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,66),_kf_=1;break;
                         case 41:
                         case 125:
                          var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,_ke_),_kf_=1;
                          break;
                         case 40:
                          var
                           _kd_=scan_fmt_kk_(_jR_(add_conv_j$_,skip_j4_,i_kc_,_ke_)),
                           _kf_=1;
                          break;
                         case 123:
                          var
                           i_kl_=_jR_(add_conv_j$_,skip_j4_,i_kc_,_ke_),
                           j_kn_=_jR_(sub_format_for_printf_km_,_ke_,fmt_j0_,i_kl_),
                           i_ko_=i_kl_;
                          for(;;)
                           {if(i_ko_<(j_kn_-2|0))
                             {var
                               _kp_=_g1_(add_char_kj_,i_ko_,fmt_j0_.safeGet(i_ko_)),
                               i_ko_=_kp_;
                              continue;}
                            var _kq_=j_kn_-1|0,i_kc_=_kq_;
                            continue c;}
                         default:var _kf_=0;}
                      if(!_kf_)
                       var _kd_=bad_conversion_format_jX_(fmt_j0_,i_kc_,_ke_);}
                    var _j6_=_kd_;
                    break;}}
                var i_j3_=_j6_;
                continue a;}}
            var _kr_=i_j3_+1|0,i_j3_=_kr_;
            continue;}
          return i_j3_;}}
      scan_fmt_kk_(0);
      return 0;}
    function scan_positional_spec_kZ_(fmt_ks_,got_spec_kv_,n_kD_,i_kt_)
     {var _ku_=fmt_ks_.safeGet(i_kt_);
      if((_ku_-48|0)<0||9<(_ku_-48|0))return _g1_(got_spec_kv_,0,i_kt_);
      var accu_kw_=_ku_-48|0,j_kx_=i_kt_+1|0;
      for(;;)
       {var _ky_=fmt_ks_.safeGet(j_kx_);
        if(48<=_ky_)
         {if(!(58<=_ky_))
           {var
             _kB_=j_kx_+1|0,
             _kA_=(10*accu_kw_|0)+(_ky_-48|0)|0,
             accu_kw_=_kA_,
             j_kx_=_kB_;
            continue;}
          var _kz_=0;}
        else
         if(36===_ky_)
          if(0===accu_kw_)
           {var _kC_=_p_(_fE_),_kz_=1;}
          else
           {var
             _kC_=
              _g1_(got_spec_kv_,[0,index_of_int_iU_(accu_kw_-1|0)],j_kx_+1|0),
             _kz_=1;}
         else
          var _kz_=0;
        if(!_kz_)var _kC_=_g1_(got_spec_kv_,0,i_kt_);
        return _kC_;}}
    function next_index_kU_(spec_kE_,n_kF_)
     {return spec_kE_?n_kF_:_gx_(_iV_,n_kF_);}
    function get_index_kI_(spec_kG_,n_kH_){return spec_kG_?spec_kG_[1]:n_kH_;}
    function _mN_
     (fmt_kO_,
      args_kL_,
      n_mK_,
      pos_k4_,
      cont_s_k7_,
      cont_a_mE_,
      cont_t_mH_,
      cont_f_mi_,
      cont_m_mh_)
     {function get_arg_kQ_(spec_kK_,n_kJ_)
       {return caml_array_get(args_kL_,get_index_kI_(spec_kK_,n_kJ_));}
      function scan_flags_kW_(spec_kY_,n_kR_,widths_kT_,i_kM_)
       {var i_kN_=i_kM_;
        for(;;)
         {var _kP_=fmt_kO_.safeGet(i_kN_)-32|0;
          if(!(_kP_<0||25<_kP_))
           switch(_kP_)
            {case 1:
             case 2:
             case 4:
             case 5:
             case 6:
             case 7:
             case 8:
             case 9:
             case 12:
             case 15:break;
             case 10:
              return scan_positional_spec_kZ_
                      (fmt_kO_,
                       function(wspec_kS_,i_kX_)
                        {var _kV_=[0,get_arg_kQ_(wspec_kS_,n_kR_),widths_kT_];
                         return scan_flags_kW_
                                 (spec_kY_,next_index_kU_(wspec_kS_,n_kR_),_kV_,i_kX_);},
                       n_kR_,
                       i_kN_+1|0);
             default:var _k0_=i_kN_+1|0,i_kN_=_k0_;continue;}
          var _k1_=fmt_kO_.safeGet(i_kN_);
          if(124<=_k1_)
           var _k2_=0;
          else
           switch(_k1_)
            {case 78:
             case 88:
             case 100:
             case 105:
             case 111:
             case 117:
             case 120:
              var
               x_k5_=get_arg_kQ_(spec_kY_,n_kR_),
               s_k6_=
                caml_format_int
                 (extract_format_int_k3_
                   (_k1_,fmt_kO_,pos_k4_,i_kN_,widths_kT_),
                  x_k5_),
               _k8_=
                _jR_
                 (cont_s_k7_,next_index_kU_(spec_kY_,n_kR_),s_k6_,i_kN_+1|0),
               _k2_=1;
              break;
             case 69:
             case 71:
             case 101:
             case 102:
             case 103:
              var
               x_k9_=get_arg_kQ_(spec_kY_,n_kR_),
               s_k__=
                caml_format_float
                 (extract_format_jt_(fmt_kO_,pos_k4_,i_kN_,widths_kT_),x_k9_),
               _k8_=
                _jR_
                 (cont_s_k7_,next_index_kU_(spec_kY_,n_kR_),s_k__,i_kN_+1|0),
               _k2_=1;
              break;
             case 76:
             case 108:
             case 110:
              var _k$_=fmt_kO_.safeGet(i_kN_+1|0)-88|0;
              if(_k$_<0||32<_k$_)
               var _la_=1;
              else
               switch(_k$_)
                {case 0:
                 case 12:
                 case 17:
                 case 23:
                 case 29:
                 case 32:
                  var i_lb_=i_kN_+1|0,_lc_=_k1_-108|0;
                  if(_lc_<0||2<_lc_)
                   var _ld_=0;
                  else
                   {switch(_lc_)
                     {case 1:var _ld_=0,_le_=0;break;
                      case 2:
                       var
                        x_lf_=get_arg_kQ_(spec_kY_,n_kR_),
                        _lg_=
                         caml_format_int
                          (extract_format_jt_(fmt_kO_,pos_k4_,i_lb_,widths_kT_),x_lf_),
                        _le_=1;
                       break;
                      default:
                       var
                        x_lh_=get_arg_kQ_(spec_kY_,n_kR_),
                        _lg_=
                         caml_format_int
                          (extract_format_jt_(fmt_kO_,pos_k4_,i_lb_,widths_kT_),x_lh_),
                        _le_=1;}
                    if(_le_){var s_li_=_lg_,_ld_=1;}}
                  if(!_ld_)
                   {var
                     x_lj_=get_arg_kQ_(spec_kY_,n_kR_),
                     s_li_=
                      caml_int64_format
                       (extract_format_jt_(fmt_kO_,pos_k4_,i_lb_,widths_kT_),x_lj_);}
                  var
                   _k8_=
                    _jR_
                     (cont_s_k7_,next_index_kU_(spec_kY_,n_kR_),s_li_,i_lb_+1|0),
                   _k2_=1,
                   _la_=0;
                  break;
                 default:var _la_=1;}
              if(_la_)
               {var
                 x_lk_=get_arg_kQ_(spec_kY_,n_kR_),
                 s_ll_=
                  caml_format_int
                   (extract_format_int_k3_
                     (110,fmt_kO_,pos_k4_,i_kN_,widths_kT_),
                    x_lk_),
                 _k8_=
                  _jR_
                   (cont_s_k7_,next_index_kU_(spec_kY_,n_kR_),s_ll_,i_kN_+1|0),
                 _k2_=1;}
              break;
             case 83:
             case 115:
              var x_lm_=get_arg_kQ_(spec_kY_,n_kR_);
              if(115===_k1_)
               var x_ln_=x_lm_;
              else
               {var n_lo_=[0,0],_lp_=0,_lq_=x_lm_.getLen()-1|0;
                if(!(_lq_<_lp_))
                 {var i_lr_=_lp_;
                  for(;;)
                   {var
                     _ls_=x_lm_.safeGet(i_lr_),
                     _lt_=
                      14<=_ls_
                       ?34===_ls_?1:92===_ls_?1:0
                       :11<=_ls_?13<=_ls_?1:0:8<=_ls_?1:0,
                     _lu_=_lt_?2:caml_is_printable(_ls_)?1:4;
                    n_lo_[1]=n_lo_[1]+_lu_|0;
                    var _lv_=i_lr_+1|0;
                    if(_lq_!==i_lr_){var i_lr_=_lv_;continue;}
                    break;}}
                if(n_lo_[1]===x_lm_.getLen())
                 var _lw_=x_lm_;
                else
                 {var s__lx_=caml_create_string(n_lo_[1]);
                  n_lo_[1]=0;
                  var _ly_=0,_lz_=x_lm_.getLen()-1|0;
                  if(!(_lz_<_ly_))
                   {var i_lA_=_ly_;
                    for(;;)
                     {var _lB_=x_lm_.safeGet(i_lA_),_lC_=_lB_-34|0;
                      if(_lC_<0||58<_lC_)
                       if(-20<=_lC_)
                        var _lD_=1;
                       else
                        {switch(_lC_+34|0)
                          {case 8:
                            s__lx_.safeSet(n_lo_[1],92);
                            n_lo_[1]+=1;
                            s__lx_.safeSet(n_lo_[1],98);
                            var _lE_=1;
                            break;
                           case 9:
                            s__lx_.safeSet(n_lo_[1],92);
                            n_lo_[1]+=1;
                            s__lx_.safeSet(n_lo_[1],116);
                            var _lE_=1;
                            break;
                           case 10:
                            s__lx_.safeSet(n_lo_[1],92);
                            n_lo_[1]+=1;
                            s__lx_.safeSet(n_lo_[1],110);
                            var _lE_=1;
                            break;
                           case 13:
                            s__lx_.safeSet(n_lo_[1],92);
                            n_lo_[1]+=1;
                            s__lx_.safeSet(n_lo_[1],114);
                            var _lE_=1;
                            break;
                           default:var _lD_=1,_lE_=0;}
                         if(_lE_)var _lD_=0;}
                      else
                       var
                        _lD_=
                         (_lC_-1|0)<0||56<(_lC_-1|0)
                          ?(s__lx_.safeSet(n_lo_[1],92),
                            n_lo_[1]+=
                            1,
                            s__lx_.safeSet(n_lo_[1],_lB_),
                            0)
                          :1;
                      if(_lD_)
                       if(caml_is_printable(_lB_))
                        s__lx_.safeSet(n_lo_[1],_lB_);
                       else
                        {s__lx_.safeSet(n_lo_[1],92);
                         n_lo_[1]+=1;
                         s__lx_.safeSet(n_lo_[1],48+(_lB_/100|0)|0);
                         n_lo_[1]+=1;
                         s__lx_.safeSet(n_lo_[1],48+((_lB_/10|0)%10|0)|0);
                         n_lo_[1]+=1;
                         s__lx_.safeSet(n_lo_[1],48+(_lB_%10|0)|0);}
                      n_lo_[1]+=1;
                      var _lF_=i_lA_+1|0;
                      if(_lz_!==i_lA_){var i_lA_=_lF_;continue;}
                      break;}}
                  var _lw_=s__lx_;}
                var x_ln_=_gi_(_fI_,_gi_(_lw_,_fJ_));}
              if(i_kN_===(pos_k4_+1|0))
               var s_lG_=x_ln_;
              else
               {var _lH_=extract_format_jt_(fmt_kO_,pos_k4_,i_kN_,widths_kT_);
                try
                 {var neg_lI_=0,i_lJ_=1;
                  for(;;)
                   {if(_lH_.getLen()<=i_lJ_)
                     var _lK_=[0,0,neg_lI_];
                    else
                     {var _lL_=_lH_.safeGet(i_lJ_);
                      if(49<=_lL_)
                       if(58<=_lL_)
                        var _lM_=0;
                       else
                        {var
                          _lK_=
                           [0,
                            caml_int_of_string
                             (_hP_(_lH_,i_lJ_,(_lH_.getLen()-i_lJ_|0)-1|0)),
                            neg_lI_],
                          _lM_=1;}
                      else
                       {if(45===_lL_)
                         {var _lO_=i_lJ_+1|0,_lN_=1,neg_lI_=_lN_,i_lJ_=_lO_;
                          continue;}
                        var _lM_=0;}
                      if(!_lM_){var _lP_=i_lJ_+1|0,i_lJ_=_lP_;continue;}}
                    var match_lQ_=_lK_;
                    break;}}
                catch(_lR_)
                 {if(_lR_[1]!==_a_)throw _lR_;
                  var match_lQ_=bad_conversion_i8_(_lH_,0,115);}
                var
                 p_lS_=match_lQ_[1],
                 _lT_=x_ln_.getLen(),
                 _lU_=0,
                 neg_lY_=match_lQ_[2],
                 _lX_=32;
                if(p_lS_===_lT_&&0===_lU_)
                 {var _lV_=x_ln_,_lW_=1;}
                else
                 var _lW_=0;
                if(!_lW_)
                 if(p_lS_<=_lT_)
                  var _lV_=_hP_(x_ln_,_lU_,_lT_);
                 else
                  {var res_lZ_=_hO_(p_lS_,_lX_);
                   if(neg_lY_)
                    _hQ_(x_ln_,_lU_,res_lZ_,0,_lT_);
                   else
                    _hQ_(x_ln_,_lU_,res_lZ_,p_lS_-_lT_|0,_lT_);
                   var _lV_=res_lZ_;}
                var s_lG_=_lV_;}
              var
               _k8_=
                _jR_
                 (cont_s_k7_,next_index_kU_(spec_kY_,n_kR_),s_lG_,i_kN_+1|0),
               _k2_=1;
              break;
             case 67:
             case 99:
              var x_l0_=get_arg_kQ_(spec_kY_,n_kR_);
              if(99===_k1_)
               var s_l1_=_hO_(1,x_l0_);
              else
               {if(39===x_l0_)
                 var _l2_=_fT_;
                else
                 if(92===x_l0_)
                  var _l2_=_fU_;
                 else
                  {if(14<=x_l0_)
                    var _l3_=0;
                   else
                    switch(x_l0_)
                     {case 8:var _l2_=_fY_,_l3_=1;break;
                      case 9:var _l2_=_fX_,_l3_=1;break;
                      case 10:var _l2_=_fW_,_l3_=1;break;
                      case 13:var _l2_=_fV_,_l3_=1;break;
                      default:var _l3_=0;}
                   if(!_l3_)
                    if(caml_is_printable(x_l0_))
                     {var s_l4_=caml_create_string(1);
                      s_l4_.safeSet(0,x_l0_);
                      var _l2_=s_l4_;}
                    else
                     {var s_l5_=caml_create_string(4);
                      s_l5_.safeSet(0,92);
                      s_l5_.safeSet(1,48+(x_l0_/100|0)|0);
                      s_l5_.safeSet(2,48+((x_l0_/10|0)%10|0)|0);
                      s_l5_.safeSet(3,48+(x_l0_%10|0)|0);
                      var _l2_=s_l5_;}}
                var s_l1_=_gi_(_fG_,_gi_(_l2_,_fH_));}
              var
               _k8_=
                _jR_
                 (cont_s_k7_,next_index_kU_(spec_kY_,n_kR_),s_l1_,i_kN_+1|0),
               _k2_=1;
              break;
             case 66:
             case 98:
              var
               _l7_=i_kN_+1|0,
               _l6_=get_arg_kQ_(spec_kY_,n_kR_)?_f1_:_f0_,
               _k8_=_jR_(cont_s_k7_,next_index_kU_(spec_kY_,n_kR_),_l6_,_l7_),
               _k2_=1;
              break;
             case 40:
             case 123:
              var
               xf_l8_=get_arg_kQ_(spec_kY_,n_kR_),
               j_l9_=_jR_(sub_format_for_printf_km_,_k1_,fmt_kO_,i_kN_+1|0);
              if(123===_k1_)
               {var
                 b_l__=_iM_(xf_l8_.getLen()),
                 add_char_mc_=
                  function(i_ma_,c_l$_){_iO_(b_l__,c_l$_);return i_ma_+1|0;};
                iter_on_format_args_mf_
                 (xf_l8_,
                  function(skip_mb_,i_me_,c_md_)
                   {if(skip_mb_)_iP_(b_l__,_fD_);else _iO_(b_l__,37);
                    return add_char_mc_(i_me_,c_md_);},
                  add_char_mc_);
                var
                 _mg_=_iN_(b_l__),
                 _k8_=
                  _jR_(cont_s_k7_,next_index_kU_(spec_kY_,n_kR_),_mg_,j_l9_),
                 _k2_=1;}
              else
               {var
                 _k8_=
                  _jR_(cont_m_mh_,next_index_kU_(spec_kY_,n_kR_),xf_l8_,j_l9_),
                 _k2_=1;}
              break;
             case 33:var _k8_=_g1_(cont_f_mi_,n_kR_,i_kN_+1|0),_k2_=1;break;
             case 37:
              var _k8_=_jR_(cont_s_k7_,n_kR_,_fM_,i_kN_+1|0),_k2_=1;break;
             case 41:
              var _k8_=_jR_(cont_s_k7_,n_kR_,_fL_,i_kN_+1|0),_k2_=1;break;
             case 44:
              var _k8_=_jR_(cont_s_k7_,n_kR_,_fK_,i_kN_+1|0),_k2_=1;break;
             case 70:
              var x_mj_=get_arg_kQ_(spec_kY_,n_kR_);
              if(0===widths_kT_)
               {var
                 _mk_=caml_format_float(_f4_,x_mj_),
                 i_ml_=0,
                 l_mm_=_mk_.getLen();
                for(;;)
                 {if(l_mm_<=i_ml_)
                   var _mn_=_gi_(_mk_,_f3_);
                  else
                   {var
                     _mo_=_mk_.safeGet(i_ml_),
                     _mp_=48<=_mo_?58<=_mo_?0:1:45===_mo_?1:0;
                    if(_mp_){var _mq_=i_ml_+1|0,i_ml_=_mq_;continue;}
                    var _mn_=_mk_;}
                  var s_mr_=_mn_;
                  break;}}
              else
               {var
                 sfmt_ms_=
                  extract_format_jt_(fmt_kO_,pos_k4_,i_kN_,widths_kT_);
                if(70===_k1_)sfmt_ms_.safeSet(sfmt_ms_.getLen()-1|0,103);
                var s_mt_=caml_format_float(sfmt_ms_,x_mj_);
                if(3<=caml_classify_float(x_mj_))
                 var _mu_=s_mt_;
                else
                 {var i_mv_=0,l_mw_=s_mt_.getLen();
                  for(;;)
                   {if(l_mw_<=i_mv_)
                     var _mx_=_gi_(s_mt_,_fF_);
                    else
                     {var
                       _my_=s_mt_.safeGet(i_mv_)-46|0,
                       _mz_=
                        _my_<0||23<_my_
                         ?55===_my_?1:0
                         :(_my_-1|0)<0||21<(_my_-1|0)?1:0;
                      if(!_mz_){var _mA_=i_mv_+1|0,i_mv_=_mA_;continue;}
                      var _mx_=s_mt_;}
                    var _mu_=_mx_;
                    break;}}
                var s_mr_=_mu_;}
              var
               _k8_=
                _jR_
                 (cont_s_k7_,next_index_kU_(spec_kY_,n_kR_),s_mr_,i_kN_+1|0),
               _k2_=1;
              break;
             case 97:
              var
               printer_mB_=get_arg_kQ_(spec_kY_,n_kR_),
               n_mC_=_gx_(_iV_,get_index_kI_(spec_kY_,n_kR_)),
               arg_mD_=get_arg_kQ_(0,n_mC_),
               _k8_=
                _mF_
                 (cont_a_mE_,
                  next_index_kU_(spec_kY_,n_mC_),
                  printer_mB_,
                  arg_mD_,
                  i_kN_+1|0),
               _k2_=1;
              break;
             case 116:
              var
               printer_mG_=get_arg_kQ_(spec_kY_,n_kR_),
               _k8_=
                _jR_
                 (cont_t_mH_,
                  next_index_kU_(spec_kY_,n_kR_),
                  printer_mG_,
                  i_kN_+1|0),
               _k2_=1;
              break;
             default:var _k2_=0;}
          if(!_k2_)var _k8_=bad_conversion_format_jX_(fmt_kO_,i_kN_,_k1_);
          return _k8_;}}
      var _mM_=pos_k4_+1|0,_mJ_=0;
      return scan_positional_spec_kZ_
              (fmt_kO_,
               function(spec_mL_,i_mI_)
                {return scan_flags_kW_(spec_mL_,n_mK_,_mJ_,i_mI_);},
               n_mK_,
               _mM_);}
    function add_queue_mT_(x_mO_,q_mQ_)
     {var c_mP_=[0,[0,x_mO_,0]],_mR_=q_mQ_[1];
      if(_mR_)
       {var cell_mS_=_mR_[1];q_mQ_[1]=c_mP_;cell_mS_[2]=c_mP_;return 0;}
      q_mQ_[1]=c_mP_;
      q_mQ_[2]=c_mP_;
      return 0;}
    var Empty_queue_mU_=[0,_e$_];
    function take_queue_m2_(q_mV_)
     {var _mW_=q_mV_[2];
      if(_mW_)
       {var match_mX_=_mW_[1],tl_mY_=match_mX_[2],x_mZ_=match_mX_[1];
        q_mV_[2]=tl_mY_;
        if(0===tl_mY_)q_mV_[1]=0;
        return x_mZ_;}
      throw [0,Empty_queue_mU_];}
    function pp_enqueue_m3_(state_m1_,token_m0_)
     {state_m1_[13]=state_m1_[13]+token_m0_[3]|0;
      return add_queue_mT_(token_m0_,state_m1_[27]);}
    var pp_infinity_m4_=1000000010;
    function pp_output_string_nX_(state_m6_,s_m5_)
     {return _jR_(state_m6_[17],s_m5_,0,s_m5_.getLen());}
    function pp_output_newline_m__(state_m7_){return _gx_(state_m7_[19],0);}
    function pp_display_blanks_nc_(state_m8_,n_m9_)
     {return _gx_(state_m8_[20],n_m9_);}
    function break_new_line_nd_(state_m$_,offset_nb_,width_na_)
     {pp_output_newline_m__(state_m$_);
      state_m$_[11]=1;
      state_m$_[10]=
      _f7_(state_m$_[8],(state_m$_[6]-width_na_|0)+offset_nb_|0);
      state_m$_[9]=state_m$_[6]-state_m$_[10]|0;
      return pp_display_blanks_nc_(state_m$_,state_m$_[10]);}
    function break_line_nS_(state_nf_,width_ne_)
     {return break_new_line_nd_(state_nf_,0,width_ne_);}
    function break_same_line_nx_(state_ng_,width_nh_)
     {state_ng_[9]=state_ng_[9]-width_nh_|0;
      return pp_display_blanks_nc_(state_ng_,width_nh_);}
    function advance_left_og_(state_ni_)
     {try
       {for(;;)
         {var _nj_=state_ni_[27][2];
          if(!_nj_)throw [0,Empty_queue_mU_];
          var
           x_nk_=_nj_[1][1],
           size_nl_=x_nk_[1],
           tok_nm_=x_nk_[2],
           _nn_=size_nl_<0?1:0,
           len_np_=x_nk_[3],
           _no_=_nn_?(state_ni_[13]-state_ni_[12]|0)<state_ni_[9]?1:0:_nn_,
           _nq_=1-_no_;
          if(_nq_)
           {take_queue_m2_(state_ni_[27]);
            var _nr_=0<=size_nl_?size_nl_:pp_infinity_m4_;
            if(typeof tok_nm_==="number")
             switch(tok_nm_)
              {case 1:
                var _nZ_=state_ni_[2];
                if(_nZ_)
                 {var _n0_=_nZ_[2],_n1_=_n0_?(state_ni_[2]=_n0_,1):0;}
                else
                 var _n1_=0;
                _n1_;
                break;
               case 2:
                var _n2_=state_ni_[3];if(_n2_)state_ni_[3]=_n2_[2];break;
               case 3:
                var _n3_=state_ni_[2];
                if(_n3_)
                 break_line_nS_(state_ni_,_n3_[1][2]);
                else
                 pp_output_newline_m__(state_ni_);
                break;
               case 4:
                if(state_ni_[10]!==(state_ni_[6]-state_ni_[9]|0))
                 {var
                   match_n4_=take_queue_m2_(state_ni_[27]),
                   size_n5_=match_n4_[1];
                  state_ni_[12]=state_ni_[12]-match_n4_[3]|0;
                  state_ni_[9]=state_ni_[9]+size_n5_|0;}
                break;
               case 5:
                var _n6_=state_ni_[5];
                if(_n6_)
                 {var tags_n7_=_n6_[2];
                  pp_output_string_nX_(state_ni_,_gx_(state_ni_[24],_n6_[1]));
                  state_ni_[5]=tags_n7_;}
                break;
               default:
                var _n8_=state_ni_[3];
                if(_n8_)
                 {var
                   tabs_n9_=_n8_[1][1],
                   add_tab_ob_=
                    function(n_oa_,ls_n__)
                     {if(ls_n__)
                       {var x_n$_=ls_n__[1],l_oc_=ls_n__[2];
                        return caml_lessthan(n_oa_,x_n$_)
                                ?[0,n_oa_,ls_n__]
                                :[0,x_n$_,add_tab_ob_(n_oa_,l_oc_)];}
                      return [0,n_oa_,0];};
                  tabs_n9_[1]=
                  add_tab_ob_(state_ni_[6]-state_ni_[9]|0,tabs_n9_[1]);}}
            else
             switch(tok_nm_[0])
              {case 1:
                var off_ns_=tok_nm_[2],n_nt_=tok_nm_[1],_nu_=state_ni_[2];
                if(_nu_)
                 {var match_nv_=_nu_[1],width_nw_=match_nv_[2];
                  switch(match_nv_[1])
                   {case 1:
                     break_new_line_nd_(state_ni_,off_ns_,width_nw_);break;
                    case 2:
                     break_new_line_nd_(state_ni_,off_ns_,width_nw_);break;
                    case 3:
                     if(state_ni_[9]<_nr_)
                      break_new_line_nd_(state_ni_,off_ns_,width_nw_);
                     else
                      break_same_line_nx_(state_ni_,n_nt_);
                     break;
                    case 4:
                     if
                      (state_ni_[11]||
                       !(state_ni_[9]<
                        _nr_||
                        ((state_ni_[6]-width_nw_|0)+off_ns_|0)<
                        state_ni_[10]))
                      break_same_line_nx_(state_ni_,n_nt_);
                     else
                      break_new_line_nd_(state_ni_,off_ns_,width_nw_);
                     break;
                    case 5:break_same_line_nx_(state_ni_,n_nt_);break;
                    default:break_same_line_nx_(state_ni_,n_nt_);}}
                break;
               case 2:
                var
                 insertion_point_ny_=state_ni_[6]-state_ni_[9]|0,
                 _nz_=state_ni_[3],
                 off_nL_=tok_nm_[2],
                 n_nK_=tok_nm_[1];
                if(_nz_)
                 {var tabs_nA_=_nz_[1][1],_nB_=tabs_nA_[1];
                  if(_nB_)
                   {var x_nH_=_nB_[1];
                    try
                     {var param_nC_=tabs_nA_[1];
                      for(;;)
                       {if(!param_nC_)throw [0,_c_];
                        var x_nD_=param_nC_[1],l_nF_=param_nC_[2];
                        if(!caml_greaterequal(x_nD_,insertion_point_ny_))
                         {var param_nC_=l_nF_;continue;}
                        var _nE_=x_nD_;
                        break;}}
                    catch(_nG_){if(_nG_[1]!==_c_)throw _nG_;var _nE_=x_nH_;}
                    var tab_nI_=_nE_;}
                  else
                   var tab_nI_=insertion_point_ny_;
                  var offset_nJ_=tab_nI_-insertion_point_ny_|0;
                  if(0<=offset_nJ_)
                   break_same_line_nx_(state_ni_,offset_nJ_+n_nK_|0);
                  else
                   break_new_line_nd_(state_ni_,tab_nI_+off_nL_|0,state_ni_[6]);}
                break;
               case 3:
                var ty_nM_=tok_nm_[2],off_nT_=tok_nm_[1];
                if(state_ni_[8]<(state_ni_[6]-state_ni_[9]|0))
                 {var _nN_=state_ni_[2];
                  if(_nN_)
                   {var
                     match_nO_=_nN_[1],
                     width_nP_=match_nO_[2],
                     bl_ty_nQ_=match_nO_[1],
                     _nR_=
                      state_ni_[9]<width_nP_
                       ?0===bl_ty_nQ_
                         ?0
                         :5<=bl_ty_nQ_?1:(break_line_nS_(state_ni_,width_nP_),1)
                       :0;
                    _nR_;}
                  else
                   pp_output_newline_m__(state_ni_);}
                var
                 offset_nV_=state_ni_[9]-off_nT_|0,
                 bl_type_nU_=1===ty_nM_?1:state_ni_[9]<_nr_?ty_nM_:5;
                state_ni_[2]=[0,[0,bl_type_nU_,offset_nV_],state_ni_[2]];
                break;
               case 4:state_ni_[3]=[0,tok_nm_[1],state_ni_[3]];break;
               case 5:
                var tag_name_nW_=tok_nm_[1];
                pp_output_string_nX_
                 (state_ni_,_gx_(state_ni_[23],tag_name_nW_));
                state_ni_[5]=[0,tag_name_nW_,state_ni_[5]];
                break;
               default:
                var s_nY_=tok_nm_[1];
                state_ni_[9]=state_ni_[9]-_nr_|0;
                pp_output_string_nX_(state_ni_,s_nY_);
                state_ni_[11]=0;}
            state_ni_[12]=len_np_+state_ni_[12]|0;
            continue;}
          break;}}
      catch(_od_){if(_od_[1]===Empty_queue_mU_)return 0;throw _od_;}
      return _nq_;}
    function enqueue_advance_on_(state_of_,tok_oe_)
     {pp_enqueue_m3_(state_of_,tok_oe_);return advance_left_og_(state_of_);}
    function make_queue_elem_ol_(size_oj_,tok_oi_,len_oh_)
     {return [0,size_oj_,tok_oi_,len_oh_];}
    function enqueue_string_as_op_(state_oo_,size_om_,s_ok_)
     {return enqueue_advance_on_
              (state_oo_,make_queue_elem_ol_(size_om_,[0,s_ok_],size_om_));}
    var scan_stack_bottom_oq_=[0,[0,-1,make_queue_elem_ol_(-1,_e__,0)],0];
    function clear_scan_stack_oy_(state_or_)
     {state_or_[1]=scan_stack_bottom_oq_;return 0;}
    function set_size_oH_(state_os_,ty_oA_)
     {var _ot_=state_os_[1];
      if(_ot_)
       {var
         match_ou_=_ot_[1],
         queue_elem_ov_=match_ou_[2],
         size_ow_=queue_elem_ov_[1],
         t_ox_=_ot_[2],
         tok_oz_=queue_elem_ov_[2];
        if(match_ou_[1]<state_os_[12])return clear_scan_stack_oy_(state_os_);
        if(typeof tok_oz_!=="number")
         switch(tok_oz_[0])
          {case 1:
           case 2:
            var
             _oB_=
              ty_oA_
               ?(queue_elem_ov_[1]=
                 state_os_[13]+
                 size_ow_|
                 0,
                 state_os_[1]=
                 t_ox_,
                 0)
               :ty_oA_;
            return _oB_;
           case 3:
            var
             _oC_=1-ty_oA_,
             _oD_=
              _oC_
               ?(queue_elem_ov_[1]=
                 state_os_[13]+
                 size_ow_|
                 0,
                 state_os_[1]=
                 t_ox_,
                 0)
               :_oC_;
            return _oD_;
           default:}
        return 0;}
      return 0;}
    function scan_push_oL_(state_oF_,b_oG_,tok_oE_)
     {pp_enqueue_m3_(state_oF_,tok_oE_);
      if(b_oG_)set_size_oH_(state_oF_,1);
      state_oF_[1]=[0,[0,state_oF_[13],tok_oE_],state_oF_[1]];
      return 0;}
    function pp_open_box_gen_oZ_(state_oI_,indent_oK_,br_ty_oJ_)
     {state_oI_[14]=state_oI_[14]+1|0;
      if(state_oI_[14]<state_oI_[15])
       return scan_push_oL_
               (state_oI_,
                0,
                make_queue_elem_ol_
                 (-state_oI_[13]|0,[3,indent_oK_,br_ty_oJ_],0));
      var _oM_=state_oI_[14]===state_oI_[15]?1:0;
      if(_oM_)
       {var _oN_=state_oI_[16];
        return enqueue_string_as_op_(state_oI_,_oN_.getLen(),_oN_);}
      return _oM_;}
    function pp_close_box_oW_(state_oO_,param_oR_)
     {var _oP_=1<state_oO_[14]?1:0;
      if(_oP_)
       {if(state_oO_[14]<state_oO_[15])
         {pp_enqueue_m3_(state_oO_,[0,0,1,0]);
          set_size_oH_(state_oO_,1);
          set_size_oH_(state_oO_,0);}
        state_oO_[14]=state_oO_[14]-1|0;
        var _oQ_=0;}
      else
       var _oQ_=_oP_;
      return _oQ_;}
    function pp_open_tag_pi_(state_oS_,tag_name_oT_)
     {if(state_oS_[21])
       {state_oS_[4]=[0,tag_name_oT_,state_oS_[4]];
        _gx_(state_oS_[25],tag_name_oT_);}
      var _oU_=state_oS_[22];
      return _oU_?pp_enqueue_m3_(state_oS_,[0,0,[5,tag_name_oT_],0]):_oU_;}
    function pp_flush_queue_o8_(state_oV_,b_oX_)
     {for(;;)
       {if(1<state_oV_[14]){pp_close_box_oW_(state_oV_,0);continue;}
        state_oV_[13]=pp_infinity_m4_;
        advance_left_og_(state_oV_);
        if(b_oX_)pp_output_newline_m__(state_oV_);
        state_oV_[12]=1;
        state_oV_[13]=1;
        var _oY_=state_oV_[27];
        _oY_[1]=0;
        _oY_[2]=0;
        clear_scan_stack_oy_(state_oV_);
        state_oV_[2]=0;
        state_oV_[3]=0;
        state_oV_[4]=0;
        state_oV_[5]=0;
        state_oV_[10]=0;
        state_oV_[14]=0;
        state_oV_[9]=state_oV_[6];
        return pp_open_box_gen_oZ_(state_oV_,0,3);}}
    function pp_print_as_size_o4_(state_o0_,size_o3_,s_o2_)
     {var _o1_=state_o0_[14]<state_o0_[15]?1:0;
      return _o1_?enqueue_string_as_op_(state_o0_,size_o3_,s_o2_):_o1_;}
    function pp_print_as_pj_(state_o7_,isize_o6_,s_o5_)
     {return pp_print_as_size_o4_(state_o7_,isize_o6_,s_o5_);}
    function pp_print_flush_pk_(state_o9_,param_o__)
     {pp_flush_queue_o8_(state_o9_,0);return _gx_(state_o9_[18],0);}
    function pp_print_break_pd_(state_o$_,width_pc_,offset_pb_)
     {var _pa_=state_o$_[14]<state_o$_[15]?1:0;
      return _pa_
              ?scan_push_oL_
                (state_o$_,
                 1,
                 make_queue_elem_ol_
                  (-state_o$_[13]|0,[1,width_pc_,offset_pb_],width_pc_))
              :_pa_;}
    function pp_print_space_pl_(state_pe_,param_pf_)
     {return pp_print_break_pd_(state_pe_,1,0);}
    function display_newline_pn_(state_pg_,param_ph_)
     {return _jR_(state_pg_[17],_fa_,0,1);}
    var blank_line_pm_=_hO_(80,32);
    function display_blanks_pI_(state_pr_,n_po_)
     {var n_pp_=n_po_;
      for(;;)
       {var _pq_=0<n_pp_?1:0;
        if(_pq_)
         {if(80<n_pp_)
           {_jR_(state_pr_[17],blank_line_pm_,0,80);
            var _ps_=n_pp_-80|0,n_pp_=_ps_;
            continue;}
          return _jR_(state_pr_[17],blank_line_pm_,0,n_pp_);}
        return _pq_;}}
    function default_pp_mark_open_tag_pE_(s_pt_)
     {return _gi_(_fb_,_gi_(s_pt_,_fc_));}
    function default_pp_mark_close_tag_pD_(s_pu_)
     {return _gi_(_fd_,_gi_(s_pu_,_fe_));}
    function default_pp_print_open_tag_pC_(s_pv_){return 0;}
    function make_formatter_pM_(output_pG_,flush_pF_)
     {function _py_(_pw_){return 0;}
      var _pz_=[0,0,0];
      function _pB_(_px_){return 0;}
      var sys_tok_pA_=make_queue_elem_ol_(-1,_fg_,0);
      add_queue_mT_(sys_tok_pA_,_pz_);
      var
       _pH_=
        [0,
         [0,[0,1,sys_tok_pA_],scan_stack_bottom_oq_],
         0,
         0,
         0,
         0,
         78,
         10,
         78-10|0,
         78,
         0,
         1,
         1,
         1,
         1,
         max_int_gj_,
         _ff_,
         output_pG_,
         flush_pF_,
         _pB_,
         _py_,
         0,
         0,
         default_pp_mark_open_tag_pE_,
         default_pp_mark_close_tag_pD_,
         default_pp_print_open_tag_pC_,
         default_pp_print_open_tag_pC_,
         _pz_];
      _pH_[19]=_gx_(display_newline_pn_,_pH_);
      _pH_[20]=_gx_(display_blanks_pI_,_pH_);
      return _pH_;}
    function formatter_of_out_channel_pQ_(oc_pJ_)
     {function _pL_(param_pK_){return caml_ml_flush(oc_pJ_);}
      return make_formatter_pM_(_gx_(output_gA_,oc_pJ_),_pL_);}
    function formatter_of_buffer_pR_(b_pO_)
     {function _pP_(_pN_){return 0;}
      return make_formatter_pM_(_gx_(_iQ_,b_pO_),_pP_);}
    var
     stdbuf_pS_=_iM_(512),
     std_formatter_pT_=formatter_of_out_channel_pQ_(stdout_gu_);
    formatter_of_out_channel_pQ_(stderr_gt_);
    formatter_of_buffer_pR_(stdbuf_pS_);
    var print_flush_tZ_=_gx_(pp_print_flush_pk_,std_formatter_pT_);
    function giving_up_pZ_(mess_pY_,fmt_pU_,i_pV_)
     {var
       _pW_=
        i_pV_<fmt_pU_.getLen()
         ?_gi_(_fk_,_gi_(_hO_(1,fmt_pU_.safeGet(i_pV_)),_fl_))
         :_hO_(1,46),
       _pX_=_gi_(_fj_,_gi_(string_of_int_gk_(i_pV_),_pW_));
      return _gi_(_fh_,_gi_(mess_pY_,_gi_(_fi_,_gi_(_i6_(fmt_pU_),_pX_))));}
    function format_invalid_arg_p3_(mess_p2_,fmt_p1_,i_p0_)
     {return _f6_(giving_up_pZ_(mess_p2_,fmt_p1_,i_p0_));}
    function invalid_format_qL_(fmt_p5_,i_p4_)
     {return format_invalid_arg_p3_(_fm_,fmt_p5_,i_p4_);}
    function invalid_integer_qa_(fmt_p7_,i_p6_)
     {return _f6_(giving_up_pZ_(_fn_,fmt_p7_,i_p6_));}
    function format_int_of_string_sv_(fmt_qc_,i_qb_,s_p8_)
     {try
       {var _p9_=caml_int_of_string(s_p8_),sz_p__=_p9_;}
      catch(_p$_)
       {if(_p$_[1]!==_a_)throw _p$_;
        var sz_p__=invalid_integer_qa_(fmt_qc_,i_qb_);}
      return sz_p__;}
    function string_out_qk_(b_qe_,ppf_qd_)
     {pp_flush_queue_o8_(ppf_qd_,0);
      var s_qf_=_iN_(b_qe_);
      b_qe_[2]=0;
      b_qe_[1]=b_qe_[4];
      b_qe_[3]=b_qe_[1].getLen();
      return s_qf_;}
    function exstring_rf_(printer_qj_,arg_qi_)
     {var b_qg_=_iM_(512),ppf_qh_=formatter_of_buffer_pR_(b_qg_);
      _g1_(printer_qj_,ppf_qh_,arg_qi_);
      return string_out_qk_(b_qg_,ppf_qh_);}
    function implode_rev_q4_(s0_qm_,l_ql_)
     {return l_ql_?_hR_(_fo_,_hp_([0,s0_qm_,l_ql_])):s0_qm_;}
    function mkprintf_tV_(to_s_rb_,get_out_qq_)
     {function kprintf_sp_(k_qB_,fmt_qn_)
       {var len_qo_=fmt_qn_.getLen();
        function kpr_s1_(fmt_qp_,v_qJ_)
         {var ppf_qr_=_gx_(get_out_qq_,fmt_qp_),print_as_qs_=[0,0];
          function pp_print_as_char_r8_(c_qu_)
           {var _qt_=print_as_qs_[1];
            if(_qt_)
             {var size_qv_=_qt_[1];
              pp_print_as_size_o4_(ppf_qr_,size_qv_,_hO_(1,c_qu_));
              print_as_qs_[1]=0;
              return 0;}
            var s_qw_=caml_create_string(1);
            s_qw_.safeSet(0,c_qu_);
            return pp_print_as_pj_(ppf_qr_,1,s_qw_);}
          function pp_print_as_string_r$_(s_qy_)
           {var _qx_=print_as_qs_[1];
            return _qx_
                    ?(pp_print_as_size_o4_(ppf_qr_,_qx_[1],s_qy_),
                      print_as_qs_[1]=
                      0,
                      0)
                    :pp_print_as_pj_(ppf_qr_,s_qy_.getLen(),s_qy_);}
          function doprn_qT_(n_qI_,i_qz_)
           {var i_qA_=i_qz_;
            for(;;)
             {if(len_qo_<=i_qA_)return _gx_(k_qB_,ppf_qr_);
              var _qC_=fmt_qp_.safeGet(i_qA_);
              if(37===_qC_)
               return _mN_
                       (fmt_qp_,
                        v_qJ_,
                        n_qI_,
                        i_qA_,
                        cont_s_qH_,
                        cont_a_qG_,
                        cont_t_qF_,
                        cont_f_qE_,
                        cont_m_qD_);
              if(64===_qC_)
               {var i_qK_=i_qA_+1|0;
                if(len_qo_<=i_qK_)return invalid_format_qL_(fmt_qp_,i_qK_);
                var _qM_=fmt_qp_.safeGet(i_qK_);
                if(65<=_qM_)
                 {if(94<=_qM_)
                   {var _qN_=_qM_-123|0;
                    if(!(_qN_<0||2<_qN_))
                     switch(_qN_)
                      {case 1:break;
                       case 2:
                        if(ppf_qr_[22])pp_enqueue_m3_(ppf_qr_,[0,0,5,0]);
                        if(ppf_qr_[21])
                         {var _qO_=ppf_qr_[4];
                          if(_qO_)
                           {var tags_qP_=_qO_[2];
                            _gx_(ppf_qr_[26],_qO_[1]);
                            ppf_qr_[4]=tags_qP_;
                            var _qQ_=1;}
                          else
                           var _qQ_=0;}
                        else
                         var _qQ_=0;
                        _qQ_;
                        var _qR_=i_qK_+1|0,i_qA_=_qR_;
                        continue;
                       default:
                        var _qS_=i_qK_+1|0;
                        if(len_qo_<=_qS_)
                         {pp_open_tag_pi_(ppf_qr_,_fq_);
                          var _qU_=doprn_qT_(n_qI_,_qS_);}
                        else
                         if(60===fmt_qp_.safeGet(_qS_))
                          {var
                            got_name_qZ_=
                             function(tag_name_qV_,n_qY_,i_qX_)
                              {pp_open_tag_pi_(ppf_qr_,tag_name_qV_);
                               return doprn_qT_(n_qY_,skip_gt_qW_(i_qX_));},
                            _q0_=_qS_+1|0,
                            get_q__=
                             function(accu_q5_,n_q6_,i_q3_,j_q1_)
                              {var j_q2_=j_q1_;
                               for(;;)
                                {if(len_qo_<=j_q2_)
                                  return got_name_qZ_
                                          (implode_rev_q4_
                                            (_i0_(fmt_qp_,index_of_int_iU_(i_q3_),j_q2_-i_q3_|0),
                                             accu_q5_),
                                           n_q6_,
                                           j_q2_);
                                 var _q7_=fmt_qp_.safeGet(j_q2_);
                                 if(37===_q7_)
                                  {var
                                    s0_q8_=_i0_(fmt_qp_,index_of_int_iU_(i_q3_),j_q2_-i_q3_|0),
                                    cont_s_ru_=
                                     function(n_ra_,s_q9_,i_q$_)
                                      {return get_q__
                                               ([0,s_q9_,[0,s0_q8_,accu_q5_]],n_ra_,i_q$_,i_q$_);},
                                    cont_a_rv_=
                                     function(n_rh_,printer_rd_,arg_rc_,i_rg_)
                                      {var
                                        s_re_=
                                         to_s_rb_
                                          ?_g1_(printer_rd_,0,arg_rc_)
                                          :exstring_rf_(printer_rd_,arg_rc_);
                                       return get_q__
                                               ([0,s_re_,[0,s0_q8_,accu_q5_]],n_rh_,i_rg_,i_rg_);},
                                    cont_t_rw_=
                                     function(n_ro_,printer_ri_,i_rn_)
                                      {if(to_s_rb_)
                                        var s_rj_=_gx_(printer_ri_,0);
                                       else
                                        {var
                                          _rm_=0,
                                          s_rj_=
                                           exstring_rf_
                                            (function(ppf_rk_,param_rl_)
                                              {return _gx_(printer_ri_,ppf_rk_);},
                                             _rm_);}
                                       return get_q__
                                               ([0,s_rj_,[0,s0_q8_,accu_q5_]],n_ro_,i_rn_,i_rn_);},
                                    cont_f_rx_=
                                     function(n_rq_,i_rp_)
                                      {return format_invalid_arg_p3_(_fr_,fmt_qp_,i_rp_);};
                                   return _mN_
                                           (fmt_qp_,
                                            v_qJ_,
                                            n_q6_,
                                            j_q2_,
                                            cont_s_ru_,
                                            cont_a_rv_,
                                            cont_t_rw_,
                                            cont_f_rx_,
                                            function(n_rs_,sfmt_rt_,i_rr_)
                                             {return format_invalid_arg_p3_(_fs_,fmt_qp_,i_rr_);});}
                                 if(62===_q7_)
                                  return got_name_qZ_
                                          (implode_rev_q4_
                                            (_i0_(fmt_qp_,index_of_int_iU_(i_q3_),j_q2_-i_q3_|0),
                                             accu_q5_),
                                           n_q6_,
                                           j_q2_);
                                 var _ry_=j_q2_+1|0,j_q2_=_ry_;
                                 continue;}},
                            _qU_=get_q__(0,n_qI_,_q0_,_q0_);}
                         else
                          {pp_open_tag_pi_(ppf_qr_,_fp_);
                           var _qU_=doprn_qT_(n_qI_,_qS_);}
                        return _qU_;}}
                  else
                   if(91<=_qM_)
                    switch(_qM_-91|0)
                     {case 1:break;
                      case 2:
                       pp_close_box_oW_(ppf_qr_,0);
                       var _rz_=i_qK_+1|0,i_qA_=_rz_;
                       continue;
                      default:
                       var _rA_=i_qK_+1|0;
                       if(len_qo_<=_rA_||!(60===fmt_qp_.safeGet(_rA_)))
                        {pp_open_box_gen_oZ_(ppf_qr_,0,4);
                         var _rB_=doprn_qT_(n_qI_,_rA_);}
                       else
                        {var _rC_=_rA_+1|0;
                         if(len_qo_<=_rC_)
                          var match_rD_=[0,4,_rC_];
                         else
                          {var _rE_=fmt_qp_.safeGet(_rC_);
                           if(98===_rE_)
                            var match_rD_=[0,4,_rC_+1|0];
                           else
                            if(104===_rE_)
                             {var i_rF_=_rC_+1|0;
                              if(len_qo_<=i_rF_)
                               var match_rD_=[0,0,i_rF_];
                              else
                               {var _rG_=fmt_qp_.safeGet(i_rF_);
                                if(111===_rG_)
                                 {var i_rH_=i_rF_+1|0;
                                  if(len_qo_<=i_rH_)
                                   var match_rD_=format_invalid_arg_p3_(_fu_,fmt_qp_,i_rH_);
                                  else
                                   {var
                                     _rI_=fmt_qp_.safeGet(i_rH_),
                                     match_rD_=
                                      118===_rI_
                                       ?[0,3,i_rH_+1|0]
                                       :format_invalid_arg_p3_
                                         (_gi_(_ft_,_hO_(1,_rI_)),fmt_qp_,i_rH_);}}
                                else
                                 var match_rD_=118===_rG_?[0,2,i_rF_+1|0]:[0,0,i_rF_];}}
                            else
                             var match_rD_=118===_rE_?[0,1,_rC_+1|0]:[0,4,_rC_];}
                         var
                          i_rN_=match_rD_[2],
                          kind_rJ_=match_rD_[1],
                          _rB_=
                           get_int_rO_
                            (n_qI_,
                             i_rN_,
                             function(size_rK_,n_rM_,i_rL_)
                              {pp_open_box_gen_oZ_(ppf_qr_,size_rK_,kind_rJ_);
                               return doprn_qT_(n_rM_,skip_gt_qW_(i_rL_));});}
                       return _rB_;}}
                else
                 {if(10===_qM_)
                   {if(ppf_qr_[14]<ppf_qr_[15])
                     enqueue_advance_on_(ppf_qr_,make_queue_elem_ol_(0,3,0));
                    var _rP_=i_qK_+1|0,i_qA_=_rP_;
                    continue;}
                  if(32<=_qM_)
                   switch(_qM_-32|0)
                    {case 0:
                      pp_print_space_pl_(ppf_qr_,0);
                      var _rQ_=i_qK_+1|0,i_qA_=_rQ_;
                      continue;
                     case 12:
                      pp_print_break_pd_(ppf_qr_,0,0);
                      var _rR_=i_qK_+1|0,i_qA_=_rR_;
                      continue;
                     case 14:
                      pp_flush_queue_o8_(ppf_qr_,1);
                      _gx_(ppf_qr_[18],0);
                      var _rS_=i_qK_+1|0,i_qA_=_rS_;
                      continue;
                     case 27:
                      var _rT_=i_qK_+1|0;
                      if(len_qo_<=_rT_||!(60===fmt_qp_.safeGet(_rT_)))
                       {pp_print_space_pl_(ppf_qr_,0);
                        var _rU_=doprn_qT_(n_qI_,_rT_);}
                      else
                       {var
                         got_nspaces_r3_=
                          function(nspaces_rV_,n_rY_,i_rX_)
                           {return get_int_rO_
                                    (n_rY_,i_rX_,_gx_(got_offset_rW_,nspaces_rV_));},
                         got_offset_rW_=
                          function(nspaces_r0_,offset_rZ_,n_r2_,i_r1_)
                           {pp_print_break_pd_(ppf_qr_,nspaces_r0_,offset_rZ_);
                            return doprn_qT_(n_r2_,skip_gt_qW_(i_r1_));},
                         _rU_=get_int_rO_(n_qI_,_rT_+1|0,got_nspaces_r3_);}
                      return _rU_;
                     case 28:
                      return get_int_rO_
                              (n_qI_,
                               i_qK_+1|0,
                               function(size_r4_,n_r6_,i_r5_)
                                {print_as_qs_[1]=[0,size_r4_];
                                 return doprn_qT_(n_r6_,skip_gt_qW_(i_r5_));});
                     case 31:
                      pp_print_flush_pk_(ppf_qr_,0);
                      var _r7_=i_qK_+1|0,i_qA_=_r7_;
                      continue;
                     case 32:
                      pp_print_as_char_r8_(_qM_);
                      var _r9_=i_qK_+1|0,i_qA_=_r9_;
                      continue;
                     default:}}
                return invalid_format_qL_(fmt_qp_,i_qK_);}
              pp_print_as_char_r8_(_qC_);
              var _r__=i_qA_+1|0,i_qA_=_r__;
              continue;}}
          function cont_s_qH_(n_sc_,s_sa_,i_sb_)
           {pp_print_as_string_r$_(s_sa_);return doprn_qT_(n_sc_,i_sb_);}
          function cont_a_qG_(n_sg_,printer_se_,arg_sd_,i_sf_)
           {if(to_s_rb_)
             pp_print_as_string_r$_(_g1_(printer_se_,0,arg_sd_));
            else
             _g1_(printer_se_,ppf_qr_,arg_sd_);
            return doprn_qT_(n_sg_,i_sf_);}
          function cont_t_qF_(n_sj_,printer_sh_,i_si_)
           {if(to_s_rb_)
             pp_print_as_string_r$_(_gx_(printer_sh_,0));
            else
             _gx_(printer_sh_,ppf_qr_);
            return doprn_qT_(n_sj_,i_si_);}
          function cont_f_qE_(n_sl_,i_sk_)
           {pp_print_flush_pk_(ppf_qr_,0);return doprn_qT_(n_sl_,i_sk_);}
          function cont_m_qD_(n_sn_,sfmt_sq_,i_sm_)
           {return kprintf_sp_
                    (function(param_so_){return doprn_qT_(n_sn_,i_sm_);},
                     sfmt_sq_);}
          function get_int_rO_(n_sQ_,i_sr_,c_sz_)
           {var i_ss_=i_sr_;
            for(;;)
             {if(len_qo_<=i_ss_)return invalid_integer_qa_(fmt_qp_,i_ss_);
              var _st_=fmt_qp_.safeGet(i_ss_);
              if(32===_st_){var _su_=i_ss_+1|0,i_ss_=_su_;continue;}
              if(37===_st_)
               {var
                 cont_s_sM_=
                  function(n_sy_,s_sw_,i_sx_)
                   {return _jR_
                            (c_sz_,
                             format_int_of_string_sv_(fmt_qp_,i_sx_,s_sw_),
                             n_sy_,
                             i_sx_);},
                 cont_a_sN_=
                  function(n_sB_,printer_sC_,arg_sD_,i_sA_)
                   {return invalid_integer_qa_(fmt_qp_,i_sA_);},
                 cont_t_sO_=
                  function(n_sF_,printer_sG_,i_sE_)
                   {return invalid_integer_qa_(fmt_qp_,i_sE_);},
                 cont_f_sP_=
                  function(n_sI_,i_sH_)
                   {return invalid_integer_qa_(fmt_qp_,i_sH_);};
                return _mN_
                        (fmt_qp_,
                         v_qJ_,
                         n_sQ_,
                         i_ss_,
                         cont_s_sM_,
                         cont_a_sN_,
                         cont_t_sO_,
                         cont_f_sP_,
                         function(n_sK_,sfmt_sL_,i_sJ_)
                          {return invalid_integer_qa_(fmt_qp_,i_sJ_);});}
              var j_sR_=i_ss_;
              for(;;)
               {if(len_qo_<=j_sR_)
                 var _sS_=invalid_integer_qa_(fmt_qp_,j_sR_);
                else
                 {var
                   _sT_=fmt_qp_.safeGet(j_sR_),
                   _sU_=48<=_sT_?58<=_sT_?0:1:45===_sT_?1:0;
                  if(_sU_){var _sV_=j_sR_+1|0,j_sR_=_sV_;continue;}
                  var
                   size_sW_=
                    j_sR_===i_ss_
                     ?0
                     :format_int_of_string_sv_
                       (fmt_qp_,
                        j_sR_,
                        _i0_(fmt_qp_,index_of_int_iU_(i_ss_),j_sR_-i_ss_|0)),
                   _sS_=_jR_(c_sz_,size_sW_,n_sQ_,j_sR_);}
                return _sS_;}}}
          function skip_gt_qW_(i_sX_)
           {var i_sY_=i_sX_;
            for(;;)
             {if(len_qo_<=i_sY_)return invalid_format_qL_(fmt_qp_,i_sY_);
              var _sZ_=fmt_qp_.safeGet(i_sY_);
              if(32===_sZ_){var _s0_=i_sY_+1|0,i_sY_=_s0_;continue;}
              return 62===_sZ_?i_sY_+1|0:invalid_format_qL_(fmt_qp_,i_sY_);}}
          return doprn_qT_(index_of_int_iU_(0),0);}
        var ac_s2_=[0,0,0,0];
        function add_conv_s$_(skip_s7_,i_s8_,c_s3_)
         {var _s4_=41!==c_s3_?1:0,_s5_=_s4_?125!==c_s3_?1:0:_s4_;
          if(_s5_)
           {var inc_s6_=97===c_s3_?2:1;
            if(114===c_s3_)ac_s2_[3]=ac_s2_[3]+1|0;
            if(skip_s7_)
             ac_s2_[2]=ac_s2_[2]+inc_s6_|0;
            else
             ac_s2_[1]=ac_s2_[1]+inc_s6_|0;}
          return i_s8_+1|0;}
        iter_on_format_args_mf_
         (fmt_qn_,add_conv_s$_,function(i_s9_,c_s__){return i_s9_+1|0;});
        var _ta_=ac_s2_[1];
        if(_ta_<0||6<_ta_)
         {var
           loop_tn_=
            function(i_tb_,args_th_)
             {if(_ta_<=i_tb_)
               {var
                 a_tc_=caml_make_vect(_ta_,0),
                 _tf_=
                  function(i_td_,arg_te_)
                   {return caml_array_set(a_tc_,(_ta_-i_td_|0)-1|0,arg_te_);},
                 i_tg_=0,
                 param_ti_=args_th_;
                for(;;)
                 {if(param_ti_)
                   {var _tj_=param_ti_[2],_tk_=param_ti_[1];
                    if(_tj_)
                     {_tf_(i_tg_,_tk_);
                      var _tl_=i_tg_+1|0,i_tg_=_tl_,param_ti_=_tj_;
                      continue;}
                    _tf_(i_tg_,_tk_);}
                  return kpr_s1_(fmt_qn_,a_tc_);}}
              return function(x_tm_)
               {return loop_tn_(i_tb_+1|0,[0,x_tm_,args_th_]);};},
           _to_=loop_tn_(0,0);}
        else
         switch(_ta_)
          {case 1:
            var
             _to_=
              function(x_tq_)
               {var a_tp_=caml_make_vect(1,0);
                caml_array_set(a_tp_,0,x_tq_);
                return kpr_s1_(fmt_qn_,a_tp_);};
            break;
           case 2:
            var
             _to_=
              function(x_ts_,y_tt_)
               {var a_tr_=caml_make_vect(2,0);
                caml_array_set(a_tr_,0,x_ts_);
                caml_array_set(a_tr_,1,y_tt_);
                return kpr_s1_(fmt_qn_,a_tr_);};
            break;
           case 3:
            var
             _to_=
              function(x_tv_,y_tw_,z_tx_)
               {var a_tu_=caml_make_vect(3,0);
                caml_array_set(a_tu_,0,x_tv_);
                caml_array_set(a_tu_,1,y_tw_);
                caml_array_set(a_tu_,2,z_tx_);
                return kpr_s1_(fmt_qn_,a_tu_);};
            break;
           case 4:
            var
             _to_=
              function(x_tz_,y_tA_,z_tB_,t_tC_)
               {var a_ty_=caml_make_vect(4,0);
                caml_array_set(a_ty_,0,x_tz_);
                caml_array_set(a_ty_,1,y_tA_);
                caml_array_set(a_ty_,2,z_tB_);
                caml_array_set(a_ty_,3,t_tC_);
                return kpr_s1_(fmt_qn_,a_ty_);};
            break;
           case 5:
            var
             _to_=
              function(x_tE_,y_tF_,z_tG_,t_tH_,u_tI_)
               {var a_tD_=caml_make_vect(5,0);
                caml_array_set(a_tD_,0,x_tE_);
                caml_array_set(a_tD_,1,y_tF_);
                caml_array_set(a_tD_,2,z_tG_);
                caml_array_set(a_tD_,3,t_tH_);
                caml_array_set(a_tD_,4,u_tI_);
                return kpr_s1_(fmt_qn_,a_tD_);};
            break;
           case 6:
            var
             _to_=
              function(x_tK_,y_tL_,z_tM_,t_tN_,u_tO_,v_tP_)
               {var a_tJ_=caml_make_vect(6,0);
                caml_array_set(a_tJ_,0,x_tK_);
                caml_array_set(a_tJ_,1,y_tL_);
                caml_array_set(a_tJ_,2,z_tM_);
                caml_array_set(a_tJ_,3,t_tN_);
                caml_array_set(a_tJ_,4,u_tO_);
                caml_array_set(a_tJ_,5,v_tP_);
                return kpr_s1_(fmt_qn_,a_tJ_);};
            break;
           default:var _to_=kpr_s1_(fmt_qn_,[0]);}
        return _to_;}
      return kprintf_sp_;}
    function ksprintf_tY_(k_tS_)
     {var b_tQ_=_iM_(512);
      function k_tU_(ppf_tR_)
       {return _gx_(k_tS_,string_out_qk_(b_tQ_,ppf_tR_));}
      return _jR_
              (mkprintf_tV_,
               1,
               function(param_tT_){return formatter_of_buffer_pR_(b_tQ_);},
               k_tU_);}
    function sprintf_t0_(fmt_tX_)
     {return _g1_(ksprintf_tY_,function(s_tW_){return s_tW_;},fmt_tX_);}
    var g_t1_=exit_function_gw_[1];
    exit_function_gw_[1]=
    function(param_t2_){_gx_(print_flush_tZ_,0);return _gx_(g_t1_,0);};
    var _t3_=[0,0];
    function _uj_(s_t__,seed_t4_)
     {var
       seed_t5_=caml_equal(seed_t4_,[0])?[0,0]:seed_t4_,
       l_t6_=seed_t5_.length-1,
       _t7_=0,
       _t8_=54;
      if(!(_t8_<_t7_))
       {var i_t9_=_t7_;
        for(;;)
         {caml_array_set(s_t__[1],i_t9_,i_t9_);
          var _t$_=i_t9_+1|0;
          if(_t8_!==i_t9_){var i_t9_=_t$_;continue;}
          break;}}
      var accu_ua_=[0,_e8_],_ub_=0,_uc_=54+_f8_(55,l_t6_)|0;
      if(!(_uc_<_ub_))
       {var i_ud_=_ub_;
        for(;;)
         {var
           j_ue_=i_ud_%55|0,
           _uf_=accu_ua_[1],
           _ug_=
            _gi_
             (_uf_,
              string_of_int_gk_
               (caml_array_get(seed_t5_,caml_mod(i_ud_,l_t6_))));
          accu_ua_[1]=caml_md5_string(_ug_,0,_ug_.getLen());
          var _uh_=accu_ua_[1];
          caml_array_set
           (s_t__[1],
            j_ue_,
            caml_array_get(s_t__[1],j_ue_)^
            (((_uh_.safeGet(0)+(_uh_.safeGet(1)<<8)|0)+
              (_uh_.safeGet(2)<<16)|
              0)+
             (_uh_.safeGet(3)<<24)|
             0));
          var _ui_=i_ud_+1|0;
          if(_uc_!==i_ud_){var i_ud_=_ui_;continue;}
          break;}}
      s_t__[2]=0;
      return 0;}
    32===_hS_;
    var _uk_=[0,_e7_.slice(),0];
    function _un_(param_um_)
     {var seq_ul_=[];
      caml_update_dummy(seq_ul_,[0,seq_ul_,seq_ul_]);
      return seq_ul_;}
    var Canceled_uo_=[0,_eV_],current_data_up_=[0,0],max_removed_uW_=42;
    function repr_rec_ut_(t_uq_)
     {var _ur_=t_uq_[1];
      {if(3===_ur_[0])
        {var t__us_=_ur_[1],t___uu_=repr_rec_ut_(t__us_);
         if(t___uu_!==t__us_)t_uq_[1]=[3,t___uu_];
         return t___uu_;}
       return t_uq_;}}
    function repr_uX_(t_uv_){return repr_rec_ut_(t_uv_);}
    function run_waiters_uU_(waiters_uw_,state_uA_)
     {var ws_ux_=waiters_uw_,rem_uy_=0,save_uN_=current_data_up_[1];
      for(;;)
       {if(typeof ws_ux_==="number")
         {if(rem_uy_)
           {var
             rem_uM_=rem_uy_[2],
             ws_uL_=rem_uy_[1],
             ws_ux_=ws_uL_,
             rem_uy_=rem_uM_;
            continue;}}
        else
         switch(ws_ux_[0])
          {case 1:
            var _uz_=ws_ux_[1];
            if(rem_uy_)
             {var rem_uC_=rem_uy_[2],ws_uB_=rem_uy_[1];
              _gx_(_uz_,state_uA_);
              var ws_ux_=ws_uB_,rem_uy_=rem_uC_;
              continue;}
            _gx_(_uz_,state_uA_);
            break;
           case 2:
            var
             ws1_uD_=ws_ux_[1],
             _uE_=[0,ws_ux_[2],rem_uy_],
             ws_ux_=ws1_uD_,
             rem_uy_=_uE_;
            continue;
           default:
            var _uF_=ws_ux_[1][1];
            if(_uF_)
             {var _uG_=_uF_[1];
              if(rem_uy_)
               {var rem_uI_=rem_uy_[2],ws_uH_=rem_uy_[1];
                _gx_(_uG_,state_uA_);
                var ws_ux_=ws_uH_,rem_uy_=rem_uI_;
                continue;}
              _gx_(_uG_,state_uA_);}
            else
             if(rem_uy_)
              {var
                rem_uK_=rem_uy_[2],
                ws_uJ_=rem_uy_[1],
                ws_ux_=ws_uJ_,
                rem_uy_=rem_uK_;
               continue;}}
        current_data_up_[1]=save_uN_;
        return 0;}}
    function wakeup_uY_(t_uO_,v_uR_)
     {var t_uP_=repr_rec_ut_(t_uO_),_uQ_=t_uP_[1];
      switch(_uQ_[0])
       {case 1:if(_uQ_[1][1]===Canceled_uo_)return 0;break;
        case 2:
         var state_uS_=[0,v_uR_],waiters_uT_=_uQ_[1][2];
         t_uP_[1]=state_uS_;
         return run_waiters_uU_(waiters_uT_,state_uS_);
        default:}
      return _f6_(_eW_);}
    var cancel_none_v__=[0,function(_uV_){return 0;}];
    function append_u5_(l1_uZ_,l2_u0_)
     {return typeof l1_uZ_==="number"
              ?l2_u0_
              :typeof l2_u0_==="number"?l1_uZ_:[2,l1_uZ_,l2_u0_];}
    function cleanup_u2_(ws_u1_)
     {if(typeof ws_u1_!=="number")
       switch(ws_u1_[0])
        {case 2:
          var l1_u3_=ws_u1_[1],_u4_=cleanup_u2_(ws_u1_[2]);
          return append_u5_(cleanup_u2_(l1_u3_),_u4_);
         case 1:break;
         default:if(!ws_u1_[1][1])return 0;}
      return ws_u1_;}
    function fast_connect_vU_(t_u6_,state_u9_)
     {var t_u7_=repr_uX_(t_u6_),_u8_=t_u7_[1];
      {if(2===_u8_[0])
        {var waiters_u__=_u8_[1][2];
         t_u7_[1]=state_u9_;
         return run_waiters_uU_(waiters_u__,state_u9_);}
       return _f6_(_eZ_);}}
    function return_v7_(v_u$_){return [0,[0,v_u$_]];}
    function fail_vA_(e_va_){return [0,[1,e_va_]];}
    function temp_vC_(r_vb_){return [0,[2,[0,r_vb_,0,0]]];}
    function task_v$_(param_vl_)
     {var t_vc_=[],_vk_=0,_vj_=0;
      caml_update_dummy
       (t_vc_,
        [0,
         [2,
          [0,
           [0,
            [0,
             function(param_vi_)
              {var t_vd_=repr_rec_ut_(t_vc_),_ve_=t_vd_[1];
               if(2===_ve_[0])
                {var state_vf_=[1,[0,Canceled_uo_]],waiters_vg_=_ve_[1][2];
                 t_vd_[1]=state_vf_;
                 var _vh_=run_waiters_uU_(waiters_vg_,state_vf_);}
               else
                var _vh_=0;
               return _vh_;}]],
           _vj_,
           _vk_]]]);
      return [0,t_vc_,t_vc_];}
    function add_immutable_waiter_vx_(sleeper_vm_,waiter_vn_)
     {var
       _vo_=
        typeof sleeper_vm_[2]==="number"
         ?[1,waiter_vn_]
         :[2,[1,waiter_vn_],sleeper_vm_[2]];
      sleeper_vm_[2]=_vo_;
      return 0;}
    function on_cancel_wa_(t_vp_,f_vr_)
     {var _vq_=repr_uX_(t_vp_)[1];
      switch(_vq_[0])
       {case 1:if(_vq_[1][1]===Canceled_uo_)return _gx_(f_vr_,0);break;
        case 2:
         var sleeper_vw_=_vq_[1],data_vt_=current_data_up_[1];
         return add_immutable_waiter_vx_
                 (sleeper_vw_,
                  function(param_vs_)
                   {if(1===param_vs_[0]&&param_vs_[1][1]===Canceled_uo_)
                     {current_data_up_[1]=data_vt_;
                      try {var _vu_=_gx_(f_vr_,0);}catch(_vv_){return 0;}
                      return _vu_;}
                    return 0;});
        default:}
      return 0;}
    function bind_wb_(t_vy_,f_vH_)
     {var _vz_=repr_uX_(t_vy_)[1];
      switch(_vz_[0])
       {case 1:return fail_vA_(_vz_[1]);
        case 2:
         var
          sleeper_vB_=_vz_[1],
          res_vD_=temp_vC_(sleeper_vB_[1]),
          data_vF_=current_data_up_[1];
         add_immutable_waiter_vx_
          (sleeper_vB_,
           function(param_vE_)
            {switch(param_vE_[0])
              {case 0:
                var v_vG_=param_vE_[1];
                current_data_up_[1]=data_vF_;
                try
                 {var _vI_=_gx_(f_vH_,v_vG_),_vJ_=_vI_;}
                catch(_vK_){var _vJ_=fail_vA_(_vK_);}
                var
                 t1_vL_=repr_uX_(res_vD_),
                 t2_vM_=repr_uX_(_vJ_),
                 _vN_=t1_vL_[1];
                if(2===_vN_[0])
                 {var sleeper1_vO_=_vN_[1];
                  if(t1_vL_===t2_vM_)
                   var _vP_=0;
                  else
                   {var _vQ_=t2_vM_[1];
                    if(2===_vQ_[0])
                     {var sleeper2_vR_=_vQ_[1];
                      t2_vM_[1]=[3,t1_vL_];
                      sleeper1_vO_[1][1]=[1,sleeper2_vR_[1]];
                      var
                       waiters_vS_=append_u5_(sleeper1_vO_[2],sleeper2_vR_[2]),
                       removed_vT_=sleeper1_vO_[3]+sleeper2_vR_[3]|0,
                       _vP_=
                        max_removed_uW_<removed_vT_
                         ?(sleeper1_vO_[3]=
                           0,
                           sleeper1_vO_[2]=
                           cleanup_u2_(waiters_vS_),
                           0)
                         :(sleeper1_vO_[3]=removed_vT_,sleeper1_vO_[2]=waiters_vS_,0);}
                    else
                     {t1_vL_[1]=_vQ_;
                      var _vP_=run_waiters_uU_(sleeper1_vO_[2],_vQ_);}}}
                else
                 var _vP_=_f6_(_eY_);
                return _vP_;
               case 1:return fast_connect_vU_(res_vD_,[1,param_vE_[1]]);
               default:throw [0,_d_,_e1_];}});
         return res_vD_;
        case 3:throw [0,_d_,_e0_];
        default:return _gx_(f_vH_,_vz_[1]);}}
    function _wc_(t_vV_,f_v3_)
     {var _vW_=repr_uX_(t_vV_)[1];
      switch(_vW_[0])
       {case 1:var _vX_=[0,[1,_vW_[1]]];break;
        case 2:
         var
          sleeper_vY_=_vW_[1],
          res_vZ_=temp_vC_(sleeper_vY_[1]),
          data_v1_=current_data_up_[1];
         add_immutable_waiter_vx_
          (sleeper_vY_,
           function(param_v0_)
            {switch(param_v0_[0])
              {case 0:
                var v_v2_=param_v0_[1];
                current_data_up_[1]=data_v1_;
                try
                 {var _v4_=[0,_gx_(f_v3_,v_v2_)],_v5_=_v4_;}
                catch(_v6_){var _v5_=[1,_v6_];}
                return fast_connect_vU_(res_vZ_,_v5_);
               case 1:return fast_connect_vU_(res_vZ_,[1,param_v0_[1]]);
               default:throw [0,_d_,_e3_];}});
         var _vX_=res_vZ_;
         break;
        case 3:throw [0,_d_,_e2_];
        default:var _vX_=return_v7_(_gx_(f_v3_,_vW_[1]));}
      return _vX_;}
    function poll_wd_(t_v8_)
     {var _v9_=repr_uX_(t_v8_)[1];
      switch(_v9_[0])
       {case 1:throw _v9_[1];
        case 2:return 0;
        case 3:throw [0,_d_,_e4_];
        default:return [0,_v9_[1]];}}
    _uj_([0,caml_make_vect(55,0),0],[0]);
    var pause_hook_wg_=[0,function(_we_){return 0;}],_wf_=_un_(0),_wi_=[0,0];
    function _ws_(param_wl_)
     {if(_wf_[2]===_wf_)return 0;
      var tmp_wh_=_un_(0);
      tmp_wh_[1][2]=_wf_[2];
      _wf_[2][1]=tmp_wh_[1];
      tmp_wh_[1]=_wf_[1];
      _wf_[1][2]=tmp_wh_;
      _wf_[1]=_wf_;
      _wf_[2]=_wf_;
      _wi_[1]=0;
      var curr_wj_=tmp_wh_[2];
      for(;;)
       {if(curr_wj_!==tmp_wh_)
         {if(curr_wj_[4])wakeup_uY_(curr_wj_[3],0);
          var _wk_=curr_wj_[2],curr_wj_=_wk_;
          continue;}
        return 0;}}
    function _wp_(f_wn_,l_wm_)
     {if(l_wm_)
       {var l_wo_=l_wm_[2],__pa_lwt_0_wr_=_gx_(f_wn_,l_wm_[1]);
        return bind_wb_
                (__pa_lwt_0_wr_,
                 function(param_wq_){return _wp_(f_wn_,l_wo_);});}
      return return_v7_(0);}
    var null_wt_=null,undefined_wu_=undefined;
    function _wS_(x_wv_,f_ww_){return x_wv_==null_wt_?0:_gx_(f_ww_,x_wv_);}
    function _wD_(x_wx_,f_wy_,g_wz_)
     {return x_wx_==null_wt_?_gx_(f_wy_,0):_gx_(g_wz_,x_wx_);}
    function _wT_(x_wE_)
     {function _wC_(x_wA_){return [0,x_wA_];}
      return _wD_(x_wE_,function(param_wB_){return 0;},_wC_);}
    function _wU_(x_wF_){return x_wF_!==undefined_wu_?1:0;}
    function _wV_(x_wG_,f_wH_)
     {return x_wG_!==undefined_wu_?_gx_(f_wH_,x_wG_):0;}
    function _wQ_(x_wI_,f_wJ_,g_wK_)
     {return x_wI_===undefined_wu_?_gx_(f_wJ_,0):_gx_(g_wK_,x_wI_);}
    function _wW_(x_wL_,f_wM_)
     {return x_wL_===undefined_wu_?_gx_(f_wM_,0):x_wL_;}
    function _wX_(x_wR_)
     {function _wP_(x_wN_){return [0,x_wN_];}
      return _wQ_(x_wR_,function(param_wO_){return 0;},_wP_);}
    var
     _true_wY_=true,
     _false_wZ_=false,
     regExp_w0_=RegExp,
     array_constructor_w1_=Array;
    function array_get_w5_(_w2_,_w3_){return _w2_[_w3_];}
    function match_result_w6_(_w4_){return _w4_;}
    var date_constr_w$_=Date,math_w__=Math;
    function escape_w9_(s_w7_){return escape(s_w7_);}
    function _xa_(e_w8_)
     {return e_w8_ instanceof array_constructor_w1_
              ?0
              :[0,new MlWrappedString(e_w8_.toString())];}
    _t3_[1]=[0,_xa_,_t3_[1]];
    function _xd_(_xb_){return _xb_;}
    function _xe_(_xc_){return _xc_;}
    function appendChild_xD_(p_xf_,n_xg_){p_xf_.appendChild(n_xg_);return 0;}
    function removeChild_xE_(p_xh_,n_xi_){p_xh_.removeChild(n_xi_);return 0;}
    function handler_xF_(f_xk_)
     {return _xe_
              (caml_js_wrap_callback
                (function(e_xj_)
                  {if(e_xj_)
                    {var res_xl_=_gx_(f_xk_,e_xj_);
                     if(!(res_xl_|0))e_xj_.preventDefault();
                     return res_xl_;}
                   var _xm_=event,res_xn_=_gx_(f_xk_,_xm_);
                   _xm_.returnValue=res_xn_;
                   return res_xn_;}));}
    function _xG_(s_xo_){return s_xo_.toString();}
    function _xH_(e_xp_,typ_xq_,h_xt_,capt_xA_)
     {if(e_xp_.addEventListener===undefined_wu_)
       {var
         ev_xr_=_eU_.toString().concat(typ_xq_),
         callback_xy_=
          function(e_xs_)
           {var _xx_=[0,h_xt_,e_xs_,[0]];
            return _gx_
                    (function(_xw_,_xv_,_xu_)
                      {return caml_js_call(_xw_,_xv_,_xu_);},
                     _xx_);};
        e_xp_.attachEvent(ev_xr_,callback_xy_);
        return function(param_xz_)
         {return e_xp_.detachEvent(ev_xr_,callback_xy_);};}
      e_xp_.addEventListener(typ_xq_,h_xt_,capt_xA_);
      return function(param_xB_)
       {return e_xp_.removeEventListener(typ_xq_,h_xt_,capt_xA_);};}
    function _xI_(id_xC_){return _gx_(id_xC_,0);}
    var
     onIE_xJ_=caml_js_on_ie(0)|0,
     click_xK_=_xG_(_eD_),
     mouseup_xL_=_xG_(_eC_),
     mousemove_xN_=_xG_(_eB_),
     keydown_xM_=_xG_(_eA_),
     touchstart_xO_=_xG_(_ez_),
     touchmove_xQ_=_xG_(_ey_),
     touchend_xP_=_xG_(_ex_),
     _2d__xR_=_ew_.toString(),
     window_xS_=window,
     document_xT_=window_xS_.document;
    function opt_iter_x__(x_xU_,f_xV_){return x_xU_?_gx_(f_xV_,x_xU_[1]):0;}
    function createElement_xY_(doc_xX_,name_xW_)
     {return doc_xX_.createElement(name_xW_.toString());}
    function unsafeCreateElement_x1_(doc_x0_,name_xZ_)
     {return createElement_xY_(doc_x0_,name_xZ_);}
    function createUl_x$_(doc_x2_)
     {return unsafeCreateElement_x1_(doc_x2_,_eL_);}
    function createDl_ya_(doc_x3_)
     {return unsafeCreateElement_x1_(doc_x3_,_eM_);}
    function createLi_yb_(doc_x4_)
     {return unsafeCreateElement_x1_(doc_x4_,_eN_);}
    function createDiv_yc_(doc_x5_)
     {return unsafeCreateElement_x1_(doc_x5_,_eO_);}
    function createA_yd_(doc_x6_)
     {return unsafeCreateElement_x1_(doc_x6_,_eP_);}
    function createImg_ye_(doc_x7_)
     {return unsafeCreateElement_x1_(doc_x7_,_eQ_);}
    function createDd_yf_(doc_x8_){return createElement_xY_(doc_x8_,_eR_);}
    function createDt_yg_(doc_x9_){return createElement_xY_(doc_x9_,_eS_);}
    var Canvas_not_available_yh_=[0,_ev_];
    function createCanvas_yk_(doc_yi_)
     {var c_yj_=unsafeCreateElement_x1_(doc_yi_,_eT_);
      if(1-(c_yj_.getContext==null_wt_?1:0))return c_yj_;
      throw [0,Canvas_not_available_yh_];}
    _xd_(window.HTMLElement)===undefined_wu_;
    function stopPropagation_yF_(ev_yl_)
     {function _yo_(param_ym_){return ev_yl_.stopPropagation();}
      function _yp_(param_yn_){return ev_yl_.cancelBubble=_true_wY_;}
      return _wQ_(ev_yl_.stopPropagation,_yp_,_yo_);}
    var
     _yQ_=
      caml_js_pure_expr
       (function(param_yE_)
         {var
           l_yq_=
            [0,
             window_xS_.requestAnimationFrame,
             [0,
              window_xS_.mozRequestAnimationFrame,
              [0,
               window_xS_.webkitRequestAnimationFrame,
               [0,
                window_xS_.oRequestAnimationFrame,
                [0,window_xS_.msRequestAnimationFrame,0]]]]];
          try
           {var param_yr_=l_yq_;
            for(;;)
             {if(!param_yr_)throw [0,_c_];
              var x_ys_=param_yr_[1],l_yt_=param_yr_[2];
              if(!_wU_(x_ys_)){var param_yr_=l_yt_;continue;}
              var _yv_=function(callback_yu_){return x_ys_(callback_yu_);};
              break;}}
          catch(_yw_)
           {if(_yw_[1]===_c_)
             {var
               now_yy_=
                function(param_yx_){return new date_constr_w$_().getTime();},
               last_yz_=[0,now_yy_(0)];
              return function(callback_yD_)
               {var
                 t_yA_=now_yy_(0),
                 dt_yB_=last_yz_[1]+1000/60-t_yA_,
                 dt_yC_=dt_yB_<0?0:dt_yB_;
                last_yz_[1]=t_yA_;
                window_xS_.setTimeout(callback_yD_,dt_yC_);
                return 0;};}
            throw _yw_;}
          return _yv_;});
    function yield_yP_(param_yN_)
     {var
       match_yG_=task_v$_(0),
       t_yH_=match_yG_[1],
       w_yI_=match_yG_[2],
       _yK_=0*1000,
       id_yL_=
        window_xS_.setTimeout
         (caml_js_wrap_callback
           (function(param_yJ_){return wakeup_uY_(w_yI_,0);}),
          _yK_);
      on_cancel_wa_
       (t_yH_,function(param_yM_){return window_xS_.clearTimeout(id_yL_);});
      return t_yH_;}
    pause_hook_wg_[1]=
    function(param_yO_)
     {return 1===param_yO_
              ?(window_xS_.setTimeout(caml_js_wrap_callback(_ws_),0),0)
              :0;};
    var _yR_=caml_js_get_console(0);
    function regexp_yU_(s_yS_)
     {var _yT_=_es_.toString();
      return new regExp_w0_(caml_js_from_byte_string(s_yS_),_yT_);}
    var
     quote_repl_re_yV_=new regExp_w0_(_eq_.toString(),_er_.toString()),
     _yX_=regexp_yU_(_ep_),
     l_yW_=window_xS_.location;
    function split_y0_(c_yY_,s_yZ_)
     {return s_yZ_.split(_hO_(1,c_yY_).toString());}
    var Local_exn_y1_=[0,_dI_];
    function interrupt_y3_(param_y2_){throw [0,Local_exn_y1_];}
    var
     ab0ed72bb_y4_=caml_js_from_byte_string(_dH_),
     _y5_=
      regexp_yU_
       (caml_js_to_byte_string(ab0ed72bb_y4_.replace(_yX_,_eu_.toString())));
    function urldecode_js_string_string_zb_(s_y6_)
     {return caml_js_to_byte_string(unescape(s_y6_));}
    function urlencode_zc_(_opt__y7_,s_y9_)
     {var with_plus_y8_=_opt__y7_?_opt__y7_[1]:1;
      if(with_plus_y8_)
       {var
         _y__=
          caml_js_to_byte_string(escape_w9_(caml_js_from_byte_string(s_y9_)));
        _y5_.lastIndex=0;
        var
         a33fe25d4_y$_=caml_js_from_byte_string(_y__),
         a889dca04_za_=caml_js_from_byte_string(_dJ_);
        return caml_js_to_byte_string
                (a33fe25d4_y$_.replace
                  (_y5_,
                   a889dca04_za_.replace(quote_repl_re_yV_,_et_.toString())));}
      return caml_js_to_byte_string
              (escape_w9_(caml_js_from_byte_string(s_y9_)));}
    var Not_an_http_protocol_zP_=[0,_dG_];
    function path_of_path_string_zj_(s_zd_)
     {try
       {var length_ze_=s_zd_.getLen();
        if(0===length_ze_)
         var _zf_=_eo_;
        else
         {var i_zg_=0,_zi_=47,_zh_=s_zd_.getLen();
          for(;;)
           {if(_zh_<=i_zg_)throw [0,_c_];
            if(s_zd_.safeGet(i_zg_)!==_zi_)
             {var _zm_=i_zg_+1|0,i_zg_=_zm_;continue;}
            if(0===i_zg_)
             var
              _zk_=
               [0,_en_,path_of_path_string_zj_(_hP_(s_zd_,1,length_ze_-1|0))];
            else
             {var
               _zl_=
                path_of_path_string_zj_
                 (_hP_(s_zd_,i_zg_+1|0,(length_ze_-i_zg_|0)-1|0)),
               _zk_=[0,_hP_(s_zd_,0,i_zg_),_zl_];}
            var _zf_=_zk_;
            break;}}}
      catch(_zn_){if(_zn_[1]===_c_)return [0,s_zd_,0];throw _zn_;}
      return _zf_;}
    function encode_arguments_zQ_(l_zr_)
     {return _hR_
              (_dQ_,
               _hd_
                (function(param_zo_)
                  {var
                    n_zp_=param_zo_[1],
                    _zq_=_gi_(_dR_,urlencode_zc_(0,param_zo_[2]));
                   return _gi_(urlencode_zc_(0,n_zp_),_zq_);},
                 l_zr_));}
    function decode_arguments_js_string_zR_(s_zs_)
     {var arr_zt_=split_y0_(38,s_zs_),len_zO_=arr_zt_.length;
      function aux_zK_(acc_zJ_,idx_zu_)
       {var idx_zv_=idx_zu_;
        for(;;)
         {if(0<=idx_zv_)
           {try
             {var
               _zH_=idx_zv_-1|0,
               _zI_=
                function(s_zC_)
                 {function _zE_(param_zw_)
                   {var y_zA_=param_zw_[2],x_zz_=param_zw_[1];
                    function get_zy_(t_zx_)
                     {return urldecode_js_string_string_zb_
                              (_wW_(t_zx_,interrupt_y3_));}
                    var _zB_=get_zy_(y_zA_);
                    return [0,get_zy_(x_zz_),_zB_];}
                  var arr_bis_zD_=split_y0_(61,s_zC_);
                  if(2===arr_bis_zD_.length)
                   {var
                     _zF_=array_get_w5_(arr_bis_zD_,1),
                     _zG_=_xd_([0,array_get_w5_(arr_bis_zD_,0),_zF_]);}
                  else
                   var _zG_=undefined_wu_;
                  return _wQ_(_zG_,interrupt_y3_,_zE_);},
               _zL_=
                aux_zK_
                 ([0,
                   _wQ_(array_get_w5_(arr_zt_,idx_zv_),interrupt_y3_,_zI_),
                   acc_zJ_],
                  _zH_);}
            catch(_zM_)
             {if(_zM_[1]===Local_exn_y1_)
               {var _zN_=idx_zv_-1|0,idx_zv_=_zN_;continue;}
              throw _zM_;}
            return _zL_;}
          return acc_zJ_;}}
      return aux_zK_(0,len_zO_-1|0);}
    var
     url_re_zS_=new regExp_w0_(caml_js_from_byte_string(_dF_)),
     file_re_Ar_=new regExp_w0_(caml_js_from_byte_string(_dE_));
    function string_of_url_Aq_(param_zT_)
     {switch(param_zT_[0])
       {case 1:
         var
          match_zU_=param_zT_[1],
          frag_zV_=match_zU_[6],
          args_zW_=match_zU_[5],
          port_zX_=match_zU_[2],
          path_z0_=match_zU_[3],
          host_zZ_=match_zU_[1],
          _zY_=
           caml_string_notequal(frag_zV_,_ec_)
            ?_gi_(_eb_,urlencode_zc_(0,frag_zV_))
            :_ea_,
          _z1_=args_zW_?_gi_(_d$_,encode_arguments_zQ_(args_zW_)):_d__,
          _z3_=_gi_(_z1_,_zY_),
          _z5_=
           _gi_
            (_d8_,
             _gi_
              (_hR_
                (_d9_,
                 _hd_
                  (function(eta_z2_){return urlencode_zc_(0,eta_z2_);},
                   path_z0_)),
               _z3_)),
          _z4_=443===port_zX_?_d6_:_gi_(_d7_,string_of_int_gk_(port_zX_)),
          _z6_=_gi_(_z4_,_z5_);
         return _gi_(_d5_,_gi_(urlencode_zc_(0,host_zZ_),_z6_));
        case 2:
         var
          match_z7_=param_zT_[1],
          frag_z8_=match_z7_[4],
          args_z9_=match_z7_[3],
          path_z$_=match_z7_[1],
          _z__=
           caml_string_notequal(frag_z8_,_d4_)
            ?_gi_(_d3_,urlencode_zc_(0,frag_z8_))
            :_d2_,
          _Aa_=args_z9_?_gi_(_d1_,encode_arguments_zQ_(args_z9_)):_d0_,
          _Ac_=_gi_(_Aa_,_z__);
         return _gi_
                 (_dY_,
                  _gi_
                   (_hR_
                     (_dZ_,
                      _hd_
                       (function(eta_Ab_){return urlencode_zc_(0,eta_Ab_);},
                        path_z$_)),
                    _Ac_));
        default:
         var
          match_Ad_=param_zT_[1],
          frag_Ae_=match_Ad_[6],
          args_Af_=match_Ad_[5],
          port_Ag_=match_Ad_[2],
          path_Aj_=match_Ad_[3],
          host_Ai_=match_Ad_[1],
          _Ah_=
           caml_string_notequal(frag_Ae_,_em_)
            ?_gi_(_el_,urlencode_zc_(0,frag_Ae_))
            :_ek_,
          _Ak_=args_Af_?_gi_(_ej_,encode_arguments_zQ_(args_Af_)):_ei_,
          _Am_=_gi_(_Ak_,_Ah_),
          _Ao_=
           _gi_
            (_eg_,
             _gi_
              (_hR_
                (_eh_,
                 _hd_
                  (function(eta_Al_){return urlencode_zc_(0,eta_Al_);},
                   path_Aj_)),
               _Am_)),
          _An_=80===port_Ag_?_ee_:_gi_(_ef_,string_of_int_gk_(port_Ag_)),
          _Ap_=_gi_(_An_,_Ao_);
         return _gi_(_ed_,_gi_(urlencode_zc_(0,host_Ai_),_Ap_));}}
    urldecode_js_string_string_zb_(l_yW_.hostname);
    try
     {caml_int_of_string(caml_js_to_byte_string(l_yW_.port));}
    catch(_As_){if(_As_[1]!==_a_)throw _As_;}
    path_of_path_string_zj_(urldecode_js_string_string_zb_(l_yW_.pathname));
    decode_arguments_js_string_zR_(l_yW_.search);
    urldecode_js_string_string_zb_(l_yW_.href);
    var _AB_=window.FileReader,formData_AA_=window.FormData;
    function _Az_(form_contents_At_,form_elt_Av_)
     {if(891486873<=form_contents_At_[1])
       {var list_Au_=form_contents_At_[2];
        list_Au_[1]=[0,form_elt_Av_,list_Au_[1]];
        return 0;}
      var
       f_Aw_=form_contents_At_[2],
       _Ax_=form_elt_Av_[2],
       _Ay_=form_elt_Av_[1];
      return 781515420<=_Ax_[1]
              ?f_Aw_.append(_Ay_.toString(),_Ax_[2])
              :f_Aw_.append(_Ay_.toString(),_Ax_[2]);}
    function _AD_(param_AC_){return ActiveXObject;}
    var _AG_=[0,_c6_];
    function icon_AF_(nm_AE_){return _gi_(_B_,nm_AE_).toString();}
    var tree_color_AH_=_z_.toString();
    function option_AK_(var_AJ_)
     {return _wW_
              (var_AJ_,
               function(param_AI_){return new array_constructor_w1_();});}
    var style_AL_=option_AK_(window.hyp_style);
    function opt_style_BD_(v_AO_,default_AM_)
     {return _wW_(v_AO_,function(param_AN_){return default_AM_;});}
    function sdiv_Bv_(z_AP_,s_AQ_){return [-1,z_AP_[1]/s_AQ_,z_AP_[2]/s_AQ_];}
    function sq_norm_AS_(c_AR_){return c_AR_[1]*c_AR_[1]+c_AR_[2]*c_AR_[2];}
    function norm_Bu_(c_AT_){return Math.sqrt(sq_norm_AS_(c_AT_));}
    function conj_Be_(z_AU_){return [-1,z_AU_[1],-z_AU_[2]];}
    function neg_BE_(z_AV_){return [-1,-z_AV_[1],-z_AV_[2]];}
    function add_Bq_(z_AX_,t_AW_)
     {return [-1,z_AX_[1]+t_AW_[1],z_AX_[2]+t_AW_[2]];}
    function sub_Bx_(z_AZ_,t_AY_)
     {return [-1,z_AZ_[1]-t_AY_[1],z_AZ_[2]-t_AY_[2]];}
    function mul_Bg_(z_A1_,t_A0_)
     {return [-1,
              z_A1_[1]*t_A0_[1]-z_A1_[2]*t_A0_[2],
              z_A1_[1]*t_A0_[2]+z_A1_[2]*t_A0_[1]];}
    function add_mul_A8_(a_A4_,z_A3_,b_A2_)
     {return [-1,
              a_A4_[1]*z_A3_[1]-a_A4_[2]*z_A3_[2]+b_A2_[1],
              a_A4_[1]*z_A3_[2]+a_A4_[2]*z_A3_[1]+b_A2_[2]];}
    function div_Bd_(z_A7_,t_A5_)
     {var n_A6_=sq_norm_AS_(t_A5_);
      return [-1,
              (z_A7_[1]*t_A5_[1]+z_A7_[2]*t_A5_[2])/n_A6_,
              (z_A7_[2]*t_A5_[1]-z_A7_[1]*t_A5_[2])/n_A6_];}
    function transf_Bh_(a_Bb_,b_Ba_,c_A$_,d_A9_,z_A__)
     {var _Bc_=add_mul_A8_(c_A$_,z_A__,d_A9_);
      return div_Bd_(add_mul_A8_(a_Bb_,z_A__,b_Ba_),_Bc_);}
    function transl_BF_(p_Bf_)
     {var c_Bj_=mul_Bg_(conj_Be_(p_Bf_),one_g_);
      return function(z_Bi_)
       {return transf_Bh_(one_g_,p_Bf_,c_Bj_,one_g_,z_Bi_);};}
    function compose_BG_(param_Bn_,_Bk_)
     {var
       t2_Bl_=_Bk_[2],
       p2_Bm_=_Bk_[1],
       t1_Bp_=param_Bn_[2],
       t2p1_Bo_=mul_Bg_(t2_Bl_,param_Bn_[1]),
       den_Br_=add_Bq_(mul_Bg_(t2p1_Bo_,conj_Be_(p2_Bm_)),one_g_),
       _Bs_=div_Bd_(conj_Be_(den_Br_),den_Br_),
       _Bt_=mul_Bg_(mul_Bg_(t1_Bp_,t2_Bl_),_Bs_),
       _Bw_=sdiv_Bv_(_Bt_,norm_Bu_(_Bt_));
      return [0,div_Bd_(add_Bq_(t2p1_Bo_,p2_Bm_),den_Br_),_Bw_];}
    function compute_translation_BH_(z0_By_,z1_Bz_)
     {var
       dz_BA_=sub_Bx_(z1_Bz_,z0_By_),
       z0z1_BB_=mul_Bg_(z0_By_,z1_Bz_),
       _BC_=1-sq_norm_AS_(z0z1_BB_);
      return sdiv_Bv_(add_Bq_(mul_Bg_(z0z1_BB_,conj_Be_(dz_BA_)),dz_BA_),_BC_);}
    var json_BI_=JSON;
    function http_get_EI_(url_Co_)
     {var _BM_=0,_BN_=0,_BO_=0,_BP_=0,_BQ_=0,_BR_=0;
      function _BT_(r_BJ_)
       {var cod_BK_=r_BJ_[2],msg_BL_=r_BJ_[4];
        if(0!==cod_BK_&&200!==cod_BK_)
         return [0,[2,[0,[0,cancel_none_v__],0,0]]];
        return return_v7_(msg_BL_);}
      var
       headers_BS_=_BR_?_BR_[1]:0,
       get_args_BU_=_BO_?_BO_[1]:0,
       check_headers_BV_=_BM_?_BM_[1]:function(param_BW_,_BX_){return 1;};
      if(_BN_)
       {var form_arg_BY_=_BN_[1];
        if(_BP_)
         {var post_args_B0_=_BP_[1];
          _hq_
           (function(param_BZ_)
             {return _Az_
                      (form_arg_BY_,
                       [0,param_BZ_[1],[0,-976970511,param_BZ_[2].toString()]]);},
            post_args_B0_);}
        var form_arg_B1_=[0,form_arg_BY_];}
      else
       if(_BP_)
        {var
          post_args_B2_=_BP_[1],
          _B3_=_wX_(_xd_(formData_AA_)),
          contents_B4_=_B3_?[0,808620462,new (_B3_[1])()]:[0,891486873,[0,0]];
         _hq_
          (function(param_B5_)
            {return _Az_
                     (contents_B4_,
                      [0,param_B5_[1],[0,-976970511,param_B5_[2].toString()]]);},
           post_args_B2_);
         var form_arg_B1_=[0,contents_B4_];}
       else
        var form_arg_B1_=0;
      if(form_arg_B1_)
       {var _B6_=form_arg_B1_[1];
        if(_BQ_)
         var _B7_=[0,_dx_,_BQ_,126925477];
        else
         {if(891486873<=_B6_[1])
           {var yes_B8_=0,no_B9_=0,param_B__=_B6_[2][1];
            for(;;)
             {if(param_B__)
               {var
                 l_B$_=param_B__[2],
                 x_Ca_=param_B__[1],
                 _Cb_=781515420<=x_Ca_[2][1]?0:1;
                if(_Cb_)
                 {var _Cc_=[0,x_Ca_,yes_B8_],yes_B8_=_Cc_,param_B__=l_B$_;
                  continue;}
                var _Cd_=[0,x_Ca_,no_B9_],no_B9_=_Cd_,param_B__=l_B$_;
                continue;}
              var _Ce_=_hp_(no_B9_);
              _hp_(yes_B8_);
              if(_Ce_)
               {var
                 nine_digits_Cg_=
                  function(param_Cf_)
                   {return string_of_int_gk_(math_w__.random()*1000000000|0);},
                 _Ch_=nine_digits_Cg_(0),
                 _Ci_=_gi_(_c$_,_gi_(nine_digits_Cg_(0),_Ch_)),
                 _Cj_=[0,_dv_,[0,_gi_(_dw_,_Ci_)],[0,164354597,_Ci_]];}
              else
               var _Cj_=_du_;
              var _Ck_=_Cj_;
              break;}}
          else
           var _Ck_=_dt_;
          var _B7_=_Ck_;}
        var match_Cl_=_B7_;}
      else
       var match_Cl_=[0,_ds_,_BQ_,126925477];
      var
       post_encode_Cm_=match_Cl_[3],
       content_type_Cn_=match_Cl_[2],
       method__Cq_=match_Cl_[1],
       _Cp_=caml_js_from_byte_string(url_Co_);
      function _CZ_(handle_Cr_)
       {var
         res_Cs_=match_result_w6_(handle_Cr_),
         _Ct_=
          caml_js_to_byte_string
           (_wW_(array_get_w5_(res_Cs_,1),interrupt_y3_).toLowerCase());
        if(caml_string_notequal(_Ct_,_dP_)&&caml_string_notequal(_Ct_,_dO_))
         {if(caml_string_notequal(_Ct_,_dN_)&&caml_string_notequal(_Ct_,_dM_))
           {if
             (caml_string_notequal(_Ct_,_dL_)&&
              caml_string_notequal(_Ct_,_dK_))
             {var _Cv_=1,_Cu_=0;}
            else
             var _Cu_=1;
            if(_Cu_){var ssl_Cw_=1,_Cv_=2;}}
          else
           var _Cv_=0;
          switch(_Cv_)
           {case 1:var _Cx_=0;break;
            case 2:var _Cx_=1;break;
            default:var ssl_Cw_=0,_Cx_=1;}
          if(_Cx_)
           {var
             path_str_Cy_=
              urldecode_js_string_string_zb_
               (_wW_(array_get_w5_(res_Cs_,5),interrupt_y3_)),
             _CA_=function(param_Cz_){return caml_js_from_byte_string(_dT_);},
             _CC_=
              urldecode_js_string_string_zb_
               (_wW_(array_get_w5_(res_Cs_,9),_CA_)),
             _CD_=function(param_CB_){return caml_js_from_byte_string(_dU_);},
             _CE_=
              decode_arguments_js_string_zR_
               (_wW_(array_get_w5_(res_Cs_,7),_CD_)),
             _CG_=path_of_path_string_zj_(path_str_Cy_),
             _CH_=function(param_CF_){return caml_js_from_byte_string(_dV_);},
             _CI_=caml_js_to_byte_string(_wW_(array_get_w5_(res_Cs_,4),_CH_)),
             _CJ_=
              caml_string_notequal(_CI_,_dS_)
               ?caml_int_of_string(_CI_)
               :ssl_Cw_?443:80,
             url_CK_=
              [0,
               urldecode_js_string_string_zb_
                (_wW_(array_get_w5_(res_Cs_,2),interrupt_y3_)),
               _CJ_,
               _CG_,
               path_str_Cy_,
               _CE_,
               _CC_],
             _CL_=ssl_Cw_?[1,url_CK_]:[0,url_CK_];
            return [0,_CL_];}}
        throw [0,Not_an_http_protocol_zP_];}
      function _C0_(param_CY_)
       {function _CW_(handle_CM_)
         {var
           res_CN_=match_result_w6_(handle_CM_),
           path_str_CO_=
            urldecode_js_string_string_zb_
             (_wW_(array_get_w5_(res_CN_,2),interrupt_y3_));
          function _CQ_(param_CP_){return caml_js_from_byte_string(_dW_);}
          var
           _CS_=
            caml_js_to_byte_string(_wW_(array_get_w5_(res_CN_,6),_CQ_));
          function _CT_(param_CR_){return caml_js_from_byte_string(_dX_);}
          var
           _CU_=
            decode_arguments_js_string_zR_
             (_wW_(array_get_w5_(res_CN_,4),_CT_));
          return [0,
                  [2,
                   [0,
                    path_of_path_string_zj_(path_str_CO_),
                    path_str_CO_,
                    _CU_,
                    _CS_]]];}
        function _CX_(param_CV_){return 0;}
        return _wD_(file_re_Ar_.exec(_Cp_),_CX_,_CW_);}
      var _C1_=_wD_(url_re_zS_.exec(_Cp_),_C0_,_CZ_);
      if(_C1_)
       {var _C2_=_C1_[1];
        switch(_C2_[0])
         {case 0:
           var url_C3_=_C2_[1],_C4_=url_C3_.slice(),_C5_=url_C3_[5];
           _C4_[5]=0;
           var match_C6_=[0,string_of_url_Aq_([0,_C4_]),_C5_],_C7_=1;
           break;
          case 1:
           var url_C8_=_C2_[1],_C9_=url_C8_.slice(),_C__=url_C8_[5];
           _C9_[5]=0;
           var match_C6_=[0,string_of_url_Aq_([1,_C9_]),_C__],_C7_=1;
           break;
          default:var _C7_=0;}}
      else
       var _C7_=0;
      if(!_C7_)var match_C6_=[0,url_Co_,0];
      var
       url_C$_=match_C6_[1],
       _Da_=_gf_(match_C6_[2],get_args_BU_),
       url_Db_=
        _Da_?_gi_(url_C$_,_gi_(_dr_,encode_arguments_zQ_(_Da_))):url_C$_,
       match_Dc_=task_v$_(0),
       w_Dd_=match_Dc_[2],
       res_De_=match_Dc_[1];
      try
       {var _Df_=new XMLHttpRequest(),req_Dg_=_Df_;}
      catch(_Eu_)
       {try
         {var
           a287eef3f_Dh_=_AD_(0),
           _Di_=new a287eef3f_Dh_(_c__.toString()),
           req_Dg_=_Di_;}
        catch(_Dp_)
         {try
           {var
             adf052a6f_Dj_=_AD_(0),
             _Dk_=new adf052a6f_Dj_(_c9_.toString()),
             req_Dg_=_Dk_;}
          catch(_Do_)
           {try
             {var
               a90ab7ebb_Dl_=_AD_(0),
               _Dm_=new a90ab7ebb_Dl_(_c8_.toString());}
            catch(_Dn_){throw [0,_d_,_c7_];}
            var req_Dg_=_Dm_;}}}
      req_Dg_.open(method__Cq_.toString(),url_Db_.toString(),_true_wY_);
      if(content_type_Cn_)
       req_Dg_.setRequestHeader
        (_dq_.toString(),content_type_Cn_[1].toString());
      _hq_
       (function(param_Dq_)
         {return req_Dg_.setRequestHeader
                  (param_Dq_[1].toString(),param_Dq_[2].toString());},
        headers_BS_);
      function headers_Dw_(s_Du_)
       {function _Dt_(v_Dr_){return [0,new MlWrappedString(v_Dr_)];}
        function _Dv_(param_Ds_){return 0;}
        return _wD_
                (req_Dg_.getResponseHeader(caml_js_from_byte_string(s_Du_)),
                 _Dv_,
                 _Dt_);}
      var checked_Dx_=[0,0];
      function do_check_headers_DG_(param_DF_)
       {if(checked_Dx_[1]||_g1_(check_headers_BV_,req_Dg_.status,headers_Dw_))
         var _Dy_=0;
        else
         {var
           _DA_=[0,_AG_,[0,req_Dg_.status,headers_Dw_]],
           t_Dz_=repr_rec_ut_(w_Dd_),
           _DB_=t_Dz_[1];
          switch(_DB_[0])
           {case 1:var _DC_=_DB_[1][1]===Canceled_uo_?1:0;break;
            case 2:
             var state_DD_=[1,_DA_],waiters_DE_=_DB_[1][2];
             t_Dz_[1]=state_DD_;
             run_waiters_uU_(waiters_DE_,state_DD_);
             var _DC_=1;
             break;
            default:var _DC_=0;}
          if(!_DC_)_f6_(_eX_);
          req_Dg_.abort();
          var _Dy_=1;}
        _Dy_;
        checked_Dx_[1]=1;
        return 0;}
      req_Dg_.onreadystatechange=
      caml_js_wrap_callback
       (function(param_DL_)
         {switch(req_Dg_.readyState)
           {case 2:if(!onIE_xJ_)return do_check_headers_DG_(0);break;
            case 3:if(onIE_xJ_)return do_check_headers_DG_(0);break;
            case 4:
             do_check_headers_DG_(0);
             var
              _DK_=
               function(param_DJ_)
                {var _DH_=_wT_(req_Dg_.responseXML);
                 if(_DH_)
                  {var doc_DI_=_DH_[1];
                   return _xe_(doc_DI_.documentElement)===null_wt_
                           ?0
                           :[0,doc_DI_];}
                 return 0;};
             return wakeup_uY_
                     (w_Dd_,
                      [0,
                       url_Db_,
                       req_Dg_.status,
                       headers_Dw_,
                       new MlWrappedString(req_Dg_.responseText),
                       _DK_]);
            default:}
          return 0;});
      if(form_arg_B1_)
       {var _DM_=form_arg_B1_[1];
        if(891486873<=_DM_[1])
         {var l_DN_=_DM_[2];
          if(typeof post_encode_Cm_==="number")
           {var _DT_=l_DN_[1];
            req_Dg_.send
             (_xe_
               (_hR_
                  (_dn_,
                   _hd_
                    (function(param_DO_)
                      {var _DP_=param_DO_[2],_DQ_=param_DO_[1];
                       if(781515420<=_DP_[1])
                        {var
                          _DR_=
                           _gi_
                            (_dp_,urlencode_zc_(0,new MlWrappedString(_DP_[2].name)));
                         return _gi_(urlencode_zc_(0,_DQ_),_DR_);}
                       var
                        _DS_=
                         _gi_(_do_,urlencode_zc_(0,new MlWrappedString(_DP_[2])));
                       return _gi_(urlencode_zc_(0,_DQ_),_DS_);},
                     _DT_)).toString
                 ()));}
          else
           {var
             boundary_DU_=post_encode_Cm_[2],
             _DX_=
              function(data_DV_)
               {var data_DW_=_xe_(data_DV_.join(_dy_.toString()));
                return _wU_(req_Dg_.sendAsBinary)
                        ?req_Dg_.sendAsBinary(data_DW_)
                        :req_Dg_.send(data_DW_);},
             _DZ_=l_DN_[1],
             b_DY_=new array_constructor_w1_(),
             _Es_=
              function(param_D0_)
               {b_DY_.push(_gi_(_da_,_gi_(boundary_DU_,_db_)).toString());
                return b_DY_;};
            _wc_
             (_wc_
               (_wp_
                 (function(v_D1_)
                   {b_DY_.push(_gi_(_df_,_gi_(boundary_DU_,_dg_)).toString());
                    var _D2_=v_D1_[2],_D3_=v_D1_[1];
                    if(781515420<=_D2_[1])
                     {var
                       value_D4_=_D2_[2],
                       _D$_=-1041425454,
                       _Ea_=
                        function(file_D__)
                         {var
                           _D7_=_dm_.toString(),
                           _D6_=_dl_.toString(),
                           _D5_=_wX_(value_D4_.name);
                          if(_D5_)
                           var _D8_=_D5_[1];
                          else
                           {var
                             _D9_=_wX_(value_D4_.fileName),
                             _D8_=_D9_?_D9_[1]:_p_(_dz_);}
                          b_DY_.push
                           (_gi_(_dj_,_gi_(_D3_,_dk_)).toString(),_D8_,_D6_,_D7_);
                          b_DY_.push(_dh_.toString(),file_D__,_di_.toString());
                          return return_v7_(0);},
                       _Eb_=_wX_(_xd_(_AB_));
                      if(_Eb_)
                       {var
                         reader_Ec_=new (_Eb_[1])(),
                         match_Ed_=task_v$_(0),
                         res_Ee_=match_Ed_[1],
                         w_Ei_=match_Ed_[2];
                        reader_Ec_.onloadend=
                        handler_xF_
                         (function(param_Ej_)
                           {if(2===reader_Ec_.readyState)
                             {var
                               _Ef_=reader_Ec_.result,
                               _Eg_=
                                caml_equal(typeof _Ef_,_dA_.toString())?_xe_(_Ef_):null_wt_,
                               _Eh_=_wT_(_Eg_);
                              if(!_Eh_)throw [0,_d_,_dB_];
                              wakeup_uY_(w_Ei_,_Eh_[1]);}
                            return _false_wZ_;});
                        on_cancel_wa_
                         (res_Ee_,function(param_Ek_){return reader_Ec_.abort();});
                        if(typeof _D$_==="number")
                         if(-550809787===_D$_)
                          reader_Ec_.readAsDataURL(value_D4_);
                         else
                          if(936573133<=_D$_)
                           reader_Ec_.readAsText(value_D4_);
                          else
                           reader_Ec_.readAsBinaryString(value_D4_);
                        else
                         reader_Ec_.readAsText(value_D4_,_D$_[2]);
                        var _El_=res_Ee_;}
                      else
                       {var fail_En_=function(param_Em_){return _p_(_dD_);};
                        if(typeof _D$_==="number")
                         var
                          _Eo_=
                           -550809787===_D$_
                            ?_wU_(value_D4_.getAsDataURL)
                              ?value_D4_.getAsDataURL()
                              :fail_En_(0)
                            :936573133<=_D$_
                              ?_wU_(value_D4_.getAsText)
                                ?value_D4_.getAsText(_dC_.toString())
                                :fail_En_(0)
                              :_wU_(value_D4_.getAsBinary)
                                ?value_D4_.getAsBinary()
                                :fail_En_(0);
                        else
                         {var
                           e_Ep_=_D$_[2],
                           _Eo_=
                            _wU_(value_D4_.getAsText)
                             ?value_D4_.getAsText(e_Ep_)
                             :fail_En_(0);}
                        var _El_=return_v7_(_Eo_);}
                      return bind_wb_(_El_,_Ea_);}
                    var value_Er_=_D2_[2],_Eq_=_de_.toString();
                    b_DY_.push
                     (_gi_(_dc_,_gi_(_D3_,_dd_)).toString(),value_Er_,_Eq_);
                    return return_v7_(0);},
                  _DZ_),
                _Es_),
              _DX_);}}
        else
         req_Dg_.send(_DM_[2]);}
      else
       req_Dg_.send(null_wt_);
      on_cancel_wa_(res_De_,function(param_Et_){return req_Dg_.abort();});
      return bind_wb_(res_De_,_BT_);}
    function load_image_EJ_(src_EE_)
     {var img_Ev_=createImg_ye_(document_xT_);
      function _Ey_(param_Ew_){return return_v7_(img_Ev_);}
      var match_Ex_=task_v$_(0),w_EA_=match_Ex_[2],t_EB_=match_Ex_[1];
      function cont_EC_(x_Ez_){return wakeup_uY_(w_EA_,x_Ez_);}
      img_Ev_.onload=
      handler_xF_(function(param_ED_){cont_EC_(0);return _false_wZ_;});
      img_Ev_.src=src_EE_;
      return bind_wb_(t_EB_,_Ey_);}
    function create_canvas_EK_(w_EG_,h_EH_)
     {var c_EF_=createCanvas_yk_(window_xS_.document);
      c_EF_.width=w_EG_;
      c_EF_.height=h_EH_;
      return c_EF_;}
    var debug_widget_EL_=createDiv_yc_(document_xT_);
    debug_widget_EL_.style.position=_y_.toString();
    debug_widget_EL_.style.bottom=_x_.toString();
    debug_widget_EL_.style.left=_w_.toString();
    debug_widget_EL_.style.lineHeight=_v_.toString();
    var
     text_size_div_EO_=
      [246,
       function(param_EN_)
        {var d_EM_=createDiv_yc_(document_xT_);
         d_EM_.style.visibility=_Q_.toString();
         d_EM_.style.position=_P_.toString();
         d_EM_.style.whiteSpace=_O_.toString();
         appendChild_xD_(document_xT_.body,d_EM_);
         return d_EM_;}],
     navigator_EP_=window.navigator;
    function default_language_EX_(param_EU_)
     {function _ET_(param_ES_)
       {function _ER_(param_EQ_){return _R_.toString();}
        return _wW_(navigator_EP_.userLanguage,_ER_);}
      return _wW_(navigator_EP_.language,_ET_).substring(0,2);}
    function _EZ_(st_EV_)
     {var
       _EW_=st_EV_.getItem(_S_.toString()),
       _EY_=_EW_==null_wt_?default_language_EX_(0):_EW_;
      return _EY_;}
    var
     language_E0_=
      [0,_wQ_(window_xS_.localStorage,default_language_EX_,_EZ_)];
    _yR_.log(language_E0_[1]);
    function local_messages_E8_(msgs_E1_)
     {return option_AK_(msgs_E1_[language_E0_[1]]);}
    function screen_transform_E9_(canvas_E4_)
     {var
       _E2_=opt_style_BD_(style_AL_.padding,0),
       offset_E3_=opt_style_BD_(style_AL_.border,0.5)+_E2_,
       w_E5_=canvas_E4_.width,
       h_E6_=canvas_E4_.height,
       rx_E7_=_f8_(5,w_E5_/2-offset_E3_);
      return [0,rx_E7_,_f8_(5,h_E6_/2-offset_E3_),w_E5_/2,h_E6_/2];}
    var eps_E__=0.05;
    function from_screen_Ff_(canvas_E$_,x_Fc_,y_Fb_)
     {var
       match_Fa_=screen_transform_E9_(canvas_E$_),
       z_Fd_=
        [-1,
         (x_Fc_-match_Fa_[3])/match_Fa_[1],
         (y_Fb_-match_Fa_[4])/match_Fa_[2]],
       n_Fe_=norm_Bu_(z_Fd_);
      return n_Fe_<=1-eps_E__?z_Fd_:sdiv_Bv_(z_Fd_,n_Fe_/(1-eps_E__));}
    var pi_Fg_=4*Math.atan(1);
    function ellipse_arc_Fp_
     (c_Fh_,cx_Fj_,cy_Fi_,rx_Fl_,ry_Fk_,start_Fo_,fin_Fn_,clock_wise_Fm_)
     {c_Fh_.save();
      c_Fh_.translate(cx_Fj_,cy_Fi_);
      c_Fh_.scale(rx_Fl_,ry_Fk_);
      c_Fh_.arc(0,0,1,start_Fo_,fin_Fn_,clock_wise_Fm_);
      return c_Fh_.restore();}
    var shadow_Fq_=0;
    function _FT_(x_Fr_,f_Fs_){return _gx_(f_Fs_,x_Fr_);}
    function tree_vertice_count_Fu_(n_Ft_)
     {var l_Fy_=n_Ft_[2],_Fx_=1;
      return _g5_
              (function(s_Fw_,n_Fv_)
                {return s_Fw_+tree_vertice_count_Fu_(n_Fv_)|0;},
               _Fx_,
               l_Fy_);}
    function tree_edge_count_FA_(n_Fz_)
     {var l_FE_=n_Fz_[2],_FD_=0;
      return _g5_
              (function(s_FC_,n_FB_)
                {return (s_FC_+1|0)+tree_edge_count_FA_(n_FB_)|0;},
               _FD_,
               l_FE_);}
    function randomize_tree_FS_(n_FF_)
     {var ch_FG_=n_FF_[2],_FH_=ch_FG_.length-1-1|0,_FI_=0;
      if(!(_FH_<_FI_))
       {var i_FJ_=_FH_;
        for(;;)
         {var _FK_=i_FJ_+1|0,v_FQ_=caml_array_get(ch_FG_,i_FJ_);
          if(1073741823<_FK_||!(0<_FK_))
           var _FL_=0;
          else
           for(;;)
            {_uk_[2]=(_uk_[2]+1|0)%55|0;
             var
              newval_FM_=
               caml_array_get(_uk_[1],(_uk_[2]+24|0)%55|0)+
               (caml_array_get(_uk_[1],_uk_[2])^
                caml_array_get(_uk_[1],_uk_[2])>>>
                25&
                31)|
               0;
             caml_array_set(_uk_[1],_uk_[2],newval_FM_);
             var _FN_=newval_FM_&1073741823,v_FO_=caml_mod(_FN_,_FK_);
             if(((1073741823-_FK_|0)+1|0)<(_FN_-v_FO_|0))continue;
             var _FP_=v_FO_,_FL_=1;
             break;}
          if(!_FL_)var _FP_=_f6_(_e9_);
          caml_array_set(ch_FG_,i_FJ_,caml_array_get(ch_FG_,_FP_));
          caml_array_set(ch_FG_,_FP_,v_FQ_);
          var _FR_=i_FJ_-1|0;
          if(_FI_!==i_FJ_){var i_FJ_=_FR_;continue;}
          break;}}
      return _g3_(randomize_tree_FS_,ch_FG_);}
    var
     need_redraw_FU_=[0,0],
     redraw_funct_FW_=[0,function(param_FV_){return 0;}];
    function perform_redraw_FY_(param_FX_)
     {need_redraw_FU_[1]=0;return _gx_(redraw_funct_FW_[1],0);}
    function schedule_redraw_F1_(now_F0_)
     {return need_redraw_FU_[1]
              ?0
              :(need_redraw_FU_[1]=
                1,
                _gx_
                 (_yQ_,
                  caml_js_wrap_callback
                   (function(param_FZ_)
                     {return need_redraw_FU_[1]?perform_redraw_FY_(0):0;})));}
    regexp_yU_(_t_);
    regexp_yU_(_s_);
    regexp_yU_(_r_);
    function compute_text_nodes_Iq_(node_names_F2_,nodes_Gb_)
     {try
       {var _F3_=_hr_(language_E0_[1],node_names_F2_)[1],names_F4_=_F3_;}
      catch(_F5_)
       {if(_F5_[1]!==_c_)throw _F5_;
        try
         {var _F6_=_hr_(_af_.toString(),node_names_F2_)[1],_F7_=_F6_;}
        catch(_F8_){if(_F8_[1]!==_c_)throw _F8_;var _F7_=_ia_(11);}
        var names_F4_=_F7_;}
      try
       {var _F9_=_ib_(names_F4_,_ae_),_F__=_F9_;}
      catch(_F$_){if(_F$_[1]!==_c_)throw _F$_;var _F__=_ad_;}
      document_xT_.title=_F__.toString();
      var _Ga_=0,_Gc_=nodes_Gb_.length-1-1|0;
      if(!(_Gc_<_Ga_))
       {var i_Gd_=_Ga_;
        for(;;)
         {var _Ge_=caml_array_get(nodes_Gb_,i_Gd_),_Gf_=_Ge_[2],_GB_=_Ge_[1];
          if(typeof _Gf_==="number"||!(4204112===_Gf_[1]))
           var _Gg_=0;
          else
           {var
             match_Gh_=_Gf_[2],
             info_Gi_=match_Gh_[3],
             is_root_GA_=match_Gh_[1];
            try
             {var
               _Gj_=_ib_(names_F4_,info_Gi_),
               font_Gk_=opt_style_BD_(style_AL_.nodeFont,_ac_.toString()),
               _Gl_=caml_obj_tag(text_size_div_EO_),
               d_Gm_=
                250===_Gl_
                 ?text_size_div_EO_[1]
                 :246===_Gl_?_im_(text_size_div_EO_):text_size_div_EO_;
              d_Gm_.style.font=font_Gk_;
              var txt_Gn_=document_xT_.createTextNode(_Gj_.toString());
              appendChild_xD_(d_Gm_,txt_Gn_);
              var _Gp_=d_Gm_.clientHeight,_Go_=d_Gm_.clientWidth;
              removeChild_xE_(d_Gm_,txt_Gn_);
              var
               w_Gq_=_Go_+8|0,
               h_Gr_=_Gp_+8|0,
               canvas_Gs_=create_canvas_EK_(w_Gq_,h_Gr_),
               c_Gt_=canvas_Gs_.getContext(_2d__xR_);
              c_Gt_.fillStyle=
              opt_style_BD_(style_AL_.nodeBackgroundColor,tree_color_AH_);
              var _Gu_=0,_Gv_=0,r_Gw_=_f7_(4,_f7_(w_Gq_,h_Gr_)/2);
              c_Gt_.beginPath();
              c_Gt_.moveTo(_Gv_+r_Gw_,_Gu_);
              c_Gt_.arcTo(_Gv_+w_Gq_,_Gu_,_Gv_+w_Gq_,_Gu_+r_Gw_,r_Gw_);
              c_Gt_.arcTo
               (_Gv_+w_Gq_,_Gu_+h_Gr_,_Gv_+w_Gq_-r_Gw_,_Gu_+h_Gr_,r_Gw_);
              c_Gt_.arcTo(_Gv_,_Gu_+h_Gr_,_Gv_,_Gu_+h_Gr_-r_Gw_,r_Gw_);
              c_Gt_.arcTo(_Gv_,_Gu_,_Gv_+r_Gw_,_Gu_,r_Gw_);
              c_Gt_.fill();
              c_Gt_.font=font_Gk_;
              c_Gt_.fillStyle=
              opt_style_BD_(style_AL_.nodeColor,_ab_.toString());
              c_Gt_.textAlign=_aa_.toString();
              c_Gt_.textBaseline=_$_.toString();
              c_Gt_.fillText(_Gj_.toString(),w_Gq_/2,h_Gr_/2);
              var _Gx_=[0,canvas_Gs_],canvas_Gy_=_Gx_;}
            catch(_Gz_){if(_Gz_[1]!==_c_)throw _Gz_;var canvas_Gy_=0;}
            caml_array_set
             (nodes_Gb_,
              i_Gd_,
              [0,_GB_,[0,4204112,[0,is_root_GA_,canvas_Gy_,info_Gi_]]]);
            var _Gg_=1;}
          _Gg_;
          var _GC_=i_Gd_+1|0;
          if(_Gc_!==i_Gd_){var i_Gd_=_GC_;continue;}
          break;}}
      return 0;}
    function weight_sum_GL_(l_GG_)
     {var _GF_=0;
      return _g5_(function(s_GE_,n_GD_){return s_GE_+n_GD_[1];},_GF_,l_GG_);}
    function compute_weights_GJ_(node_GH_)
     {var l_GI_=node_GH_[2];
      if(0===l_GI_.length-1)return [0,1,[0]];
      var l__GK_=_g4_(compute_weights_GJ_,l_GI_);
      return [0,0.6*weight_sum_GL_(l__GK_),l__GK_];}
    function close_button_HU_(over_GS_)
     {var
       color_GM_=opt_style_BD_(style_AL_.buttonColor,_ap_.toString()),
       size_GN_=32,
       offset_GO_=4,
       lw_GP_=4,
       canvas_GQ_=create_canvas_EK_(size_GN_,size_GN_),
       c_GR_=canvas_GQ_.getContext(_2d__xR_);
      c_GR_.save();
      c_GR_.lineWidth=2;
      c_GR_.strokeStyle=color_GM_;
      if(over_GS_){c_GR_.shadowBlur=offset_GO_;c_GR_.shadowColor=color_GM_;}
      c_GR_.beginPath();
      var
       a_GT_=offset_GO_+lw_GP_/Math.sqrt(2),
       b_GU_=size_GN_-offset_GO_-lw_GP_/Math.sqrt(2);
      c_GR_.moveTo(a_GT_,a_GT_);
      c_GR_.lineTo(b_GU_,b_GU_);
      c_GR_.moveTo(a_GT_,b_GU_);
      c_GR_.lineTo(b_GU_,a_GT_);
      c_GR_.stroke();
      c_GR_.restore();
      var _GV_=over_GS_?_ao_:_an_;
      canvas_GQ_.className=_GV_.toString();
      canvas_GQ_.style.position=_am_.toString();
      canvas_GQ_.style.top=_al_.toString();
      canvas_GQ_.style.right=_ak_.toString();
      return canvas_GQ_;}
    function img_button_HZ_(href_G8_,h_GZ_,src_GX_)
     {function decoration_G5_(over_G3_)
       {var img_GW_=createImg_ye_(document_xT_);
        img_GW_.src=icon_AF_(src_GX_);
        var div_GY_=createDiv_yc_(document_xT_);
        div_GY_.style.position=_aC_.toString();
        div_GY_.style.width=_aB_.toString();
        var a64d849eb_G0_=div_GY_.style;
        a64d849eb_G0_.height=
        _gi_(string_of_int_gk_(_f8_(38,h_GZ_)),_aA_).toString();
        div_GY_.style.margin=_az_.toString();
        div_GY_.style.borderRadius=_ay_.toString();
        var extra_G1_=_f8_(6,44-h_GZ_|0),a13470ac0_G2_=div_GY_.style;
        a13470ac0_G2_.padding=
        _jR_(sprintf_t0_,_ax_,extra_G1_/2|0,extra_G1_-(extra_G1_/2|0)|0).toString
         ();
        var _G4_=over_G3_?_aw_:_av_;
        div_GY_.className=_gi_(_au_,_G4_).toString();
        appendChild_xD_(div_GY_,img_GW_);
        return div_GY_;}
      var button_G6_=createDiv_yc_(document_xT_);
      button_G6_.className=_at_.toString();
      button_G6_.style.width=_as_.toString();
      var aa9039393_G7_=button_G6_.style;
      aa9039393_G7_.height=
      _gi_(string_of_int_gk_(8+_f8_(38,h_GZ_)|0),_ar_).toString();
      if(href_G8_)
       {var url_G__=href_G8_[1],a_G9_=createA_yd_(document_xT_);
        a_G9_.target=_aq_.toString();
        a_G9_.href=url_G__;
        appendChild_xD_(button_G6_,a_G9_);
        var container_G$_=a_G9_;}
      else
       var container_G$_=button_G6_;
      appendChild_xD_(container_G$_,decoration_G5_(1));
      appendChild_xD_(container_G$_,decoration_G5_(0));
      return button_G6_;}
    function tooltip_HV_(txt_Hb_)
     {var tooltip_Ha_=createDiv_yc_(document_xT_);
      tooltip_Ha_.style.position=_aE_.toString();
      tooltip_Ha_.className=_aD_.toString();
      tooltip_Ha_.innerHTML=txt_Hb_;
      return tooltip_Ha_;}
    function show_on_click_Im_(button_Hj_,txt_He_)
     {var activated_Hc_=[0,0];
      return button_Hj_.onclick=
             handler_xF_
              (function(ev_Hi_)
                {if(!activated_Hc_[1])
                  {activated_Hc_[1]=1;
                   var c_Hd_=[0,null_wt_];
                   c_Hd_[1]=
                   _xe_
                    (_xH_
                      (document_xT_,
                       click_xK_,
                       handler_xF_
                        (function(ev_Hh_)
                          {function _Hg_(param_Hf_)
                            {_wS_(c_Hd_[1],_xI_);
                             txt_He_.className=_aG_.toString();
                             activated_Hc_[1]=0;
                             return return_v7_(0);}
                           bind_wb_(yield_yP_(0),_Hg_);
                           return _true_wY_;}),
                       _true_wY_));
                   txt_He_.className=_aF_.toString();}
                 stopPropagation_yF_(ev_Hi_);
                 return _false_wZ_;});}
    function show_image_Ir_
     (all_messages_Hk_,image_info_Ip_,name_Hn_,small_image_HC_)
     {return bind_wb_
              (image_info_Ip_,
               function(image_info_Hp_)
                {var
                  messages_Hl_=local_messages_E8_(all_messages_Hk_),
                  i_Hm_=[0,-1],
                  _Ho_=0,
                  _Hq_=image_info_Hp_.length-1-1|0,
                  name_js_Hs_=name_Hn_.toString();
                 if(!(_Hq_<_Ho_))
                  {var j_Hr_=_Ho_;
                   for(;;)
                    {if(name_js_Hs_===caml_array_get(image_info_Hp_,j_Hr_)[1])
                      i_Hm_[1]=j_Hr_;
                     var _Ht_=j_Hr_+1|0;
                     if(_Hq_!==j_Hr_){var j_Hr_=_Ht_;continue;}
                     break;}}
                 if(0<=i_Hm_[1])
                  {var info_Hu_=caml_array_get(image_info_Hp_,i_Hm_[1]);
                   _yR_.log(name_Hn_,i_Hm_[1]);
                   var container_Hv_=createDiv_yc_(document_xT_);
                   container_Hv_.style.margin=_bL_.toString();
                   container_Hv_.style.position=_bK_.toString();
                   container_Hv_.style.top=_bJ_.toString();
                   container_Hv_.style.bottom=_bI_.toString();
                   container_Hv_.style.left=_bH_.toString();
                   container_Hv_.style.right=_bG_.toString();
                   var img_container_Hw_=createDiv_yc_(document_xT_);
                   img_container_Hw_.style.position=_bF_.toString();
                   img_container_Hw_.style.top=_bE_.toString();
                   img_container_Hw_.style.bottom=_bD_.toString();
                   img_container_Hw_.style.left=_bC_.toString();
                   img_container_Hw_.style.right=_bB_.toString();
                   var
                    wrap_HA_=
                     function(elt_Hz_)
                      {var w_Hx_=createDiv_yc_(document_xT_);
                       w_Hx_.style.position=_bS_.toString();
                       w_Hx_.style.top=_bR_.toString();
                       w_Hx_.style.bottom=_bQ_.toString();
                       w_Hx_.style.left=_bP_.toString();
                       w_Hx_.style.right=_bO_.toString();
                       w_Hx_.style.margin=_bN_.toString();
                       var a72a5ce18_Hy_=w_Hx_.style;
                       a72a5ce18_Hy_.maxHeight=
                       _gi_(string_of_int_gk_(info_Hu_[5]),_bM_).toString();
                       appendChild_xD_(w_Hx_,elt_Hz_);
                       return w_Hx_;},
                    img_HB_=createImg_ye_(document_xT_),
                    _HD_=caml_obj_tag(small_image_HC_),
                    _HE_=
                     250===_HD_
                      ?small_image_HC_[1]
                      :246===_HD_?_im_(small_image_HC_):small_image_HC_,
                    _HF_=poll_wd_(_HE_);
                   if(_HF_)
                    {var
                      small_image_HH_=_HF_[1],
                      canvas_HG_=create_canvas_EK_(info_Hu_[4],info_Hu_[5]),
                      c_HI_=canvas_HG_.getContext(_2d__xR_);
                     c_HI_.drawImage(small_image_HH_,0,0,info_Hu_[4],info_Hu_[5]);
                     canvas_HG_.style.display=_bA_.toString();
                     canvas_HG_.style.height=_bz_.toString();
                     canvas_HG_.style.width=_by_.toString();
                     canvas_HG_.style.maxWidth=_bx_.toString();
                     canvas_HG_.style.maxHeight=_bw_.toString();
                     canvas_HG_.style.marginLeft=_bv_.toString();
                     canvas_HG_.style.marginRight=_bu_.toString();
                     var w_HJ_=wrap_HA_(canvas_HG_);
                     appendChild_xD_(img_container_Hw_,w_HJ_);
                     img_HB_.onload=
                     handler_xF_
                      (function(param_HK_)
                        {removeChild_xE_(img_container_Hw_,w_HJ_);
                         return _false_wZ_;});}
                   var
                    _HL_=info_Hu_[7],
                    _HM_=_HL_?_HL_[1]:_gi_(_bs_,_gi_(name_Hn_,_bt_)).toString();
                   img_HB_.src=_HM_;
                   img_HB_.width=info_Hu_[4];
                   img_HB_.height=info_Hu_[5];
                   img_HB_.style.display=_br_.toString();
                   img_HB_.style.height=_bq_.toString();
                   img_HB_.style.width=_bp_.toString();
                   img_HB_.style.maxWidth=_bo_.toString();
                   img_HB_.style.maxHeight=_bn_.toString();
                   img_HB_.style.marginLeft=_bm_.toString();
                   img_HB_.style.marginRight=_bl_.toString();
                   var
                    w_HN_=wrap_HA_(img_HB_),
                    handle_error_HP_=
                     function(param_HO_)
                      {removeChild_xE_(img_container_Hw_,w_HN_);
                       return _false_wZ_;};
                   img_HB_.onerror=handler_xF_(handle_error_HP_);
                   img_HB_.onabort=handler_xF_(handle_error_HP_);
                   appendChild_xD_(img_container_Hw_,w_HN_);
                   appendChild_xD_(container_Hv_,img_container_Hw_);
                   var legend_HQ_=createDiv_yc_(document_xT_);
                   legend_HQ_.innerHTML=info_Hu_[3];
                   legend_HQ_.onclick=
                   handler_xF_
                    (function(ev_HR_)
                      {stopPropagation_yF_(ev_HR_);return _true_wY_;});
                   legend_HQ_.className=_bk_.toString();
                   legend_HQ_.style.position=_bj_.toString();
                   legend_HQ_.style.bottom=_bi_.toString();
                   legend_HQ_.style.marginRight=_bh_.toString();
                   legend_HQ_.style.marginLeft=_bg_.toString();
                   appendChild_xD_(container_Hv_,legend_HQ_);
                   var background_HS_=createDiv_yc_(document_xT_);
                   appendChild_xD_(background_HS_,container_Hv_);
                   background_HS_.className=_bf_.toString();
                   background_HS_.style.width=_be_.toString();
                   background_HS_.style.height=_bd_.toString();
                   background_HS_.style.position=_bc_.toString();
                   background_HS_.style.top=_bb_.toString();
                   background_HS_.style.left=_ba_.toString();
                   background_HS_.style.zIndex=_a$_.toString();
                   var button_HT_=createDiv_yc_(document_xT_);
                   button_HT_.className=_a__.toString();
                   button_HT_.style.position=_a9_.toString();
                   button_HT_.style.top=_a8_.toString();
                   button_HT_.style.right=_a7_.toString();
                   button_HT_.style.cursor=_a6_.toString();
                   appendChild_xD_(button_HT_,close_button_HU_(1));
                   appendChild_xD_(button_HT_,close_button_HU_(0));
                   var
                    tt_HW_=
                     tooltip_HV_
                      (opt_style_BD_(messages_Hl_.close,_a5_.toString()));
                   tt_HW_.style.right=_a4_.toString();
                   tt_HW_.style.top=_a3_.toString();
                   appendChild_xD_(button_HT_,tt_HW_);
                   appendChild_xD_(background_HS_,button_HT_);
                   var buttons_HX_=createDiv_yc_(document_xT_);
                   buttons_HX_.style.position=_a2_.toString();
                   buttons_HX_.style.top=_a1_.toString();
                   buttons_HX_.style.left=_a0_.toString();
                   var
                    suffix_HY_=
                     language_E0_[1]===_aZ_.toString()
                      ?_aY_
                      :_gi_(_aX_,new MlWrappedString(language_E0_[1])),
                    commons_H0_=
                     img_button_HZ_
                      ([0,
                        _gi_(_aW_,_gi_(new MlWrappedString(info_Hu_[2]),suffix_HY_)).toString
                         ()],
                       52,
                       _aV_),
                    tt_H1_=
                     tooltip_HV_
                      (opt_style_BD_
                        (messages_Hl_.wikimediaCommons,_aU_.toString()));
                   tt_H1_.style.left=_aT_.toString();
                   tt_H1_.style.top=_aS_.toString();
                   appendChild_xD_(commons_H0_,tt_H1_);
                   appendChild_xD_(buttons_HX_,commons_H0_);
                   var
                    wikipedia_H2_=img_button_HZ_(0,34,_aR_),
                    txt_H3_=createDiv_yc_(document_xT_),
                    count_H4_=[0,0],
                    dl_H5_=createDl_ya_(document_xT_),
                    list_Ij_=
                     function(title_Ih_,lang_H__)
                      {var
                        ul_H6_=createUl_x$_(document_xT_),
                        empty_H7_=[0,1],
                        _If_=info_Hu_[6];
                       _g3_
                        (function(param_H8_)
                          {var name_H9_=param_H8_[1],refer_Ia_=param_H8_[3];
                           if(param_H8_[2]===lang_H__)
                            {empty_H7_[1]=0;
                             var a_H$_=createA_yd_(document_xT_);
                             appendChild_xD_(a_H$_,document_xT_.createTextNode(name_H9_));
                             a_H$_.target=_bV_.toString();
                             var
                              refer_Ib_=new MlWrappedString(refer_Ia_),
                              _Ic_=
                               0===refer_Ib_.getLen()
                                ?new MlWrappedString(name_H9_)
                                :refer_Ib_,
                              _Id_=_gi_(_bU_,_Ic_);
                             a_H$_.href=
                             _gi_(_bT_,_gi_(new MlWrappedString(lang_H__),_Id_)).toString
                              ();
                             var li_Ie_=createLi_yb_(document_xT_);
                             appendChild_xD_(li_Ie_,a_H$_);
                             return appendChild_xD_(ul_H6_,li_Ie_);}
                           return 0;},
                         _If_);
                       if(empty_H7_[1])return 0;
                       count_H4_[1]+=1;
                       var dd_Ig_=createDd_yf_(document_xT_);
                       appendChild_xD_
                        (dd_Ig_,document_xT_.createTextNode(title_Ih_));
                       appendChild_xD_(dl_H5_,dd_Ig_);
                       var dt_Ii_=createDt_yg_(document_xT_);
                       appendChild_xD_(dt_Ii_,ul_H6_);
                       return appendChild_xD_(dl_H5_,dt_Ii_);},
                    _Ik_=language_E0_[1];
                   list_Ij_
                    (opt_style_BD_(messages_Hl_.language,_aQ_.toString()),_Ik_);
                   if(language_E0_[1]!==_aP_.toString())
                    list_Ij_(_aN_.toString(),_aO_.toString());
                   if(0<count_H4_[1])
                    appendChild_xD_(txt_H3_,dl_H5_);
                   else
                    appendChild_xD_
                     (txt_H3_,
                      document_xT_.createTextNode
                       (opt_style_BD_(messages_Hl_.noRef,_aM_.toString())));
                   txt_H3_.className=_aL_.toString();
                   txt_H3_.style.position=_aK_.toString();
                   txt_H3_.style.left=_aJ_.toString();
                   txt_H3_.style.top=_aI_.toString();
                   txt_H3_.style.whiteSpace=_aH_.toString();
                   appendChild_xD_(wikipedia_H2_,txt_H3_);
                   appendChild_xD_(buttons_HX_,wikipedia_H2_);
                   txt_H3_.onclick=
                   handler_xF_
                    (function(ev_Il_)
                      {stopPropagation_yF_(ev_Il_);return _true_wY_;});
                   show_on_click_Im_(wikipedia_H2_,txt_H3_);
                   buttons_HX_.onclick=
                   handler_xF_
                    (function(ev_In_)
                      {stopPropagation_yF_(ev_In_);return _true_wY_;});
                   appendChild_xD_(background_HS_,buttons_HX_);
                   appendChild_xD_(document_xT_.body,background_HS_);
                   background_HS_.onclick=
                   handler_xF_
                    (function(param_Io_)
                      {removeChild_xE_(document_xT_.body,background_HS_);
                       return _true_wY_;});}
                 return return_v7_(0);});}
    var information_en_Is_=_q_.toString();
    _uj_(_uk_,[0,caml_sys_random_seed(0)]);
    _hq_
     (function(src_It_){load_image_EJ_(icon_AF_(src_It_));return 0;},icons_A_);
    function _Iv_(s_Iu_){return return_v7_(json_BI_.parse(s_Iu_.toString()));}
    var _KM_=bind_wb_(http_get_EI_(_U_),_Iv_);
    function _KN_(s_Iw_)
     {var
       info_Ix_=json_BI_.parse(s_Iw_.toString()),
       tree_Iy_=info_Ix_[1],
       node_names_Iz_=info_Ix_[2];
      randomize_tree_FS_(tree_Iy_);
      var
       node_names_I1_=
        _FT_
         (_FT_
           (node_names_Iz_,
            _gx_
             (_g4_,
              function(param_IA_)
               {var
                 about_IE_=param_IA_[3],
                 tbl_ID_=param_IA_[2],
                 lang_IC_=param_IA_[1],
                 h_IB_=_ia_(101);
                _g3_
                 (function(param_IF_)
                   {var
                     _IG_=new MlWrappedString(param_IF_[1]),
                     _II_=new MlWrappedString(param_IF_[2]),
                     _IH_=h_IB_[2].length-1,
                     i_IJ_=caml_mod(_hY_(_IG_),_IH_);
                    caml_array_set
                     (h_IB_[2],
                      i_IJ_,
                      [0,_IG_,_II_,caml_array_get(h_IB_[2],i_IJ_)]);
                    h_IB_[1]=h_IB_[1]+1|0;
                    var _IK_=h_IB_[2].length-1<<1<h_IB_[1]?1:0;
                    if(_IK_)
                     {var
                       odata_IL_=h_IB_[2],
                       osize_IM_=odata_IL_.length-1,
                       nsize_IN_=_f7_((2*osize_IM_|0)+1|0,_hT_),
                       _IO_=nsize_IN_!==osize_IM_?1:0;
                      if(_IO_)
                       {var
                         ndata_IP_=caml_make_vect(nsize_IN_,0),
                         insert_bucket_IS_=
                          function(param_IQ_)
                           {if(param_IQ_)
                             {var key_IR_=param_IQ_[1],data_IT_=param_IQ_[2];
                              insert_bucket_IS_(param_IQ_[3]);
                              var nidx_IU_=caml_mod(_hY_(key_IR_),nsize_IN_);
                              return caml_array_set
                                      (ndata_IP_,
                                       nidx_IU_,
                                       [0,key_IR_,data_IT_,caml_array_get(ndata_IP_,nidx_IU_)]);}
                            return 0;},
                         _IV_=0,
                         _IW_=osize_IM_-1|0;
                        if(!(_IW_<_IV_))
                         {var i_IX_=_IV_;
                          for(;;)
                           {insert_bucket_IS_(caml_array_get(odata_IL_,i_IX_));
                            var _IY_=i_IX_+1|0;
                            if(_IW_!==i_IX_){var i_IX_=_IY_;continue;}
                            break;}}
                        h_IB_[2]=ndata_IP_;
                        var _IZ_=0;}
                      else
                       var _IZ_=_IO_;
                      var _I0_=_IZ_;}
                    else
                     var _I0_=_IK_;
                    return _I0_;},
                  tbl_ID_);
                return [0,lang_IC_,[0,h_IB_,about_IE_]];})),
          _g6_);
      function compute_Jb_(is_root_I$_,n_I2_)
       {var _I3_=new MlWrappedString(n_I2_[1]),ch_Ja_=n_I2_[2];
        if(0===_I3_.getLen())
         var info_I4_=870530776;
        else
         if(124===_I3_.safeGet(0))
          {var
            _I5_=_hP_(_I3_,1,_I3_.getLen()-1|0),
            info_I4_=
             [0,
              3654627,
              [0,
               [246,
                function(param_I__)
                 {function _I9_(param_I8_)
                   {function _I7_(img_I6_)
                     {schedule_redraw_F1_(0);return return_v7_(img_I6_);}
                    return bind_wb_
                            (load_image_EJ_(_gi_(_Z_,_gi_(_I5_,___)).toString()),_I7_);}
                  return bind_wb_(yield_yP_(0),_I9_);}],
               _I5_]];}
         else
          var info_I4_=[0,4204112,[0,is_root_I$_,0,_I3_]];
        return [0,
                info_I4_,
                _g4_(function(n_Jc_){return compute_Jb_(0,n_Jc_);},ch_Ja_)];}
      var
       _Jd_=compute_Jb_(1,tree_Iy_),
       node_count_Je_=tree_vertice_count_Fu_(_Jd_),
       vertices_Jf_=caml_make_vect(node_count_Je_,zero_h_),
       edges_Jg_=caml_make_vect(tree_edge_count_FA_(_Jd_),_ai_),
       nodes_Jh_=caml_make_vect(node_count_Je_,[0,[0],870530776]),
       vi_Ji_=[0,0],
       ei_Jj_=[0,0],
       weights_JV_=compute_weights_GJ_(_Jd_);
      function layout_rec_JI_
       (current_Jk_,
        current_weights_Jm_,
        is_root_Jt_,
        transf_Jq_,
        lineWidth_JH_,
        dir_Jz_)
       {var
         ch_Jl_=current_Jk_[2],
         ch_weights_Jn_=current_weights_Jm_[2],
         i_Jo_=vi_Ji_[1],
         info_Jp_=current_Jk_[1];
        vi_Ji_[1]+=1;
        caml_array_set(vertices_Jf_,i_Jo_,transf_Jq_[1]);
        if(0===ch_Jl_.length-1)
         var ch__Jr_=[0];
        else
         {var
           total_weight_Js_=weight_sum_GL_(ch_weights_Jn_),
           j_Jv_=[0,0],
           _Ju_=
            is_root_Jt_
             ?(total_weight_Js_-caml_array_get(ch_weights_Jn_,0)[1])/2
             :0,
           w0_Jw_=[0,_Ju_],
           _JN_=
            function(node_JJ_,weights_Jx_)
             {var
               w_Jy_=weights_Jx_[1],
               angle_JA_=Math.acos(dir_Jz_[1])*w_Jy_/total_weight_Js_,
               th_JB_=
                Math.acos(dir_Jz_[1])*
                ((w0_Jw_[1]+w_Jy_/2)/total_weight_Js_*2-1);
              j_Jv_[1]+=1;
              w0_Jw_[1]=w0_Jw_[1]+w_Jy_;
              var
               min_angle_JC_=pi_Fg_/3,
               a_JD_=
                [-1,
                 (Math.cos(angle_JA_)-Math.cos(min_angle_JC_))/
                 (1-Math.cos(min_angle_JC_+angle_JA_)),
                 0],
               dir_JE_=[-1,Math.cos(min_angle_JC_),Math.sin(min_angle_JC_)],
               match_JF_=
                0.25<a_JD_[1]
                 ?[0,a_JD_,dir_JE_]
                 :[0,
                   a_f_,
                   _g1_
                    (transl_BF_,
                     neg_BE_(a_f_),
                     [-1,Math.cos(angle_JA_),Math.sin(angle_JA_)])],
               dir_JG_=match_JF_[2],
               ch_JK_=
                layout_rec_JI_
                 (node_JJ_,
                  weights_Jx_,
                  0,
                  compose_BG_
                   (compose_BG_
                     ([0,match_JF_[1],one_g_],
                      [0,zero_h_,[-1,Math.cos(th_JB_),Math.sin(th_JB_)]]),
                    transf_Jq_),
                  lineWidth_JH_*0.94,
                  dir_JG_),
               i__JM_=ch_JK_[1],
               k_JL_=ei_Jj_[1];
              ei_Jj_[1]+=1;
              caml_array_set(edges_Jg_,k_JL_,[0,i_Jo_,i__JM_,lineWidth_JH_]);
              return ch_JK_;},
           l_JO_=ch_Jl_.length-1;
          if(ch_weights_Jn_.length-1!==l_JO_)throw [0,_d_,_ag_];
          if(0===l_JO_)
           var _JP_=[0];
          else
           {var
             r_JQ_=
              caml_make_vect
               (l_JO_,
                _JN_
                 (caml_array_get(ch_Jl_,0),caml_array_get(ch_weights_Jn_,0))),
             _JR_=1,
             _JS_=l_JO_-1|0;
            if(!(_JS_<_JR_))
             {var i_JT_=_JR_;
              for(;;)
               {caml_array_set
                 (r_JQ_,
                  i_JT_,
                  _JN_
                   (caml_array_get(ch_Jl_,i_JT_),
                    caml_array_get(ch_weights_Jn_,i_JT_)));
                var _JU_=i_JT_+1|0;
                if(_JS_!==i_JT_){var i_JT_=_JU_;continue;}
                break;}}
            var _JP_=r_JQ_;}
          var ch__Jr_=_JP_;}
        caml_array_set(nodes_Jh_,i_Jo_,[0,[0],info_Jp_]);
        return [0,i_Jo_,ch__Jr_];}
      var
       tree_JW_=layout_rec_JI_(_Jd_,weights_JV_,1,[0,zero_h_,one_g_],6,_ah_),
       frontiers_JX_=caml_make_vect(nodes_Jh_.length-1,[0,[0],[0]]);
      function node_info_J7_(param_JY_){return param_JY_[1];}
      function status_J4_(i_JZ_)
       {return [0,i_JZ_,870530776!==caml_array_get(nodes_Jh_,i_JZ_)[2]?1:0];}
      function compute_frontiers_J3_(node_J0_)
       {var l_J1_=node_J0_[2],i_J2_=node_J0_[1];
        _g3_(compute_frontiers_J3_,l_J1_);
        if(0===l_J1_.length-1)
         {var _J5_=[0,status_J4_(i_J2_)],_J6_=[0,[0,status_J4_(i_J2_)],_J5_];}
        else
         {var
           _J8_=
            caml_array_get
              (frontiers_JX_,
               node_info_J7_(caml_array_get(l_J1_,l_J1_.length-1-1|0)))
             [2],
           _J6_=
            [0,
             caml_array_get
               (frontiers_JX_,node_info_J7_(caml_array_get(l_J1_,0)))
              [1],
             _J8_];}
        return caml_array_set(frontiers_JX_,i_J2_,_J6_);}
      compute_frontiers_J3_(tree_JW_);
      var neighboors_J9_=caml_make_vect(nodes_Jh_.length-1,[0]);
      function compute_neigh_KG_(node_J__,parent_Ke_,lft_Kd_,rght_Kc_)
       {var
         ch_J$_=node_J__[2],
         i_Ka_=node_J__[1],
         aa_Kf_=
          [0,
           parent_Ke_,
           [0,
            lft_Kd_,
            [0,
             rght_Kc_,
             [0,
              _g4_
               (function(n_Kb_){return status_J4_(node_info_J7_(n_Kb_));},
                ch_J$_),
              0]]]];
        for(;;)
         {if(aa_Kf_)
           {var a_Kg_=aa_Kf_[1],rem_Kx_=aa_Kf_[2];
            if(!(0<a_Kg_.length-1)){var aa_Kf_=rem_Kx_;continue;}
            var accu_Kh_=0,param_Ki_=aa_Kf_,_Kl_=a_Kg_[0+1];
            for(;;)
             {if(param_Ki_)
               {var
                 t_Kk_=param_Ki_[2],
                 _Kj_=accu_Kh_+(param_Ki_[1].length-1)|0,
                 accu_Kh_=_Kj_,
                 param_Ki_=t_Kk_;
                continue;}
              var
               res_Km_=caml_make_vect(accu_Kh_,_Kl_),
               pos_Kn_=0,
               param_Ko_=aa_Kf_;
              for(;;)
               {if(param_Ko_)
                 {var
                   h_Kp_=param_Ko_[1],
                   _Kq_=0,
                   _Kr_=h_Kp_.length-1-1|0,
                   t_Ku_=param_Ko_[2];
                  if(!(_Kr_<_Kq_))
                   {var i_Ks_=_Kq_;
                    for(;;)
                     {res_Km_[(pos_Kn_+i_Ks_|0)+1]=h_Kp_[i_Ks_+1];
                      var _Kt_=i_Ks_+1|0;
                      if(_Kr_!==i_Ks_){var i_Ks_=_Kt_;continue;}
                      break;}}
                  var
                   _Kv_=pos_Kn_+(h_Kp_.length-1)|0,
                   pos_Kn_=_Kv_,
                   param_Ko_=t_Ku_;
                  continue;}
                var _Kw_=res_Km_;
                break;}
              break;}}
          else
           var _Kw_=[0];
          caml_array_set(neighboors_J9_,i_Ka_,_Kw_);
          var
           is_root_Ky_=0===parent_Ke_.length-1?1:0,
           n_Kz_=ch_J$_.length-1,
           _KA_=0,
           _KB_=n_Kz_-1|0;
          if(!(_KB_<_KA_))
           {var j_KC_=_KA_;
            for(;;)
             {var
               lft_KD_=
                0<j_KC_
                 ?caml_array_get
                    (frontiers_JX_,
                     node_info_J7_(caml_array_get(ch_J$_,j_KC_-1|0)))
                   [2]
                 :is_root_Ky_
                   ?caml_array_get
                      (frontiers_JX_,
                       node_info_J7_(caml_array_get(ch_J$_,n_Kz_-1|0)))
                     [2]
                   :lft_Kd_,
               rght_KE_=
                j_KC_<(n_Kz_-1|0)
                 ?caml_array_get
                    (frontiers_JX_,
                     node_info_J7_(caml_array_get(ch_J$_,j_KC_+1|0)))
                   [1]
                 :is_root_Ky_
                   ?caml_array_get
                      (frontiers_JX_,node_info_J7_(caml_array_get(ch_J$_,0)))
                     [1]
                   :rght_Kc_,
               _KF_=[0,status_J4_(i_Ka_)];
              compute_neigh_KG_
               (caml_array_get(ch_J$_,j_KC_),_KF_,lft_KD_,rght_KE_);
              var _KH_=j_KC_+1|0;
              if(_KB_!==j_KC_){var j_KC_=_KH_;continue;}
              break;}}
          return 0;}}
      compute_neigh_KG_(tree_JW_,[0],[0],[0]);
      var _KI_=0,_KJ_=nodes_Jh_.length-1-1|0;
      if(!(_KJ_<_KI_))
       {var i_KK_=_KI_;
        for(;;)
         {caml_array_set
           (nodes_Jh_,
            i_KK_,
            [0,
             caml_array_get(neighboors_J9_,i_KK_),
             caml_array_get(nodes_Jh_,i_KK_)[2]]);
          var _KL_=i_KK_+1|0;
          if(_KJ_!==i_KK_){var i_KK_=_KL_;continue;}
          break;}}
      compute_text_nodes_Iq_(node_names_I1_,nodes_Jh_);
      return return_v7_
              ([0,
                [0,
                 vertices_Jf_,
                 edges_Jg_,
                 nodes_Jh_,
                 [0,
                  caml_make_vect(node_count_Je_,0),
                  caml_make_vect(node_count_Je_,0),
                  caml_make_vect(node_count_Je_,0),
                  caml_make_vect(node_count_Je_,0)]],
                node_names_I1_]);}
    var _KP_=bind_wb_(http_get_EI_(tree_url_u_),_KN_);
    function _KQ_(s_KO_){return return_v7_(json_BI_.parse(s_KO_.toString()));}
    var _KR_=bind_wb_(http_get_EI_(_aj_),_KQ_);
    window_xS_.onload=
    handler_xF_
     (function(param_Pm_)
       {try
         {createCanvas_yk_(window_xS_.document);
          var
           _Pe_=
            repr_uX_
              (bind_wb_
                (_KP_,
                 function(param_KS_)
                  {var
                    tree_i18n_KT_=param_KS_[2],
                    match_KU_=param_KS_[1],
                    boxes_KV_=match_KU_[4],
                    nodes_KW_=match_KU_[3],
                    edges_KX_=match_KU_[2],
                    vertices_KY_=match_KU_[1];
                   return bind_wb_
                           (_KM_,
                            function(all_messages_NE_)
                             {var page_KZ_=document_xT_.documentElement;
                              page_KZ_.style.overflow=_cl_.toString();
                              page_KZ_.style.height=_ck_.toString();
                              document_xT_.body.style.overflow=_cj_.toString();
                              document_xT_.body.style.margin=_ci_.toString();
                              document_xT_.body.style.height=_ch_.toString();
                              var
                               canvas_K0_=
                                create_canvas_EK_
                                 (page_KZ_.clientWidth,page_KZ_.clientHeight);
                              appendChild_xD_(document_xT_.body,canvas_K0_);
                              var
                               tr_K1_=[0,[0,zero_h_,one_g_]],
                               tr__K2_=[0,tr_K1_[1]],
                               l_K3_=vertices_KY_.length-1;
                              if(0===l_K3_)
                               var vertices__K4_=[0];
                              else
                               {var
                                 res_K5_=caml_make_vect(l_K3_,vertices_KY_[0+1]),
                                 _K6_=1,
                                 _K7_=l_K3_-1|0;
                                if(!(_K7_<_K6_))
                                 {var i_K8_=_K6_;
                                  for(;;)
                                   {res_K5_[i_K8_+1]=vertices_KY_[i_K8_+1];
                                    var _K9_=i_K8_+1|0;
                                    if(_K7_!==i_K8_){var i_K8_=_K9_;continue;}
                                    break;}}
                                var vertices__K4_=res_K5_;}
                              redraw_funct_FW_[1]=
                              function(param_MZ_)
                               {need_redraw_FU_[1]=0;
                                _yR_.time(_cn_.toString());
                                var
                                 w_K__=page_KZ_.clientWidth,
                                 h_K$_=page_KZ_.clientHeight,
                                 _La_=
                                  w_K__!==canvas_K0_.width?0:h_K$_!==canvas_K0_.height?0:1;
                                if(!_La_){canvas_K0_.width=w_K__;canvas_K0_.height=h_K$_;}
                                var
                                 _Lb_=tr__K2_[1],
                                 t_Lc_=_Lb_[2],
                                 p_Ld_=_Lb_[1],
                                 _Le_=0,
                                 _Lf_=vertices_KY_.length-1-1|0,
                                 c_Lh_=mul_Bg_(conj_Be_(p_Ld_),t_Lc_);
                                if(!(_Lf_<_Le_))
                                 {var i_Lg_=_Le_;
                                  for(;;)
                                   {caml_array_set
                                     (vertices__K4_,
                                      i_Lg_,
                                      transf_Bh_
                                       (t_Lc_,
                                        p_Ld_,
                                        c_Lh_,
                                        one_g_,
                                        caml_array_get(vertices_KY_,i_Lg_)));
                                    var _Li_=i_Lg_+1|0;
                                    if(_Lf_!==i_Lg_){var i_Lg_=_Li_;continue;}
                                    break;}}
                                _yR_.timeEnd(_cm_.toString());
                                _yR_.time(_Y_.toString());
                                var
                                 c_Lj_=canvas_K0_.getContext(_2d__xR_),
                                 transf_Lk_=screen_transform_E9_(canvas_K0_),
                                 dy_Ll_=transf_Lk_[4],
                                 dx_Lm_=transf_Lk_[3],
                                 ry_Lo_=transf_Lk_[2],
                                 rx_Ln_=transf_Lk_[1];
                                c_Lj_.clearRect(0,0,canvas_K0_.width,canvas_K0_.height);
                                var padding_Lp_=opt_style_BD_(style_AL_.padding,0);
                                c_Lj_.beginPath();
                                ellipse_arc_Fp_
                                 (c_Lj_,
                                  dx_Lm_,
                                  dy_Ll_,
                                  rx_Ln_+padding_Lp_,
                                  ry_Lo_+padding_Lp_,
                                  0,
                                  7,
                                  _false_wZ_);
                                function _Lr_(color_Lq_)
                                 {c_Lj_.fillStyle=color_Lq_;return c_Lj_.fill();}
                                _wV_(style_AL_.backgroundColor,_Lr_);
                                function _Lt_(color_Ls_)
                                 {c_Lj_.lineWidth=1;
                                  c_Lj_.strokeStyle=color_Ls_;
                                  return c_Lj_.stroke();}
                                _wV_(style_AL_.boundaryColor,_Lt_);
                                c_Lj_.lineWidth=2;
                                c_Lj_.lineCap=_X_.toString();
                                c_Lj_.strokeStyle=
                                opt_style_BD_(style_AL_.treeColor,tree_color_AH_);
                                var
                                 ry_Lu_=transf_Lk_[2],
                                 rx_Lv_=transf_Lk_[1],
                                 _Lw_=0,
                                 _Lx_=edges_KX_.length-1-1|0;
                                if(!(_Lx_<_Lw_))
                                 {var i_Ly_=_Lw_;
                                  for(;;)
                                   {var
                                     match_Lz_=caml_array_get(edges_KX_,i_Ly_),
                                     z_LA_=caml_array_get(vertices__K4_,match_Lz_[1]),
                                     z__LB_=caml_array_get(vertices__K4_,match_Lz_[2]),
                                     x_LC_=z_LA_[1]-z__LB_[1],
                                     y_LD_=z_LA_[2]-z__LB_[2],
                                     w_LE_=match_Lz_[3];
                                    if(4<rx_Lv_*ry_Lu_*(x_LC_*x_LC_+y_LD_*y_LD_))
                                     {c_Lj_.lineWidth=w_LE_;
                                      var d_LF_=2*(z_LA_[1]*z__LB_[2]-z_LA_[2]*z__LB_[1]);
                                      if(Math.abs(d_LF_)<0.05)
                                       {var
                                         dy_LG_=transf_Lk_[4],
                                         dx_LH_=transf_Lk_[3],
                                         ry_LI_=transf_Lk_[2],
                                         rx_LJ_=transf_Lk_[1];
                                        c_Lj_.beginPath();
                                        c_Lj_.moveTo(z_LA_[1]*rx_LJ_+dx_LH_,z_LA_[2]*ry_LI_+dy_LG_);
                                        c_Lj_.lineTo
                                         (z__LB_[1]*rx_LJ_+dx_LH_,z__LB_[2]*ry_LI_+dy_LG_);
                                        c_Lj_.stroke();}
                                      else
                                       {var
                                         n1_LK_=sq_norm_AS_(z_LA_)+1,
                                         n2_LL_=sq_norm_AS_(z__LB_)+1,
                                         z0_LM_=
                                          [-1,
                                           (z__LB_[2]*n1_LK_-z_LA_[2]*n2_LL_)/d_LF_,
                                           (z_LA_[1]*n2_LL_-z__LB_[1]*n1_LK_)/d_LF_],
                                         dy_LN_=transf_Lk_[4],
                                         dx_LO_=transf_Lk_[3],
                                         ry_LP_=transf_Lk_[2],
                                         rx_LQ_=transf_Lk_[1],
                                         rd_LR_=norm_Bu_(sub_Bx_(z_LA_,z0_LM_)),
                                         start_LS_=Math.atan2(z_LA_[2]-z0_LM_[2],z_LA_[1]-z0_LM_[1]),
                                         fin_LT_=Math.atan2(z__LB_[2]-z0_LM_[2],z__LB_[1]-z0_LM_[1]);
                                        c_Lj_.beginPath();
                                        var alpha_LU_=(fin_LT_-start_LS_+2*pi_Fg_)%(2*pi_Fg_);
                                        if(rx_LQ_==ry_LP_)
                                         c_Lj_.arc
                                          (z0_LM_[1]*rx_LQ_+dx_LO_,
                                           z0_LM_[2]*rx_LQ_+dy_LN_,
                                           rd_LR_*rx_LQ_,
                                           start_LS_,
                                           fin_LT_,
                                           !!(pi_Fg_<alpha_LU_?1:0));
                                        else
                                         ellipse_arc_Fp_
                                          (c_Lj_,
                                           z0_LM_[1]*rx_LQ_+dx_LO_,
                                           z0_LM_[2]*ry_LP_+dy_LN_,
                                           rd_LR_*rx_LQ_,
                                           rd_LR_*ry_LP_,
                                           start_LS_,
                                           fin_LT_,
                                           !!(pi_Fg_<alpha_LU_?1:0));
                                        c_Lj_.stroke();}}
                                    var _LV_=i_Ly_+1|0;
                                    if(_Lx_!==i_Ly_){var i_Ly_=_LV_;continue;}
                                    break;}}
                                var
                                 image_count_LW_=[0,0],
                                 large_image_count_LX_=[0,0],
                                 _LY_=0,
                                 _LZ_=nodes_KW_.length-1-1|0;
                                if(!(_LZ_<_LY_))
                                 {var i_L0_=_LY_;
                                  for(;;)
                                   {var
                                     match_L1_=caml_array_get(nodes_KW_,i_L0_),
                                     img_L2_=match_L1_[2],
                                     l_L3_=match_L1_[1];
                                    if(typeof img_L2_==="number")
                                     var _L4_=0;
                                    else
                                     {if(4204112<=img_L2_[1])
                                       {var _L5_=img_L2_[2],_L6_=_L5_[2];
                                        if(_L6_)
                                         {var
                                           txt_L7_=_L6_[1],
                                           z_L8_=caml_array_get(vertices__K4_,i_L0_),
                                           circle_Ma_=_L5_[1],
                                           _L$_=1,
                                           r2_Mc_=
                                            _g5_
                                             (function(z_L8_)
                                                {return function(r2_L__,param_L9_)
                                                  {return _f7_
                                                           (r2_L__,
                                                            sq_norm_AS_
                                                             (sub_Bx_(caml_array_get(vertices__K4_,param_L9_[1]),z_L8_)));};}
                                               (z_L8_),
                                              _L$_,
                                              l_L3_),
                                           w_Mb_=txt_L7_.width,
                                           h_Md_=txt_L7_.height,
                                           img_d_Me_=Math.sqrt(w_Mb_*w_Mb_+h_Md_*h_Md_),
                                           rd_Mf_=Math.sqrt(r2_Mc_*rx_Lv_*ry_Lu_)*0.5,
                                           rd_Mg_=img_d_Me_/2<rd_Mf_?img_d_Me_/2:rd_Mf_,
                                           w_Mh_=w_Mb_/img_d_Me_*rd_Mg_,
                                           h_Mi_=h_Md_/img_d_Me_*rd_Mg_;
                                          if(circle_Ma_)
                                           {c_Lj_.beginPath();
                                            c_Lj_.fillStyle=
                                            opt_style_BD_(style_AL_.nodeBackgroundColor,tree_color_AH_);
                                            c_Lj_.arc
                                             (z_L8_[1]*rx_Lv_+dx_Lm_,
                                              z_L8_[2]*ry_Lu_+dy_Ll_,
                                              Math.sqrt(w_Mh_*w_Mh_+h_Mi_*h_Mi_),
                                              0,
                                              7,
                                              _false_wZ_);
                                            c_Lj_.fill();}
                                          c_Lj_.drawImage
                                           (txt_L7_,
                                            z_L8_[1]*rx_Lv_+dx_Lm_-w_Mh_,
                                            z_L8_[2]*ry_Lu_+dy_Ll_-h_Mi_,
                                            2*w_Mh_,
                                            2*h_Mi_);
                                          var _Mj_=1;}
                                        else
                                         {var _L4_=0,_Mj_=0;}}
                                      else
                                       {var img_Mk_=img_L2_[2][1];
                                        caml_array_set(boxes_KV_[3],i_L0_,0);
                                        var
                                         z_Ml_=caml_array_get(vertices__K4_,i_L0_),
                                         min_scale_MC_=
                                          function(z_Ml_)
                                            {return function(l_Mp_,w_Mu_,h_Mw_,s_Mm_)
                                              {var s_Mn_=[0,s_Mm_],_Mo_=0,_Mq_=l_Mp_.length-1-1|0;
                                               if(!(_Mq_<_Mo_))
                                                {var i_Mr_=_Mo_;
                                                 for(;;)
                                                  {var
                                                    match_Ms_=caml_array_get(l_Mp_,i_Mr_),
                                                    j_Mt_=match_Ms_[1],
                                                    sx_Mv_=
                                                     Math.abs(caml_array_get(vertices__K4_,j_Mt_)[1]-z_Ml_[1])/
                                                     w_Mu_,
                                                    sy_Mx_=
                                                     Math.abs(caml_array_get(vertices__K4_,j_Mt_)[2]-z_Ml_[2])/
                                                     h_Mw_,
                                                    large_Mz_=match_Ms_[2],
                                                    s__My_=sy_Mx_<sx_Mv_?sx_Mv_:sy_Mx_,
                                                    s__MA_=large_Mz_?s__My_:1.9*s__My_;
                                                   if(s__MA_<s_Mn_[1])s_Mn_[1]=s__MA_;
                                                   var _MB_=i_Mr_+1|0;
                                                   if(_Mq_!==i_Mr_){var i_Mr_=_MB_;continue;}
                                                   break;}}
                                               return s_Mn_[1];};}
                                           (z_Ml_);
                                        if(caml_obj_tag(img_Mk_)!==_il_)
                                         {var
                                           _MD_=caml_obj_tag(img_Mk_),
                                           _ME_=250===_MD_?img_Mk_[1]:246===_MD_?_im_(img_Mk_):img_Mk_,
                                           _MF_=poll_wd_(_ME_);
                                          if(_MF_)
                                           {var
                                             img_MG_=_MF_[1],
                                             w_MH_=img_MG_.width,
                                             h_MI_=img_MG_.height,
                                             s_MJ_=min_scale_MC_(l_L3_,1,1,1),
                                             scale_MK_=s_MJ_/_f8_(w_MH_/rx_Lv_,h_MI_/ry_Lu_),
                                             w_ML_=w_MH_*scale_MK_/2,
                                             h_MM_=h_MI_*scale_MK_/2;
                                            if(1<w_ML_&&1<h_MM_)
                                             {if(shadow_Fq_)
                                               {c_Lj_.save();
                                                var
                                                 blur_MN_=7*scale_MK_,
                                                 offset_MO_=5*scale_MK_,
                                                 _MP_=blur_MN_<1?0:blur_MN_;
                                                c_Lj_.shadowBlur=_MP_;
                                                var _MQ_=blur_MN_<1?0:offset_MO_;
                                                c_Lj_.shadowOffsetX=_MQ_;
                                                var _MR_=blur_MN_<1?0:offset_MO_;
                                                c_Lj_.shadowOffsetY=_MR_;
                                                c_Lj_.shadowColor=_W_.toString();}
                                              var
                                               x_MS_=z_Ml_[1]*rx_Lv_+dx_Lm_,
                                               y_MT_=z_Ml_[2]*ry_Lu_+dy_Ll_;
                                              c_Lj_.drawImage
                                               (img_MG_,x_MS_-w_ML_,y_MT_-h_MM_,2*w_ML_,2*h_MM_);
                                              if(shadow_Fq_)c_Lj_.restore();
                                              caml_array_set(boxes_KV_[1],i_L0_,x_MS_);
                                              caml_array_set(boxes_KV_[2],i_L0_,y_MT_);
                                              caml_array_set(boxes_KV_[3],i_L0_,w_ML_);
                                              caml_array_set(boxes_KV_[4],i_L0_,h_MM_);
                                              image_count_LW_[1]+=1;
                                              var
                                               _MU_=
                                                2<=w_ML_?2<=h_MM_?(large_image_count_LX_[1]+=1,1):0:0;
                                              _MU_;
                                              var _MV_=1;}
                                            else
                                             var _MV_=0;
                                            _MV_;}}
                                        else
                                         {var s_MW_=min_scale_MC_(l_L3_,1,1,1);
                                          if(1<s_MW_*_f8_(rx_Lv_,ry_Lu_))
                                           {var _MX_=caml_obj_tag(img_Mk_);
                                            if(250!==_MX_&&246===_MX_)_im_(img_Mk_);}}
                                        var _Mj_=1;}
                                      if(_Mj_)var _L4_=1;}
                                    _L4_;
                                    var _MY_=i_L0_+1|0;
                                    if(_LZ_!==i_L0_){var i_L0_=_MY_;continue;}
                                    break;}}
                                _yR_.timeEnd(_V_.toString());
                                return _yR_.log(image_count_LW_[1],large_image_count_LX_[1]);};
                              perform_redraw_FY_(0);
                              window_xS_.onresize=
                              handler_xF_
                               (function(param_M4_)
                                 {var
                                   page_M0_=document_xT_.documentElement,
                                   w_M1_=page_M0_.clientWidth,
                                   h_M2_=page_M0_.clientHeight;
                                  _jR_(sprintf_t0_,_co_,w_M1_,h_M2_);
                                  var
                                   _M3_=
                                    w_M1_!==canvas_K0_.width?0:h_M2_!==canvas_K0_.height?0:1;
                                  if(!_M3_)schedule_redraw_F1_(1);
                                  return _true_wY_;});
                              function find_box_Nc_(boxes_M7_,x_M__,y_M$_)
                               {var p_M5_=[0,-1],_M6_=0,_M8_=boxes_M7_[3].length-1-1|0;
                                if(!(_M8_<_M6_))
                                 {var i_M9_=_M6_;
                                  for(;;)
                                   {var
                                     _Na_=
                                      0<boxes_M7_[3][i_M9_+1]
                                       ?Math.abs(x_M__-boxes_M7_[1][i_M9_+1])<boxes_M7_[3][i_M9_+1]
                                         ?Math.abs(y_M$_-boxes_M7_[2][i_M9_+1])<boxes_M7_[4][i_M9_+1]
                                           ?(p_M5_[1]=i_M9_,1)
                                           :0
                                         :0
                                       :0;
                                    _Na_;
                                    var _Nb_=i_M9_+1|0;
                                    if(_M8_!==i_M9_){var i_M9_=_Nb_;continue;}
                                    break;}}
                                return p_M5_[1];}
                              var on_image_Nd_=[0,0];
                              function update_cursor_Nh_(x_Nf_,y_Ne_)
                               {return -1===find_box_Nc_(boxes_KV_,x_Nf_,y_Ne_)
                                        ?on_image_Nd_[1]
                                          ?(canvas_K0_.style.cursor=
                                            _cp_.toString(),
                                            on_image_Nd_[1]=
                                            0,
                                            0)
                                          :0
                                        :on_image_Nd_[1]
                                          ?0
                                          :(canvas_K0_.style.cursor=
                                            _cq_.toString(),
                                            on_image_Nd_[1]=
                                            1,
                                            0);}
                              canvas_K0_.onmousemove=
                              handler_xF_
                               (function(ev_Ng_)
                                 {update_cursor_Nh_(ev_Ng_.clientX,ev_Ng_.clientY);
                                  return _false_wZ_;});
                              var fuzz_Ni_=4;
                              canvas_K0_.onmousedown=
                              handler_xF_
                               (function(ev_Nj_)
                                 {var x0_Nk_=ev_Nj_.clientX,y0_Nl_=ev_Nj_.clientY;
                                  _jR_(sprintf_t0_,_C_,x0_Nk_,y0_Nl_);
                                  var
                                   started_Nm_=[0,0],
                                   c2_Nv_=[0,null_wt_],
                                   c1_Nx_=
                                    _xH_
                                     (document_xT_,
                                      mousemove_xN_,
                                      handler_xF_
                                       (function(ev_Nn_)
                                         {var x_No_=ev_Nn_.clientX,y_Np_=ev_Nn_.clientY;
                                          _Nq_(sprintf_t0_,_E_,x0_Nk_,y0_Nl_,x_No_,y_Np_);
                                          if(started_Nm_[1])
                                           var _Nr_=0;
                                          else
                                           {if
                                             (fuzz_Ni_<
                                              _f9_(x_No_-x0_Nk_|0)||
                                              fuzz_Ni_<
                                              _f9_(y_Np_-y0_Nl_|0))
                                             var _Ns_=1;
                                            else
                                             {var _Nr_=0,_Ns_=0;}
                                            if(_Ns_)
                                             {started_Nm_[1]=1;
                                              canvas_K0_.style.cursor=_D_.toString();
                                              var _Nr_=1;}}
                                          _Nr_;
                                          if(started_Nm_[1])
                                           {var
                                             z0_Nt_=from_screen_Ff_(canvas_K0_,x0_Nk_,y0_Nl_),
                                             z1_Nu_=from_screen_Ff_(canvas_K0_,x_No_,y_Np_);
                                            tr__K2_[1]=
                                            [0,
                                             compute_translation_BH_
                                              (_g1_(transl_BF_,neg_BE_(tr_K1_[1][1]),z0_Nt_),z1_Nu_),
                                             one_g_];
                                            schedule_redraw_F1_(1);}
                                          stopPropagation_yF_(ev_Nn_);
                                          return _true_wY_;}),
                                      _true_wY_);
                                  c2_Nv_[1]=
                                  _xe_
                                   (_xH_
                                     (document_xT_,
                                      mouseup_xL_,
                                      handler_xF_
                                       (function(ev_Nw_)
                                         {_Nq_
                                           (sprintf_t0_,
                                            _G_,
                                            x0_Nk_,
                                            y0_Nl_,
                                            ev_Nw_.clientX,
                                            ev_Nw_.clientY);
                                          _xI_(c1_Nx_);
                                          _wS_(c2_Nv_[1],_xI_);
                                          if(started_Nm_[1])
                                           {canvas_K0_.style.cursor=_F_.toString();
                                            var _Nz_=ev_Nw_.clientY,_Ny_=ev_Nw_.clientX;
                                            tr_K1_[1]=tr__K2_[1];
                                            on_image_Nd_[1]=0;
                                            update_cursor_Nh_(_Ny_,_Nz_);}
                                          else
                                           {var
                                             i_NA_=
                                              find_box_Nc_(boxes_KV_,ev_Nw_.clientX,ev_Nw_.clientY);
                                            if(0<i_NA_)
                                             {var _NB_=caml_array_get(nodes_KW_,i_NA_)[2];
                                              if(typeof _NB_==="number"||!(3654627===_NB_[1]))
                                               var _NC_=0;
                                              else
                                               {var match_ND_=_NB_[2];
                                                show_image_Ir_
                                                 (all_messages_NE_,_KR_,match_ND_[2],match_ND_[1]);
                                                var _NC_=1;}
                                              _NC_;}}
                                          return _true_wY_;}),
                                      _true_wY_));
                                  return _true_wY_;});
                              var fuzz_NF_=4;
                              _xH_
                               (canvas_K0_,
                                touchstart_xO_,
                                handler_xF_
                                 (function(ev_Ok_)
                                   {function _Ol_(touch_NG_)
                                     {var
                                       id_NH_=touch_NG_.identifier,
                                       x0_NI_=touch_NG_.clientX,
                                       y0_NJ_=touch_NG_.clientY;
                                      _jR_(sprintf_t0_,_H_,x0_NI_,y0_NJ_);
                                      var
                                       started_NK_=[0,0],
                                       c1_NY_=
                                        _xH_
                                         (document_xT_,
                                          touchmove_xQ_,
                                          handler_xF_
                                           (function(ev_NM_)
                                             {var _NL_=0,_NN_=ev_NM_.changedTouches.length-1|0;
                                              if(!(_NN_<_NL_))
                                               {var i_NO_=_NL_;
                                                for(;;)
                                                 {var
                                                   _NW_=
                                                    function(touch_NP_)
                                                     {if(touch_NP_.identifier===id_NH_)
                                                       {var x_NQ_=touch_NP_.clientX,y_NR_=touch_NP_.clientY;
                                                        _Nq_(sprintf_t0_,_J_,x0_NI_,y0_NJ_,x_NQ_,y_NR_);
                                                        if(started_NK_[1])
                                                         var _NS_=0;
                                                        else
                                                         {if
                                                           (fuzz_NF_<
                                                            _f9_(x_NQ_-x0_NI_|0)||
                                                            fuzz_NF_<
                                                            _f9_(y_NR_-y0_NJ_|0))
                                                           var _NT_=1;
                                                          else
                                                           {var _NS_=0,_NT_=0;}
                                                          if(_NT_)
                                                           {started_NK_[1]=1;
                                                            canvas_K0_.style.cursor=_I_.toString();
                                                            var _NS_=1;}}
                                                        _NS_;
                                                        if(started_NK_[1])
                                                         {_yR_.time(_cr_.toString());
                                                          var
                                                           z0_NU_=from_screen_Ff_(canvas_K0_,x0_NI_,y0_NJ_),
                                                           z1_NV_=from_screen_Ff_(canvas_K0_,x_NQ_,y_NR_);
                                                          tr__K2_[1]=
                                                          [0,
                                                           compute_translation_BH_
                                                            (_g1_(transl_BF_,neg_BE_(tr_K1_[1][1]),z0_NU_),z1_NV_),
                                                           one_g_];
                                                          return schedule_redraw_F1_(1);}
                                                        return 0;}
                                                      return 0;};
                                                  _wV_(ev_NM_.changedTouches.item(i_NO_),_NW_);
                                                  var _NX_=i_NO_+1|0;
                                                  if(_NN_!==i_NO_){var i_NO_=_NX_;continue;}
                                                  break;}}
                                              stopPropagation_yF_(ev_NM_);
                                              return _false_wZ_;}),
                                          _true_wY_),
                                       c2_NZ_=[0,null_wt_],
                                       c3_N0_=[0,null_wt_];
                                      c2_NZ_[1]=
                                      _xe_
                                       (_xH_
                                         (document_xT_,
                                          touchend_xP_,
                                          handler_xF_
                                           (function(ev_N2_)
                                             {var _N1_=0,_N3_=ev_N2_.changedTouches.length-1|0;
                                              if(!(_N3_<_N1_))
                                               {var i_N4_=_N1_;
                                                for(;;)
                                                 {var
                                                   _Ob_=
                                                    function(touch_N5_)
                                                     {if(touch_N5_.identifier===id_NH_)
                                                       {var x_N6_=touch_N5_.clientX,y_N7_=touch_N5_.clientY;
                                                        _Nq_(sprintf_t0_,_L_,x0_NI_,y0_NJ_,x_N6_,y_N7_);
                                                        _xI_(c1_NY_);
                                                        _wS_(c2_NZ_[1],_xI_);
                                                        _wS_(c3_N0_[1],_xI_);
                                                        if(started_NK_[1])
                                                         {canvas_K0_.style.cursor=_K_.toString();
                                                          tr_K1_[1]=tr__K2_[1];
                                                          return 0;}
                                                        var i_N8_=find_box_Nc_(boxes_KV_,x_N6_,y_N7_);
                                                        if(0<i_N8_)
                                                         {var _N9_=caml_array_get(nodes_KW_,i_N8_)[2];
                                                          if(typeof _N9_==="number"||!(3654627===_N9_[1]))
                                                           var _N__=0;
                                                          else
                                                           {var match_N$_=_N9_[2];
                                                            show_image_Ir_
                                                             (all_messages_NE_,_KR_,match_N$_[2],match_N$_[1]);
                                                            var _Oa_=0,_N__=1;}
                                                          if(!_N__)var _Oa_=0;}
                                                        else
                                                         var _Oa_=0;
                                                        return _Oa_;}
                                                      return 0;};
                                                  _wV_(ev_N2_.changedTouches.item(i_N4_),_Ob_);
                                                  var _Oc_=i_N4_+1|0;
                                                  if(_N3_!==i_N4_){var i_N4_=_Oc_;continue;}
                                                  break;}}
                                              return _true_wY_;}),
                                          _true_wY_));
                                      c3_N0_[1]=
                                      _xe_
                                       (_xH_
                                         (document_xT_,
                                          touchend_xP_,
                                          handler_xF_
                                           (function(ev_Oe_)
                                             {var _Od_=0,_Of_=ev_Oe_.changedTouches.length-1|0;
                                              if(!(_Of_<_Od_))
                                               {var i_Og_=_Od_;
                                                for(;;)
                                                 {var
                                                   _Oi_=
                                                    function(touch_Oh_)
                                                     {if(touch_Oh_.identifier===id_NH_)
                                                       {_Nq_
                                                         (sprintf_t0_,
                                                          _N_,
                                                          x0_NI_,
                                                          y0_NJ_,
                                                          touch_Oh_.clientX,
                                                          touch_Oh_.clientY);
                                                        _xI_(c1_NY_);
                                                        _wS_(c2_NZ_[1],_xI_);
                                                        _wS_(c3_N0_[1],_xI_);
                                                        if(started_NK_[1])canvas_K0_.style.cursor=_M_.toString();
                                                        tr_K1_[1]=tr__K2_[1];
                                                        return 0;}
                                                      return 0;};
                                                  _wV_(ev_Oe_.changedTouches.item(i_Og_),_Oi_);
                                                  var _Oj_=i_Og_+1|0;
                                                  if(_Of_!==i_Og_){var i_Og_=_Oj_;continue;}
                                                  break;}}
                                              return _false_wZ_;}),
                                          _true_wY_));
                                      return 0;}
                                    _wV_(ev_Ok_.changedTouches.item(0),_Ol_);
                                    return _false_wZ_;}),
                                _true_wY_);
                              _xH_
                               (document_xT_,
                                keydown_xM_,
                                handler_xF_
                                 (function(ev_Om_)
                                   {var _On_=ev_Om_.keyCode-37|0;
                                    if(_On_<0||3<_On_)return _true_wY_;
                                    switch(_On_)
                                     {case 1:
                                       tr__K2_[1]=
                                       [0,
                                        compute_translation_BH_
                                         (_g1_(transl_BF_,neg_BE_(tr_K1_[1][1]),z0_cx_),z1_cw_),
                                        one_g_];
                                       tr_K1_[1]=tr__K2_[1];
                                       schedule_redraw_F1_(1);
                                       return _false_wZ_;
                                      case 2:
                                       tr__K2_[1]=
                                       [0,
                                        compute_translation_BH_
                                         (_g1_(transl_BF_,neg_BE_(tr_K1_[1][1]),z0_cv_),z1_cu_),
                                        one_g_];
                                       tr_K1_[1]=tr__K2_[1];
                                       schedule_redraw_F1_(1);
                                       return _false_wZ_;
                                      case 3:
                                       tr__K2_[1]=
                                       [0,
                                        compute_translation_BH_
                                         (_g1_(transl_BF_,neg_BE_(tr_K1_[1][1]),z0_ct_),z1_cs_),
                                        one_g_];
                                       tr_K1_[1]=tr__K2_[1];
                                       schedule_redraw_F1_(1);
                                       return _false_wZ_;
                                      default:
                                       tr__K2_[1]=
                                       [0,
                                        compute_translation_BH_
                                         (_g1_(transl_BF_,neg_BE_(tr_K1_[1][1]),z0_cz_),z1_cy_),
                                        one_g_];
                                       tr_K1_[1]=tr__K2_[1];
                                       schedule_redraw_F1_(1);
                                       return _false_wZ_;}}),
                                _true_wY_);
                              var prev_buttons_Oo_=[0,0];
                              function make_buttons_O7_(param_Pd_)
                               {var _Op_=prev_buttons_Oo_[1];
                                if(_Op_)removeChild_xE_(document_xT_.body,_Op_[1]);
                                var buttons_Oq_=createDiv_yc_(document_xT_);
                                buttons_Oq_.style.position=_c4_.toString();
                                buttons_Oq_.style.right=_c3_.toString();
                                buttons_Oq_.style.bottom=_c2_.toString();
                                var
                                 messages_Or_=local_messages_E8_(all_messages_NE_),
                                 info_Os_=img_button_HZ_(0,38,_c1_);
                                info_Os_.style.position=_c0_.toString();
                                info_Os_.style.bottom=_cZ_.toString();
                                info_Os_.style.right=_cY_.toString();
                                info_Os_.style.cursor=_cX_.toString();
                                info_Os_.onclick=
                                handler_xF_
                                 (function(param_OU_)
                                   {try
                                     {var
                                       _Ot_=_hr_(language_E0_[1],tree_i18n_KT_)[2],
                                       info_Ou_=_Ot_;}
                                    catch(_Ov_)
                                     {if(_Ov_[1]!==_c_)throw _Ov_;
                                      try
                                       {var _Ow_=_hr_(_b8_.toString(),tree_i18n_KT_)[2],_Ox_=_Ow_;}
                                      catch(_Oy_)
                                       {if(_Oy_[1]!==_c_)throw _Oy_;var _Ox_=information_en_Is_;}
                                      var info_Ou_=_Ox_;}
                                    var txt_Oz_=createDiv_yc_(document_xT_);
                                    txt_Oz_.className=_b7_.toString();
                                    txt_Oz_.style.width=_b6_.toString();
                                    txt_Oz_.style.margin=_b5_.toString();
                                    txt_Oz_.innerHTML=info_Ou_;
                                    var cell_OA_=createDiv_yc_(document_xT_);
                                    cell_OA_.style.display=_b4_.toString();
                                    cell_OA_.style.verticalAlign=_b3_.toString();
                                    appendChild_xD_(cell_OA_,txt_Oz_);
                                    var table_OB_=createDiv_yc_(document_xT_);
                                    table_OB_.style.width=_b2_.toString();
                                    table_OB_.style.height=_b1_.toString();
                                    table_OB_.style.display=_b0_.toString();
                                    appendChild_xD_(table_OB_,cell_OA_);
                                    var overlay_OC_=createDiv_yc_(document_xT_);
                                    overlay_OC_.className=_bZ_.toString();
                                    appendChild_xD_(overlay_OC_,table_OB_);
                                    var c_OD_=[0,null_wt_];
                                    function close_info_OH_(param_OE_)
                                     {removeChild_xE_(document_xT_.body,overlay_OC_);
                                      return _wS_(c_OD_[1],_xI_);}
                                    c_OD_[1]=
                                    _xe_
                                     (_xH_
                                       (document_xT_,
                                        keydown_xM_,
                                        handler_xF_
                                         (function(e_OF_)
                                           {var _OG_=e_OF_.keyCode;
                                            if(13!==_OG_&&27!==_OG_)return _true_wY_;
                                            close_info_OH_(0);
                                            return _false_wZ_;}),
                                        _true_wY_));
                                    var _OI_=0,_OJ_=0;
                                    if(0===_OJ_&&0===_OI_)
                                     {var _OK_=createElement_xY_(document_xT_,_e_),_OL_=1;}
                                    else
                                     var _OL_=0;
                                    if(!_OL_)
                                     if(onIE_xJ_)
                                      {var a_OM_=new array_constructor_w1_();
                                       a_OM_.push(_eG_.toString(),_e_.toString());
                                       opt_iter_x__
                                        (_OJ_,
                                         function(t_ON_)
                                          {a_OM_.push
                                            (_eH_.toString(),caml_js_html_escape(t_ON_),_eI_.toString());
                                           return 0;});
                                       opt_iter_x__
                                        (_OI_,
                                         function(n_OO_)
                                          {a_OM_.push
                                            (_eJ_.toString(),caml_js_html_escape(n_OO_),_eK_.toString());
                                           return 0;});
                                       a_OM_.push(_eF_.toString());
                                       var
                                        _OK_=
                                         document_xT_.createElement(a_OM_.join(_eE_.toString()));}
                                     else
                                      {var res_OP_=createElement_xY_(document_xT_,_e_);
                                       opt_iter_x__
                                        (_OJ_,function(t_OQ_){return res_OP_.type=t_OQ_;});
                                       opt_iter_x__
                                        (_OI_,function(n_OR_){return res_OP_.name=n_OR_;});
                                       var _OK_=res_OP_;}
                                    appendChild_xD_
                                     (_OK_,
                                      document_xT_.createTextNode
                                       (opt_style_BD_(messages_Or_.ok,_bY_.toString())));
                                    _OK_.onclick=
                                    handler_xF_
                                     (function(param_OS_){close_info_OH_(0);return _false_wZ_;});
                                    var button_div_OT_=createDiv_yc_(document_xT_);
                                    button_div_OT_.style.textAlign=_bX_.toString();
                                    button_div_OT_.style.margin=_bW_.toString();
                                    appendChild_xD_(button_div_OT_,_OK_);
                                    appendChild_xD_(txt_Oz_,button_div_OT_);
                                    appendChild_xD_(document_xT_.body,overlay_OC_);
                                    return _false_wZ_;});
                                var
                                 tt_OV_=
                                  tooltip_HV_
                                   (opt_style_BD_(messages_Or_.info,_cW_.toString()));
                                tt_OV_.style.right=_cV_.toString();
                                tt_OV_.style.bottom=_cU_.toString();
                                appendChild_xD_(info_Os_,tt_OV_);
                                appendChild_xD_(buttons_Oq_,info_Os_);
                                var lang_OW_=img_button_HZ_(0,38,_cT_);
                                lang_OW_.style.position=_cS_.toString();
                                lang_OW_.style.bottom=_cR_.toString();
                                lang_OW_.style.right=_cQ_.toString();
                                lang_OW_.style.cursor=_cP_.toString();
                                var
                                 txt_OX_=createDiv_yc_(document_xT_),
                                 dl_OY_=createDl_ya_(document_xT_),
                                 ul_OZ_=createUl_x$_(document_xT_);
                                _hq_
                                 (function(param_O0_)
                                   {var
                                     id_O3_=param_O0_[2],
                                     name_O2_=param_O0_[1],
                                     a_O1_=createA_yd_(document_xT_);
                                    appendChild_xD_
                                     (a_O1_,document_xT_.createTextNode(name_O2_.toString()));
                                    a_O1_.href=_c5_.toString();
                                    a_O1_.onclick=
                                    handler_xF_
                                     (function(param_O8_)
                                       {var _O4_=id_O3_.toString();
                                        function _O6_(st_O5_)
                                         {return st_O5_.setItem(_T_.toString(),_O4_);}
                                        _wV_(window_xS_.localStorage,_O6_);
                                        language_E0_[1]=_O4_;
                                        make_buttons_O7_(0);
                                        compute_text_nodes_Iq_(tree_i18n_KT_,nodes_KW_);
                                        schedule_redraw_F1_(1);
                                        return _false_wZ_;});
                                    var li_O9_=createLi_yb_(document_xT_);
                                    appendChild_xD_(li_O9_,a_O1_);
                                    return appendChild_xD_(ul_OZ_,li_O9_);},
                                  languages_cO_);
                                var dd_O__=createDd_yf_(document_xT_);
                                appendChild_xD_
                                 (dd_O__,
                                  document_xT_.createTextNode
                                   (opt_style_BD_(messages_Or_.languages,_cN_.toString())));
                                appendChild_xD_(dl_OY_,dd_O__);
                                var dt_O$_=createDt_yg_(document_xT_);
                                appendChild_xD_(dt_O$_,ul_OZ_);
                                appendChild_xD_(dl_OY_,dt_O$_);
                                appendChild_xD_(txt_OX_,dl_OY_);
                                txt_OX_.className=_cM_.toString();
                                txt_OX_.style.position=_cL_.toString();
                                txt_OX_.style.right=_cK_.toString();
                                txt_OX_.style.bottom=_cJ_.toString();
                                txt_OX_.style.whiteSpace=_cI_.toString();
                                appendChild_xD_(lang_OW_,txt_OX_);
                                show_on_click_Im_(lang_OW_,txt_OX_);
                                appendChild_xD_(buttons_Oq_,lang_OW_);
                                var recenter_Pa_=img_button_HZ_(0,38,_cH_);
                                recenter_Pa_.style.position=_cG_.toString();
                                recenter_Pa_.style.bottom=_cF_.toString();
                                recenter_Pa_.style.right=_cE_.toString();
                                recenter_Pa_.style.cursor=_cD_.toString();
                                recenter_Pa_.onclick=
                                handler_xF_
                                 (function(param_Pb_)
                                   {tr__K2_[1]=[0,zero_h_,one_g_];
                                    tr_K1_[1]=tr__K2_[1];
                                    schedule_redraw_F1_(1);
                                    return _false_wZ_;});
                                var
                                 tt_Pc_=
                                  tooltip_HV_
                                   (opt_style_BD_(messages_Or_.recenter,_cC_.toString()));
                                tt_Pc_.style.right=_cB_.toString();
                                tt_Pc_.style.bottom=_cA_.toString();
                                appendChild_xD_(recenter_Pa_,tt_Pc_);
                                appendChild_xD_(buttons_Oq_,recenter_Pa_);
                                appendChild_xD_(document_xT_.body,buttons_Oq_);
                                prev_buttons_Oo_[1]=[0,buttons_Oq_];
                                return 0;}
                              make_buttons_O7_(0);
                              return return_v7_(0);});}))
             [1];
          switch(_Pe_[0])
           {case 1:throw _Pe_[1];
            case 2:
             var sleeper_Pg_=_Pe_[1];
             add_immutable_waiter_vx_
              (sleeper_Pg_,
               function(param_Pf_)
                {switch(param_Pf_[0])
                  {case 0:return 0;
                   case 1:throw param_Pf_[1];
                   default:throw [0,_d_,_e6_];}});
             break;
            case 3:throw [0,_d_,_e5_];
            default:}}
        catch(_Ph_)
         {if(_Ph_[1]===Canvas_not_available_yh_)
           {var txt_Pi_=createDiv_yc_(document_xT_);
            txt_Pi_.className=_cg_.toString();
            txt_Pi_.style.width=_cf_.toString();
            txt_Pi_.style.margin=_ce_.toString();
            txt_Pi_.innerHTML=_cd_.toString();
            var cell_Pj_=createDiv_yc_(document_xT_);
            cell_Pj_.style.display=_cc_.toString();
            cell_Pj_.style.verticalAlign=_cb_.toString();
            appendChild_xD_(cell_Pj_,txt_Pi_);
            var table_Pk_=createDiv_yc_(document_xT_);
            table_Pk_.style.width=_ca_.toString();
            table_Pk_.style.height=_b$_.toString();
            table_Pk_.style.display=_b__.toString();
            appendChild_xD_(table_Pk_,cell_Pj_);
            var overlay_Pl_=createDiv_yc_(document_xT_);
            overlay_Pl_.className=_b9_.toString();
            appendChild_xD_(overlay_Pl_,table_Pk_);
            appendChild_xD_(document_xT_.body,overlay_Pl_);
            return _false_wZ_;}
          throw _Ph_;}
        return _false_wZ_;});
    do_at_exit_gz_(0);
    return;}
  ());
